#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>

#include <gtk/gtk.h>

#define COMMON extern
#include "glg/main.h"

#include "glg/modules.h"


static	int		f_again = FALSE;



static void
clear_list_msg( void )
{

	gtk_list_clear_items( GTK_LIST( wgt_history ), 0, -1 );

}								// clear_list_msg


static int
list_length( void )
{
	GList	*list_children;

	list_children = gtk_container_children( GTK_CONTAINER( wgt_history ) );
	if ( list_children == NULL )
		return 0;
	else
		return g_list_length( list_children );

}								// list_length


static void
add_list_msg( const char *fmt, ... )
{
	va_list 		ap;
	char    		buff[ 384 ];
	GtkWidget		*list_item;
	GList			*item_list;

	/*--- Develop message ---*/
	va_start( ap, fmt );
	vsprintf( buff, fmt, ap );
	va_end( ap );

	/*--- Add new line into the list ---*/
	list_item = gtk_list_item_new_with_label( buff );
	gtk_widget_show( list_item );
	item_list = g_list_append( NULL, list_item );
	gtk_list_append_items( GTK_LIST( wgt_history ), item_list );

}								// add_list_msg


static void
replace_last_list_msg( const char *fmt, ... )
{
	va_list 		ap;
	char    		buff[ 384 ];
	GtkWidget		*list_item;
	GList			*item_list;
	int				nb;

	/*--- Develop message ---*/
	va_start( ap, fmt );
	vsprintf( buff, fmt, ap );
	va_end( ap );

	/*--- Remove new line from the list ---*/
	nb = list_length();
	gtk_list_clear_items( GTK_LIST( wgt_history ), nb-1, nb );

	/*--- Add new line into the list ---*/
	list_item = gtk_list_item_new_with_label( buff );
	gtk_widget_show( list_item );
	item_list = g_list_append( NULL, list_item );
	gtk_list_append_items( GTK_LIST( wgt_history ), item_list );

}								// replace_last_list_msg


static void
init_game( void )
{

	w_e = 0;													// 20
	for ( w_i = 0; w_i <= 12; w_i++ )
		v_b[ w_i ] = 3;											// 25
	w_c = 0; v_f[ w_n ] = 0; v_b[ 13 ] = 0; v_b[ 6 ] = 0;		// 30

	f_again = FALSE;

}								// init_game


static void
f_500( void )
{
	char	tmp[ 80 ];

	#define DISPLAY( N ) \
		sprintf( tmp, "%d", v_b[ N ] ); \
		gtk_widget_set( GTK_WIDGET(wgt_cell_##N  ), "label", tmp, NULL )

	DISPLAY( 0 );
	DISPLAY( 1 );
	DISPLAY( 2 );
	DISPLAY( 3 );
	DISPLAY( 4 );
	DISPLAY( 5 );
	DISPLAY( 6 );
	DISPLAY( 7 );
	DISPLAY( 8 );
	DISPLAY( 9 );
	DISPLAY( 10 );
	DISPLAY( 11 );
	DISPLAY( 12 );
	DISPLAY( 13 );

	#undef DISPLAY

}								// f_500


static void
enable_player_btn( const int enable )
{
	#define BTN( N ) \
		gtk_widget_set( GTK_WIDGET(wgt_cell_##N  ), "sensitive", \
			(enable && (v_b[ N ] > 0)) ? TRUE : FALSE, \
			NULL )

	BTN( 0 );
	BTN( 1 );
	BTN( 2 );
	BTN( 3 );
	BTN( 4 );
	BTN( 5 );

	#undef BTN

}								// enable_player_btn


static void
f_600( void )
{

	w_p = v_b[ w_m ]; v_b[ w_m ] = 0;							// 600
	for ( ; w_p >= 1; w_p-- )
	{
		w_m++; if ( w_m > 13 ) w_m -= 14;						// 605
		v_b[ w_m ]++;											// 610
	}
	if ( !(v_b[w_m]==1 && w_m!=6 && w_m!=13 && v_b[12-w_m]) )	// 615
		return;													// 620

	v_b[w_h] += v_b[12 - w_m]+1; v_b[w_m] = v_b[12 - w_m] = 0;	// 625

}								// f_600


static void
f_200( void )
{
	int	ok;

	w_k = w_m; f_600();											// 200
	w_e = 0; if ( w_k > 6 ) w_k -= 7;							// 205
	w_c++; if ( w_c < 9 ) v_f[ w_n ] = v_f[ w_n ] * 6 + w_k;	// 210
	for ( ok = 0, w_i = 0; w_i <= 5; w_i++ )
		if ( v_b[ w_i ] != 0 ) { ok = 1; break; }				// 215
	if ( !ok ) return;											// 225

	for ( w_i = 7; w_i <= 12; w_i++ )
		if ( v_b[ w_i ] != 0 ) { w_e = 1; return; }				// 230

}								// f_200


static void 
f_110( void )
{

	w_m--;														// 110
	w_h = 6; f_200();											// 140
	f_500();													// 150

}								// f_110


static void
game_over( void )
{

	add_list_msg( "Game over!" );								// 80
	w_d = v_b[6] - v_b[13];
	if ( w_d < 0 )
		add_list_msg( "I win by %d point%s!", -w_d, (-w_d > 1) ? "s" : "" );
	else if ( w_d > 0 )
		add_list_msg( "You win by %d point%s!", w_d, (w_d > 1) ? "s" : "" );
	else add_list_msg( "Drawn game!" );

	enable_player_btn( FALSE );

	/*--- Expand the main window to show this group ---*/
	gtk_widget_show_all( wgt_dlg_yesno );

}								// game_over


static void 
f_800( const int f_again )
{

	w_d = -99; w_h = 13;										// 800
	for ( w_i = 0; w_i <= 13; w_i++ )
		v_g[ w_i ] = v_b[ w_i ];								// 805
	for ( w_j = 7; w_j <= 12; w_j++ )
	{
		if ( v_b[ w_j ] == 0 ) continue;						// 810
		w_g = 0; w_m = w_j; f_600();							// 815
		for ( w_i = 0; w_i <= 5; w_i++ )
		{
			if ( v_b[ w_i ] == 0 ) continue;					// 820
			w_l = v_b[ w_i ] + w_i; w_r = 0;					// 825
_830:		if ( w_l > 13 ) { w_l -= 14; w_r = 1; goto _830; }	// 830
			if ( v_b[w_l]==0 && w_l!=6 && w_l!=13 )				
				w_r += v_b[ 12 - w_l ];							// 835
			if ( w_r > w_q ) w_q = w_r;							// 840
		}						// next (i)
		w_q = v_b[13] - v_b[6]  - w_q; if ( w_c > 8 ) goto _875;// 850
		w_k = w_j; if ( w_k > 6 ) w_k -= 7;						// 855
		for ( w_i = 0; w_i <= w_n-1; w_i++ )
		{
			if ( v_f[w_n]*6+w_k == (int)(v_f[w_i]/pow(6, 7-w_c)) + 0.1 )
				w_q -= 2;										// 860
		}						// next (i)						// 870
_875:	for ( w_i = 0; w_i <= 13; w_i++ )
			v_b[ w_i ] = v_g[ w_i ];							// 875
		if ( w_q >= w_d ) { w_a = w_j; w_d = w_q; }				// 880
	}							// next (j)						// 885

	w_m = w_a;													// 890
	add_list_msg( "Computer played %sin %c (%d)",
		(f_again) ? "again " : "",
		58 + w_m, v_b[ w_m ] );
	f_200();
	f_500();

}								// f_800


static void
computer_play( void )
{

	f_800( FALSE );												// 60
	if ( w_e == 0 ) return;										// 65
	if ( w_m == w_h ) f_800( TRUE );							// 70
	if ( w_e <= 0 ) game_over();

	enable_player_btn( TRUE );
	add_list_msg( "This is your turn." );

}								// computer_play


/* Callback "clicked" for GtkButton widget wgt_cell_0..5 */
void
cb_user_play(GtkButton *button, gpointer user_data)
{
	
	if ( button == GTK_BUTTON( wgt_cell_0 ) )		w_m = 1;
	else if ( button == GTK_BUTTON( wgt_cell_1 ) )	w_m = 2;
	else if ( button == GTK_BUTTON( wgt_cell_2 ) )	w_m = 3;
	else if ( button == GTK_BUTTON( wgt_cell_3 ) )	w_m = 4;
	else if ( button == GTK_BUTTON( wgt_cell_4 ) )	w_m = 5;
	else if ( button == GTK_BUTTON( wgt_cell_5 ) )	w_m = 6;
	else											w_m = -1;
	if ( w_m == -1 )
		return;
	replace_last_list_msg( "You played %sin %c (%d)",
		(f_again) ? "again " : "",
		'@' + w_m, v_b[ w_m-1 ] );
	f_110();
	if ( w_e == 0 ) { game_over(); return; }					// 45
	if ( !f_again && (w_m == w_h) )
	{
		add_list_msg( "This is your turn again" );
		enable_player_btn( TRUE );
		f_again = TRUE;
		return;
	}
	f_again = FALSE;

	computer_play();
	
}								// cb_user_play


static void
start_new_game( void )
{

	/*--- Hide group 'yes' 'no' ---*/
	gtk_widget_hide_all( wgt_dlg_yesno );

	/*--- Clear history ---*/
	clear_list_msg();

	/*--- Start game ---*/
	init_game();

}								// start_new_game


/* Callback "clicked" for GtkButton widget wgt_dlgyesno_btn_yes */
void
cb_dlgyesno_btn_yes(GtkButton *button, gpointer user_data)
{

	start_new_game();
	f_500();
	enable_player_btn( TRUE );
	add_list_msg( "This is your turn." );

}								// cb_dlgyesno_btn_yes


/* Callback "clicked" for GtkButton widget wgt_dlgyesno_btn_no */
void
cb_dlgyesno_btn_no(GtkButton *button, gpointer user_data)
{

	start_new_game();
	f_500();
	computer_play();

}								// cb_dlgyesno_btn_no
