#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "main.h"
#include "modules.h"

typedef struct
{
	GtkWidget	*initial;
	int			cpt;
	int			depth;
	GtkWidget	*result;
}						_HIERARCHYCOMPOSITE_DATA;

static void
_forall_compute_hierarchy_composite_childs( GtkWidget *widget, _HIERARCHYCOMPOSITE_DATA *data )
{

	if ( gtk_object_get_data( GTK_OBJECT( widget ), "__non_delete__" ) != NULL )
	{
		if ( widget != data->initial )
		{
			if (data->cpt++ == data->depth)
			{
				data->result = widget;
				return;
			}
		}
	}

	if ( GTK_IS_CONTAINER(widget) )
	{
		gtk_container_forall( GTK_CONTAINER(widget), 
			(GtkCallback)_forall_compute_hierarchy_composite_childs, data );
	}

}								// _forall_compute_hierarchy_composite_childs

PUBLIC GtkWidget *
_compute_hierarchy_composite_childs( GtkWidget *wgt_main, int depth )
{
	_HIERARCHYCOMPOSITE_DATA	data;

	data.initial = wgt_main;
	data.cpt	 = 0;
	data.depth	 = depth;
	data.result  = NULL;
	_forall_compute_hierarchy_composite_childs( wgt_main, &data );
	return data.result;
	
}								// _compute_hierarchy_composite_childs

PUBLIC void
_forall_flag_nondelete_widgets( GtkWidget *widget, GtkWidget *dlg )
{

	if ( widget != dlg )
		gtk_object_set_data( GTK_OBJECT( widget ), "__non_delete__", widget );

	if ( GTK_IS_CONTAINER(widget) )
		gtk_container_forall( GTK_CONTAINER(widget),
			(GtkCallback)_forall_flag_nondelete_widgets, dlg );

}								// _forall_flag_nondelete_widgets

PUBLIC GtkWidget *
__get_parent__( GtkWidget *wgt )
{
	GtkArg		args[1];
	GtkWidget	*wgt_parent;

	args[0].name = "GtkWidget::parent";
	args[0].type = GTK_TYPE_CONTAINER;
	gtk_widget_getv( GTK_WIDGET( wgt ), 1, args );
	wgt_parent = GTK_WIDGET( GTK_VALUE_OBJECT(args[0]) );
	return wgt_parent;
}								// __get_parent__

static void 
my_glog( const gchar *log_domain,
	GLogLevelFlags log_level,
	const gchar *message,
	gpointer user_data)
{
	g_log_default_handler( log_domain, log_level, message, user_data );
}								// my_glog

int
main( int argc, char *argv[] )
{

	/*--- Initialize the GTK library ---*/
	gtk_init( &argc, &argv );

	/*--- Custom GTK logger ---*/
	g_log_set_handler( "Gtk",
		(GLogLevelFlags)(G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL),
		my_glog, NULL );
	g_log_set_handler( "Gdk",
		(GLogLevelFlags)(G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL),
		my_glog, NULL );
	g_log_set_handler( "GLib",
		(GLogLevelFlags)(G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL),
		my_glog, NULL );
	g_log_set_handler( NULL,
		(GLogLevelFlags)(G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL),
		my_glog, NULL );

	/*--- Create styles ---*/
	init_styles();

	startup( argc, argv );

	/*--- Wait until exit ---*/
	gtk_main();
	return 0;

}								// main
