#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "main.h"
#include "modules.h"

GtkWidget *
create_window_rules( GtkWidget *parent, const int realize )
{
	GtkWidget	*wgt_1_2, *wgt_2_3, *wgt_3_4, *wgt_4_5, *wgt_2_6;

	wgt_rules = gtk_widget_new( gtk_window_get_type(),
		"GtkWidget::width", 400,
		"GtkWidget::height", 260,
		"GtkWidget::events", GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK |
			GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkWindow::title", "Rules of Awari",
		"GtkWindow::allow_grow", TRUE,
		"GtkWindow::default_width", 400,
		"GtkWindow::default_height", 260,
		NULL );

	wgt_1_2 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_rules,
		"GtkBox::spacing", 6,
		NULL );

	wgt_2_3 = gtk_widget_new( gtk_scrolled_window_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkScrolledWindow::hadjustment", gtk_adjustment_new( 0.000000, 0.000000, 378.000000, 10.000000, 189.000000, 378.000000 ),
		"GtkScrolledWindow::vadjustment", gtk_adjustment_new( 0.000000, 0.000000, 331.000000, 10.000000, 114.000000, 228.000000 ),
		"GtkScrolledWindow::hscrollbar_policy", GTK_POLICY_AUTOMATIC,
		"GtkScrolledWindow::vscrollbar_policy", GTK_POLICY_AUTOMATIC,
		NULL );

	wgt_3_4 = gtk_widget_new( gtk_viewport_get_type(),
		"GtkWidget::parent", wgt_2_3,
		"GtkWidget::width", 382,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkViewport::hadjustment", gtk_adjustment_new( 0.000000, 0.000000, 378.000000, 10.000000, 189.000000, 378.000000 ),
		"GtkViewport::vadjustment", gtk_adjustment_new( 0.000000, 0.000000, 331.000000, 10.000000, 114.000000, 228.000000 ),
		NULL );

	wgt_4_5 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_3_4,
		"GtkMisc::xalign", 0.100000,
		"GtkMisc::yalign", 0.100000,
		"GtkLabel::label", "Awari is an ancient African game played with seven sticks and thirty-six stones or beans. The board is divided into six pits on each side. In addition, there are two special home pits at the ends. \n\nA move is made by taking all the beans from any (non empty) pit on your own side. Starting from the pit to the right of this one, these beans are 'sown' one in each pit working around the board anticlockwise. \n\nA turn consists of one or two moves. If the last bean of your move is sown in your home you may take a second move. If the last bean sown in a move lands in an empty pit, provided that the opposite pit is not empty, all the beans in the opposite pit, together with the last bean sown are 'captured' and moved to player's home.\n\nWhen either side is empty, the game is finished. The player with most beans in his home has won.",
		"GtkLabel::justify", GTK_JUSTIFY_LEFT,
		"GtkLabel::wrap", TRUE,
		NULL );

	wgt_2_6 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Close",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_6,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_2_6 ), "clicked",
		GTK_SIGNAL_FUNC( cb_rules_btn_close ), NULL );

	if ( realize )
		gtk_widget_show_all( wgt_rules );

	return wgt_rules;

}								// create_window_rules
