#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "main.h"
#include "modules.h"

GtkWidget *
create_game_window( GtkWidget *parent, const int realize )
{
	GtkWidget	*wgt_1_2, *wgt_2_3, *wgt_3_4, *wgt_4_5, *wgt_5_6, 
				*wgt_5_8, *wgt_2_9, *wgt_3_10, *wgt_4_11, *wgt_5_12, 
				*wgt_5_13, *wgt_5_15, *wgt_5_16, *wgt_4_17, *wgt_5_18, 
				*wgt_5_20, *wgt_5_22, *wgt_4_23, *wgt_5_24, *wgt_5_26, 
				*wgt_5_28, *wgt_4_29, *wgt_5_30, *wgt_5_32, *wgt_5_34, 
				*wgt_4_35, *wgt_5_36, *wgt_5_38, *wgt_5_40, *wgt_4_41, 
				*wgt_5_42, *wgt_5_44, *wgt_5_46, *wgt_4_47, *wgt_5_48, 
				*wgt_5_50, *wgt_5_52, *wgt_4_53, *wgt_5_54, *wgt_5_55, 
				*wgt_5_57, *wgt_5_58, *wgt_2_59, *wgt_3_60, *wgt_4_61, 
				*wgt_3_65;
	GtkTooltips	*_wgt_tooltips = gtk_tooltips_new();
	GtkAccelGroup	*_wgt_accel_group;

	wgt_window = gtk_widget_new( gtk_window_get_type(),
		"GtkWidget::width", 480,
		"GtkWidget::height", 320,
		"GtkWidget::events", GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK |
			GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkWindow::title", "Awari",
		"GtkWindow::allow_grow", TRUE,
		"GtkWindow::default_width", 480,
		"GtkWindow::default_height", 320,
		NULL );
	_wgt_accel_group = gtk_accel_group_new();
	gtk_window_add_accel_group( GTK_WINDOW( wgt_window ), _wgt_accel_group );

	wgt_1_2 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_window,
		"GtkWidget::width", 480,
		"GtkWidget::height", 320,
		"GtkWidget::visible", FALSE,
		NULL );

	wgt_2_3 = gtk_widget_new( gtk_handle_box_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_3,
		"GtkBox::expand", FALSE,
		NULL );

	wgt_3_4 = gtk_widget_new( gtk_menu_bar_get_type(),
		"GtkWidget::parent", wgt_2_3,
		NULL );

	wgt_4_5 = gtk_widget_new( gtk_menu_item_get_type(),
		"GtkWidget::parent", wgt_3_4,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_4_5 ), "activate",
		GTK_SIGNAL_FUNC( cb_btn_filemenu_activate ), NULL );

	wgt_5_6 = gtk_widget_new( gtk_accel_label_get_type(),
		"GtkWidget::parent", wgt_4_5,
		"GtkMisc::xalign", 0.000000,
		"GtkLabel::label", "File",
		NULL );
	gtk_accel_label_set_accel_widget( GTK_ACCEL_LABEL( wgt_5_6 ), wgt_4_5 );
	gtk_widget_add_accelerator( wgt_4_5, "activate", _wgt_accel_group,
		0x0078, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE );

	wgt_btn_helpmenu = gtk_widget_new( gtk_menu_item_get_type(),
		"GtkWidget::parent", wgt_3_4,
		NULL );
	gtk_menu_item_right_justify( GTK_MENU_ITEM(wgt_btn_helpmenu) );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_helpmenu ), "activate",
		GTK_SIGNAL_FUNC( cb_btn_helpmenu_activate ), NULL );

	wgt_5_8 = gtk_widget_new( gtk_accel_label_get_type(),
		"GtkWidget::parent", wgt_btn_helpmenu,
		"GtkMisc::xalign", 0.000000,
		"GtkLabel::label", "Help",
		NULL );
	gtk_accel_label_set_accel_widget( GTK_ACCEL_LABEL( wgt_5_8 ), wgt_btn_helpmenu );

	wgt_2_9 = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkWidget::width", 480,
		"GtkWidget::height", 117,
		"GtkWidget::visible", FALSE,
		"GtkFrame::label", " Game ",
		"GtkFrame::shadow", GTK_SHADOW_OUT,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_9,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_3_10 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_2_9,
		"GtkWidget::width", 476,
		"GtkWidget::height", 100,
		"GtkWidget::visible", FALSE,
		"GtkContainer::border_width", 4,
		"GtkBox::spacing", 9,
		"GtkBox::homogeneous", TRUE,
		NULL );

	wgt_4_11 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_3_10,
		"GtkWidget::width", 50,
		"GtkWidget::height", 92,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_11,
		"GtkBox::expand", FALSE,
		NULL );

	wgt_5_12 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_11,
		"GtkWidget::width", 50,
		"GtkWidget::height", 17,
		"GtkWidget::visible", FALSE,
		NULL );

	wgt_5_13 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_11,
		"GtkWidget::width", 50,
		"GtkWidget::height", 17,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_5_13,
		"GtkBox::position", 1,
		NULL );

	wgt_cell_13 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_11,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_2,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_cell_13,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 2,
		NULL );

	wgt_5_15 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_11,
		"GtkWidget::width", 50,
		"GtkWidget::height", 17,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_5_15,
		"GtkBox::position", 3,
		NULL );

	wgt_5_16 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_11,
		"GtkWidget::width", 50,
		"GtkWidget::height", 19,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_5_16,
		"GtkBox::position", 4,
		NULL );

	wgt_4_17 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_3_10,
		"GtkWidget::width", 50,
		"GtkWidget::height", 92,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_17,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_5_18 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_17,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "F",
		NULL );

	wgt_cell_12 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_17,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_2,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_17 ), wgt_cell_12,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_5_20 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_17,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_17 ), wgt_5_20,
		"GtkBox::position", 2,
		NULL );

	wgt_cell_0 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_17,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_3,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_17 ), wgt_cell_0,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_cell_0 ), "clicked",
		GTK_SIGNAL_FUNC( cb_user_play ), NULL );

	wgt_5_22 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_17,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "A",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_17 ), wgt_5_22,
		"GtkBox::position", 4,
		NULL );

	wgt_4_23 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_3_10,
		"GtkWidget::width", 50,
		"GtkWidget::height", 92,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_23,
		"GtkBox::position", 2,
		NULL );

	wgt_5_24 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_23,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "E",
		NULL );

	wgt_cell_11 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_23,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_2,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_23 ), wgt_cell_11,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_5_26 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_23,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_23 ), wgt_5_26,
		"GtkBox::position", 2,
		NULL );

	wgt_cell_1 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_23,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_3,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_23 ), wgt_cell_1,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_cell_1 ), "clicked",
		GTK_SIGNAL_FUNC( cb_user_play ), NULL );

	wgt_5_28 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_23,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "B",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_23 ), wgt_5_28,
		"GtkBox::position", 4,
		NULL );

	wgt_4_29 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_3_10,
		"GtkWidget::width", 50,
		"GtkWidget::height", 92,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_29,
		"GtkBox::position", 3,
		NULL );

	wgt_5_30 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_29,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "D",
		NULL );

	wgt_cell_10 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_29,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_2,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_29 ), wgt_cell_10,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_5_32 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_29,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_29 ), wgt_5_32,
		"GtkBox::position", 2,
		NULL );

	wgt_cell_2 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_29,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_3,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_29 ), wgt_cell_2,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_cell_2 ), "clicked",
		GTK_SIGNAL_FUNC( cb_user_play ), NULL );

	wgt_5_34 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_29,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "C",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_29 ), wgt_5_34,
		"GtkBox::position", 4,
		NULL );

	wgt_4_35 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_3_10,
		"GtkWidget::width", 50,
		"GtkWidget::height", 92,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_35,
		"GtkBox::position", 4,
		NULL );

	wgt_5_36 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_35,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "C",
		NULL );

	wgt_cell_9 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_35,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_2,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_35 ), wgt_cell_9,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_5_38 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_35,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_35 ), wgt_5_38,
		"GtkBox::position", 2,
		NULL );

	wgt_cell_3 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_35,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_3,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_35 ), wgt_cell_3,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_cell_3 ), "clicked",
		GTK_SIGNAL_FUNC( cb_user_play ), NULL );

	wgt_5_40 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_35,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "D",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_35 ), wgt_5_40,
		"GtkBox::position", 4,
		NULL );

	wgt_4_41 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_3_10,
		"GtkWidget::width", 50,
		"GtkWidget::height", 92,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_41,
		"GtkBox::position", 5,
		NULL );

	wgt_5_42 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_41,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "B",
		NULL );

	wgt_cell_8 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_41,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_2,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_41 ), wgt_cell_8,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_5_44 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_41,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_41 ), wgt_5_44,
		"GtkBox::position", 2,
		NULL );

	wgt_cell_4 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_41,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_3,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_41 ), wgt_cell_4,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_cell_4 ), "clicked",
		GTK_SIGNAL_FUNC( cb_user_play ), NULL );

	wgt_5_46 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_41,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "E",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_41 ), wgt_5_46,
		"GtkBox::position", 4,
		NULL );

	wgt_4_47 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_3_10,
		"GtkWidget::width", 50,
		"GtkWidget::height", 92,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_47,
		"GtkBox::position", 6,
		NULL );

	wgt_5_48 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_47,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "A",
		NULL );

	wgt_cell_7 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_47,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_2,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_47 ), wgt_cell_7,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_5_50 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_47,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_47 ), wgt_5_50,
		"GtkBox::position", 2,
		NULL );

	wgt_cell_5 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_47,
		"GtkWidget::width", 50,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_3,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_47 ), wgt_cell_5,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_cell_5 ), "clicked",
		GTK_SIGNAL_FUNC( cb_user_play ), NULL );

	wgt_5_52 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_47,
		"GtkWidget::width", 50,
		"GtkWidget::height", 16,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "F",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_47 ), wgt_5_52,
		"GtkBox::position", 4,
		NULL );

	wgt_4_53 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_3_10,
		"GtkWidget::width", 55,
		"GtkWidget::height", 92,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_53,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 7,
		NULL );

	wgt_5_54 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_53,
		"GtkWidget::width", 55,
		"GtkWidget::height", 17,
		"GtkWidget::visible", FALSE,
		NULL );

	wgt_5_55 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_53,
		"GtkWidget::width", 55,
		"GtkWidget::height", 17,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_53 ), wgt_5_55,
		"GtkBox::position", 1,
		NULL );

	wgt_cell_6 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_53,
		"GtkWidget::width", 55,
		"GtkWidget::height", 22,
		"GtkWidget::visible", FALSE,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkWidget::style", wgt_style_3,
		"GtkButton::label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_53 ), wgt_cell_6,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 2,
		NULL );

	wgt_5_57 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_53,
		"GtkWidget::width", 55,
		"GtkWidget::height", 17,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_53 ), wgt_5_57,
		"GtkBox::position", 3,
		NULL );

	wgt_5_58 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_53,
		"GtkWidget::width", 55,
		"GtkWidget::height", 19,
		"GtkWidget::visible", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_53 ), wgt_5_58,
		"GtkBox::position", 4,
		NULL );

	wgt_2_59 = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkWidget::visible", FALSE,
		"GtkFrame::label", " History ",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_59,
		"GtkBox::position", 2,
		NULL );

	wgt_3_60 = gtk_widget_new( gtk_scrolled_window_get_type(),
		"GtkWidget::parent", wgt_2_59,
		"GtkWidget::visible", FALSE,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkScrolledWindow::hadjustment", gtk_adjustment_new( 0.000000, 0.000000, 454.000000, 10.000000, 227.000000, 454.000000 ),
		"GtkScrolledWindow::vadjustment", gtk_adjustment_new( 0.000000, 0.000000, 114.000000, 10.000000, 57.000000, 114.000000 ),
		"GtkScrolledWindow::hscrollbar_policy", GTK_POLICY_NEVER,
		NULL );

	wgt_4_61 = gtk_widget_new( gtk_viewport_get_type(),
		"GtkWidget::parent", wgt_3_60,
		"GtkWidget::visible", FALSE,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkViewport::hadjustment", gtk_adjustment_new( 0.000000, 0.000000, 454.000000, 10.000000, 227.000000, 454.000000 ),
		"GtkViewport::vadjustment", gtk_adjustment_new( 0.000000, 0.000000, 114.000000, 10.000000, 57.000000, 114.000000 ),
		NULL );

	wgt_history = gtk_widget_new( gtk_list_get_type(),
		"GtkWidget::parent", wgt_4_61,
		"GtkWidget::visible", FALSE,
		"GtkWidget::style", wgt_style_1,
		NULL );

	wgt_dlg_yesno = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkWidget::width", 480,
		"GtkWidget::height", 44,
		"GtkWidget::visible", FALSE,
		"GtkContainer::border_width", 4,
		"GtkBox::spacing", 8,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_dlg_yesno,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );

	wgt_dlgyesno_label = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_dlg_yesno,
		"GtkWidget::width", 242,
		"GtkWidget::height", 36,
		"GtkWidget::visible", FALSE,
		"GtkLabel::label", "Do you want to\nplay first ?",
		NULL );

	wgt_3_65 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_dlg_yesno,
		"GtkWidget::width", 222,
		"GtkWidget::height", 36,
		"GtkWidget::visible", FALSE,
		"GtkBox::spacing", 8,
		"GtkBox::homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_dlg_yesno ), wgt_3_65,
		"GtkBox::position", 1,
		NULL );

	wgt_dlgyesno_btn_yes = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_3_65,
		"GtkWidget::width", 107,
		"GtkWidget::height", 36,
		"GtkWidget::visible", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Yes",
		NULL );
	gtk_tooltips_set_tip( GTK_TOOLTIPS( _wgt_tooltips ), wgt_dlgyesno_btn_yes,
		"Play first",
		"Play first" );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_65 ), wgt_dlgyesno_btn_yes,
		"GtkBox::expand", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgyesno_btn_yes ), "clicked",
		GTK_SIGNAL_FUNC( cb_dlgyesno_btn_yes ), NULL );

	wgt_dlgyesno_btn_no = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_3_65,
		"GtkWidget::width", 107,
		"GtkWidget::height", 36,
		"GtkWidget::visible", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "No",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_65 ), wgt_dlgyesno_btn_no,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgyesno_btn_no ), "clicked",
		GTK_SIGNAL_FUNC( cb_dlgyesno_btn_no ), NULL );

	if ( realize )
		gtk_widget_show_all( wgt_window );

	return wgt_window;

}								// create_game_window
