#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>

#include <gtk/gtk.h>

#define COMMON extern
#include "glg/main.h"

#include "atilo.h"

#include "glg/modules.h"


void
init_new_game( const int f_draw, const int f_reset_history )
{
	int 	k, x, y;

	/*--- By default, computer has black, play has white ---*/
	code_computer = CODE_WHITE;
	code_human = CODE_BLACK;
	color_to_play = CODE_BLACK;	// Next color to play

	/*--- Initialize the board ---*/
	for (k = 0; k < 9; k++)
		board[XY(0, k)] =
			board[XY(k, 9)] = board[XY(9, 9 - k)] = board[XY(9 - k, 0)] =
			CODE_AROUND;
	for (x = 1; x <= 8; x++)
		for (y = 1; y <= 8; y++)
			board[XY(x, y)] = CODE_EMPTY;
	board[XY(4, 4)] = CODE_WHITE;
	board[XY(4, 5)] = CODE_BLACK;
	board[XY(5, 4)] = CODE_BLACK;
	board[XY(5, 5)] = CODE_WHITE;

	/*--- Cumul time played by each color ---*/
	if (f_reset_history)
	{
		time(&t_start);	// Time when player starts thinking
		ctime_black = ctime_white = 0;
		show_horo();
	}

	/*--- Draw the complete board ---*/
	if (f_draw)
		if (board_drawing_area->window)
			redraw_board();
	compute_nb_pawns(f_draw);

	/*--- Show the possibilities of the player ---*/
	if (f_draw)
		show_poss_play_cursor(code_human, code_computer);

	/*--- Reset history of the game ---*/
	if (f_reset_history)
		clear_hist_list();

	/*--- Reset msg ---*/
	computer_infos_msg("");
	player_infos_msg("Choose a position and click to play.");

	/*--- Disable the menu option 'Save the game' ---*/
	enable_SaveGame(FALSE);

}								// init_new_game


/* Callback "delete_event" for GtkWindow widget main_wnd */
gboolean
cb_close_app(GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
//	save_config();
//	gtk_main_quit();
	return (TRUE);
}								// cb_close_app
