#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gtk/gtk.h>

#include "main.h"
#include "modules.h"

GtkWidget *
create_main_wnd( GtkWidget *parent, const int realize )
{
	GtkWidget	*wgt_2_3, *wgt_4_5, *wgt_4_7, *wgt_4_9, 
				*wgt_2_13, *wgt_4_15, *wgt_4_21, *wgt_3_26, *wgt_2_28, 
				*wgt_3_29, *wgt_3_30;

	main_wnd = gtk_widget_new( gtk_window_get_type(),
		"GtkWidget::width", 400,
		"GtkWidget::height", 300,
		"GtkWidget::events", 0x0000010C,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkWindow::title", "Atilo: Reversi Game",
		"GtkWindow::allow_grow", TRUE,
		"GtkWindow::default_width", 400,
		"GtkWindow::default_height", 300,
		NULL );
	gtk_signal_connect( GTK_OBJECT( main_wnd ), "delete_event",
		GTK_SIGNAL_FUNC( cb_close_app ), NULL );
	gtk_signal_connect( GTK_OBJECT( main_wnd ), "destroy_event",
		GTK_SIGNAL_FUNC( cb_close_app ), NULL );

	main_vbox = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", main_wnd,
		NULL );

	wgt_2_3 = gtk_widget_new( gtk_menu_bar_get_type(),
		"GtkWidget::parent", main_vbox,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( main_vbox ), wgt_2_3,
		"GtkBox::expand", FALSE,
		NULL );

	wgt_board_menu_file = gtk_widget_new( gtk_menu_item_get_type(),
		"GtkWidget::parent", wgt_2_3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_board_menu_file ), "activate",
		GTK_SIGNAL_FUNC( cb_board_menu_file ), NULL );

	wgt_4_5 = gtk_widget_new( gtk_accel_label_get_type(),
		"GtkWidget::parent", wgt_board_menu_file,
		"GtkLabel::label", "File",
		NULL );

	wgt_board_menu_options = gtk_widget_new( gtk_menu_item_get_type(),
		"GtkWidget::parent", wgt_2_3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_board_menu_options ), "activate",
		GTK_SIGNAL_FUNC( cb_board_menu_options ), NULL );

	wgt_4_7 = gtk_widget_new( gtk_accel_label_get_type(),
		"GtkWidget::parent", wgt_board_menu_options,
		"GtkLabel::label", "Options",
		NULL );

	wgt_board_menu_help = gtk_widget_new( gtk_menu_item_get_type(),
		"GtkWidget::parent", wgt_2_3,
		NULL );
	gtk_menu_item_right_justify( GTK_MENU_ITEM(wgt_board_menu_help) );
	gtk_signal_connect( GTK_OBJECT( wgt_board_menu_help ), "activate",
		GTK_SIGNAL_FUNC( cb_board_menu_help ), NULL );

	wgt_4_9 = gtk_widget_new( gtk_accel_label_get_type(),
		"GtkWidget::parent", wgt_board_menu_help,
		"GtkLabel::label", "Help",
		"GtkLabel::justify", GTK_JUSTIFY_LEFT,
		NULL );

	main_hbox = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", main_vbox,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( main_vbox ), main_hbox,
		"GtkBox::position", 1,
		NULL );

	hist_list = gtk_widget_new( gtk_clist_get_type(),
		"GtkWidget::parent", main_hbox,
		"GtkWidget::can_focus", TRUE,
		NULL );
	gtk_clist_column_titles_show(GTK_CLIST(hist_list));
	gtk_container_child_set( GTK_CONTAINER( main_hbox ), hist_list,
		"GtkBox::expand", FALSE,
		NULL );

	board_drawing_area = gtk_widget_new( gtk_drawing_area_get_type(),
		"GtkWidget::parent", main_hbox,
		"GtkWidget::events", 0x00000304,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( main_hbox ), board_drawing_area,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( board_drawing_area ), "expose_event",
		GTK_SIGNAL_FUNC( cb_main_wnd_expose ), NULL );
	gtk_signal_connect( GTK_OBJECT( board_drawing_area ), "configure_event",
		GTK_SIGNAL_FUNC( cb_main_wnd_resized ), NULL );
	gtk_signal_connect( GTK_OBJECT( board_drawing_area ), "button_press_event",
		GTK_SIGNAL_FUNC( cb_main_wnd_press ), NULL );
	gtk_signal_connect( GTK_OBJECT( board_drawing_area ), "button_release_event",
		GTK_SIGNAL_FUNC( cb_main_wnd_release ), NULL );
	gtk_signal_connect( GTK_OBJECT( board_drawing_area ), "motion_notify_event",
		GTK_SIGNAL_FUNC( cb_main_wnd_motion ), NULL );

	wgt_2_13 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", main_vbox,
		"GtkWidget::height", 31,
		"GtkContainer::border_width", 1,
		"GtkBox::spacing", 2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( main_vbox ), wgt_2_13,
		"GtkBox::expand", FALSE,
		"GtkBox::fill", FALSE,
		"GtkBox::position", 2,
		NULL );

	status_black = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", wgt_2_13,
		"GtkFrame::shadow", GTK_SHADOW_IN,
		NULL );

	wgt_4_15 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", status_black,
		"GtkContainer::border_width", 2,
		"GtkBox::spacing", 2,
		NULL );

	black_pawnsnb = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_15,
		"GtkLabel::label", "Player:",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_15 ), black_pawnsnb,
		"GtkBox::expand", FALSE,
		NULL );

	black_owner = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_15,
		"GtkLabel::label", "12",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_15 ), black_owner,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	black_pawn = gtk_widget_new( gtk_drawing_area_get_type(),
		"GtkWidget::parent", wgt_4_15,
		"GtkWidget::width", 8,
		"GtkWidget::height", 21,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_15 ), black_pawn,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( black_pawn ), "expose_event",
		GTK_SIGNAL_FUNC( cb_black_pawn_expose ), NULL );

	black_horo = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_15,
		"GtkLabel::label", "00:00",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_15 ), black_horo,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );

	status_white = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", wgt_2_13,
		"GtkFrame::shadow", GTK_SHADOW_IN,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_13 ), status_white,
		"GtkBox::position", 1,
		NULL );

	wgt_4_21 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", status_white,
		"GtkContainer::border_width", 2,
		"GtkBox::spacing", 2,
		NULL );

	white_pawnsnb = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_21,
		"GtkLabel::label", "Computer:",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_21 ), white_pawnsnb,
		"GtkBox::expand", FALSE,
		NULL );

	white_owner = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_21,
		"GtkLabel::label", "12",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_21 ), white_owner,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	white_pawn = gtk_widget_new( gtk_drawing_area_get_type(),
		"GtkWidget::parent", wgt_4_21,
		"GtkWidget::width", 8,
		"GtkWidget::height", 21,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_21 ), white_pawn,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( white_pawn ), "expose_event",
		GTK_SIGNAL_FUNC( cb_white_pawn_expose ), NULL );

	white_horo = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_21,
		"GtkLabel::label", "00:00",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_21 ), white_horo,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );

	wgt_3_26 = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", wgt_2_13,
		"GtkFrame::shadow", GTK_SHADOW_IN,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_13 ), wgt_3_26,
		"GtkBox::position", 2,
		NULL );

	progressbar = gtk_widget_new( gtk_progress_bar_get_type(),
		"GtkWidget::parent", wgt_3_26,
		"GtkProgressBar::adjustment", gtk_adjustment_new( 0.000000, 0.000000, 100.000000, 0.000000, 0.000000, 0.000000 ),
		NULL );

	wgt_2_28 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", main_vbox,
		"GtkBox::homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( main_vbox ), wgt_2_28,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );

	wgt_3_29 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_2_28,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_28 ), wgt_3_29,
		"GtkBox::expand", FALSE,
		NULL );

	wgt_3_30 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_2_28,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_28 ), wgt_3_30,
		"GtkBox::expand", FALSE,
		"GtkBox::fill", FALSE,
		"GtkBox::position", 1,
		NULL );

	if ( realize )
		gtk_widget_show_all( main_wnd );

	return main_wnd;

}								// create_main_wnd
