#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <gtk/gtk.h>

#include "main.h"
#include "modules.h"

static void
init_color( GdkColor *color,
	gushort red, gushort green, gushort blue )
{
	color->red   = red;
	color->green = green;
	color->blue  = blue;
}


void
init_styles( void )
{
	GtkStyle	*style;
	GdkColor	*color;

	/*--- wgt_style_1 ---*/
	wgt_style_1 = gtk_style_new();
	style = wgt_style_1;
	color = &style->fg[ 0 ];
	init_color( color++, 17873, 17873, 17873 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->bg[ 0 ];
	init_color( color++, 13883, 53619, 17283 );
	init_color( color++, 50000, 50000, 50000 );
	init_color( color++, 60000, 60000, 60000 );
	init_color( color++, 0, 0, 40000 );
	init_color( color++, 54998, 54998, 54998 );

	color = &style->light[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->dark[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->mid[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->text[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->base[ 0 ];
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 60000, 60000, 60000 );

	/*--- wgt_style_2 ---*/
	wgt_style_2 = gtk_style_new();
	style = wgt_style_2;
	color = &style->fg[ 0 ];
	init_color( color++, 47165, 47165, 47165 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->bg[ 0 ];
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 50000, 50000, 50000 );
	init_color( color++, 60000, 60000, 60000 );
	init_color( color++, 0, 0, 40000 );
	init_color( color++, 54998, 54998, 54998 );

	color = &style->light[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->dark[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->mid[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->text[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->base[ 0 ];
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 60000, 60000, 60000 );

	/*--- wgt_style_3 ---*/
	wgt_style_3 = gtk_style_new();
	style = wgt_style_3;
	color = &style->fg[ 0 ];
	init_color( color++, 51633, 51633, 51633 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->bg[ 0 ];
	init_color( color++, 496, 496, 496 );
	init_color( color++, 50000, 50000, 50000 );
	init_color( color++, 60000, 60000, 60000 );
	init_color( color++, 0, 0, 40000 );
	init_color( color++, 54998, 54998, 54998 );

	color = &style->light[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->dark[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->mid[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->text[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->base[ 0 ];
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 60000, 60000, 60000 );

}
