#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gtk/gtk.h>

#include "main.h"
#include "modules.h"

static void 
my_glog( const gchar *log_domain,
	GLogLevelFlags log_level,
	const gchar *message,
	gpointer user_data)
{
	g_log_default_handler( log_domain, log_level, message, user_data );
}								// my_glog

int
main( int argc, char *argv[] )
{

	/*--- Initialize the GTK library ---*/
	gtk_init( &argc, &argv );

	/*--- Custom GTK logger ---*/
	g_log_set_handler( "Gtk",
		(GLogLevelFlags)(G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL),
		my_glog, NULL );
	g_log_set_handler( "Gdk",
		(GLogLevelFlags)(G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL),
		my_glog, NULL );
	g_log_set_handler( "GLib",
		(GLogLevelFlags)(G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL),
		my_glog, NULL );
	g_log_set_handler( NULL,
		(GLogLevelFlags)(G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL),
		my_glog, NULL );

	startup( argc, argv );
	create_window1( NULL, TRUE );

	/*--- Wait until exit ---*/
	gtk_main();
	return 0;

}								// main
