#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gtk/gtk.h>

#include "main.h"
#include "modules.h"

GtkWidget *
create_window1( GtkWidget *parent, const int realize )
{
	GtkWidget	*wgt_1_2, *wgt_2_3, *wgt_2_5, *wgt_2_10, 
				*wgt_3_11, *wgt_2_13, *wgt_2_14;

	wgt_res_edit_strings = gtk_widget_new( gtk_window_get_type(),
		"GtkWidget::width", 425,
		"GtkWidget::height", 363,
		"GtkWidget::events", 0x0000030C,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkWindow::type", GTK_WINDOW_DIALOG,
		"GtkWindow::title", "List Items Editor",
		"GtkWindow::allow_grow", TRUE,
		"GtkWindow::modal", TRUE,
		"GtkWindow::default_width", 400,
		"GtkWindow::default_height", 300,
		NULL );

	wgt_1_2 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_res_edit_strings,
		"GtkContainer::border_width", 6,
		"GtkBox::spacing", 2,
		NULL );

	wgt_2_3 = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkFrame::label", "List of Items",
		NULL );

	wgt_list_items = gtk_widget_new( gtk_list_get_type(),
		"GtkWidget::parent", wgt_2_3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_list_items ), "select_child",
		GTK_SIGNAL_FUNC( cb_list_items_select_child ), NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_list_items ), "unselect_child",
		GTK_SIGNAL_FUNC( cb_list_items_unselect_child ), NULL );

	wgt_2_5 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkBox::homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_5,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_btn_add_after = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_5,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Add After",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_5 ), wgt_btn_add_after,
		"GtkBox::expand", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_add_after ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_add_after_clicked ), NULL );

	wgt_btn_add_before = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_5,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Add Before",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_5 ), wgt_btn_add_before,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_add_before ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_add_before_clicked ), NULL );

	wgt_btn_remove = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_5,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Remove",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_5 ), wgt_btn_remove,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_remove ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_remove_clicked ), NULL );

	wgt_btn_edit = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_5,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Update",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_5 ), wgt_btn_edit,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_edit ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_update_clicked ), NULL );

	wgt_2_10 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkBox::spacing", 4,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_10,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 2,
		NULL );

	wgt_3_11 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_2_10,
		"GtkLabel::label", "Item:",
		"GtkLabel::justify", GTK_JUSTIFY_LEFT,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_10 ), wgt_3_11,
		"GtkBox::expand", FALSE,
		NULL );

	wgt_item = gtk_widget_new( gtk_entry_get_type(),
		"GtkWidget::parent", wgt_2_10,
		"GtkWidget::can_focus", TRUE,
		NULL );
	gtk_entry_set_text( GTK_ENTRY(wgt_item), "" );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_10 ), wgt_item,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_item ), "changed",
		GTK_SIGNAL_FUNC( cb_item_changed ), NULL );

	wgt_2_13 = gtk_widget_new( gtk_hseparator_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_13,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 4,
		"GtkBox::position", 3,
		NULL );

	wgt_2_14 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkBox::homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_14,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 4,
		NULL );

	wgt_btn_default = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_14,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Default",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_14 ), wgt_btn_default,
		"GtkBox::expand", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_default ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_default_clicked ), NULL );

	wgt_btn_cancel = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_14,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Cancel",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_14 ), wgt_btn_cancel,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_cancel ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_cancel_clicked ), NULL );

	wgt_btn_apply = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_14,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Apply",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_14 ), wgt_btn_apply,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_apply ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_apply_clicked ), NULL );

	wgt_btn_done = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_14,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Done",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_14 ), wgt_btn_done,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_done ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_done_clicked ), NULL );

	if ( realize )
		gtk_widget_show_all( wgt_res_edit_strings );

	return wgt_res_edit_strings;

}								// create_window1
