#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gnome.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>

#include "glg/main.h"
#include "glg/modules.h"


static char **szaFontNames;
static int nb_fonts;
typedef struct
{
	unsigned char width, height;
	char *name;
}
FONT_INFO;
static FONT_INFO *font_infos;


/* Callback "activate" for GtkMenuItem widget wgt_1_5 */
void
on_About_atilo_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	about_dialog();
}								// on_About_atilo_activate


void
scan_fonts(void)
{
	int n, k;
	int sz, max_width, max_height;
	GdkFont *font;
	FONT_INFO *font_info;
	static char *hor[8] = { "A", "B", "C", "D", "E", "F", "G", "H" };
	static char *vert[8] = { "1", "2", "3", "4", "5", "6", "7", "8" };

	/* --- Get the font names --- */
#if 0
	if (!read_fonts())
#endif
	{

		szaFontNames =
			XListFonts(GDK_DISPLAY(), "*bold-r-normal-*-p*iso8859-1", 1000,
				   &nb_fonts);
		if (nb_fonts == 0)
			szaFontNames =
				XListFonts(GDK_DISPLAY(), "*bold-r-normal-*iso8859-1", 1000,
					   &nb_fonts);
		if (nb_fonts == 0)
			szaFontNames =
				XListFonts(GDK_DISPLAY(), "*-r-normal-*iso8859-1", 1000,
					   &nb_fonts);
		font_infos = malloc(sizeof(FONT_INFO) * nb_fonts);

		/* --- Compute size for each font --- */
		for (font_info = font_infos, n = 0; n < nb_fonts; n++, font_info++)
		{
			font = gdk_font_load(szaFontNames[n]);
			for (max_width = 0, k = 0; k < 8; k++)
				if ((sz = gdk_string_width(font, hor[k])) > max_width)
					max_width = sz;
			for (max_height = 0, k = 0; k < 8; k++)
				if ((sz = gdk_string_height(font, vert[k])) > max_height)
					max_height = sz;
			font_info->width = max_width;
			font_info->height = max_height;
			font_info->name = strdup(szaFontNames[n]);
		}
		free(szaFontNames);

#if 0
		/*--- Write all fonts to a file ---*/
		write_fonts();
#endif

	}

}				// scan_fonts


char *
find_max_font(const int width, const int height)
{
	FONT_INFO *font_info, *info = NULL;
	int max_width, max_height, n;

	for (max_width = max_height = 0, font_info = font_infos, n = 0;
	     n < nb_fonts; n++, font_info++)
	{
		if ((font_info->width <= width) && (font_info->height <= height) &&
		    (font_info->width > max_width) && (font_info->height > max_height))
		{
			max_width = font_info->width;
			max_height = font_info->height;
			info = font_info;
		}
	}

	if (info == NULL)
		return "*bold*-r*140*";
	else
		return info->name;

}				// find_max_font


/*	load_config()
	Return: FALSE if needs to reload all fonts
*/
int
load_config(void)
{
	char tmp[100];

	g_snprintf(tmp, sizeof(tmp), "/atilo/config/level=%d", LEVEL2);
	config.level = gnome_config_get_int(tmp);

	g_snprintf(tmp, sizeof(tmp), "/atilo/config/strategy=%d", STRATEGY4);
	config.strategy = gnome_config_get_int(tmp);

	g_snprintf(tmp, sizeof(tmp), "/atilo/config/mainwnd_w=%d", 460);
	config.mainwnd_w = gnome_config_get_int(tmp);

	g_snprintf(tmp, sizeof(tmp), "/atilo/config/mainwnd_h=%d", 400);
	config.mainwnd_h = gnome_config_get_int(tmp);

	return FALSE;

}				// load_config


void
save_config(void)
{

	gnome_config_set_int("/atilo/config/level", config.level);
	gnome_config_set_int("/atilo/config/strategy", config.strategy);
	gnome_config_set_int("/atilo/config/mainwnd_w", main_wnd->allocation.width);
	gnome_config_set_int("/atilo/config/mainwnd_h", main_wnd->allocation.height);
	gnome_config_sync();

}				// save_config
