#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gnome.h>

#include "main.h"
#include "modules.h"

GtkWidget *
create_dialog_settings( GtkWidget *parent, const int realize )
{
	GtkWidget	*wgt_1_2, *wgt_2_3, *wgt_3_4, *wgt_3_9, 
				*wgt_2_15, *wgt_2_16;

	dlg_settings = gtk_widget_new( gtk_window_get_type(),
		"GtkWidget::width", 400,
		"GtkWidget::height", 300,
		"GtkWidget::events", GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK |
			GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkWindow::type", GTK_WINDOW_DIALOG,
		"GtkWindow::title", "Atilo Settings",
		"GtkWindow::allow_grow", TRUE,
		"GtkWindow::modal", TRUE,
		"GtkWindow::default_width", 400,
		"GtkWindow::default_height", 300,
		NULL );

	wgt_1_2 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", dlg_settings,
		NULL );

	wgt_2_3 = gtk_widget_new( gtk_notebook_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkWidget::can_focus", TRUE,
		"GtkContainer::border_width", 4,
		"GtkNotebook::page", 0,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_3,
		"GtkBox::position", 0,
		NULL );

	wgt_3_4 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_2_3,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_3 ), wgt_3_4,
		"GtkNotebook::tab_label", "Level",
		NULL );

	radiobtn_level_1 = gtk_widget_new( gtk_radio_button_get_type(),
		"GtkWidget::parent", wgt_3_4,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Beginners",
		"GtkButton::relief", GTK_RELIEF_NORMAL,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_4 ), radiobtn_level_1,
		"GtkBox::position", 0,
		NULL );
	gtk_signal_connect( GTK_OBJECT( radiobtn_level_1 ), "toggled",
		GTK_SIGNAL_FUNC( cb_settings_touched ), NULL );

	radiobtn_level_2 = gtk_widget_new( gtk_radio_button_get_type(),
		"GtkWidget::parent", wgt_3_4,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Intermediate",
		"GtkButton::relief", GTK_RELIEF_NORMAL,
		NULL );
	gtk_radio_button_set_group( GTK_RADIO_BUTTON( radiobtn_level_2 ), gtk_radio_button_group( GTK_RADIO_BUTTON( radiobtn_level_1 ) ) );
	gtk_signal_connect( GTK_OBJECT( radiobtn_level_2 ), "toggled",
		GTK_SIGNAL_FUNC( cb_settings_touched ), NULL );

	radiobtn_level_3 = gtk_widget_new( gtk_radio_button_get_type(),
		"GtkWidget::parent", wgt_3_4,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Good player",
		"GtkButton::relief", GTK_RELIEF_NORMAL,
		NULL );
	gtk_radio_button_set_group( GTK_RADIO_BUTTON( radiobtn_level_3 ), gtk_radio_button_group( GTK_RADIO_BUTTON( radiobtn_level_1 ) ) );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_4 ), radiobtn_level_3,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( radiobtn_level_3 ), "toggled",
		GTK_SIGNAL_FUNC( cb_settings_touched ), NULL );

	radiobtn_level_4 = gtk_widget_new( gtk_radio_button_get_type(),
		"GtkWidget::parent", wgt_3_4,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Very good player",
		"GtkButton::relief", GTK_RELIEF_NORMAL,
		NULL );
	gtk_radio_button_set_group( GTK_RADIO_BUTTON( radiobtn_level_4 ), gtk_radio_button_group( GTK_RADIO_BUTTON( radiobtn_level_1 ) ) );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_4 ), radiobtn_level_4,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( radiobtn_level_4 ), "toggled",
		GTK_SIGNAL_FUNC( cb_settings_touched ), NULL );

	wgt_3_9 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_2_3,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_3 ), wgt_3_9,
		"GtkNotebook::tab_label", "Strategy",
		"GtkNotebook::position", 1,
		NULL );

	radiobtn_strategy_1 = gtk_widget_new( gtk_radio_button_get_type(),
		"GtkWidget::parent", wgt_3_9,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Analyze corners and sub-corners",
		"GtkButton::relief", GTK_RELIEF_NORMAL,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_9 ), radiobtn_strategy_1,
		"GtkBox::position", 0,
		NULL );
	gtk_signal_connect( GTK_OBJECT( radiobtn_strategy_1 ), "toggled",
		GTK_SIGNAL_FUNC( cb_settings_touched ), NULL );

	radiobtn_strategy_2 = gtk_widget_new( gtk_radio_button_get_type(),
		"GtkWidget::parent", wgt_3_9,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Analyze corners and sub-corners +\ntry to maximize number of pawns",
		"GtkButton::relief", GTK_RELIEF_NORMAL,
		NULL );
	gtk_radio_button_set_group( GTK_RADIO_BUTTON( radiobtn_strategy_2 ), gtk_radio_button_group( GTK_RADIO_BUTTON( radiobtn_strategy_1 ) ) );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_9 ), radiobtn_strategy_2,
		"GtkBox::fill", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( radiobtn_strategy_2 ), "toggled",
		GTK_SIGNAL_FUNC( cb_settings_touched ), NULL );

	radiobtn_strategy_3 = gtk_widget_new( gtk_radio_button_get_type(),
		"GtkWidget::parent", wgt_3_9,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Analize corners and sub-corners +\ntry to minimize number of pawns",
		"GtkButton::relief", GTK_RELIEF_NORMAL,
		NULL );
	gtk_radio_button_set_group( GTK_RADIO_BUTTON( radiobtn_strategy_3 ), gtk_radio_button_group( GTK_RADIO_BUTTON( radiobtn_strategy_1 ) ) );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_9 ), radiobtn_strategy_3,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( radiobtn_strategy_3 ), "toggled",
		GTK_SIGNAL_FUNC( cb_settings_touched ), NULL );

	radiobtn_strategy_4 = gtk_widget_new( gtk_radio_button_get_type(),
		"GtkWidget::parent", wgt_3_9,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Analyze corners/sub-corners +\ntry to block opponent",
		"GtkButton::relief", GTK_RELIEF_NORMAL,
		NULL );
	gtk_radio_button_set_group( GTK_RADIO_BUTTON( radiobtn_strategy_4 ), gtk_radio_button_group( GTK_RADIO_BUTTON( radiobtn_strategy_1 ) ) );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_9 ), radiobtn_strategy_4,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( radiobtn_strategy_4 ), "toggled",
		GTK_SIGNAL_FUNC( cb_settings_touched ), NULL );

	radiobtn_strategy_5 = gtk_widget_new( gtk_radio_button_get_type(),
		"GtkWidget::parent", wgt_3_9,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Same as above +\nanalyze some situtations\n(experimental)",
		"GtkButton::relief", GTK_RELIEF_NORMAL,
		NULL );
	gtk_radio_button_set_group( GTK_RADIO_BUTTON( radiobtn_strategy_5 ), gtk_radio_button_group( GTK_RADIO_BUTTON( radiobtn_strategy_1 ) ) );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_9 ), radiobtn_strategy_5,
		"GtkBox::position", 4,
		NULL );
	gtk_signal_connect( GTK_OBJECT( radiobtn_strategy_5 ), "toggled",
		GTK_SIGNAL_FUNC( cb_settings_touched ), NULL );

	wgt_2_15 = gtk_widget_new( gtk_hseparator_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_15,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 4,
		NULL );

	wgt_2_16 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_16,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 2,
		NULL );

	settings_btn_ok = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_16,
		"GtkWidget::sensitive", FALSE,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Ok",
		"GtkButton::relief", GTK_RELIEF_NORMAL,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_16 ), settings_btn_ok,
		"GtkBox::position", 0,
		NULL );
	gtk_signal_connect( GTK_OBJECT( settings_btn_ok ), "clicked",
		GTK_SIGNAL_FUNC( cb_settings_btn_ok ), NULL );

	settings_btn_cancel = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_16,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Cancel",
		"GtkButton::relief", GTK_RELIEF_NORMAL,
		NULL );
	gtk_signal_connect( GTK_OBJECT( settings_btn_cancel ), "clicked",
		GTK_SIGNAL_FUNC( cb_settings_btn_cancel ), NULL );

	if ( realize )
		gtk_widget_show_all( dlg_settings );

	return dlg_settings;

}								// create_dialog_settings
