#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gnome.h>

#include "main.h"
#include "modules.h"

GtkWidget *
create_main_window( GtkWidget *parent, const int realize )
{
	GtkWidget	*wgt_2_3, *wgt_3_4, *wgt_4_5, *wgt_3_6, *wgt_4_7, 
				*wgt_3_8, *wgt_4_9, *wgt_3_13, *wgt_4_17, *wgt_4_23, 
				*wgt_3_28;

	main_wnd = gtk_widget_new( gtk_window_get_type(),
		"GtkWidget::width", 462,
		"GtkWidget::height", 398,
		"GtkWidget::events", GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK |
			GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkWindow::title", "Atilo: Reversi Game",
		"GtkWindow::allow_grow", TRUE,
		"GtkWindow::default_width", 400,
		"GtkWindow::default_height", 300,
		NULL );
	gtk_signal_connect( GTK_OBJECT( main_wnd ), "destroy",
		GTK_SIGNAL_FUNC( destroy_app ), NULL );
	gtk_signal_connect( GTK_OBJECT( main_wnd ), "delete_event",
		GTK_SIGNAL_FUNC( close_app ), NULL );

	main_vbox = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", main_wnd,
		NULL );

	wgt_2_3 = gtk_widget_new( gtk_menu_bar_get_type(),
		"GtkWidget::parent", main_vbox,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( main_vbox ), wgt_2_3,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 0,
		NULL );

	wgt_3_4 = gtk_widget_new( gtk_menu_item_get_type(),
		"GtkWidget::parent", wgt_2_3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_3_4 ), "activate",
		GTK_SIGNAL_FUNC( cb_menubtn_file_activate ), NULL );

	wgt_4_5 = gtk_widget_new( gtk_accel_label_get_type(),
		"GtkWidget::parent", wgt_3_4,
		"GtkMisc::xalign", 0.000000,
		"GtkLabel::label", "File",
		NULL );
	gtk_accel_label_set_accel_widget( GTK_ACCEL_LABEL( wgt_4_5 ), wgt_3_4 );

	wgt_3_6 = gtk_widget_new( gtk_menu_item_get_type(),
		"GtkWidget::parent", wgt_2_3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_3_6 ), "activate",
		GTK_SIGNAL_FUNC( cb_menubtn_options_activate ), NULL );

	wgt_4_7 = gtk_widget_new( gtk_accel_label_get_type(),
		"GtkWidget::parent", wgt_3_6,
		"GtkMisc::xalign", 0.000000,
		"GtkLabel::label", "Options",
		NULL );
	gtk_accel_label_set_accel_widget( GTK_ACCEL_LABEL( wgt_4_7 ), wgt_3_6 );

	wgt_3_8 = gtk_widget_new( gtk_menu_item_get_type(),
		"GtkWidget::parent", wgt_2_3,
		NULL );
	gtk_menu_item_right_justify( GTK_MENU_ITEM(wgt_3_8) );
	gtk_signal_connect( GTK_OBJECT( wgt_3_8 ), "activate",
		GTK_SIGNAL_FUNC( cb_menubtn_help_activate ), NULL );

	wgt_4_9 = gtk_widget_new( gtk_accel_label_get_type(),
		"GtkWidget::parent", wgt_3_8,
		"GtkMisc::xalign", 0.000000,
		"GtkLabel::label", "Help",
		NULL );
	gtk_accel_label_set_accel_widget( GTK_ACCEL_LABEL( wgt_4_9 ), wgt_3_8 );

	main_hbox = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", main_vbox,
		NULL );

	scrolled_win = gtk_widget_new( gtk_scrolled_window_get_type(),
		"GtkWidget::parent", main_hbox,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkScrolledWindow::hadjustment", gtk_adjustment_new( 0.000000, 0.000000, 64.000000, 10.000000, 32.000000, 64.000000 ),
		"GtkScrolledWindow::vadjustment", gtk_adjustment_new( 0.000000, 0.000000, 1.000000, 15.000000, 146.000000, 1.000000 ),
		"GtkScrolledWindow::hscrollbar_policy", GTK_POLICY_NEVER,
		"GtkScrolledWindow::vscrollbar_policy", GTK_POLICY_AUTOMATIC,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( main_hbox ), scrolled_win,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 0,
		NULL );

	hist_list = gtk_widget_new( gtk_clist_get_type(),
		"GtkWidget::parent", scrolled_win,
		"GtkWidget::can_focus", TRUE,
		NULL );
	gtk_clist_column_titles_show(GTK_CLIST(hist_list));
	gtk_clist_set_column_title( GTK_CLIST( hist_list ), 0, "History" );
	gtk_clist_column_titles_passive( GTK_CLIST( hist_list ) );
	gtk_signal_connect( GTK_OBJECT( hist_list ), "select_row",
		GTK_SIGNAL_FUNC( hist_list_selected ), NULL );

	wgt_3_13 = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", main_hbox,
		"GtkContainer::border_width", 16,
		"GtkFrame::shadow", GTK_SHADOW_NONE,
		NULL );

	board_drawing_area = gtk_widget_new( gtk_drawing_area_get_type(),
		"GtkWidget::parent", wgt_3_13,
		"GtkWidget::events", GDK_EXPOSURE_MASK | GDK_POINTER_MOTION_MASK |
			GDK_BUTTON_MOTION_MASK | GDK_BUTTON_PRESS_MASK |
			GDK_BUTTON_RELEASE_MASK,
		NULL );
	gtk_drawing_area_size( GTK_DRAWING_AREA( board_drawing_area ), 80, 80 );
	gtk_signal_connect( GTK_OBJECT( board_drawing_area ), "expose_event",
		GTK_SIGNAL_FUNC( main_wnd_expose ), NULL );
	gtk_signal_connect( GTK_OBJECT( board_drawing_area ), "configure_event",
		GTK_SIGNAL_FUNC( main_wnd_resized ), NULL );
	gtk_signal_connect( GTK_OBJECT( board_drawing_area ), "button_press_event",
		GTK_SIGNAL_FUNC( main_wnd_press ), NULL );
	gtk_signal_connect( GTK_OBJECT( board_drawing_area ), "button_release_event",
		GTK_SIGNAL_FUNC( main_wnd_release ), NULL );

	status_hbox = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", main_vbox,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( main_vbox ), status_hbox,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 2,
		NULL );

	status_black = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", status_hbox,
		"GtkFrame::shadow", GTK_SHADOW_IN,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( status_hbox ), status_black,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 0,
		NULL );

	wgt_4_17 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", status_black,
		"GtkContainer::border_width", 2,
		"GtkBox::spacing", 4,
		NULL );

	black_owner = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_17,
		"GtkLabel::label", "Player:",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_17 ), black_owner,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 0,
		NULL );

	black_pawnsnb = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_17,
		NULL );

	black_pawn = gtk_widget_new( gtk_drawing_area_get_type(),
		"GtkWidget::parent", wgt_4_17,
		"GtkWidget::height", 16,
		NULL );
	gtk_drawing_area_size( GTK_DRAWING_AREA( black_pawn ), 24, 18 );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_17 ), black_pawn,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 12,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( black_pawn ), "expose_event",
		GTK_SIGNAL_FUNC( black_pawn_expose ), NULL );

	black_horo = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_17,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_17 ), black_horo,
		"GtkBox::position", 3,
		NULL );

	status_white = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", status_hbox,
		"GtkFrame::shadow", GTK_SHADOW_IN,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( status_hbox ), status_white,
		"GtkBox::expand", FALSE,
		NULL );

	wgt_4_23 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", status_white,
		"GtkContainer::border_width", 2,
		"GtkBox::spacing", 4,
		NULL );

	white_owner = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_23,
		"GtkLabel::label", "Computer:",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_23 ), white_owner,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 0,
		NULL );

	white_pawnsnb = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_23,
		NULL );

	white_pawn = gtk_widget_new( gtk_drawing_area_get_type(),
		"GtkWidget::parent", wgt_4_23,
		"GtkWidget::height", 16,
		NULL );
	gtk_drawing_area_size( GTK_DRAWING_AREA( white_pawn ), 24, 18 );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_23 ), white_pawn,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( white_pawn ), "expose_event",
		GTK_SIGNAL_FUNC( white_pawn_expose ), NULL );

	white_horo = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_23,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_23 ), white_horo,
		"GtkBox::position", 3,
		NULL );

	wgt_3_28 = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", status_hbox,
		"GtkFrame::shadow", GTK_SHADOW_IN,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( status_hbox ), wgt_3_28,
		"GtkBox::position", 2,
		NULL );

	progressbar = gtk_widget_new( gtk_progress_bar_get_type(),
		"GtkWidget::parent", wgt_3_28,
		"GtkProgressBar::adjustment", gtk_adjustment_new( 0.000000, 0.000000, 1000.000000, 0.000000, 0.000000, 0.000000 ),
		NULL );

	computer_infos_label = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", main_vbox,
		"GtkMisc::xalign", 0.050000,
		"GtkLabel::label", ".",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( main_vbox ), computer_infos_label,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );

	player_infos_label = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", main_vbox,
		"GtkMisc::xalign", 0.050000,
		"GtkLabel::label", ".",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( main_vbox ), player_infos_label,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 4,
		NULL );

	if ( realize )
		gtk_widget_show_all( main_wnd );

	return main_wnd;

}								// create_main_window
