#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gnome.h>

#include "glg/main.h"
#include "glg/modules.h"


/* Callback "activate" for GtkMenuItem widget wgt_1_2 */
void
on_New_game_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	init_new_game( TRUE, TRUE );
}								// on_New_game_activate


/* Callback "activate" for GtkMenuItem widget wgt_1_4 */
void
on_Save_game_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	file_save_game();
}								// on_Save_game_activate


/* Callback "activate" for GtkMenuItem widget wgt_1_6 */
void
on_Load_game_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	file_load_game();
}								// on_Load_game_activate


/* Callback "activate" for GtkMenuItem widget wgt_1_12 */
void
on_Quit_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	gtk_widget_destroy(main_wnd);
}								// on_Quit_activate


/* Callback "activate" for GtkMenuItem widget wgt_3_4 */
void
cb_menubtn_file_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	create_file_menu();
}								// cb_menubtn_file_activate

/* Callback "activate" for GtkMenuItem widget wgt_3_6 */
void
cb_menubtn_options_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	create_options_menu();
}								// cb_menubtn_options_activate

/* Callback "activate" for GtkMenuItem widget wgt_3_8 */
void
cb_menubtn_help_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	create_help_menu();
}								// cb_menubtn_help_activate


/* Callback "activate" for GtkMenuItem widget Change_side */
void
on_Change_side_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	change_side();
}								// on_Change_side_activate


/* Callback "activate" for GtkMenuItem widget Suggest_move */
void
on_SuggestMove_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	suggest_move();
}								// on_SuggestMove_activate


/* Callback "activate" for GtkMenuItem widget wgt_1_7 */
void
on_Settings_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	create_dialog_settings( main_wnd, FALSE );
	settings_set_level();
	settings_set_strategy();
	gtk_widget_show_all( dlg_settings );
}								// on_Settings_activate


/* Callback "activate" for GtkMenuItem widget wgt_1_2 */
void
on_Rules_of_Reversi_activate(GtkMenuItem *menu_item, gpointer user_data)
{
	gchar *path = gnome_help_file_path("atilo", "index.html");
	if (path != NULL)
		gnome_help_goto(NULL, path);
}								// on_Rules_of_Reversi_activate




void
enable_NewGame(const int flag)
{
	gtk_widget_set_sensitive(New_game, flag);
}				// enable_NewGame

void
enable_SaveGame(const int flag)
{
	if ( Save_game != NULL )
		gtk_widget_set_sensitive(Save_game, flag);
}				// enable_SaveGame

void
enable_ChangeSide(const int flag)
{
	gtk_widget_set_sensitive(Change_side, flag);
}				// enable_ChangeSide

void
enable_SuggestMove(const int flag)
{
	gtk_widget_set_sensitive(Suggest_move, flag);
}				// enable_SuggestMove


