#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gnome.h>

#include "glg/main.h"
#include "glg/modules.h"


void
settings_set_level( void )
{
	GtkWidget *btn = NULL;

	switch (config.level)
	{
		case LEVEL1:
			btn = radiobtn_level_1;
			break;
		case LEVEL2:
			btn = radiobtn_level_2;
			break;
		case LEVEL3:
			btn = radiobtn_level_3;
			break;
		case LEVEL4:
			btn = radiobtn_level_4;
			break;
	}
	
	gtk_toggle_button_set_state( GTK_TOGGLE_BUTTON( btn ), TRUE );
	
}								// settings_set_level


static int
get_level( void )
{
	if (GTK_WIDGET_STATE(radiobtn_level_1))
		return LEVEL1;
	else if (GTK_WIDGET_STATE(radiobtn_level_2))
		return LEVEL2;
	else if (GTK_WIDGET_STATE(radiobtn_level_3))
		return LEVEL3;
	else if (GTK_WIDGET_STATE(radiobtn_level_4))
		return LEVEL4;
	else
		return -1;
}								// get_level


void
settings_set_strategy(void)
{
	GtkWidget *btn = NULL;

	switch (config.strategy)
	{
		case STRATEGY1:
			btn = radiobtn_strategy_1;
			break;
		case STRATEGY2:
			btn = radiobtn_strategy_2;
			break;
		case STRATEGY3:
			btn = radiobtn_strategy_3;
			break;
		case STRATEGY4:
			btn = radiobtn_strategy_4;
			break;
		case STRATEGY5:
			btn = radiobtn_strategy_5;
			break;
	}
	
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(btn), TRUE);
	
}								// settings_set_strategy


static int
get_strategy(void)
{
	if (GTK_WIDGET_STATE(radiobtn_strategy_1))
		return STRATEGY1;
	else if (GTK_WIDGET_STATE(radiobtn_strategy_2))
		return STRATEGY2;
	else if (GTK_WIDGET_STATE(radiobtn_strategy_3))
		return STRATEGY3;
	else if (GTK_WIDGET_STATE(radiobtn_strategy_4))
		return STRATEGY4;
	else if (GTK_WIDGET_STATE(radiobtn_strategy_5))
		return STRATEGY5;
	else
		return -1;
}				// get_strategy


/* Callback "clicked" for GtkButton widget settings_btn_ok */
void
cb_settings_btn_ok(GtkButton *button, gpointer user_data)
{
	
	config.level = get_level();
	config.strategy = get_strategy();
	gtk_widget_destroy(dlg_settings);

}								// cb_settings_btn_ok

/* Callback "clicked" for GtkButton widget settings_btn_cancel */
void
cb_settings_btn_cancel(GtkButton *button, gpointer user_data)
{
	
	gtk_widget_destroy( dlg_settings );

}								// cb_settings_btn_cancel

/* Callback "toggled" for GtkRadioButton widget radiobtn_level_1 */
void
cb_settings_touched(GtkToggleButton *togglebutton, gpointer user_data)
{
	gtk_widget_set_sensitive( settings_btn_ok, TRUE );
}								// cb_settings_touched
