#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gnome.h>

#define __STARTUP__
#include "glg/main.h"

#include "glg/modules.h"


static void
size_hist_list( void )
{
	GtkStyle	*style, *new_style;
	gint		sz, max_sz;
	int			n;
	char		tmp[ 80 ];

	style = gtk_widget_get_style(hist_list);
	new_style = gtk_style_copy( style );
	if ((new_style->font = gdk_font_load("*courier-*-r*140*")) == NULL)
		if ((new_style->font = gdk_font_load("*courier-*-r*120*")) == NULL)
			new_style->font = style->font;
	gtk_widget_set_style( hist_list, new_style );
	
	for ( max_sz = 0, n = 0; n < 10; n++ )
	{
		sprintf(tmp, "%d: %s: %c%d",
			RANDOM(1, 60),
			(rand() % 2) ? "Black" : "White", RANDOM(0, 7) + 'A', RANDOM(1, 8));
		sz = gdk_string_width(new_style->font, tmp);
		if (sz > max_sz)
			max_sz = sz;
	}

	gtk_clist_set_column_width( GTK_CLIST( hist_list ), 0, max_sz );

}								// size_hist_list


void
startup( int argc, char *argv[] )
{

	if ( !load_config() )
		scan_fonts();

	create_main_window( NULL, FALSE );
	install_motion_handler( TRUE );
	size_hist_list();
	gtk_widget_set( main_wnd,
		"GtkWidget::width", config.mainwnd_w,
		"GtkWidget::height", config.mainwnd_h,
		NULL );
	gtk_widget_show_all( main_wnd );
	
	init_new_game( TRUE, TRUE );

}
