#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gnome.h>

#include "glg/main.h"
#include "glg/modules.h"


/* Callback "expose_event" for GtkDrawingArea widget wgt_5_12 */
gboolean
black_pawn_expose(GtkWidget *widget, GdkEventExpose *event, gpointer user_data)
{
	int	z;

	z = MIN( widget->allocation.width, widget->allocation.height );

	if (penBlackCell)
	{
		gdk_draw_arc(widget->window,
			penBlackCell,
			TRUE,
			0, 0, 
			z, z,
			0, 360 * 64);
	}
	
	return FALSE;
	
}								// black_pawn_expose


/* Callback "expose_event" for GtkDrawingArea widget wgt_5_18 */
gboolean
white_pawn_expose(GtkWidget *widget, GdkEventExpose *event, gpointer user_data)
{

	int	z;

	z = MIN( widget->allocation.width, widget->allocation.height );

	if (penWhiteCell)
	{
		gdk_draw_arc(widget->window,
			penWhiteCell,
			TRUE,
			0, 0, 
			z, z,
			0, 360 * 64);
	}
	
	return FALSE;
	
}								// white_pawn_expose


void
set_progressbar(const int val, const int max_val)
{
	gtk_progress_set_value(GTK_PROGRESS(progressbar), (double) (1000 / max_val) * val);
	gdk_flush();
	while (gtk_events_pending())
		gtk_main_iteration();
}								// set_progressbar


void
show_nb_pawns(void)
{
	char tmp[80];

	sprintf(tmp, "%d", nb_pawns[CODE_BLACK]);
	gtk_label_set_text(GTK_LABEL(black_pawnsnb), tmp);

	sprintf(tmp, "%d", nb_pawns[CODE_WHITE]);
	gtk_label_set_text(GTK_LABEL(white_pawnsnb), tmp);

}								// show_nb_pawns


void
set_owners(void)
{
	gtk_label_set_text(GTK_LABEL(black_owner),
			   (code_computer == CODE_BLACK) ? "Computer:" : "Player:");
	gtk_label_set_text(GTK_LABEL(white_owner),
			   (code_computer == CODE_WHITE) ? "Computer:" : "Player:");
}								// set_owners


void
show_horo(void)
{
	char buff[80];

	sprintf(buff, "%02d:%02d", ctime_black / 60, ctime_black % 60);
	gtk_label_set_text(GTK_LABEL(black_horo), buff);

	sprintf(buff, "%02d:%02d", ctime_white / 60, ctime_white % 60);
	gtk_label_set_text(GTK_LABEL(white_horo), buff);

}								// show_horo
