#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <sys/time.h>
#include <assert.h>

#include <gtk/gtk.h>

#define COMMON extern
#include "glg/main.h"

#include "glg/modules.h"

#include <gdk/gdkkeysyms.h>


/* linear congruential generator.  Generator x[n+1] = a * x[n] mod m */
static unsigned int SEED = 93186752;
PUBLIC double 
frandom ( void )  
{
	/* The following parameters are recommended settings based on research
	uncomment the one you want. */

	static unsigned int a = 1588635695, m = 4294967291U, q = 2, r = 1117695901;
	/* static unsigned int a = 1223106847, m = 4294967291U, q = 3, r = 625646750;*/
	/* static unsigned int a = 279470273, m = 4294967291U, q = 15, r = 102913196;*/
	/* static unsigned int a = 1583458089, m = 2147483647, q = 1, r = 564025558; */
	/* static unsigned int a = 784588716, m = 2147483647, q = 2, r = 578306215;  */
	/* static unsigned int a = 16807, m = 2147483647, q = 127773, r = 2836;      */
	/* static unsigned int a = 950706376, m = 2147483647, q = 2, r = 246070895;  */

	SEED = a*(SEED % q) - r*(SEED / q);
	return ((double)SEED / (double)m);
}								// frandom
 


PUBLIC now_t
now( void )
{
static	struct timeval	_tv;
static	struct timezone	_tz;
static	int				first = TRUE;
		struct timeval	tv;
		struct timezone	tz;

	if ( first )
	{
		gettimeofday( &_tv, &_tz );
		first = FALSE;
	}

	gettimeofday( &tv, &tz );
	return (((now_t)tv.tv_sec - (now_t)_tv.tv_sec) * (now_t)1000000) + ((now_t)tv.tv_usec);
}								// now


PUBLIC void
set_label( GtkWidget *wgt, char *fmt, ... )
{
	va_list		ap;
	char		buff[ 384 ];

	/*--- Develop message to display ---*/ 
	va_start( ap, fmt );
	vsprintf( buff, fmt, ap );
	va_end( ap );

	gtk_widget_set( GTK_WIDGET( wgt ), 
		"label", buff,
		NULL );

}								// set_label


PUBLIC void
draw_score( void )
{

	set_label( wgt_score, "%d", score );

}								// draw_score


PUBLIC void
set_gauge_minmax( GtkWidget *gauge, int vmin, int vmax )
{

	gtk_progress_configure( GTK_PROGRESS( gauge ), 0, vmin, vmax );

}								// set_gauge_minmax


PUBLIC void
set_gauge_val( GtkWidget *gauge, int val )
{

	gtk_progress_set_value( GTK_PROGRESS( gauge ), val );

}								// set_gauge_val


PUBLIC int
rect_intersect( rect_t *r1, rect_t *r2 )
{
	GdkRectangle	s1, s2, r;

	s1.x = r1->ul.x;
	s1.y = r1->ul.y;
	s1.width  = r1->lr.x - r1->ul.x;
	s1.height = r1->lr.y - r1->ul.y;

	s2.x = r2->ul.x;
	s2.y = r2->ul.y;
	s2.width  = r2->lr.x - r2->ul.x;
	s2.height = r2->lr.y - r2->ul.y;

	return gdk_rectangle_intersect( &s1, &s2, &r );

}								// rect_intersect
