#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <gtk/gtk.h>

#include "main.h"
#include "modules.h"

static void
init_color( GdkColor *color,
	gushort red, gushort green, gushort blue )
{
	color->red   = red;
	color->green = green;
	color->blue  = blue;
}


void
init_styles( void )
{
	GtkStyle	*style;
	GdkColor	*color;

	/*--- wgt_style_1 ---*/
	wgt_style_1 = gtk_style_new();
	style = wgt_style_1;
	color = &style->fg[ 0 ];
	init_color( color++, 39489, 39489, 39489 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->bg[ 0 ];
	init_color( color++, 420, 267, 0 );
	init_color( color++, 50000, 50000, 50000 );
	init_color( color++, 60000, 60000, 60000 );
	init_color( color++, 0, 0, 40000 );
	init_color( color++, 54998, 54998, 54998 );

	color = &style->light[ 0 ];
	init_color( color++, 545, 347, 0 );
	init_color( color++, 65000, 65000, 65000 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 0, 0, 52000 );
	init_color( color++, 65535, 65535, 65535 );

	color = &style->dark[ 0 ];
	init_color( color++, 249, 174, 44 );
	init_color( color++, 34999, 34999, 34999 );
	init_color( color++, 41999, 41999, 41999 );
	init_color( color++, 4200, 4200, 23800 );
	init_color( color++, 38498, 38498, 38498 );

	color = &style->mid[ 0 ];
	init_color( color++, 397, 260, 22 );
	init_color( color++, 49999, 49999, 49999 );
	init_color( color++, 53767, 53767, 53767 );
	init_color( color++, 2100, 2100, 37900 );
	init_color( color++, 52016, 52016, 52016 );

	color = &style->text[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->base[ 0 ];
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 60000, 60000, 60000 );

	/*--- wgt_style_2 ---*/
	wgt_style_2 = gtk_style_new();
	style = wgt_style_2;
	color = &style->fg[ 0 ];
	init_color( color++, 39489, 39489, 39489 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->bg[ 0 ];
	init_color( color++, 52512, 52512, 52512 );
	init_color( color++, 27645, 49999, 28423 );
	init_color( color++, 35588, 41676, 59999 );
	init_color( color++, 40000, 17699, 15380 );
	init_color( color++, 54998, 54998, 54998 );

	color = &style->light[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->dark[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->mid[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->text[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->base[ 0 ];
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 60000, 60000, 60000 );

	/*--- wgt_style_3 ---*/
	wgt_style_3 = gtk_style_new();
	style = wgt_style_3;
	color = &style->fg[ 0 ];
	init_color( color++, 39489, 39489, 39489 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->bg[ 0 ];
	init_color( color++, 52512, 52512, 52512 );
	init_color( color++, 27645, 49999, 28423 );
	init_color( color++, 35588, 41676, 59999 );
	init_color( color++, 0, 0, 40000 );
	init_color( color++, 54998, 54998, 54998 );

	color = &style->light[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->dark[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->mid[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->text[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->base[ 0 ];
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 60000, 60000, 60000 );

	/*--- wgt_style_4 ---*/
	wgt_style_4 = gtk_style_new();
	style = wgt_style_4;
	color = &style->fg[ 0 ];
	init_color( color++, 39489, 39489, 39489 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->bg[ 0 ];
	init_color( color++, 52512, 52512, 52512 );
	init_color( color++, 27645, 49999, 28423 );
	init_color( color++, 65535, 0, 0 );
	init_color( color++, 0, 0, 40000 );
	init_color( color++, 54998, 54998, 54998 );

	color = &style->light[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->dark[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->mid[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );

	color = &style->text[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->base[ 0 ];
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 60000, 60000, 60000 );

	/*--- wgt_style_5 ---*/
	wgt_style_5 = gtk_style_new();
	style = wgt_style_5;
	color = &style->fg[ 0 ];
	init_color( color++, 39489, 39489, 39489 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->bg[ 0 ];
	init_color( color++, 52512, 52512, 52512 );
	init_color( color++, 27645, 49999, 28423 );
	init_color( color++, 35588, 41676, 59999 );
	init_color( color++, 0, 0, 40000 );
	init_color( color++, 54998, 54998, 54998 );

	color = &style->light[ 0 ];
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 42273, 58663, 42843 );
	init_color( color++, 59087, 60605, 65175 );
	init_color( color++, 0, 0, 52000 );
	init_color( color++, 65535, 65535, 65535 );

	color = &style->dark[ 0 ];
	init_color( color++, 36758, 36758, 36758 );
	init_color( color++, 19216, 35134, 19770 );
	init_color( color++, 18006, 25712, 48904 );
	init_color( color++, 4200, 4200, 23800 );
	init_color( color++, 38498, 38498, 38498 );

	color = &style->mid[ 0 ];
	init_color( color++, 51146, 51146, 51146 );
	init_color( color++, 30744, 46898, 31306 );
	init_color( color++, 38546, 43158, 57039 );
	init_color( color++, 2100, 2100, 37900 );
	init_color( color++, 52016, 52016, 52016 );

	color = &style->text[ 0 ];
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 0, 0, 0 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 30000, 30000, 30000 );

	color = &style->base[ 0 ];
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 65535, 65535, 65535 );
	init_color( color++, 60000, 60000, 60000 );

}
