#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gtk/gtk.h>

#include "main.h"
#include "modules.h"

GtkWidget *
create_main_window( GtkWidget *parent, const int realize )
{
	GtkWidget	*wgt_1_2, *wgt_2_3, *wgt_2_8, *wgt_3_10, 
				*wgt_4_11, *wgt_5_12, *wgt_6_14, *wgt_5_15, *wgt_6_17, 
				*wgt_5_18, *wgt_6_20, *wgt_2_23;

	wgt_wnd = gtk_widget_new( gtk_window_get_type(),
		"GtkWidget::width", 800,
		"GtkWidget::height", 518,
		"GtkWidget::events", 0x00000D0C,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkWindow::type", GTK_WINDOW_DIALOG,
		"GtkWindow::title", "greshold",
		"GtkWindow::allow_grow", TRUE,
		"GtkWindow::default_width", 640,
		"GtkWindow::default_height", 480,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_wnd ), "key_press_event",
		GTK_SIGNAL_FUNC( cb_wnd_keypress ), NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_wnd ), "key_release_event",
		GTK_SIGNAL_FUNC( cb_wnd_keyrelease ), NULL );

	wgt_1_2 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_wnd,
		"GtkWidget::width", 800,
		"GtkWidget::height", 518,
		NULL );

	wgt_2_3 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_3,
		"GtkBox::expand", FALSE,
		NULL );

	wgt_btn_play = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_3,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Play",
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_play ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_play_pressed ), NULL );

	wgt_btn_pause = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_3,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Pause",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_3 ), wgt_btn_pause,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_pause ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_pause_pressed ), NULL );

	wgt_btn_about = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_3,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "About",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_3 ), wgt_btn_about,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_about ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_about_pressed ), NULL );

	wgt_btn_quit = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_3,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Quit",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_3 ), wgt_btn_quit,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_quit ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_quit_pressed ), NULL );

	wgt_2_8 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_8,
		"GtkBox::position", 1,
		NULL );

	wgt_spacearea = gtk_widget_new( gtk_drawing_area_get_type(),
		"GtkWidget::parent", wgt_2_8,
		"GtkWidget::width", 640,
		"GtkWidget::height", 480,
		"GtkWidget::style", wgt_style_1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_spacearea ), "expose_event",
		GTK_SIGNAL_FUNC( cb_wgt_spacearea_expose ), NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_spacearea ), "configure_event",
		GTK_SIGNAL_FUNC( cb_wgt_spacearea_configure ), NULL );

	wgt_3_10 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_2_8,
		"GtkWidget::width", 160,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_8 ), wgt_3_10,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_4_11 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_3_10,
		"GtkWidget::width", 160,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		NULL );

	wgt_5_12 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_4_11,
		"GtkWidget::width", 48,
		"GtkContainer::border_width", 8,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_5_12,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 8,
		NULL );

	wgt_laser = gtk_widget_new( gtk_progress_bar_get_type(),
		"GtkWidget::parent", wgt_5_12,
		"GtkWidget::width", 32,
		"GtkProgressBar::adjustment", gtk_adjustment_new( 0.000000, 0.000000, 100.000000, 0.000000, 0.000000, 0.000000 ),
		"GtkProgressBar::orientation", GTK_PROGRESS_BOTTOM_TO_TOP,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_laser ), "configure_event",
		GTK_SIGNAL_FUNC( cb_laser_configure ), NULL );

	wgt_6_14 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_5_12,
		"GtkLabel::label", "Laser",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_5_12 ), wgt_6_14,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_5_15 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_4_11,
		"GtkWidget::width", 36,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_5_15,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_start = gtk_widget_new( gtk_drawing_area_get_type(),
		"GtkWidget::parent", wgt_5_15,
		"GtkWidget::width", 36,
		"GtkWidget::style", wgt_style_1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_start ), "expose_event",
		GTK_SIGNAL_FUNC( cb_start_expose ), NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_start ), "configure_event",
		GTK_SIGNAL_FUNC( cb_start_configure ), NULL );

	wgt_6_17 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_5_15,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_5_15 ), wgt_6_17,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_5_18 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_4_11,
		"GtkWidget::width", 48,
		"GtkContainer::border_width", 8,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_5_18,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 8,
		"GtkBox::position", 2,
		NULL );

	wgt_fuel = gtk_widget_new( gtk_progress_bar_get_type(),
		"GtkWidget::parent", wgt_5_18,
		"GtkWidget::style", wgt_style_5,
		"GtkProgressBar::adjustment", gtk_adjustment_new( 0.000000, 0.000000, 100.000000, 0.000000, 0.000000, 0.000000 ),
		"GtkProgressBar::orientation", GTK_PROGRESS_BOTTOM_TO_TOP,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_fuel ), "configure_event",
		GTK_SIGNAL_FUNC( cb_fuel_configure ), NULL );

	wgt_6_20 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_5_18,
		"GtkLabel::label", "Fuel",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_5_18 ), wgt_6_20,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_score = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_3_10,
		"GtkLabel::label", "Score",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_score,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 8,
		"GtkBox::position", 1,
		NULL );

	wgt_level = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_3_10,
		"GtkLabel::label", "Level",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_level,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 8,
		"GtkBox::position", 2,
		NULL );

	wgt_2_23 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_23,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 2,
		NULL );

	wgt_info_nbships = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_2_23,
		"GtkLabel::label", "Nb ships",
		NULL );

	wgt_info_frame = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_2_23,
		"GtkLabel::label", "Label",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_23 ), wgt_info_frame,
		"GtkBox::position", 1,
		NULL );

	if ( realize )
		gtk_widget_show_all( wgt_wnd );

	return wgt_wnd;

}								// create_main_window
