#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <sys/time.h>
#include <assert.h>

#include <gtk/gtk.h>

#define COMMON extern
#include "glg/main.h"

#include "glg/modules.h"

#define wgt_style_laser_ok 			wgt_style_3
#define wgt_style_laser_overheat	wgt_style_4

PUBLIC void 
update_laser( void )
{
	GtkStyle	*style;
	double		elapsed;

	/*--- Decrease laser ---*/
	if ( laser.prev_now != 0 )
	{
		elapsed = _now - laser.prev_now;
		if ( laser.level > 0 )
			laser.level -= (LASER_DEC * elapsed / 1000000.0);
		if ( laser.level < 0 )
			laser.level = 0;
	}							// if
	laser.prev_now = _now;

	/*--- Update style ? ---*/
	if ( laser.level >= LASER_OVERHEAT )
		laser.is_overheat = TRUE;
	else 
		if ( laser.level <= LASER_OK )
			laser.is_overheat = FALSE;
	style = (laser.is_overheat) ? wgt_style_laser_overheat : wgt_style_laser_ok;
	if ( style != laser.style )
	{
		laser.style = style;
		gtk_widget_set( GTK_WIDGET( wgt_laser ), 
			"GtkWidget::style", style,
			NULL );
	}

	/*--- Update laser level ---*/
	set_gauge_val( wgt_laser, laser.level );

}								// update_laser

/* Callback "configure_event" for GtkProgressBar widget wgt_laser */
gboolean
cb_laser_configure(GtkWidget *widget, GdkEventConfigure *event, gpointer user_data)
{
	return FALSE;
	
}								// cb_laser_configure
