extern	void level2_pos_funct( conf_ship_t *des );

#include "graphics/L1.0.xpm"
#include "graphics/L1.1.xpm"
#include "graphics/L1.2.xpm"
#include "graphics/L1.3.xpm"
#include "graphics/L1.4.xpm"
#include "graphics/L1.5.xpm"
#include "graphics/L1.6.xpm"

#include "graphics/L2.0.xpm"
#include "graphics/L2.1.xpm"
#include "graphics/L2.2.xpm"
#include "graphics/L2.3.xpm"
#include "graphics/L2.4.xpm"
#include "graphics/L2.5.xpm"
#include "graphics/L2.6.xpm"

#include "graphics/L3.0.xpm"
#include "graphics/L3.1.xpm"
#include "graphics/L3.2.xpm"

#include "graphics/L4.0.xpm"
#include "graphics/L4.1.xpm"
#include "graphics/L4.2.xpm"
#include "graphics/L4.3.xpm"

#include "graphics/L5.0.xpm"

#include "graphics/L6.0.xpm"
#include "graphics/L6.1.xpm"
#include "graphics/L6.2.xpm"

#include "graphics/L7.0.xpm"
#include "graphics/L7.1.xpm"
#include "graphics/L7.2.xpm"
#include "graphics/L7.3.xpm"
#include "graphics/L7.4.xpm"

#define XPM( LEVEL, INDEX ) \
	L##LEVEL##_##INDEX##_xpm,

conf_level_t	conf_levels[] =
{

	/*--- -------- ---*/
	/*--- Level #1 ---*/
	/*--- -------- ---*/

	{
	1,
	280,						// Fuel time (in seconds)
	1,							// Max nb of ships attacking at same time
	32,							// Max number of shells for this level
	4,							// Max number of missiles (cannon)

	{ {
	FALSE,						// Do the ships move grouped ?
	FALSE, FALSE,				// Scrolling left-right, Scrolling bottom-top
	FALSE,						// Do ships have the same state ?
	NULL,						// Function to place ships
	15, 15,						// Nb of ships (btw [n1..n2])
	TYPMOV_RANDOM,				// Type of movment
	PIXELS_SEC_MM(-220, 220),	
		MSEC(400), MSEC(1100),	// Generate a random X movement btw [x1, x2]
	PIXELS_SEC_MM(-160, 160),
		MSEC(400), MSEC(900),	// Generate a random X movement btw [x1, x2]
	145,						// Bottom gap btw the bottom and ship

	/*--- Description of the ships ---*/
	TRUE,						// State transition: 01232101232... or 012301230...
	7,							// Nb of states of each ship
	MSEC(20),					// State transition time
	{ {0, 0}, {-1, 1}, {0, 3}, {0, 0}, {0, 0}, {0, 0}, {1, 0} },
	10,							// Max nb of sec. of ship being hidden
	90, 80,						// % of chance to force ship inside if computed outside
	MSEC(3000),					// Time for a ship to be destroyed
	FALSE,						// Destroyed ships continue to drop shells ?

	/*--- Attack ---*/
	30,							// Shells drop: avg number / minute
	PIXELS_SEC_MM(100, 400),	// Speed of shells (between), in pixels/sec
	1,							// Frequency of the attacks: avg nb / minute
	MSEC(10000), MSEC(12000),	// Time (msec) for attack (descent)
	MSEC(8000), MSEC(10000),	// Time (msec) for attach (come back)
	-50, 50,					// Distance to the cannon (X)
	-30, 5,						// Distance to the cannon (Y)
	
	{ XPM(1, 0)  XPM(1, 1)  XPM(1, 2)  XPM(1, 3)   XPM(1, 4)  XPM(1, 5)  XPM(1, 6) },

	} }
	},
	

	/*--- -------- ---*/
	/*--- Level #2 ---*/
	/*--- -------- ---*/

	{
	1,
	280,						// Fuel time (in seconds)
	1,							// Max nb of ships attacking at same time
	24,							// Max number of shells for this level
	4,							// Max number of missiles (cannon)

	{ {
	TRUE,						// Do the ships move grouped ?
	TRUE, FALSE,				// Scrolling left-right, Scrolling bottom-top
	TRUE,						// Do ships have the same state ?
	level2_pos_funct,			// Function to place ships
	11, 11,						// Nb of ships (btw [n1..n2])
	TYPMOV_RANDOM,				// Type of movment
	PIXELS_SEC_MM(-200, 200),	
		MSEC(300), MSEC(1000),	// Generate a random X movement btw [x1, x2]
	PIXELS_SEC_MM(-150, 150),
		MSEC(400), MSEC(900),	// Generate a random X movement btw [x1, x2]
	160,						// Bottom gap btw the bottom and ship

	/*--- Description of the ships ---*/
	FALSE,						// State transition: 01232101232... or 012301230...
	7,							// Nb of states of each ship
	MSEC(20),					// State transition time
	{ {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0} },
	10,							// Max nb of sec. of ship being hidden
	0, 90,						// % of chance to force ship inside if computed outside
	MSEC(600),					// Time for a ship to be destroyed
	FALSE,						// Destroyed ships continue to drop shells ?

	/*--- Attack ---*/
	10,							// Shells drop: avg number / minute
	PIXELS_SEC_MM(100, 400),	// Speed of shells (between), in pixels/sec
	1,							// Frequency of the attacks: avg nb / minute
	MSEC(10000), MSEC(12000),	// Time (msec) for attack (descent)
	MSEC(8000), MSEC(10000),	// Time (msec) for attach (come back)
	-50, 50,					// Distance to the cannon (X)
	-30, 5,						// Distance to the cannon (Y)

	{ XPM(2, 0)  XPM(2, 1)  XPM(2, 2)  XPM(2, 3)   XPM(2, 4)  XPM(2, 5)  XPM(2, 6) },

	} }
	},


	/*--- -------- ---*/
	/*--- Level #3 ---*/
	/*--- -------- ---*/

	{
	1,
	280,						// Fuel time (in seconds)
	1,							// Max nb of ships attacking at same time
	50,							// Max number of shells for this level
	4,							// Max number of missiles (cannon)

	{ {
	FALSE,						// Do the ships move grouped ?
	FALSE, FALSE,				// Scrolling left-right, Scrolling bottom-top
	FALSE,						// Do ships have the same state ?
	NULL,						// Function to place ships
	16, 16,						// Nb of ships (btw [n1..n2])
	TYPMOV_ELLIPSE,				// Type of movment
	PIXELS_SEC_MM(-300, 300),	
		MSEC(300), MSEC(1000),	// Generate a random X movement btw [x1, x2]
	PIXELS_SEC_MM(-150, 150),
		MSEC(400), MSEC(900),	// Generate a random X movement btw [x1, x2]
	190,						// Bottom gap btw the bottom and ship

	/*--- Description of the ships ---*/
	FALSE,						// State transition: 01232101232... or 012301230...
	3,							// Nb of states of each ship
	MSEC(50),					// State transition time
	{ {0, 0}, {0, 0}, {0, 0} },
	10,							// Max nb of sec. of ship being hidden
	90, 90,						// % of chance to force ship inside if computed outside
	MSEC(600),					// Time for a ship to be destroyed
	FALSE,						// Destroyed ships continue to drop shells ?

	/*--- Attack ---*/
	11,							// Shells drop: avg number / minute
	PIXELS_SEC_MM(100, 400),	// Speed of shells (between), in pixels/sec
	1,							// Frequency of the attacks: avg nb / minute
	MSEC(10000), MSEC(12000),	// Time (msec) for attack (descent)
	MSEC(8000), MSEC(10000),	// Time (msec) for attach (come back)
	-50, 50,					// Distance to the cannon (X)
	-30, 5,						// Distance to the cannon (Y)

	{ XPM(3, 0)  XPM(3, 1)  XPM(3, 2) },

	} }
	},


	/*--- -------- ---*/
	/*--- Level #4 ---*/
	/*--- -------- ---*/

	{
	1,
	280,						// Fuel time (in seconds)
	1,							// Max nb of ships attacking at same time
	44,							// Max number of shells for this level
	4,							// Max number of missiles (cannon)

	{ {
	FALSE,						// Do the ships move grouped ?
	TRUE, TRUE, 				// Scrolling left-right, Scrolling bottom-top
	FALSE,						// Do ships have the same state ?
	NULL,						// Function to place ships
	9, 9, 						// Nb of ships (btw [n1..n2])
	TYPMOV_RANDOM,				// Type of movment
	PIXELS_SEC_MM(-300, 150),	
		MSEC(300), MSEC(1000),	// Generate a random X movement btw [x1, x2]
	PIXELS_SEC_MM(-140, 150),
		MSEC(400), MSEC(900),	// Generate a random X movement btw [x1, x2]
	190,						// Bottom gap btw the bottom and ship

	/*--- Description of the ships ---*/
	TRUE,						// State transition: 01232101232... or 012301230...
	4,							// Nb of states of each ship
	MSEC(30),					// State transition time
	{ {0, 0}, {1, -1}, {1, -3}, {3, -2} },
	10,							// Max nb of sec. of ship being hidden
	0, 0,						// % of chance to force ship inside if computed outside
	MSEC(600),					// Time for a ship to be destroyed
	TRUE,						// Destroyed ships continue to drop shells ?

	/*--- Attack ---*/
	14,							// Shells drop: avg number / minute
	PIXELS_SEC_MM(100, 400),	// Speed of shells (between), in pixels/sec
	1,							// Frequency of the attacks: avg nb / minute
	MSEC(10000), MSEC(12000),	// Time (msec) for attack (descent)
	MSEC(8000), MSEC(10000),	// Time (msec) for attach (come back)
	-50, 50,					// Distance to the cannon (X)
	-30, 5,						// Distance to the cannon (Y)

	{ XPM(4, 0)  XPM(4, 1)  XPM(4, 2) XPM(4, 3) },

	} }
	},
	

	/*--- -------- ---*/
	/*--- Level #5 ---*/
	/*--- -------- ---*/

	{
	1,
	280,						// Fuel time (in seconds)
	2,							// Max nb of ships attacking at same time
	64,							// Max number of shells for this level
	4,							// Max number of missiles (cannon)

	{ {
	FALSE,						// Do the ships move grouped ?
	TRUE, FALSE,				// Scrolling left-right, Scrolling bottom-top
	FALSE,						// Do ships have the same state ?
	NULL,						// Function to place ships
	9, 9,						// Nb of ships (btw [n1..n2])
	TYPMOV_RANDOM,				// Type of movment
	PIXELS_SEC_MM(120, 350),	
		MSEC(250), MSEC(1200),	// Generate a random X movement btw [x1, x2]
	PIXELS_SEC_MM(-160, 160),
		MSEC(400), MSEC(900),	// Generate a random X movement btw [x1, x2]
	120,						// Bottom gap btw the bottom and ship

	/*--- Description of the ships ---*/
	TRUE,						// State transition: 01232101232... or 012301230...
	1,							// Nb of states of each ship
	MSEC(20),					// State transition time
	{ {0, 0} },
	12,							// Max nb of sec. of ship being hidden
	0, 0,						// % of chance to force ship inside if computed outside
	MSEC(600),					// Time for a ship to be destroyed
	FALSE,						// Destroyed ships continue to drop shells ?

	/*--- Attack ---*/
	45,							// Level of agressivity (shell drop)
	PIXELS_SEC_MM(100, 400),	// Speed of shells (between), in pixels/sec
	3,							// Frequency of the attacks: avg nb / minute
	MSEC(8000), MSEC(12000),	// Time (msec) for attack (descent)
	MSEC(7000), MSEC(9000),		// Time (msec) for attach (come back)
	-40, 40,					// Distance to the cannon (X)
	-20, 3,						// Distance to the cannon (Y)

	{ XPM(5, 0)  },

	} }
	},


	/*--- -------- ---*/
	/*--- Level #6 ---*/
	/*--- -------- ---*/

	{
	1,
	280,						// Fuel time (in seconds)
	5,							// Max nb of ships attacking at same time
	70,							// Max number of shells for this level
	4,							// Max number of missiles (cannon)

	{ {
	FALSE,						// Do the ships move grouped ?
	FALSE, FALSE,				// Scrolling left-right, Scrolling bottom-top
	FALSE,						// Do ships have the same state ?
	NULL,						// Function to place ships
	9, 9,						// Nb of ships (btw [n1..n2])
	TYPMOV_RANDOM,				// Type of movment
	PIXELS_SEC_MM(-300, 300),	
		MSEC(300), MSEC(1000),	// Generate a random X movement btw [x1, x2]
	PIXELS_SEC_MM(-150, 150),
		MSEC(400), MSEC(900),	// Generate a random X movement btw [x1, x2]
	120,						// Bottom gap btw the bottom and ship

	/*--- Description of the ships ---*/
	TRUE,						// State transition: 01232101232... or 012301230...
	3,							// Nb of states of each ship
	MSEC(20),					// State transition time
	{ {0, 0}, {0, 0}, {-1, 0} },
	12,							// Max nb of sec. of ship being hidden
	90, 90,						// % of chance to force ship inside if computed outside
	MSEC(600),					// Time for a ship to be destroyed
	TRUE,						// Destroyed ships continue to drop shells ?

	/*--- Attack ---*/
	60,							// Level of agressivity (shell drop)
	PIXELS_SEC_MM(100, 400),	// Speed of shells (between), in pixels/sec
	8,							// Frequency of the attacks: avg nb / minute
	MSEC(8000), MSEC(12000),	// Time (msec) for attack (descent)
	MSEC(7000), MSEC(9000),		// Time (msec) for attach (come back)
	-40, 40,					// Distance to the cannon (X)
	-20, 3,						// Distance to the cannon (Y)

	{ XPM(6, 0)  XPM(6, 1)  XPM(6, 2) },

	} }
	},


	/*--- -------- ---*/
	/*--- Level #7 ---*/
	/*--- -------- ---*/

	{
	1,
	280,						// Fuel time (in seconds)
	1,							// Max nb of ships attacking at same time
	60,							// Max number of shells for this level
	4,							// Max number of missiles (cannon)

	{ {
	FALSE,						// Do the ships move grouped ?
	FALSE, FALSE,				// Scrolling left-right, Scrolling bottom-top
	FALSE,						// Do ships have the same state ?
	NULL,						// Function to place ships
	9, 9,						// Nb of ships (btw [n1..n2])
	TYPMOV_RANDOM,				// Type of movment
	PIXELS_SEC_MM(-300, 300),	
		MSEC(300), MSEC(1000),	// Generate a random X movement btw [x1, x2]
	PIXELS_SEC_MM(-150, 150),
		MSEC(400), MSEC(900),	// Generate a random X movement btw [x1, x2]
	120,						// Bottom gap btw the bottom and ship

	/*--- Description of the ships ---*/
	TRUE,						// State transition: 01232101232... or 012301230...
	5,							// Nb of states of each ship
	MSEC(100),					// State transition time
	{ {0, 0}, {0, 3}, {0, 4}, {-1, 0}, {1, 0} },
	10,							// Max nb of sec. of ship being hidden
	90, 90,						// % of chance to force ship inside if computed outside
	MSEC(600),					// Time for a ship to be destroyed
	TRUE,						// Destroyed ships continue to drop shells ?

	/*--- Attack ---*/
	60,							// Level of agressivity (shell drop)
	PIXELS_SEC_MM(100, 400),	// Speed of shells (between), in pixels/sec
	8,							// Frequency of the attacks: avg nb / minute
	MSEC(8000), MSEC(12000),	// Time (msec) for attack (descent)
	MSEC(7000), MSEC(9000),		// Time (msec) for attach (come back)
	-40, 40,					// Distance to the cannon (X)
	-20, 3,						// Distance to the cannon (Y)

	{ XPM(7, 0)  XPM(7, 1)  XPM(7, 2)  XPM(7, 3)   XPM(7, 4)  },

	} }
	},


#if 0	
	/*--- -------- ---*/
	/*--- Level #8 ---*/
	/*--- -------- ---*/

	{
	1,
	280,					// Fuel time (in seconds)
	3,						// Max nb of ships attacking at same time
	30,						// Max number of shells for this level
	1,							// Max number of missiles (cannon)

	{ {
	8,						// No of the bitmap
	FALSE,					// Do the ships move grouped ?
	FALSE, FALSE,			// Scrolling left-right, Scrolling bottom-top
	FALSE,					// Do ships have the same state ?
	NULL,					// Function to place ships
	13, 13,					// Nb of ships (btw [n1..n2])
	0, 0, 1, 1,	// Generate a random X movement btw [x1, x2]
	0, 0,  1, 1,			// Generate a random X movement btw [x1, x2]
//	-5000, 5000, 500, 500,	// Generate a random X movement btw [x1, x2]
//	-10, 10,  3, 5,			// Generate a random X movement btw [x1, x2]
	180,					// Bottom gap btw the bottom and ship

	/*--- Description of the ships ---*/
	FALSE,					// State transition: 01232101232... or 012301230...
	24,						// Nb of states of each ship
	{ {0, 0}, {0, 3}, {0, 3}, {0, 3}, {0, 5}, {0, 0}, {0, 1}, {-1, 0}, {-1, 0}, {-4, 0 },
	  {0, 0}, {-7, 0}, {-3, 0}, {-2, -1}, {-1, -1}, {1, -4}, {0, -4}, {1, -4}, {2, -3},
	  {3, -1}, {3, -1}, {3, 1}, {4, 0}, {1+1, 1+2} },
	10,						// Max nb of sec. of ship being hidden

	/*--- Attack ---*/
	100,					// Level of agressivity (shell drop)
	3, 4,					// Speed of shells (between)
	600,					// Frequency of the attacks

	} }
	},

	
	/*--- -------- ---*/
	/*--- Level #9 ---*/
	/*--- -------- ---*/

	{
	1,
	280,					// Fuel time (in seconds)
	2,						// Max nb of ships attacking at same time
	10,						// Max number of shells for this level
	1,							// Max number of missiles (cannon)

	{ {
	9,						// No of the bitmap
	TRUE,					// Do the ships move grouped ?
	TRUE, FALSE,			// Scrolling left-right, Scrolling bottom-top
	FALSE,					// Do ships have the same state ?
	NULL,					// Function to place ships
	14, 14,					// Nb of ships (btw [n1..n2])
	18, 21, 2, 2,			// Generate a random X movement btw [x1, x2]
	-10, 10,  3, 5,			// Generate a random X movement btw [x1, x2]
	180,					// Bottom gap btw the bottom and ship

	/*--- Description of the ships ---*/
	TRUE,					// State transition: 01232101232... or 012301230...
	6,						// Nb of states of each ship
	{ {0, 0}, {0, 1}, {0, 1}, {0, 1}, {0, 1}, {0, 1} },
	0,						// Max nb of sec. of ship being hidden

	/*--- Attack ---*/
	120,					// Level of agressivity (shell drop)
	3, 4,					// Speed of shells (between)
	350,					// Frequency of the attacks

	} }
	},

	
	/*--- --------- ---*/
	/*--- Level #10 ---*/
	/*--- --------- ---*/

	{
	2,
	280,					// Fuel time (in seconds)
	1,						// Max nb of ships attacking at same time
	36,						// Max number of shells for this level
	1,							// Max number of missiles (cannon)

	// SET #1
	{ {
	1,						// No of the bitmap
	FALSE,					// Do the ships move grouped ?
	FALSE, FALSE,			// Scrolling left-right, Scrolling bottom-top
	FALSE,					// Do ships have the same state ?
	NULL,					// Function to place ships
	4, 4,  					// Nb of ships (btw [n1..n2])
	-128, 128,  16, 32,		// Generate a random X movement btw [x1, x2]
	-24, 24,  5, 8,			// Generate a random X movement btw [x1, x2]
	120,					// Bottom gap btw the bottom and ship

	/*--- Description of the ships ---*/
	TRUE,					// State transition: 01232101232... or 012301230...
	7,						// Nb of states of each ship
	{ {0, 0}, {-1, 1}, {0, 3}, {0, 0}, {0, 0}, {0, 0}, {1, 0} },
	10,						// Max nb of sec. of ship being hidden

	/*--- Attack ---*/
	110,					// Level of agressivity (shell drop)
	3, 5,					// Speed of shells (between)
	500,					// Frequency of the attacks
	},

	// SET #2
	{
	2,						// No of the bitmap
	TRUE,					// Do the ships move grouped ?
	TRUE, FALSE,			// Scrolling left-right, Scrolling bottom-top
	TRUE,					// Do ships have the same state ?
	level2_pos_funct,		// Function to place ships
	11, 11,					// Nb of ships (btw [n1..n2])
	18, 24, 2, 2,			// Generate a random X movement btw [x1, x2]
	-12, 12,  3, 5,			// Generate a random X movement btw [x1, x2]
	200,					// Bottom gap btw the bottom and ship

	/*--- Description of the ships ---*/
	FALSE,					// State transition: 01232101232... or 012301230...
	7,						// Nb of states of each ship
	{ {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0} },
	10,						// Max nb of sec. of ship being hidden

	/*--- Attack ---*/
	90,						// Level of agressivity (shell drop)
	3, 4,					// Speed of shells (between)
	500,					// Frequency of the attacks

	} }

	},
#endif	

	};

#undef XPM

