#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <sys/time.h>
#include <math.h>
#include <assert.h>

#include <gtk/gtk.h>

#define COMMON extern
#include "glg/main.h"

#include "glg/modules.h"

#include <gdk/gdkkeysyms.h>

#include "graphics/mother.xpm"


PUBLIC void
load_mother( void )
{
	GdkBitmap	*mask;

	mother.img_des = gdk_pixmap_create_from_xpm_d( wgt_spacearea->window,
		&mask, &BACKGROUND, mother_xpm );
	assert( mother.img_des != NULL );
	gdk_window_get_size( (GdkWindow *)mother.img_des,
		&mother.w, &mother.h );

	mother.is_active = FALSE;

}								// load_mother


PUBLIC void
start_mother( const int start_a_cannon )
{

	mother.start_a_cannon = start_a_cannon;
	
	mother.x = (frame_width - mother.w) / 2;
	mother.y = -mother.h;

	mother.is_active = TRUE;
	mother.going_down  = TRUE;
	mother.refill_fuel = FALSE;
	mother.going_up    = FALSE;

	set_gauge_minmax( wgt_fuel, 0, 1000 );

}								// start_mother


PUBLIC void
end_mother( void )
{

	mother.is_active = FALSE;
	start_new_level( mother.start_a_cannon );

}								// end_mother


PUBLIC void
draw_mother( void )
{

	if ( mother.going_down )
	{
		mother.y += (frame_duration * MOTHER_GOING_DOWN_YSPEED);
		if ( mother.y >= (frame_height - mother.h) )
		{
			mother.y = frame_height - mother.h;
			mother.going_down  = FALSE;
			mother.refill_fuel = TRUE;
fuel.level = 0;
		}
	}
	else if ( mother.refill_fuel )
	{
			fuel.level += (frame_duration / MOTHER_REFILL_FUEL_SPEED);
			if ( fuel.level <= 1000 )
			{
				set_gauge_val( wgt_fuel, fuel.level );
			}
			else
			{
				set_gauge_val( wgt_fuel, 1000 );
				mother.refill_fuel = FALSE;
				mother.going_up    = TRUE;
			}
	}
	else if ( mother.going_up )
	{
		mother.y -= (frame_duration * MOTHER_GOING_UP_YSPEED);
		if ( mother.y < -mother.h )
		{
			mother.going_up = FALSE;
			end_mother();
		}
	}
	else 
		assert( 0 );

	/*--- Draw the missile to the frame buffer ---*/
	gdk_draw_pixmap( pixmap_frame, 
		BACKGROUND_GC,
		mother.img_des,
		0, 0, mother.x, mother.y,
		mother.w, mother.h );

}								// draw_mother
