#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <sys/time.h>
#include <assert.h>

#include <gtk/gtk.h>

#define COMMON extern
#include "glg/main.h"

#include "glg/modules.h"

#include <gdk/gdkkeysyms.h>

#include "graphics/star.0.xpm"
#include "graphics/star.1.xpm"
#include "graphics/star.2.xpm"
#include "graphics/star.3.xpm"
#include "graphics/star.4.xpm"
#include "graphics/star.5.xpm"


PUBLIC void
load_stars( void )
{
	GdkBitmap	*mask;

#define LOAD( N ) \
	pixmap_stars[ N ] = gdk_pixmap_create_from_xpm_d( wgt_spacearea->window, \
		&mask, &BACKGROUND, star_##N##_xpm ); \
	assert( pixmap_stars[ N ] != NULL )

	LOAD( 0 );
	LOAD( 1 );
	LOAD( 2 );
	LOAD( 3 );
	LOAD( 4 );
	LOAD( 5 );
	
#undef LOAD

}								// load_stars


PUBLIC void
put_stars( void )
{
	star_t		*star;
	int			n;

	nb_stars = RND( 4, MAXNB_STARS );
	for ( star = stars, n = 0; n < nb_stars; n++, star++ )
	{
		star->x = RND( STAR_WIDTH + 1, frame_width - STAR_WIDTH - 1);
		star->y = RND( STAR_HEIGHT + 1, frame_height - STAR_HEIGHT - 1);
		star->state = RND( 1, STAR_NBSTATES - 2 );
		star->inc   = 2*RND( 0, 1) - 1;
		star->yinc = FRND( STAR_YSPEED_MIN, STAR_YSPEED_MAX );
	}

}								// put_stars


PUBLIC void 
draw_stars( void )
{
	star_t		*star;
	int			n;
	double		yinc;

	for ( star = stars, n = 0; n < nb_stars; n++, star++ )
	{

		/*--- Draw the star to the frame buffer ---*/
		gdk_draw_pixmap( pixmap_frame, 
			BACKGROUND_GC,
			pixmap_stars[ star->state ],
			0, 0, star->x, star->y,
			STAR_WIDTH, STAR_HEIGHT );

		/*--- How many pixels by frame ---*/
		yinc = frame_duration * star->yinc;

		/*--- Compute the new state of the ship ---*/
		if ( RND( 0, 10 ) == 5 )
		{
			if ( star->inc == 1 )
			{
				if ( ++star->state == STAR_NBSTATES )
				{
					star->state -= 2;
					star->inc = -1;
				}
			}
			else
			{
				if ( !star->state-- )
				{
					star->state += 2;
					star->inc = 1;
				}
			}
		}

		/*--- Move down the star ? ---*/
		star->y += yinc;
		if ( star->y > frame_height )
		{
			star->x = RND( STAR_WIDTH + 1, frame_width - STAR_WIDTH - 1);
			star->y = 0;
			star->state = RND( 1, STAR_NBSTATES-2 );
			star->inc   = 2 * RND( 0, 1) - 1;
			star->yinc = FRND( STAR_YSPEED_MIN, STAR_YSPEED_MAX );
		}

	}							// for (star)
	
}								// draw_stars
