#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>
#include <sched.h>
#include <assert.h>

#include <gtk/gtk.h>

#define __STARTUP__
#include "glg/main.h"

#include "glg/modules.h"


static void 
my_glog( const gchar *log_domain,
	GLogLevelFlags log_level,
	const gchar *message,
	gpointer user_data)
{
	g_log_default_handler( log_domain, log_level, message, user_data );
}								// my_glog


PUBLIC void 
startup( int argc, char *argv[] )
{
#if 0
	struct sched_param	param;	
#endif
	int					n;

	g_log_set_handler( "Gtk", 
		G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL, 
		my_glog, NULL );
	g_log_set_handler( "Gdk", 
		G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL, 
		my_glog, NULL );
	g_log_set_handler( "GLib", 
		G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL, 
		my_glog, NULL );
	g_log_set_handler( NULL, 
		G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_FLAG_FATAL, 
		my_glog, NULL );

#if 0
	memset( &param, 0, sizeof( struct sched_param ) );
	sched_getparam( 0, &param );
	printf( "%d %d %d %d %d\n",
		SCHED_FIFO, SCHED_RR, SCHED_OTHER, 
		param.sched_priority, 
		sched_get_priority_max(SCHED_FIFO) );
	param.sched_priority = sched_get_priority_max( SCHED_FIFO ); 
	printf( "%d\n", sched_setscheduler( 0, SCHED_FIFO, &param ) );
	sched_setparam( 0, &param );
#endif

	gdk_rgb_init();
	gtk_widget_set_default_colormap( gdk_rgb_get_cmap() );
	gtk_widget_set_default_visual( gdk_rgb_get_visual() );

	/*--- Testing level ? ---*/
	testing_level = -1;
	for ( n = 1; n < argc; n++ )
	{
		if ( !strcmp( argv[ n ], "TestLevel#" ) )
		{
			testing_level = atoi( argv[ n+1 ] ) - 1;
			if ( (testing_level < 0) || (testing_level >= nb_levels) )
				testing_level = -1;
			break;
		}
	}

	create_main_window( NULL, TRUE );

}								// startup

