#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <inttypes.h>
#include <unistd.h>

#include <gtk/gtk.h>

#include "main.h"
#include "modules.h"

GtkWidget *
create_matches( GtkWidget *parent, const int realize )
{
	GtkWidget	*wgt_1_2, *wgt_2_3, *wgt_2_5, *wgt_4_7, *wgt_4_8, 
				*wgt_3_14, *wgt_3_15, *wgt_4_16, *wgt_4_17;

	matches = gtk_widget_new( gtk_window_get_type(),
		"GtkWidget::width", 463,
		"GtkWidget::height", 290,
		"GtkWidget::events", 0x0000030C,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkWindow::title", "wgt_window",
		"GtkWindow::allow_grow", TRUE,
		"GtkWindow::default_width", 450,
		"GtkWindow::default_height", 290,
		NULL );

	wgt_1_2 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", matches,
		NULL );

	wgt_2_3 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkLabel::label", "Blow 1,2 or 3 matches.
\nThe one who blow the last one has lost!.",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_3,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 4,
		NULL );

	wgt_field = gtk_widget_new( gtk_drawing_area_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_field,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_field ), "expose_event",
		GTK_SIGNAL_FUNC( cb_field_expose ), NULL );

	wgt_2_5 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_5,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 2,
		NULL );

	wgt_user_play = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_2_5,
		"GtkWidget::height", 64,
		"GtkContainer::border_width", 8,
		"GtkBox::spacing", 8,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_5 ), wgt_user_play,
		"GtkBox::fill", FALSE,
		NULL );

	wgt_4_7 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_user_play,
		"GtkLabel::label", "How many matches\ndo you blow ?",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_user_play ), wgt_4_7,
		"GtkBox::expand", FALSE,
		NULL );

	wgt_4_8 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_user_play,
		"GtkBox::homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_user_play ), wgt_4_8,
		"GtkBox::position", 1,
		NULL );

	wgt_btn_blow1 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_8,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Blow\none match",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_8 ), wgt_btn_blow1,
		"GtkBox::expand", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_blow1 ), "clicked",
		GTK_SIGNAL_FUNC( cb_blow_match1 ), NULL );

	wgt_btn_blow2 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_8,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Blow\ntwo matches",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_8 ), wgt_btn_blow2,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_blow2 ), "clicked",
		GTK_SIGNAL_FUNC( cb_blow_match2 ), NULL );

	wgt_btn_blow3 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_4_8,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Blow\nthree matches",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_8 ), wgt_btn_blow3,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_blow3 ), "clicked",
		GTK_SIGNAL_FUNC( cb_blow_match3 ), NULL );

	wgt_computer_play = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_2_5,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_5 ), wgt_computer_play,
		"GtkBox::position", 1,
		NULL );

	wgt_whobegins = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkWidget::height", 48,
		"GtkContainer::border_width", 8,
		"GtkBox::spacing", 8,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_whobegins,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 3,
		NULL );

	wgt_3_14 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_whobegins,
		"GtkLabel::label", "Do you want to start ?",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_whobegins ), wgt_3_14,
		"GtkBox::expand", FALSE,
		NULL );

	wgt_3_15 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_whobegins,
		"GtkBox::spacing", 4,
		"GtkBox::homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_whobegins ), wgt_3_15,
		"GtkBox::position", 1,
		NULL );

	wgt_4_16 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_3_15,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Yes",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_15 ), wgt_4_16,
		"GtkBox::expand", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_4_16 ), "clicked",
		GTK_SIGNAL_FUNC( cb_start_user ), NULL );

	wgt_4_17 = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_3_15,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "No",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_15 ), wgt_4_17,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_4_17 ), "clicked",
		GTK_SIGNAL_FUNC( cb_start_computer ), NULL );

	if ( realize )
		gtk_widget_show_all( matches );

	return matches;

}								// create_matches
