/*


*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


PUBLIC void
_check_default_values( const int pass )
{
	gtk_wgtdef_t	**wgtdef, *w;
	gtk_wgtdef_t	*wgtdef_depth;
	GtkWidget		*wgt_window;
	GtkWidget		*wgt_new;
	GtkWidget		*wgt_child;
	defclass_t		*classes, *p;
	int				depth, n;
	int				nb_res;
	int				is_container;

	INIT_ARGS;
	SETARG_INT( "x", 0 );
	SETARG_INT( "y", 0 );
	SETARG_INT( "width", 1000 );
	SETARG_INT( "height", 800 );
	wgt_window = gtk_widget_newv( gtk_window_get_type(), nb_args, args );
	gtk_widget_realize( wgt_window );

	for ( wgtdef = (gtk_wgtdef_t **)gtk_wgtdef; (w = *wgtdef) != NULL; wgtdef++ )
	{

		/*--- Is-it a GTkWindow widget ? ---*/
		for ( w->is_window = FALSE, depth = 0; 
			  (depth < MAXNB_HIERARCHIES) && (w->def[ depth ].classnames != NULL); 
			  depth++ )
		{
			if ( !strcmp( w->def[ depth ].classnames, "GtkWindow" ) )
			{
				w->is_window = TRUE;
				break;
			}
		}

		if ( w->which_palette == -1 )
			continue;

		/*--- Create a placeholder widget ---*/
		INIT_ARGS;
		SETARG_INT( "x", 0 );
		SETARG_INT( "y", 0 );
		SETARG_INT( "width", 1000 );
		SETARG_INT( "height", 800 );
		if ( !w->is_window )
		{
			SETARG_OBJECT( GTK_TYPE_CONTAINER, "GtkWidget::parent", wgt_window );
		}
		wgt_new = gtk_widget_newv( w->pfct_get_widget_type(), nb_args, args );
		assert( wgt_new != NULL );
		gtk_widget_realize( wgt_new );
		set_outsideres_function( wgt_new, w );

#if 0
		if ( GTK_IS_CONTAINER(wgt_new) )
			trace( "%s\n", gtk_widget_get_name(wgt_new) );
#endif

		for ( depth = 0; 
			  (depth < MAXNB_HIERARCHIES) && (w->def[ depth ].classnames != NULL); 
			  depth++ )
		{

			wgtdef_depth = w->def[depth].wgtdef_depth;

			classes = w->def[ depth ].classes;
			nb_res  = w->def[ depth ].nb_classes;
			for ( p = classes, n = 0; n < nb_res; n++, p++ )
			{
				p->f_child = FALSE;
				p->wgtdef_depth = wgtdef_depth;
				if ( !p->f_generate )
					continue;
				if ( (pass == 0) &&
					 ((p->saved_where == SAVED_INSIDE) || (p->saved_where == SAVED_OUTSIDE_FUNCTION) || (p->saved_where == SAVED_OUTSIDE)) )
				{
					p->arg_default.type = p->restype;
					p->arg_default.name = p->resname;
					gtk_widget_get( GTK_WIDGET(wgt_new), &p->arg_default );
				}
				else if ( (pass == 1) && (p->saved_where == SAVED_FUNCTION) )
				{
					GtkArg	arg, *parg;
					if ( (*wgtdef_depth->pfct_getdlg)(p, wgt_new, &arg) == NULL )
						parg = get_outsideres_wgt( wgt_new, p->resname );
					else
						parg = &arg;
					assert( parg != NULL );
					gtk_arg_copy( parg, &p->arg_default );
				}
			}					// for (p)

			/*--- Dump all resources ---*/
			if ( pass == 0 )
			{
				classes = w->def[depth].classes_child;
				nb_res  = w->def[depth].nb_classes_child;
				if (nb_res == 0)
					continue;
				wgt_child = gtk_type_new( GTK_TYPE_LABEL );
				assert( wgt_child != NULL );
				INIT_ARGS;
				SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_new );
				gtk_widget_setv( wgt_child, nb_args, args );
				for ( p = classes, n = 0; n < nb_res; n++, p++ )
				{
					p->f_child = TRUE;
					p->wgtdef_depth = wgtdef_depth;
					if ( !p->f_generate )
						continue;
					p->arg_default.type = p->restype;
					p->arg_default.name = p->resname;
					gtk_container_child_getv( GTK_CONTAINER(wgt_new), GTK_WIDGET(wgt_child), 1, &p->arg_default );
				}			  	// for (p)
				gtk_widget_destroy(wgt_child);
			}					// if

		}						// for (depth)

#if 0
		/*--- Is position/size possible ? ---*/
		if ( GTK_IS_CONTAINER( wgt_new ) )
		{
			gint	x2, y2, w2, h2;
			gint	x3, y3, w3, h3, depth;

			INIT_ARGS;
			SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_new );
			wgt_child = gtk_widget_newv( gtk_label_get_type, nb_args, args );
			assert( wgt_child != NULL );
			gtk_widget_realize( wgt_child );
			gdk_window_move_resize( wgt_child->window, 12, 23, 100, 80 );

			gdk_window_get_position( wgt_child->window, &x2, &y2 );
			gdk_window_get_size( wgt_child->window, &w2, &h2 );
			gdk_window_get_geometry( wgt_child->window, &x3, &y3, &w3, &h3, &depth );
#if 0
			trace( "%-18s: %4d,%4d,%4d,%4d  %4d,%4d,%4d,%4d\n",
				gtk_widget_get_name(wgt_new), 
				x2, y2, w2, h2,
				x3, y3, w3, h3 );
#endif

			if ( x2==12 && y2==23 )
				w->f_children_posable = TRUE;
			else
				w->f_children_posable = FALSE;

			if ( w2==100 && h2==80 )
				w->f_children_dimable = TRUE;
			else
				w->f_children_dimable = FALSE;

			gtk_widget_destroy( wgt_child );
			
		}						// if
#endif

		/*--- Not Window for this widget ? ---*/
		w->gtk_no_window = GTK_WIDGET_NO_WINDOW( wgt_new );

		is_container = GTK_IS_CONTAINER( wgt_new );
		gtk_widget_destroy( wgt_new );

	}							// for

	gtk_widget_destroy( wgt_window );

}								// _check_default_values


PUBLIC void
check_default_values( void )
{
	int	 pass;
	
	for ( pass = 0; pass < 2; pass++ )
		_check_default_values( pass );
	
}								// check_default_values



PUBLIC int
is_default_value( GtkWidget *wgt, GtkWidget *wgt_parent, 
	gtk_wgtdef_t *wgtdef, defclass_t *p )
{
	GtkArg	arg, *parg=NULL;

	/*--- First read current value for this resource ---*/
	if ( p->saved_where == SAVED_INSIDE )
	{
		memset( &arg, 0, sizeof(GtkArg) );
		arg.type = p->restype;
		arg.name = p->resname;
		if ( !p->f_child )
			gtk_widget_get( GTK_WIDGET(wgt), &arg );
		else
			gtk_container_child_getv( GTK_CONTAINER(wgt_parent), GTK_WIDGET( wgt ), 1, &arg );
		parg = &arg;
	}
	else if ( p->saved_where == SAVED_OUTSIDE || p->saved_where == SAVED_OUTSIDE_FUNCTION )
	{
		parg = get_outsideres_wgt( wgt, p->resname );
		assert( parg != NULL );
	}
	else if ( p->saved_where == SAVED_FUNCTION )
	{
		memset( &arg, 0, sizeof(GtkArg) );
		arg.type = p->restype;
		if ( (*wgtdef->pfct_getdlg)(p, wgt, &arg) == NULL )
			parg = get_outsideres_wgt( wgt, p->resname );
		else
			parg = &arg;
		assert( parg != NULL );
	}

	switch ( p->restype )
	{
		case GTK_TYPE_BOOL :
			return (GTK_VALUE_BOOL(parg[0]) == GTK_VALUE_BOOL(p->arg_default));
		case GTK_TYPE_INT :
			return (GTK_VALUE_INT(parg[0]) == GTK_VALUE_INT(p->arg_default));
		case GTK_TYPE_UINT :
			return (GTK_VALUE_UINT(parg[0]) == GTK_VALUE_UINT(p->arg_default));
		case GTK_TYPE_LONG :
			return (GTK_VALUE_LONG(parg[0]) == GTK_VALUE_LONG(p->arg_default));
		case GTK_TYPE_ULONG :
			return (GTK_VALUE_ULONG(parg[0]) == GTK_VALUE_ULONG(p->arg_default));
		case GTK_TYPE_FLOAT :
			return (GTK_VALUE_FLOAT(parg[0]) == GTK_VALUE_FLOAT(p->arg_default));
		case GTK_TYPE_STRING :
			if ( GTK_VALUE_STRING(parg[0]) && GTK_VALUE_STRING(p->arg_default) )
				return (!strcmp( GTK_VALUE_STRING(parg[0]), GTK_VALUE_STRING(p->arg_default))) ? TRUE : FALSE;
			else
				return ( GTK_VALUE_STRING(parg[0]) == GTK_VALUE_STRING(p->arg_default) );
		case GTK_TYPE_ENUM :
			return (GTK_VALUE_ENUM(parg[0]) == GTK_VALUE_ENUM(p->arg_default));
		case GTK_TYPE_FLAGS :
			return (GTK_VALUE_FLAGS(parg[0]) == GTK_VALUE_FLAGS(p->arg_default));
		case GTK_TYPE_OBJECT :
			return (GTK_VALUE_OBJECT(parg[0]) == GTK_VALUE_OBJECT(p->arg_default));
		case GTK_TYPE_POINTER :
			return (GTK_VALUE_POINTER(parg[0]) == GTK_VALUE_POINTER(p->arg_default));
		default :
			if (p->restype == GTK_TYPE_CONTAINER)
				return (GTK_VALUE_OBJECT(parg[0]) == GTK_VALUE_OBJECT(p->arg_default));
			RES_NOT_YET_HANDLED( wgtdef, p );
			assert(0);
			break;
	}							// switch

	return FALSE;

}								// is_default_value
