#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <sys/stat.h>
#include <signal.h>
#include <ctype.h>
#include <errno.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/select.h>
#include <utime.h>
#include <sys/time.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"

#include "about_icon.xpm"


static GtkWidget	*wgt_dlg_about;
static GtkWidget	*wgt_aboutdlg_vbox;
static GtkWidget	*wgt_aboutdlg_pixmap;
static GtkWidget	*wgt_aboutdlg_label_version;
#ifdef DLG_EMAIL
static GtkWidget	*wgt_aboutdlg_btn_email;
#endif
static GtkWidget	*wgt_aboutdlg_btn_ok;


#ifdef DLG_EMAIL
/* Callback "clicked" for GtkButton widget wgt_aboutdlg_btn_email */
void
cb_aboutdlg_btn_email(GtkButton *button, gpointer user_data)
{
	dlg_email();
}								// cb_aboutdlg_btn_email
#endif


/* Callback "clicked" for GtkButton widget wgt_aboutdlg_btn_ok */
void
cb_aboutdlg_btn_ok(GtkButton *button, gpointer user_data)
{
	
	/*--- Close the dialog ---*/
	gtk_widget_destroy(wgt_dlg_about);
	wgt_dlg_about = NULL;
	
}								// cb_aboutdlg_btn_ok


/*--- This CB is used to avoid the close of window when user clicks X - top/right corner ---*/
static gint
cb_close_window( GtkWidget * widget, gpointer data )
{
	return TRUE;
}								// cb_close_window


static GtkWidget *
create_wgt_dlg_about( GtkWidget *parent )
{
	GtkWidget	*wgt_2_3, *wgt_2_4, *wgt_3_6, *wgt_4_7, *wgt_4_9, 
				*wgt_2_10, *wgt_2_11;
	char		tmp[80];
	GdkColor	*transparent = NULL;
	GdkPixmap	*about_icon;
	GdkBitmap	*about_icon_mask;

	wgt_dlg_about = gtk_widget_new( gtk_window_get_type(),
		"width", 320,
		"height", 240,
		"visible", 1,
		"resize_mode", GTK_RESIZE_QUEUE,
		"window_position", GTK_WIN_POS_CENTER,
		"title", "About GLG...",
		"allow_grow", 1,
		"modal", 1,
		"default_width", 320,
		"default_height", 240,
		NULL );

	wgt_aboutdlg_vbox = gtk_widget_new( gtk_vbox_get_type(),
		"parent", wgt_dlg_about,
		"visible", 1,
		NULL );

	wgt_2_3 = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_aboutdlg_vbox,
		"visible", 1,
		"label", "GLG - Gtk Lo Gafet",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_aboutdlg_vbox ), wgt_2_3,
		"expand", 0,
		"padding", 4,
		NULL );

	wgt_2_4 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_aboutdlg_vbox,
		"visible", 1,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_aboutdlg_vbox ), wgt_2_4,
		"position", 1,
		"expand", TRUE,
		NULL );

	wgt_aboutdlg_pixmap = gtk_widget_new( gtk_pixmap_get_type(),
		"parent", wgt_2_4,
		"visible", 1,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_4 ), wgt_aboutdlg_pixmap,
		"expand", 8,
		"fill", 0,
		NULL );
	
	wgt_3_6 = gtk_widget_new( gtk_vbox_get_type(),
		"parent", wgt_2_4,
		"visible", 1,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_4 ), wgt_3_6,
		"position", 1,
		NULL );

	wgt_4_7 = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_3_6,
		"visible", 1,
		"label", "Open Application Builder\nfor the GTK",
		NULL );

	sprintf( tmp, "v%d.%d.%c\n%s %s\n",
		FLG_APPVERSION_MAJOR, FLG_APPVERSION_MINOR, FLG_APPVERSION_SEQ+'a',
		FLG_APPVERSION_DATE, FLG_APPVERSION_TIME );
	wgt_aboutdlg_label_version = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_3_6,
		"visible", 1,
		"label", tmp,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_6 ), wgt_aboutdlg_label_version,
		"position", 1,
		NULL );

	wgt_4_7 = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_3_6,
		"visible", 1,
		"label",
#ifdef USE_GNOME
		"  Compiled with GNOME support  \n",
#else
		"  Compiled witout GNOME support  \n",
#endif
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_6 ), wgt_4_7,
		"position", 2,
		NULL );

	wgt_4_9 = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_3_6,
		"visible", 1,
		"label", "Olivier Singla\nlo_gafet@users.sourceforget.net",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_6 ), wgt_4_9,
		"position", 3,
		NULL );

	wgt_2_10 = gtk_widget_new( gtk_hseparator_get_type(),
		"parent", wgt_aboutdlg_vbox,
		"visible", 1,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_aboutdlg_vbox ), wgt_2_10,
		"expand", 0,
		"padding", 4,
		"position", 2,
		NULL );

	wgt_2_11 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_aboutdlg_vbox,
		"height", 60,
		"visible", 1,
		"border_width", 4,
		"spacing", 4,
		"homogeneous", 1,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_aboutdlg_vbox ), wgt_2_11,
		"expand", 0,
		"position", 3,
		NULL );

#ifdef DLG_EMAIL
	wgt_aboutdlg_btn_email = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_11,
		"visible", 1,
		"can_focus", 1,
		"receives_default", 1,
		"label", "Send an Email\nto the Author",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_11 ), wgt_aboutdlg_btn_email,
		"expand", 0,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_aboutdlg_btn_email ), "clicked",
		GTK_SIGNAL_FUNC( cb_aboutdlg_btn_email ), NULL );
#endif

	wgt_aboutdlg_btn_ok = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_11,
		"visible", 1,
		"can_focus", 1,
		"receives_default", 1,
		"label", "Close",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_11 ), wgt_aboutdlg_btn_ok,
		"expand", 0,
		"position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_aboutdlg_btn_ok ), "clicked",
		GTK_SIGNAL_FUNC( cb_aboutdlg_btn_ok ), NULL );

	gtk_widget_realize( wgt_dlg_about );

	about_icon = gdk_pixmap_create_from_xpm_d( wgt_dlg_about->window,
		&about_icon_mask,  transparent, about_icon_xpm );
	gtk_pixmap_set (GTK_PIXMAP (wgt_aboutdlg_pixmap), about_icon, about_icon_mask);

	gtk_signal_connect( GTK_OBJECT(wgt_dlg_about), "delete_event",
		GTK_SIGNAL_FUNC(cb_close_window), NULL );
	gtk_widget_show_all( wgt_dlg_about );
	return wgt_dlg_about;

}								// create_wgt_dlg_about


PUBLIC void
dlg_about( void )
{
	
	create_wgt_dlg_about( NULL );
	
	push_block_all_windows();
	while ( wgt_dlg_about != NULL )
		gtk_main_iteration();
	pop_block_all_windows();

}								// dlg_about
