#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


static GtkWidget	*dlg_edit_style	INIT( NULL );
static GtkWidget	*wgt_editstyle_fg0;
static GtkWidget	*wgt_editstyle_fg1;
static GtkWidget	*wgt_editstyle_fg2;
static GtkWidget	*wgt_editstyle_fg3;
static GtkWidget	*wgt_editstyle_fg4;
static GtkWidget	*wgt_editstyle_bg0;
static GtkWidget	*wgt_editstyle_bg1;
static GtkWidget	*wgt_editstyle_bg2;
static GtkWidget	*wgt_editstyle_bg3;
static GtkWidget	*wgt_editstyle_bg4;
static GtkWidget	*wgt_editstyle_text0;
static GtkWidget	*wgt_editstyle_text1;
static GtkWidget	*wgt_editstyle_text2;
static GtkWidget	*wgt_editstyle_text3;
static GtkWidget	*wgt_editstyle_text4;
static GtkWidget	*wgt_editstyle_base0;
static GtkWidget	*wgt_editstyle_base1;
static GtkWidget	*wgt_editstyle_base2;
static GtkWidget	*wgt_editstyle_base3;
static GtkWidget	*wgt_editstyle_base4;
static GtkWidget	*wgt_editstyle_font_specify;
static GtkWidget	*wgt_editstyle_font_example;
static GtkWidget	*wgt_editstyle_btn_cancel;
static GtkWidget	*wgt_editstyle_btn_ok;

static	int			retval;


/* Callback "clicked" for GtkButton widget wgt_editstyle_btn_cancel */
static void
cb_editstyle_btn_cancel(GtkButton *button, gpointer user_data)
{
		
	/*--- Close the dialog ---*/
	retval = FALSE;
	gtk_widget_destroy( dlg_edit_style );
	dlg_edit_style = NULL;
	
}								// cb_editstyle_btn_cancel

/* Callback "clicked" for GtkButton widget wgt_editstyle_btn_ok */
static void
cb_editstyle_btn_ok( GtkButton *button, gpointer user_data )
{
	GtkStyle	*style = (GtkStyle *)user_data;
	GtkStyle	*s;

#define SET_STYLE( WGT, C ) \
	s = gtk_widget_get_style( WGT ); \
	C = s->bg[ 0 ]
			
	SET_STYLE( wgt_editstyle_fg0, style->fg[ 0 ] );
	SET_STYLE( wgt_editstyle_fg1, style->fg[ 1 ] );
	SET_STYLE( wgt_editstyle_fg2, style->fg[ 2 ] );
	SET_STYLE( wgt_editstyle_fg3, style->fg[ 3 ] );
	SET_STYLE( wgt_editstyle_fg4, style->fg[ 4 ] );
			
	SET_STYLE( wgt_editstyle_bg0, style->bg[ 0 ] );
	SET_STYLE( wgt_editstyle_bg1, style->bg[ 1 ] );
	SET_STYLE( wgt_editstyle_bg2, style->bg[ 2 ] );
	SET_STYLE( wgt_editstyle_bg3, style->bg[ 3 ] );
	SET_STYLE( wgt_editstyle_bg4, style->bg[ 4 ] );
			
	SET_STYLE( wgt_editstyle_base0, style->base[ 0 ] );
	SET_STYLE( wgt_editstyle_base1, style->base[ 1 ] );
	SET_STYLE( wgt_editstyle_base2, style->base[ 2 ] );
	SET_STYLE( wgt_editstyle_base3, style->base[ 3 ] );
	SET_STYLE( wgt_editstyle_base4, style->base[ 4 ] );
			
	SET_STYLE( wgt_editstyle_text0, style->text[ 0 ] );
	SET_STYLE( wgt_editstyle_text1, style->text[ 1 ] );
	SET_STYLE( wgt_editstyle_text2, style->text[ 2 ] );
	SET_STYLE( wgt_editstyle_text3, style->text[ 3 ] );
	SET_STYLE( wgt_editstyle_text4, style->text[ 4 ] );
			
#undef SET_STYLE
	
	/*--- Close the dialog ---*/
	retval = TRUE;
	gtk_widget_destroy( dlg_edit_style );
	dlg_edit_style = NULL;
	
}								// cb_editstyle_btn_ok

static void
cb_colorselection_btn_ok( GtkButton *button, gpointer user_data )
{
	int		*done = (int *)user_data;
			
	*done = TRUE;
	
}								// cb_editstyle_btn_ok


static void
cb_colorselection_btn_cancel( GtkButton *button, gpointer user_data )
{
	GtkWidget	**wgt_dlg = (GtkWidget **)user_data;
			
	/*--- Close the dialog ---*/
	gtk_widget_destroy( *wgt_dlg );
	*wgt_dlg = NULL;
	
}								// cb_editstyle_btn_cancel


static void
cb_editstyle_button( GtkButton *button )
{
	GdkColor	*c;
	GtkWidget	*wgt_dlg;
	GtkStyle	*style;
	gdouble		color[ 4 ], pcolor[ 4 ];
	int			done;

	wgt_dlg = gtk_color_selection_dialog_new( "bla" );
	style = gtk_widget_get_style( GTK_WIDGET( button ) );
	c = &style->bg[ 0 ];
	color[ 0 ] = (gdouble)c->red / 65535;
	color[ 1 ] = (gdouble)c->green / 65535;
	color[ 2 ] = (gdouble)c->blue / 65535;
	color[ 3 ] = 0;
	gtk_color_selection_set_color( 
		GTK_COLOR_SELECTION( GTK_COLOR_SELECTION_DIALOG(wgt_dlg)->colorsel ),
		color );

	done = FALSE;
	gtk_signal_connect( GTK_OBJECT( GTK_COLOR_SELECTION_DIALOG(wgt_dlg)->cancel_button ), 
		"clicked", GTK_SIGNAL_FUNC( cb_colorselection_btn_cancel ), &wgt_dlg );
	gtk_signal_connect( GTK_OBJECT( GTK_COLOR_SELECTION_DIALOG(wgt_dlg)->ok_button ), 
		"clicked", GTK_SIGNAL_FUNC( cb_colorselection_btn_ok ), &done );

	gtk_window_set_modal( GTK_WINDOW( wgt_dlg ), TRUE );
	gtk_widget_show_all( wgt_dlg );

	push_block_all_windows();
	while ( wgt_dlg && !done )
		gtk_main_iteration();
	pop_block_all_windows();

	if ( wgt_dlg )
	{
		GdkColor	c;
		GtkStyle	*new_style;
		gtk_color_selection_get_color( 
			GTK_COLOR_SELECTION( GTK_COLOR_SELECTION_DIALOG(wgt_dlg)->colorsel ),
			pcolor );
		new_style = gtk_style_copy( style );
		c.red   = (gushort)(pcolor[ 0 ] * 65535);
		c.green = (gushort)(pcolor[ 1 ] * 65535);
		c.blue  = (gushort)(pcolor[ 2 ] * 65535);
		new_style->bg[ 0 ] = c;
		gtk_widget_set_style( GTK_WIDGET( button ), new_style );
		set_object_data( GTK_WIDGET( button ), "style", new_style, TRUE );
		gtk_widget_destroy( wgt_dlg );
		wgt_dlg = NULL;
	}

}								// cb_editstyle_button


/* Callback "clicked" for GtkButton widget wgt_editstyle_fg0 */
static void
cb_editstyle_fg0( GtkButton *button, gpointer user_data )
{
	cb_editstyle_button( button );
}								// cb_editstyle_fg0

/* Callback "clicked" for GtkButton widget wgt_editstyle_fg1 */
static void
cb_editstyle_fg1(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_fg1

/* Callback "clicked" for GtkButton widget wgt_editstyle_fg2 */
static void
cb_editstyle_fg2(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_fg2

/* Callback "clicked" for GtkButton widget wgt_editstyle_fg3 */
static void
cb_editstyle_fg3(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_fg3

/* Callback "clicked" for GtkButton widget wgt_editstyle_fg4 */
static void
cb_editstyle_fg4(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_fg4

/* Callback "clicked" for GtkButton widget wgt_editstyle_bg0 */
static void
cb_editstyle_bg0(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_bg0

/* Callback "clicked" for GtkButton widget wgt_editstyle_bg1 */
static void
cb_editstyle_bg1(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_bg1

/* Callback "clicked" for GtkButton widget wgt_editstyle_bg2 */
static void
cb_editstyle_bg2(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_bg2

/* Callback "clicked" for GtkButton widget wgt_editstyle_bg3 */
static void
cb_editstyle_bg3(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_bg3

/* Callback "clicked" for GtkButton widget wgt_editstyle_bg4 */
static void
cb_editstyle_bg4(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_bg4

/* Callback "clicked" for GtkButton widget wgt_editstyle_text0 */
static void
cb_editstyle_text0(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_text0

/* Callback "clicked" for GtkButton widget wgt_editstyle_text1 */
static void
cb_editstyle_text1(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_text1

/* Callback "clicked" for GtkButton widget wgt_editstyle_text2 */
static void
cb_editstyle_text2(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_text2

/* Callback "clicked" for GtkButton widget wgt_editstyle_text3 */
static void
cb_editstyle_text3(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_text3

/* Callback "clicked" for GtkButton widget wgt_editstyle_text4 */
static void
cb_editstyle_text4(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_text4

/* Callback "clicked" for GtkButton widget wgt_editstyle_base0 */
static void
cb_editstyle_base0(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_base0

/* Callback "clicked" for GtkButton widget wgt_editstyle_base1 */
static void
cb_editstyle_base1(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_base1

/* Callback "clicked" for GtkButton widget wgt_editstyle_base2 */
static void
cb_editstyle_base2(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_base2

/* Callback "clicked" for GtkButton widget wgt_editstyle_base3 */
static void
cb_editstyle_base3(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_base3

/* Callback "clicked" for GtkButton widget wgt_editstyle_base4 */
static void
cb_editstyle_base4(GtkButton *button, gpointer user_data)
{
	cb_editstyle_button( button );
}								// cb_editstyle_base4


static void
font_selection_ok( GtkWidget *w, GtkFontSelectionDialog *fs )
{
	gchar		*s = gtk_font_selection_dialog_get_font_name( fs );

	g_print( "%s\n", s );
	g_free( s );
	gtk_widget_destroy( GTK_WIDGET(fs) );

}								// font_selection_ok


/* Callback "clicked" for GtkButton widget wgt_editstyle_font_example */
static void
cb_editstyle_font_specify_toggled(GtkToggleButton *togglebutton, gpointer user_data )
{
	GtkArg	arg;
	
	arg.name = "active";
	gtk_widget_get( GTK_WIDGET( togglebutton ), &arg );
	if ( GTK_VALUE_BOOL( arg ) )
		gtk_widget_set( GTK_WIDGET( wgt_editstyle_font_example ), "sensitive",
			TRUE, NULL );
	else
		gtk_widget_set( GTK_WIDGET( wgt_editstyle_font_example ), "sensitive",
			FALSE, NULL );
		
}								// cb_editstyle_font_specify_toggled


/* Callback "clicked" for GtkButton widget wgt_editstyle_font_example */
static void
cb_editstyle_font_example(GtkButton *button, gpointer user_data)
{
	GtkStyle	*style = (GtkStyle *)user_data;
	GtkWidget	*wgt_fontdlg;

	wgt_fontdlg = gtk_font_selection_dialog_new( "Font Selection Dialog" );
	gtk_window_set_modal( GTK_WINDOW( wgt_fontdlg ), TRUE );
	gtk_font_selection_dialog_set_filter( GTK_FONT_SELECTION_DIALOG( wgt_fontdlg ),
		GTK_FONT_FILTER_BASE, GTK_FONT_ALL,
		NULL, NULL, NULL, NULL, NULL, NULL );
	gtk_font_selection_dialog_set_font_name( GTK_FONT_SELECTION_DIALOG( wgt_fontdlg ),
		get_font_name( style ) );

	gtk_signal_connect_object( GTK_OBJECT (GTK_FONT_SELECTION_DIALOG(wgt_fontdlg)->cancel_button),
		"clicked", GTK_SIGNAL_FUNC( gtk_widget_destroy ),
		GTK_OBJECT( wgt_fontdlg ) );
	gtk_signal_connect( GTK_OBJECT( GTK_FONT_SELECTION_DIALOG( wgt_fontdlg )->ok_button ),
		"clicked", GTK_SIGNAL_FUNC( font_selection_ok ),
		GTK_FONT_SELECTION_DIALOG( wgt_fontdlg ) );

	gtk_widget_show_all( wgt_fontdlg );
	
}								// cb_editstyle_font_example


/*--- This CB is used to avoid the close of window when user clicks X - top/right corner ---*/
static gint
cb_close_window( GtkWidget * widget, gpointer data )
{
	return TRUE;
}								// cb_close_window


static GtkWidget *
create_window( GtkWidget *parent, const int realize,
	GtkStyle *style )
{
	GtkWidget	*wgt_1_2, *wgt_2_3, *wgt_3_4, *wgt_4_5, *wgt_4_6, 
				*wgt_4_7, *wgt_4_8, *wgt_4_9, *wgt_3_10, *wgt_4_11, 
				*wgt_4_17, *wgt_4_23, *wgt_4_29, *wgt_2_36, *wgt_2_37;
	GtkTooltips *tooltips;

	tooltips = gtk_tooltips_new ();

	dlg_edit_style = gtk_widget_new( gtk_window_get_type(),
		"width", 400,
		"height", 300,
		"visible", TRUE,
		"resize_mode", GTK_RESIZE_QUEUE,
//		"window_position", GTK_WIN_POS_MOUSE,
		"title", "Edit Style",
		"allow_grow", TRUE,
		"modal", TRUE,
		"default_width", 400,
		"default_height", 300,
		NULL );

	wgt_1_2 = gtk_widget_new( gtk_vbox_get_type(),
		"parent", dlg_edit_style,
		"visible", TRUE,
		"border_width", 4,
		"spacing", 8,
		NULL );

	wgt_2_3 = gtk_widget_new( gtk_hpaned_get_type(),
		"parent", wgt_1_2,
		"visible", TRUE,
		NULL );

	wgt_3_4 = gtk_widget_new( gtk_vbox_get_type(),
		"parent", wgt_2_3,
		"visible", TRUE,
		"border_width", 4,
		"homogeneous", TRUE,
		NULL );

	wgt_4_5 = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_3_4,
		"visible", TRUE,
		"xalign", 0.000000,
		"label", "Fg",
		NULL );

	wgt_4_6 = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_3_4,
		"visible", TRUE,
		"xalign", 0.000000,
		"label", "Bg",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_4 ), wgt_4_6,
		"position", 1,
		NULL );

	wgt_4_7 = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_3_4,
		"visible", TRUE,
		"xalign", 0.000000,
		"label", "Text",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_4 ), wgt_4_7,
		"position", 2,
		NULL );

	wgt_4_8 = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_3_4,
		"visible", TRUE,
		"xalign", 0.000000,
		"label", "Base",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_4 ), wgt_4_8,
		"position", 3,
		NULL );

	wgt_4_9 = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_3_4,
		"visible", TRUE,
		"xalign", 0.000000,
		"label", "Font",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_4 ), wgt_4_9,
		"position", 4,
		NULL );

	wgt_3_10 = gtk_widget_new( gtk_vbox_get_type(),
		"parent", wgt_2_3,
		"visible", TRUE,
		"border_width", 4,
		"homogeneous", TRUE,
		NULL );

	wgt_4_11 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_3_10,
		"visible", TRUE,
		"spacing", 8,
		"homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_11,
		"expand", FALSE,
		"padding", 8,
		NULL );

	wgt_editstyle_fg0 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_11,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_fg0 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_fg0 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_fg0, "GTK_STATE_NORMAL", NULL );

	wgt_editstyle_fg1 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_11,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_editstyle_fg1,
		"position", 1,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_fg1 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_fg1 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_fg1, "GTK_STATE_ACTIVE", NULL );

	wgt_editstyle_fg2 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_11,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_editstyle_fg2,
		"position", 2,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_fg2 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_fg2 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_fg2, "GTK_STATE_PRELIGHT", NULL );

	wgt_editstyle_fg3 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_11,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_editstyle_fg3,
		"position", 3,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_fg3 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_fg3 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_fg3, "GTK_STATE_SELECTED", NULL );

	wgt_editstyle_fg4 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_11,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_editstyle_fg4,
		"position", 4,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_fg4 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_fg4 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_fg4, "GTK_STATE_INSENSITIVE", NULL );

	wgt_4_17 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_3_10,
		"visible", TRUE,
		"spacing", 8,
		"homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_17,
		"padding", 8,
		"position", 1,
		NULL );

	wgt_editstyle_bg0 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_17,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_bg0 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_bg0 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_bg0, "GTK_STATE_NORMAL", NULL );

	wgt_editstyle_bg1 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_17,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_17 ), wgt_editstyle_bg1,
		"position", 1,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_bg1 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_bg1 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_bg1, "GTK_STATE_ACTIVE", NULL );

	wgt_editstyle_bg2 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_17,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_17 ), wgt_editstyle_bg2,
		"position", 2,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_bg2 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_bg2 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_bg2, "GTK_STATE_PRELIGHT", NULL );

	wgt_editstyle_bg3 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_17,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_17 ), wgt_editstyle_bg3,
		"position", 3,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_bg3 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_bg3 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_bg3, "GTK_STATE_SELECTED", NULL );

	wgt_editstyle_bg4 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_17,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_17 ), wgt_editstyle_bg4,
		"position", 4,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_bg4 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_bg4 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_bg4, "GTK_STATE_INSENSITIVE", NULL );

	wgt_4_23 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_3_10,
		"visible", TRUE,
		"spacing", 8,
		"homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_23,
		"padding", 8,
		"position", 2,
		NULL );

	wgt_editstyle_text0 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_23,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_text0 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_text0 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_text0, "GTK_STATE_NORMAL", NULL );

	wgt_editstyle_text1 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_23,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_23 ), wgt_editstyle_text1,
		"position", 1,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_text1 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_text1 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_text1, "GTK_STATE_ACTIVE", NULL );

	wgt_editstyle_text2 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_23,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_23 ), wgt_editstyle_text2,
		"position", 2,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_text2 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_text2 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_text2, "GTK_STATE_PRELIGHT", NULL );

	wgt_editstyle_text3 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_23,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_23 ), wgt_editstyle_text3,
		"position", 3,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_text3 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_text3 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_text3, "GTK_STATE_SELECTED", NULL );

	wgt_editstyle_text4 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_23,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_23 ), wgt_editstyle_text4,
		"position", 4,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_text4 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_text4 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_text4, "GTK_STATE_INSENSITIVE", NULL );

	wgt_4_29 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_3_10,
		"visible", TRUE,
		"spacing", 8,
		"homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_29,
		"padding", 8,
		"position", 3,
		NULL );

	wgt_editstyle_base0 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_29,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_base0 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_base0 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_base0, "GTK_STATE_NORMAL", NULL );

	wgt_editstyle_base1 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_29,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_29 ), wgt_editstyle_base1,
		"position", 1,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_base1 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_base1 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_base1, "GTK_STATE_ACTIVE", NULL );

	wgt_editstyle_base2 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_29,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_29 ), wgt_editstyle_base2,
		"position", 2,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_base2 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_base2 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_base2, "GTK_STATE_PRELIGHT", NULL );

	wgt_editstyle_base3 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_29,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_29 ), wgt_editstyle_base3,
		"position", 3,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_base3 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_base3 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_base3, "GTK_STATE_SELECTED", NULL );

	wgt_editstyle_base4 = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_29,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_29 ), wgt_editstyle_base4,
		"position", 4,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_base4 ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_base4 ), NULL );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_base4, "GTK_STATE_INSENSITIVE", NULL );

	wgt_4_11 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_3_10,
		"visible", TRUE,
		"spacing", 8,
		"homogeneous", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_10 ), wgt_4_11,
		"expand", FALSE,
		"padding", 8,
		NULL );

	wgt_editstyle_font_specify = gtk_widget_new( gtk_check_button_get_type(),
		"parent", wgt_4_11,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_editstyle_font_specify,
		"expand", FALSE,
		"padding", 8,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_font_specify ), "toggled",
		GTK_SIGNAL_FUNC( cb_editstyle_font_specify_toggled ), NULL );

	wgt_editstyle_font_example = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_4_11,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "Example",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_11 ), wgt_editstyle_font_example,
		"expand", TRUE,
		"padding", 8,
		NULL );
	gtk_signal_connect_after( GTK_OBJECT( wgt_editstyle_font_example ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_font_example ), style );
	gtk_tooltips_set_tip( tooltips, wgt_editstyle_font_example, 
		get_font_name( style ), 
		NULL );

	wgt_2_36 = gtk_widget_new( gtk_hseparator_get_type(),
		"parent", wgt_1_2,
		"visible", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_36,
		"expand", FALSE,
		"position", 1,
		NULL );

	wgt_2_37 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_1_2,
		"height", 32,
		"visible", TRUE,
		"spacing", 8,
		"homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_37,
		"expand", FALSE,
		"position", 2,
		NULL );

	wgt_editstyle_btn_cancel = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_37,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "Cancel",
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_editstyle_btn_cancel ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_btn_cancel ), NULL );

	wgt_editstyle_btn_ok = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_37,
		"visible", TRUE,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "Ok",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_37 ), wgt_editstyle_btn_ok,
		"position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_editstyle_btn_ok ), "clicked",
		GTK_SIGNAL_FUNC( cb_editstyle_btn_ok ), style );

	gtk_signal_connect( GTK_OBJECT(dlg_edit_style), "delete_event",
		GTK_SIGNAL_FUNC(cb_close_window), NULL );

	if ( realize )
		gtk_widget_show_all( dlg_edit_style );

	return dlg_edit_style;

}								// create_window


PUBLIC int
edit_style( GtkStyle *style )
{
	GtkStyle	*new_style;

	create_window( NULL, FALSE, style );

#define NEW_STYLE( C, WGT ) \
	new_style = gtk_style_copy( style ); \
	new_style->bg [ 0 ] = style->##C; \
	gtk_widget_set_style( WGT, new_style ); \
	set_object_data( WGT, "style", new_style, TRUE )
	
	NEW_STYLE( fg [ 0 ], wgt_editstyle_fg0 );
	NEW_STYLE( fg [ 1 ], wgt_editstyle_fg1 );
	NEW_STYLE( fg [ 2 ], wgt_editstyle_fg2 );
	NEW_STYLE( fg [ 3 ], wgt_editstyle_fg3 );
	NEW_STYLE( fg [ 4 ], wgt_editstyle_fg4 );

	NEW_STYLE( bg [ 0 ], wgt_editstyle_bg0 );
	NEW_STYLE( bg [ 1 ], wgt_editstyle_bg1 );
	NEW_STYLE( bg [ 2 ], wgt_editstyle_bg2 );
	NEW_STYLE( bg [ 3 ], wgt_editstyle_bg3 );
	NEW_STYLE( bg [ 4 ], wgt_editstyle_bg4 );

	NEW_STYLE( base [ 0 ], wgt_editstyle_base0 );
	NEW_STYLE( base [ 1 ], wgt_editstyle_base1 );
	NEW_STYLE( base [ 2 ], wgt_editstyle_base2 );
	NEW_STYLE( base [ 3 ], wgt_editstyle_base3 );
	NEW_STYLE( base [ 4 ], wgt_editstyle_base4 );

	NEW_STYLE( text [ 0 ], wgt_editstyle_text0 );
	NEW_STYLE( text [ 1 ], wgt_editstyle_text1 );
	NEW_STYLE( text [ 2 ], wgt_editstyle_text2 );
	NEW_STYLE( text [ 3 ], wgt_editstyle_text3 );
	NEW_STYLE( text [ 4 ], wgt_editstyle_text4 );

#undef NEW_STYLE

	gtk_widget_realize( dlg_edit_style );
	gtk_widget_show_all( dlg_edit_style );

	push_block_all_windows();
	while ( dlg_edit_style != NULL )
		gtk_main_iteration();
	pop_block_all_windows();

	return retval;

}								// edit_style

