#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


static	int			done;		
static	int			result;		
static	GtkWidget	*wgt_entry;


static void
cb_ok( GtkWidget *widget, void *data )
{
	result = gtk_spin_button_get_value_as_int( GTK_SPIN_BUTTON(wgt_entry) );
	done = 1;
}								// cb_ok


static void
cb_cancel( GtkWidget *widget, void *data )
{
	done = -1;
}								// cb_cancel


#define _INIT_ARGS \
	nb_args = 0

#define _SETARG_INT( n, v ) \
	args[nb_args].type=GTK_TYPE_INT; \
	args[nb_args].name=n; \
	GTK_VALUE_INT(args[nb_args++])=v

#define _SETARG_ULONG( n, v ) \
	args[nb_args].type=GTK_TYPE_ULONG; \
	args[nb_args].name=n; \
	GTK_VALUE_ULONG(args[nb_args++])=v


PUBLIC int
infos_addwgt_dialog( char *title, 
	int *val, int vmin, int vmax,
	char *fmt, ... )
{
	va_list		ap;
	char		buff[ 384 ];
    GtkWidget	*wgt_dialog, *wgt_btn_ok, *wgt_btn_cancel;
	GtkWidget	*hbox;
    GtkWidget	*wgt_label;
	GtkObject	*wgt_adj;
	int			nb_args;
	GtkArg		args[ 100 ];

	/*--- Develop message to display ---*/ 
	va_start( ap, fmt );
	vsprintf( buff, fmt, ap );
	va_end( ap );

    /* Create the widgets */  
    wgt_dialog = gtk_dialog_new();
	gtk_window_set_position( GTK_WINDOW(wgt_dialog), GTK_WIN_POS_MOUSE );
    wgt_btn_ok = gtk_button_new_with_label( "Ok" );
    wgt_btn_cancel = gtk_button_new_with_label( "Cancel" );
 
    gtk_signal_connect( GTK_OBJECT( wgt_btn_ok ), "clicked",
		GTK_SIGNAL_FUNC( cb_ok ), (gpointer) &result );
    gtk_signal_connect( GTK_OBJECT( wgt_btn_cancel ), "clicked",
		GTK_SIGNAL_FUNC( cb_cancel ), (gpointer) &result );

    /* Ensure that the dialog box is destroyed when the user clicks ok. */   
    gtk_signal_connect_object( GTK_OBJECT( wgt_btn_ok ), "clicked",
		GTK_SIGNAL_FUNC (gtk_widget_destroy), (gpointer) wgt_dialog );
    gtk_signal_connect_object( GTK_OBJECT( wgt_btn_cancel ), "clicked",
		GTK_SIGNAL_FUNC (gtk_widget_destroy), (gpointer) wgt_dialog );
    gtk_container_add( GTK_CONTAINER(GTK_DIALOG(wgt_dialog)->action_area),
		wgt_btn_ok );
    gtk_container_add( GTK_CONTAINER(GTK_DIALOG(wgt_dialog)->action_area),
		wgt_btn_cancel );

	hbox = gtk_type_new( gtk_hbox_get_type() );
	gtk_container_add( GTK_CONTAINER(GTK_DIALOG(wgt_dialog)->vbox), hbox );
	_INIT_ARGS;
	_SETARG_ULONG( "border_width", 16 );
	_SETARG_INT( "spacing", 8 );
	gtk_widget_setv( GTK_WIDGET(hbox), nb_args, args );

    /* Add the label, and show everything we've added to the dialog. */
    wgt_label = gtk_label_new( buff );
    gtk_container_add( GTK_CONTAINER(hbox), wgt_label );

	wgt_adj = gtk_adjustment_new( *val, vmin, vmax, 1, 1, 1 );
	wgt_entry = gtk_spin_button_new( GTK_ADJUSTMENT(wgt_adj), 1, 0 );
	gtk_widget_set_usize( wgt_entry, 80, -1 );
	gtk_spin_button_set_numeric( GTK_SPIN_BUTTON( wgt_entry ), TRUE );
	gtk_entry_set_max_length( GTK_ENTRY( wgt_entry ), 6 );
	gtk_spin_button_set_value( GTK_SPIN_BUTTON(wgt_entry), *val );
    gtk_container_add( GTK_CONTAINER(hbox), wgt_entry );
	
	gtk_window_set_title( GTK_WINDOW( wgt_dialog ), title );
	gtk_window_set_modal( GTK_WINDOW( wgt_dialog ), TRUE );
	gtk_widget_show_all( wgt_dialog );

	gtk_window_set_focus( GTK_WINDOW( wgt_dialog ), wgt_entry );

	done = 0;
	push_block_all_windows();
	while ( !done )
		gtk_main_iteration();
	pop_block_all_windows();

	if ( done == 1)
		*val = result;   	   
	return (done == -1) ? FALSE : TRUE;
	
}								// infos_addwgt_dialog
