#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


static	int			done;		
static	int			result1, result2;		
static	GtkWidget	*wgt_entry1, *wgt_entry2;


static void
cb_ok( GtkWidget *widget, void *data )
{
	result1 = gtk_spin_button_get_value_as_int( GTK_SPIN_BUTTON( wgt_entry1 ) );
	result2 = gtk_spin_button_get_value_as_int( GTK_SPIN_BUTTON( wgt_entry2 ) );
	done = 1;
}								// cb_ok


static void
cb_cancel( GtkWidget *widget, void *data )
{
	done = -1;
}								// cb_cancel


#define _INIT_ARGS \
	nb_args = 0

#define _SETARG_INT( n, v ) \
	args[nb_args].type=GTK_TYPE_INT; \
	args[nb_args].name=n; \
	GTK_VALUE_INT(args[nb_args++])=v

#define _SETARG_ULONG( n, v ) \
	args[nb_args].type=GTK_TYPE_ULONG; \
	args[nb_args].name=n; \
	GTK_VALUE_ULONG(args[nb_args++])=v


PUBLIC int
infos_addwgt_dialog2( char *title, 
	int *val1, int vmin1, int vmax1, char *msg1,
	int *val2, int vmin2, int vmax2, char *msg2 )
{
    GtkWidget	*wgt_dialog, *wgt_btn_ok, *wgt_btn_cancel;
	GtkWidget	*vbox;
 	GtkWidget	*hbox1, *hbox2;
	GtkWidget	*wgt_label;
	GtkObject	*wgt_adj1, *wgt_adj2;
	int			nb_args;
	GtkArg		args[ 100 ];

    /* Create the widgets */  
    wgt_dialog = gtk_dialog_new();
	gtk_window_set_position( GTK_WINDOW(wgt_dialog), GTK_WIN_POS_MOUSE );
    wgt_btn_ok = gtk_button_new_with_label( "Ok" );
    wgt_btn_cancel = gtk_button_new_with_label( "Cancel" );
 
    gtk_signal_connect( GTK_OBJECT( wgt_btn_ok ), "clicked",
		GTK_SIGNAL_FUNC( cb_ok ), NULL );
    gtk_signal_connect( GTK_OBJECT( wgt_btn_cancel ), "clicked",
		GTK_SIGNAL_FUNC( cb_cancel ), NULL );

    /* Ensure that the dialog box is destroyed when the user clicks ok. */   
    gtk_signal_connect_object( GTK_OBJECT( wgt_btn_ok ), "clicked",
		GTK_SIGNAL_FUNC (gtk_widget_destroy), (gpointer) wgt_dialog );
    gtk_signal_connect_object( GTK_OBJECT( wgt_btn_cancel ), "clicked",
		GTK_SIGNAL_FUNC (gtk_widget_destroy), (gpointer) wgt_dialog );
    gtk_container_add( GTK_CONTAINER(GTK_DIALOG(wgt_dialog)->action_area),
		wgt_btn_ok );
    gtk_container_add( GTK_CONTAINER(GTK_DIALOG(wgt_dialog)->action_area),
		wgt_btn_cancel );

	vbox = gtk_type_new( gtk_vbox_get_type() );
	gtk_container_add( GTK_CONTAINER(GTK_DIALOG(wgt_dialog)->vbox), vbox );
	_INIT_ARGS;
	_SETARG_ULONG( "border_width", 16 );
	_SETARG_INT( "spacing", 8 );
	gtk_widget_setv( GTK_WIDGET( vbox ), nb_args, args );

	hbox1 = gtk_type_new( gtk_hbox_get_type() );
	gtk_container_add( GTK_CONTAINER( vbox ), hbox1 );
	_INIT_ARGS;
	_SETARG_ULONG( "border_width", 16 );
	_SETARG_INT( "spacing", 8 );
	gtk_widget_setv( GTK_WIDGET(hbox1), nb_args, args );

    /* Add the label, and show everything we've added to the dialog. */
    wgt_label = gtk_label_new( msg1 );
    gtk_container_add( GTK_CONTAINER( hbox1 ), wgt_label );

	wgt_adj1 = gtk_adjustment_new( *val1, vmin1, vmax1, 1, 1, 1 );
	wgt_entry1 = gtk_spin_button_new( GTK_ADJUSTMENT( wgt_adj1 ), 1, 0 );
	gtk_widget_set_usize( wgt_entry1, 80, -1 );
	gtk_spin_button_set_numeric( GTK_SPIN_BUTTON( wgt_entry1 ), TRUE );
	gtk_entry_set_max_length( GTK_ENTRY( wgt_entry1 ), 6 );
	gtk_spin_button_set_value( GTK_SPIN_BUTTON(wgt_entry1), *val1 );
    gtk_container_add( GTK_CONTAINER(hbox1), wgt_entry1 );
	
	hbox2 = gtk_type_new( gtk_hbox_get_type() );
	gtk_container_add( GTK_CONTAINER( vbox ), hbox2 );
	_INIT_ARGS;
	_SETARG_ULONG( "border_width", 16 );
	_SETARG_INT( "spacing", 8 );
	gtk_widget_setv( GTK_WIDGET( hbox2 ), nb_args, args );

    /* Add the label, and show everything we've added to the dialog. */
    wgt_label = gtk_label_new( msg2 );
    gtk_container_add( GTK_CONTAINER( hbox2 ), wgt_label );

	wgt_adj2 = gtk_adjustment_new( *val2, vmin2, vmax2, 1, 1, 1 );
	wgt_entry2 = gtk_spin_button_new( GTK_ADJUSTMENT( wgt_adj2 ), 1, 0 );
	gtk_widget_set_usize( wgt_entry2, 80, -1 );
	gtk_spin_button_set_numeric( GTK_SPIN_BUTTON( wgt_entry2 ), TRUE );
	gtk_entry_set_max_length( GTK_ENTRY( wgt_entry2 ), 6 );
	gtk_spin_button_set_value( GTK_SPIN_BUTTON(wgt_entry2), *val2 );
    gtk_container_add( GTK_CONTAINER( hbox2 ), wgt_entry2 );
	
	gtk_window_set_title( GTK_WINDOW( wgt_dialog ), title );
	gtk_window_set_modal( GTK_WINDOW( wgt_dialog ), TRUE );
	gtk_widget_show_all( wgt_dialog );

	gtk_window_set_focus( GTK_WINDOW( wgt_dialog ), wgt_entry2 );

	done = 0;
	push_block_all_windows();
	while ( !done )
		gtk_main_iteration();
	pop_block_all_windows();

	if ( done == 1 )
	{
		*val1 = result1;   	   
		*val2 = result2;
	}
	return (done == -1) ? FALSE : TRUE;
	
}								// infos_addwgt_dialog2
