#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


static	GtkWidget	*wgt_window_prjopt;
static	GtkWidget	*wgt_dlgopt_pres_opt_expand_container_blank;
static	GtkWidget	*wgt_dlgopt_codegen_setgetres1;
static	GtkWidget	*wgt_dlgopt_codegen_setgetres2;
static	GtkWidget	*wgt_dlgopt_codegen_maxsourcelen;
static	GtkWidget	*wgt_dlgopt_codegen_indent1;
static	GtkWidget	*wgt_dlgopt_codegen_indent2;
static	GtkWidget	*wgt_dlgopt_codegen_indent3;
static	GtkWidget	*wgt_dlgopt_gen_gotolineopt;
static	GtkWidget	*wgt_dlgopt_gen_gotolineopt_after;
static	GtkWidget	*wgt_dlgopt_gen_editor1;
static	GtkWidget	*wgt_dlgopt_gen_editor2;
static	GtkWidget	*wgt_dlgopt_gen_editor3;

static	GtkWidget	*wgt_dlgopt_project_exename;
static	GtkWidget	*wgt_dlgopt_project_headerincl;
static	GtkWidget	*wgt_dlgopt_project_isgnome;
static	GtkWidget	*wgt_dlgopt_project_lang_newprj_c;
#ifdef GLG_SUPPORT_LANGUAGECPP
static	GtkWidget	*wgt_dlgopt_project_lang_newprj_cpp;
#endif
static	GtkWidget	*wgt_dlgopt_project_lang_current_c;
#ifdef GLG_SUPPORT_LANGUAGECPP
static	GtkWidget	*wgt_dlgopt_project_lang_current_cpp;
#endif

static	GtkWidget	*wgt_dlgopt_btn_ok;
static	GtkWidget	*wgt_dlgopt_btn_cancel;

static	GtkWidget	*wgt_vbox_project;
static	GtkWidget	*wgt_frame_gnome;


static void
write_screen( const int is_project )
{

	/*--- Presentation ---*/
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_pres_opt_expand_container_blank), 
		config.is_expand_container_blank );

	/*--- Code generation ---*/
	if (config.setgetres_method == SETGETRES_METHOD_ARGS)
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_codegen_setgetres1), TRUE );
	else if (config.setgetres_method == SETGETRES_METHOD_ARGV)
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_codegen_setgetres2), TRUE );
	else assert(0);
	gtk_spin_button_set_value( GTK_SPIN_BUTTON(wgt_dlgopt_codegen_maxsourcelen), 
		config.max_source_line );
	if (config.indentstyle_block == INDENTSTYLE_BLOCK1)
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_codegen_indent1), TRUE );
	else if (config.indentstyle_block == INDENTSTYLE_BLOCK2)
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_codegen_indent2), TRUE );
	else if (config.indentstyle_block == INDENTSTYLE_BLOCK3)
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_codegen_indent3), TRUE );
	else assert(0);

	/*--- General ---*/
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgopt_gen_editor1), config.editor1 );
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgopt_gen_editor2), config.editor2 );
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgopt_gen_editor3), config.editor3 );
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgopt_gen_gotolineopt), config.goto_line_option );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_gen_gotolineopt_after), config.is_glo_after );

	/*--- Project ---*/
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgopt_project_exename), 
		is_project ? config.exe_name : "" );
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgopt_project_headerincl), 
		is_project ? config.header_to_include : "" );
#ifdef USE_GNOME
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_project_isgnome), config.is_gnome );
	gtk_widget_set_sensitive( GTK_WIDGET(wgt_frame_gnome), TRUE );
#else
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_project_isgnome), FALSE );
	gtk_widget_set_sensitive( GTK_WIDGET(wgt_frame_gnome), FALSE );
#endif

	if (config.language_newprj == LANGUAGE_C)
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_project_lang_newprj_c), TRUE );
#ifdef GLG_SUPPORT_LANGUAGECPP
	else if (config.language_newprj == LANGUAGE_CPP)
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_project_lang_newprj_cpp), TRUE );
#endif
	else assert(0);

	if (config.language_current == LANGUAGE_C)
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_project_lang_current_c), TRUE );
#ifdef GLG_SUPPORT_LANGUAGECPP
	else if (config.language_current == LANGUAGE_CPP)
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_project_lang_current_cpp), TRUE );
#endif
	else assert(0);

}								// write_screen


static void
read_screen( const int is_project )
{

	/*--- Presentation ---*/
	config.is_expand_container_blank =
		gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wgt_dlgopt_pres_opt_expand_container_blank) );
	
	/*--- Code generation ---*/
	if (gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_codegen_setgetres1)) )
		config.setgetres_method = SETGETRES_METHOD_ARGS;
	else if (gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_codegen_setgetres2)) )
		config.setgetres_method = SETGETRES_METHOD_ARGV;
	else assert(0);
	config.max_source_line =
		gtk_spin_button_get_value_as_int( GTK_SPIN_BUTTON(wgt_dlgopt_codegen_maxsourcelen) );
	if (gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_codegen_indent1)) )
		config.indentstyle_block = INDENTSTYLE_BLOCK1;
	else if (gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_codegen_indent2)) )
		config.indentstyle_block = INDENTSTYLE_BLOCK2;
	else if (gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_codegen_indent3)) )
		config.indentstyle_block = INDENTSTYLE_BLOCK3;
	else assert(0);

	/*--- General ---*/
	strcpy( config.editor1, 
		gtk_editable_get_chars( GTK_EDITABLE(wgt_dlgopt_gen_editor1), 0, -1 ) );
	strcpy( config.editor2, 
		gtk_editable_get_chars( GTK_EDITABLE(wgt_dlgopt_gen_editor2), 0, -1 ) );
	strcpy( config.editor3, 
		gtk_editable_get_chars( GTK_EDITABLE(wgt_dlgopt_gen_editor3), 0, -1 ) );
	strcpy( config.goto_line_option, 
		gtk_editable_get_chars( GTK_EDITABLE(wgt_dlgopt_gen_gotolineopt), 0, -1 ) );
	config.is_glo_after = 
		gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_gen_gotolineopt_after) );

	/*--- Project ---*/
	if ( is_project )
	{
		strcpy( config.exe_name,
			gtk_editable_get_chars( GTK_EDITABLE(wgt_dlgopt_project_exename), 0, -1 ) );
		strcpy( config.header_to_include,
			gtk_editable_get_chars( GTK_EDITABLE(wgt_dlgopt_project_headerincl), 0, -1 ) ); 
		if (gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_project_isgnome) ) )
			config.is_gnome = TRUE;
		else
			config.is_gnome = FALSE;
		if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_project_lang_newprj_c) ) )
			config.language_newprj = LANGUAGE_C;
#ifdef GLG_SUPPORT_LANGUAGECPP
		else if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_dlgopt_project_lang_newprj_cpp) ) )
			config.language_newprj = LANGUAGE_CPP;
#endif
		else assert(0);
	}

}								// read_screen


static void
cb_ok( GtkWidget *widget, gpointer data )
{
	int		is_project = (int)data;
	char	filename[PATH_MAX+NAME_MAX + 100];

	read_screen( is_project );

	/*--- If there is current project, save the config for this project ---*/
	if ( !strcmp( project_dirname, "" ) )
	{
		write_config( config_name, FALSE );
	}
	else
	{
		sprintf( filename, "%s/lo_gafet.cfg",
			project_dirname );
		write_config( filename, TRUE );
	}

	/*--- Recompute and display the widget tree ---*/
	if (nb_modules() > 0)
		update_tree();

	/*--- Mark all modules to be saved and generated ---*/
	touch_all_modules();

	/*--- Close the dialog ---*/
	gtk_widget_destroy(wgt_window_prjopt);
	wgt_window_prjopt = NULL;
	
}								// cb_ok


static void
cb_cancel( GtkWidget *widget, gpointer data )
{

	/*--- Close the dialog ---*/
	gtk_widget_destroy(wgt_window_prjopt);
	wgt_window_prjopt = NULL;
	
}								// cb_cancel


#define ADD_CHECKBTN( parent, row, var, text ) \
	label16 = gtk_label_new (text); \
  gtk_table_attach (GTK_TABLE (table6), label16, 0, 1, row, row+1, \
                    (GtkAttachOptions) (GTK_FILL), \
                    (GtkAttachOptions) (GTK_FILL), 4, 0); \
  gtk_misc_set_alignment (GTK_MISC (label16), 1, 0.5); \
\
	var = gtk_check_button_new_with_label ("Yes"); \
   gtk_misc_set_alignment (GTK_MISC (var), 0, 0.5); \
 gtk_table_attach (GTK_TABLE (table6), var, 1, 2, row, row+1, \
                    (GtkAttachOptions) (GTK_FILL), \
                    (GtkAttachOptions) (GTK_FILL), 4, 0)

static void
create_wgt_window_prjopt( const int is_project )
{
  GtkWidget *vbox1;
  GtkWidget *notebook1;
  GtkWidget *vbox2;
  GtkWidget *frame1;
  GtkWidget *label1;
  GtkWidget *vbox3;
  GtkWidget *frame2;
  GtkWidget *hbox4;
  GSList *hbox4_group = NULL;
  GtkWidget *frame3;
  GtkWidget *table6;
  GtkWidget *label23;
  GtkWidget *label24;
  GtkWidget *hbox8;
  GSList *hbox8_group = NULL;
  GtkWidget *label12;
  GtkWidget *vbox4;
  GtkWidget *frame4;
  GtkWidget *table3;
  GtkWidget *hbox7;
  GtkWidget *label15;
  GtkWidget *label16;
  GtkWidget *label17;
  GtkWidget *label14;
  GtkWidget *frame5;
  GtkWidget *table4;
  GtkWidget *label20;
  GtkWidget *label19;
  GtkWidget *table5;
  GtkWidget *label22;
  GtkWidget *frame7;
  GtkWidget *hbox9;
  GSList *hbox9_group = NULL;
  GtkWidget *label18;
  GtkWidget *hseparator1;
  GtkWidget *hbox1;
  GtkAccelGroup *accel_group;
  GtkWidget	*wgt_label;
	GtkObject	*wgt_dlgopt_codegen_maxsourcelen_adj;
  GtkWidget *frame8;

  accel_group = gtk_accel_group_new ();

  wgt_window_prjopt = gtk_window_new (GTK_WINDOW_DIALOG);
	gtk_window_set_position( GTK_WINDOW(wgt_window_prjopt), GTK_WIN_POS_MOUSE );
  gtk_window_set_title (GTK_WINDOW (wgt_window_prjopt), "Project Options");
  gtk_window_set_modal (GTK_WINDOW (wgt_window_prjopt), TRUE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (wgt_window_prjopt), vbox1);

  notebook1 = gtk_notebook_new ();
  gtk_box_pack_start (GTK_BOX (vbox1), notebook1, TRUE, TRUE, 0);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 2);

  frame1 = gtk_frame_new ("Options");
  gtk_box_pack_start (GTK_BOX (vbox2), frame1, FALSE, TRUE, 0);

  table6 = gtk_table_new (2, 4, FALSE);
  gtk_container_add (GTK_CONTAINER (frame1), table6);

	ADD_CHECKBTN( table6, 0, wgt_dlgopt_pres_opt_expand_container_blank,
		"Expand container to display all blank children:" );

  label1 = gtk_label_new ("Presentation");
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), 
  	gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label1);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox3);
  gtk_container_set_border_width (GTK_CONTAINER (vbox3), 2);

  frame2 = gtk_frame_new ("Set/Get Resources");
  gtk_box_pack_start (GTK_BOX (vbox3), frame2, FALSE, TRUE, 0);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame2), hbox4);
  gtk_container_set_border_width (GTK_CONTAINER (hbox4), 2);

  wgt_dlgopt_codegen_setgetres1 = gtk_radio_button_new(hbox4_group);
  wgt_label = gtk_label_new("INIT_ARGS;\nSETARG_STRING( \"title\", \"My Window\" );\nSETARG_BOOL( \"allow_grow\", 1);\ngtk_widget_setv( wgt, nb_args, args );" );
  gtk_misc_set_alignment (GTK_MISC (wgt_label), 0.0, 0.0);
  gtk_label_set_justify( GTK_LABEL(wgt_label), GTK_JUSTIFY_LEFT );
  gtk_container_add (GTK_CONTAINER(wgt_dlgopt_codegen_setgetres1), wgt_label);
  hbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (wgt_dlgopt_codegen_setgetres1));
  gtk_box_pack_start (GTK_BOX (hbox4), wgt_dlgopt_codegen_setgetres1, FALSE, FALSE, 4);

  wgt_dlgopt_codegen_setgetres2 = gtk_radio_button_new(hbox4_group);
  wgt_label = gtk_label_new("gtk_widget_set( wgt,\n\t\"title\", \"My Window\",\t\n\"allow_grow\", TRUE,\n\tNULL);");
   gtk_misc_set_alignment (GTK_MISC (wgt_label), 0.0, 0.0);
  gtk_label_set_justify( GTK_LABEL(wgt_label), GTK_JUSTIFY_LEFT );
  gtk_container_add (GTK_CONTAINER(wgt_dlgopt_codegen_setgetres2), wgt_label);
  hbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (wgt_dlgopt_codegen_setgetres2));
  gtk_box_pack_start (GTK_BOX (hbox4), wgt_dlgopt_codegen_setgetres2, FALSE, FALSE, 4);

  frame3 = gtk_frame_new ("Indentation Style");
  gtk_box_pack_start (GTK_BOX (vbox3), frame3, FALSE, TRUE, 0);

  table6 = gtk_table_new (2, 2, FALSE);
  gtk_container_add (GTK_CONTAINER (frame3), table6);

  label23 = gtk_label_new ("Max source length:");
  gtk_table_attach (GTK_TABLE (table6), label23, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 4, 0);
  gtk_misc_set_alignment (GTK_MISC (label23), 1, 0.5);

  label24 = gtk_label_new ("Indentation:");
  gtk_table_attach (GTK_TABLE (table6), label24, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 4, 0);
  gtk_misc_set_alignment (GTK_MISC (label24), 1, 0.5);

  wgt_dlgopt_codegen_maxsourcelen_adj = gtk_adjustment_new (80, 64, 200, 1, 10, 10);
  wgt_dlgopt_codegen_maxsourcelen = gtk_spin_button_new (GTK_ADJUSTMENT (wgt_dlgopt_codegen_maxsourcelen_adj), 1, 0);
  gtk_table_attach (GTK_TABLE (table6), wgt_dlgopt_codegen_maxsourcelen, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 4, 0);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_table_attach (GTK_TABLE (table6), hbox8, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 4, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox8), 2);

  wgt_dlgopt_codegen_indent1 = gtk_radio_button_new(hbox8_group);
  wgt_label = gtk_label_new("if ( cond )\n{\n    instr...\n}");
  gtk_misc_set_alignment (GTK_MISC (wgt_label), 0.0, 0.0);
  gtk_label_set_justify( GTK_LABEL(wgt_label), GTK_JUSTIFY_LEFT );
  gtk_container_add (GTK_CONTAINER(wgt_dlgopt_codegen_indent1), wgt_label);
  hbox8_group = gtk_radio_button_group (GTK_RADIO_BUTTON (wgt_dlgopt_codegen_indent1));
  gtk_box_pack_start (GTK_BOX (hbox8), wgt_dlgopt_codegen_indent1, FALSE, FALSE, 0);

  wgt_dlgopt_codegen_indent2 = gtk_radio_button_new(hbox8_group);
  wgt_label = gtk_label_new("if ( cond ) {\n    instr...\n}");
  gtk_misc_set_alignment (GTK_MISC (wgt_label), 0.0, 0.0);
  gtk_label_set_justify( GTK_LABEL(wgt_label), GTK_JUSTIFY_LEFT );
  gtk_container_add (GTK_CONTAINER(wgt_dlgopt_codegen_indent2), wgt_label);
  hbox8_group = gtk_radio_button_group (GTK_RADIO_BUTTON (wgt_dlgopt_codegen_indent2));
  gtk_box_pack_start (GTK_BOX (hbox8), wgt_dlgopt_codegen_indent2, FALSE, FALSE, 0);

  wgt_dlgopt_codegen_indent3 = gtk_radio_button_new(hbox8_group);
  wgt_label = gtk_label_new("if ( cond )\n  {\n  instr...\n  }");
  gtk_misc_set_alignment (GTK_MISC (wgt_label), 0.0, 0.0);
  gtk_label_set_justify( GTK_LABEL(wgt_label), GTK_JUSTIFY_LEFT );
  gtk_container_add (GTK_CONTAINER(wgt_dlgopt_codegen_indent3), wgt_label);
  hbox8_group = gtk_radio_button_group (GTK_RADIO_BUTTON (wgt_dlgopt_codegen_indent3));
  gtk_box_pack_start (GTK_BOX (hbox8), wgt_dlgopt_codegen_indent3, FALSE, FALSE, 0);

  label12 = gtk_label_new ("Code generation");
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), 
  	gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label12);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox4);
  gtk_container_set_border_width (GTK_CONTAINER (vbox4), 2);

  frame4 = gtk_frame_new ("Source Editor");
  gtk_box_pack_start (GTK_BOX (vbox4), frame4, FALSE, TRUE, 0);

  table3 = gtk_table_new (4, 2, FALSE);
  gtk_container_add (GTK_CONTAINER (frame4), table3);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_table_attach (GTK_TABLE (table3), hbox7, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox7), 2);

	wgt_dlgopt_gen_gotolineopt = gtk_entry_new_with_max_length(sizeof(config.goto_line_option));
	gtk_box_pack_start (GTK_BOX (hbox7), wgt_dlgopt_gen_gotolineopt, TRUE, TRUE, 4);

  wgt_dlgopt_gen_gotolineopt_after = gtk_check_button_new_with_label ("After");
  gtk_box_pack_start (GTK_BOX (hbox7), wgt_dlgopt_gen_gotolineopt_after, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wgt_dlgopt_gen_gotolineopt_after), TRUE);

  label15 = gtk_label_new ("Executable:");
  gtk_table_attach (GTK_TABLE (table3), label15, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 4, 0);
  gtk_misc_set_alignment (GTK_MISC (label15), 1, 0.5);

  label15 = gtk_label_new ("[parameter 1]:");
  gtk_table_attach (GTK_TABLE (table3), label15, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 4, 0);
  gtk_misc_set_alignment (GTK_MISC (label15), 1, 0.5);

  label15 = gtk_label_new ("[parameter 2]:");
  gtk_table_attach (GTK_TABLE (table3), label15, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 4, 0);
  gtk_misc_set_alignment (GTK_MISC (label15), 1, 0.5);

  label17 = gtk_label_new ("Goto Line option:");
  gtk_table_attach (GTK_TABLE (table3), label17, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 4, 0);
  gtk_misc_set_alignment (GTK_MISC (label17), 1, 0.5);

	wgt_dlgopt_gen_editor1 = gtk_entry_new_with_max_length(sizeof(config.editor1));
	gtk_table_attach (GTK_TABLE (table3), wgt_dlgopt_gen_editor1, 1, 2, 0, 1,
		(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		(GtkAttachOptions) (0), 4, 0);

	wgt_dlgopt_gen_editor2 = gtk_entry_new_with_max_length(sizeof(config.editor2));
	gtk_table_attach (GTK_TABLE (table3), wgt_dlgopt_gen_editor2, 1, 2, 1, 2,
		(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		(GtkAttachOptions) (0), 4, 0);

	wgt_dlgopt_gen_editor3 = gtk_entry_new_with_max_length(sizeof(config.editor3));
	gtk_table_attach (GTK_TABLE (table3), wgt_dlgopt_gen_editor3, 1, 2, 2, 3,
		(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		(GtkAttachOptions) (0), 4, 0);

  label14 = gtk_label_new ("General");
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), 
  	gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), label14);

  wgt_vbox_project = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (notebook1), wgt_vbox_project);
  gtk_container_set_border_width (GTK_CONTAINER (wgt_vbox_project), 2);

  frame5 = gtk_frame_new ("Executable");
  gtk_box_pack_start (GTK_BOX (wgt_vbox_project), frame5, FALSE, TRUE, 0);

  table4 = gtk_table_new (3, 2, FALSE);
  gtk_container_add (GTK_CONTAINER (frame5), table4);
  gtk_container_set_border_width (GTK_CONTAINER (table4), 2);

	wgt_dlgopt_project_exename = gtk_entry_new_with_max_length(sizeof(config.exe_name));
	gtk_table_attach (GTK_TABLE (table4), wgt_dlgopt_project_exename, 1, 2, 0, 1,
		(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		(GtkAttachOptions) (0), 4, 0);

	wgt_dlgopt_project_headerincl = gtk_entry_new_with_max_length(sizeof(config.header_to_include));
	gtk_table_attach (GTK_TABLE (table4), wgt_dlgopt_project_headerincl, 1, 2, 1, 2,
		(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		(GtkAttachOptions) (0), 4, 0);

  label20 = gtk_label_new ("Header to include:");
  gtk_table_attach (GTK_TABLE (table4), label20, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 4, 0);
  gtk_misc_set_alignment (GTK_MISC (label20), 1, 0.5);

  label19 = gtk_label_new ("Executable name:");
  gtk_table_attach (GTK_TABLE (table4), label19, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 4, 0);
  gtk_misc_set_alignment (GTK_MISC (label19), 1, 0.5);

  wgt_frame_gnome = gtk_frame_new ("Gnome:");
  gtk_box_pack_start (GTK_BOX (wgt_vbox_project), wgt_frame_gnome, FALSE, TRUE, 0);

  table5 = gtk_table_new (2, 2, FALSE);
  gtk_container_add (GTK_CONTAINER (wgt_frame_gnome), table5);
  gtk_container_set_border_width (GTK_CONTAINER (table5), 2);

  label22 = gtk_label_new ("Gnome support:");
  gtk_table_attach (GTK_TABLE (table5), label22, 0, 1, 0, 1,
                   (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 4, 0);
  gtk_misc_set_alignment (GTK_MISC (label22), 1, 0.5);

  wgt_dlgopt_project_isgnome = gtk_check_button_new_with_label ("Yes");
   gtk_misc_set_alignment (GTK_MISC (wgt_dlgopt_project_isgnome), 0, 0.5);
 gtk_table_attach (GTK_TABLE (table5), wgt_dlgopt_project_isgnome, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 4, 0);

  frame7 = gtk_frame_new ("Language (apply to New Project)");
  gtk_box_pack_start (GTK_BOX (wgt_vbox_project), frame7, TRUE, TRUE, 0);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame7), hbox9);

  wgt_dlgopt_project_lang_newprj_c = gtk_radio_button_new_with_label (NULL, "C");
  gtk_box_pack_start (GTK_BOX (hbox9), wgt_dlgopt_project_lang_newprj_c, FALSE, FALSE, 4);
  hbox9_group = gtk_radio_button_group (GTK_RADIO_BUTTON (wgt_dlgopt_project_lang_newprj_c));

#ifdef GLG_SUPPORT_LANGUAGECPP
  wgt_dlgopt_project_lang_newprj_cpp = gtk_radio_button_new_with_label (hbox9_group, "C++");
  gtk_box_pack_start (GTK_BOX (hbox9), wgt_dlgopt_project_lang_newprj_cpp, FALSE, FALSE, 4);
#endif


  frame8 = gtk_frame_new ("Language (this project)");
  gtk_box_pack_start (GTK_BOX (wgt_vbox_project), frame8, TRUE, TRUE, 0);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame8), hbox9);

  wgt_dlgopt_project_lang_current_c = gtk_radio_button_new_with_label (NULL, "C");
  gtk_box_pack_start (GTK_BOX (hbox9), wgt_dlgopt_project_lang_current_c, FALSE, FALSE, 4);
  gtk_widget_set_sensitive( GTK_WIDGET(wgt_dlgopt_project_lang_current_c), FALSE );
  hbox9_group = gtk_radio_button_group (GTK_RADIO_BUTTON (wgt_dlgopt_project_lang_current_c));

#ifdef GLG_SUPPORT_LANGUAGECPP
  wgt_dlgopt_project_lang_current_cpp = gtk_radio_button_new_with_label (hbox9_group, "C++");
  gtk_box_pack_start (GTK_BOX (hbox9), wgt_dlgopt_project_lang_current_cpp, FALSE, FALSE, 4);
  gtk_widget_set_sensitive( GTK_WIDGET(wgt_dlgopt_project_lang_current_cpp), FALSE );
#endif


  label18 = gtk_label_new ("Project");
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), 
  	gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 3), label18);

  hseparator1 = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, TRUE, 4);

  hbox1 = gtk_hbox_new (FALSE, 8);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 4);

  wgt_dlgopt_btn_ok = gtk_button_new_with_label ("Ok");
  gtk_box_pack_start (GTK_BOX (hbox1), wgt_dlgopt_btn_ok, TRUE, TRUE, 0);
   gtk_signal_connect( GTK_OBJECT(wgt_dlgopt_btn_ok), "clicked",
		GTK_SIGNAL_FUNC(cb_ok), (gpointer)is_project );
 
  wgt_dlgopt_btn_cancel = gtk_button_new_with_label ("Cancel");
  gtk_box_pack_start (GTK_BOX (hbox1), wgt_dlgopt_btn_cancel, TRUE, TRUE, 0);
   gtk_signal_connect( GTK_OBJECT(wgt_dlgopt_btn_cancel), "clicked",
		GTK_SIGNAL_FUNC(cb_cancel), NULL );

  gtk_window_add_accel_group (GTK_WINDOW (wgt_window_prjopt), accel_group);

}								// create_wgt_window_prjopt


PUBLIC void
dialog_project_options( const int is_project )
{

	create_wgt_window_prjopt( is_project );
	gtk_window_set_modal( GTK_WINDOW(wgt_window_prjopt), TRUE );
	gtk_widget_set_sensitive( wgt_vbox_project,
		(is_project) ? TRUE : FALSE );
	write_screen( is_project );
	gtk_widget_show_all( wgt_window_prjopt );

	push_block_all_windows();
	while ( wgt_window_prjopt != NULL )
		gtk_main_iteration();
	pop_block_all_windows();

	update_main_menu();

}								// dialog_project_options

