#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <unistd.h>
#include <sys/time.h>
#include <errno.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


static GtkWidget	*wgt_res_edit_bool	INIT( NULL );
static GtkWidget	*wgt_label;
static GtkWidget	*wgt_btn_yes;
static GtkWidget	*wgt_btn_no;
static GtkWidget	*wgt_btn_default;
static GtkWidget	*wgt_btn_cancel;
static GtkWidget	*wgt_btn_apply;
static GtkWidget	*wgt_btn_ok;

static void
cb_btn_no_clicked(GtkButton *button, gpointer user_data);


typedef struct
{
	GtkWidget		*wgt_parent;
	defclass_t		*defclass;
	gtk_wgtdef_t	*wgtdef;
	gtk_wgtdef_t	*wgtdef_depth;
}	text_data_t;


typedef struct
{
	defclass_t		*defclass;
	int				state;
	GtkWidget		*wgt_parent;
	int				first;
	gtk_wgtdef_t	*wgtdef;
	gtk_wgtdef_t	*wgtdef_depth;
}	foreach_selection_data;


static void
foreach_selection( gpointer data, gpointer user_data )
{
	GtkWidget				*wgt = GTK_WIDGET( data );
	foreach_selection_data	*user = (foreach_selection_data *)user_data;

	/*--- Set the resource of the widget ---*/
	set_res_bool( wgt, user->state,
		user->wgtdef, user->wgtdef_depth, user->defclass, user->wgt_parent );

}								// foreach_selection


/*--- This CB is used to avoid the close of window when user clicks X - top/right corner ---*/
static gint
cb_close_window( GtkWidget * widget, gpointer data )
{
	return TRUE;
}								// cb_close_window


/* Callback "clicked" for GtkButton widget wgt_btn_default */
static void
cb_btn_default(GtkButton *button, gpointer user_data)
{
	
}								// cb_btn_default


/* Callback "clicked" for GtkButton widget wgt_btn_cancel */
static void
cb_btn_cancel(GtkButton *button, gpointer user_data)
{
	
	/*--- Close the dialog ---*/
	gtk_widget_destroy( wgt_res_edit_bool );
	wgt_res_edit_bool = NULL;
	
}								// cb_btn_cancel


/* Callback "clicked" for GtkButton widget wgt_btn_apply */
static void
cb_btn_apply(GtkButton *button, gpointer user_data)
{
	text_data_t				*text_data;
	int						state;
	foreach_selection_data	data;

	text_data = (text_data_t *)get_object_data( wgt_btn_yes, "text_data" );
	assert( text_data != NULL );

	state = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( wgt_btn_yes) );
	data.state   	  = state;
	data.defclass 	  = text_data->defclass;
	data.wgt_parent   = text_data->wgt_parent;
	data.first		  = TRUE;
	data.wgtdef		  = text_data->wgtdef;
	data.wgtdef_depth = text_data->wgtdef_depth;
	g_slist_foreach( list_selection, foreach_selection, &data );
	
}								// cb_btn_apply


/* Callback "clicked" for GtkButton widget wgt_btn_ok */
static void
cb_btn_ok(GtkButton *button, gpointer user_data)
{
	
	cb_btn_apply( button, user_data );

	/*--- Close the dialog ---*/
	gtk_widget_destroy( wgt_res_edit_bool );
	wgt_res_edit_bool = NULL;
	
}								// cb_btn_ok


/* Callback "clicked" for GtkRadioButton widget wgt_btn_yes */
static void
cb_btn_yes_clicked(GtkButton *button, gpointer user_data)
{

	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_apply), TRUE );
	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_ok), TRUE );

	gtk_signal_handler_block_by_func( GTK_OBJECT( wgt_btn_no ), 
		GTK_SIGNAL_FUNC( cb_btn_no_clicked ), NULL );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_btn_no ), FALSE );
	gtk_signal_handler_unblock_by_func( GTK_OBJECT( wgt_btn_no ), 
		GTK_SIGNAL_FUNC( cb_btn_no_clicked ), NULL );

}								// cb_btn_yes_clicked


/* Callback "toggled" for GtkRadioButton widget wgt_btn_no */
static void
cb_btn_no_clicked(GtkButton *button, gpointer user_data)
{

	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_apply), TRUE );
	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_ok), TRUE );
	
	gtk_signal_handler_block_by_func( GTK_OBJECT( wgt_btn_yes ), 
		GTK_SIGNAL_FUNC( cb_btn_yes_clicked ), NULL );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_btn_yes ), FALSE );
	gtk_signal_handler_unblock_by_func( GTK_OBJECT( wgt_btn_yes ), 
		GTK_SIGNAL_FUNC( cb_btn_yes_clicked ), NULL );

}								// cb_btn_no_clicked


static GtkWidget *
create_window( GtkWidget *parent, char *title )
{
	GtkWidget	*wgt_1_2, *wgt_2_4, *wgt_2_7;

	wgt_res_edit_bool = gtk_widget_new( gtk_window_get_type(),
		"width", 329,
		"height", 166,
		"events", 0x0000030C,
		"resize_mode", GTK_RESIZE_QUEUE,
		"title", title,
		"allow_grow", TRUE,
		"default_width", 280,
		"default_height", 160,
		NULL );

	wgt_1_2 = gtk_widget_new( gtk_vbox_get_type(),
		"parent", wgt_res_edit_bool,
		NULL );

	wgt_label = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_label,
		"expand", FALSE,
		NULL );

	wgt_2_4 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_1_2,
		"border_width", 48,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_4,
		"position", 1,
		NULL );

	wgt_btn_yes = gtk_widget_new( gtk_check_button_get_type(),
		"parent", wgt_2_4,
		"can_focus", TRUE,
		"label", "Yes",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_4 ), wgt_btn_yes,
		"fill", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_yes ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_yes_clicked ), NULL );

	wgt_btn_no = gtk_widget_new( gtk_check_button_get_type(),
		"parent", wgt_2_4,
		"can_focus", TRUE,
		"label", "No",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_4 ), wgt_btn_no,
		"fill", FALSE,
		"position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_no ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_no_clicked ), NULL );

	wgt_2_7 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_1_2,
		"border_width", 4,
		"spacing", 8,
		"homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_7,
		"expand", FALSE,
		"position", 2,
		NULL );

	wgt_btn_default = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_7,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "Default",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_7 ), wgt_btn_default,
		"expand", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_default ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_default ), NULL );

	wgt_btn_cancel = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_7,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "Cancel",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_7 ), wgt_btn_cancel,
		"expand", FALSE,
		"position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_cancel ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_cancel ), NULL );

	wgt_btn_apply = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_7,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "Apply",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_7 ), wgt_btn_apply,
		"expand", FALSE,
		"position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_apply ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_apply ), NULL );

	wgt_btn_ok = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_7,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "Ok",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_7 ), wgt_btn_ok,
		"expand", FALSE,
		"position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_ok ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_ok ), NULL );

	return wgt_res_edit_bool;

}								// create_window


PUBLIC void
dlg_res_editor_bool( GtkWidget *wgt_btn,
	defclass_t *defclass, 
	GtkWidget *wgt_parent,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth )
{
	int				value;
	text_data_t		*text_data;
	char			title[ 200 ];
	GtkWidget		*wgt_selected;
	GtkArg			arg, *parg;

	/*--- Create the dialog ---*/
	wgt_selected = GTK_WIDGET( g_slist_last( list_selection )->data );
	assert( wgt_selected != NULL );
	if ( get_nametype_wgt( wgt_selected ) == NAMETYPE_GLOBAL )
	{
		char *widget_name = get_name_wgt( wgt_selected );
		sprintf( title, "%s::%s\n",
			widget_name, defclass->resname );
	}
	else
	{
		sprintf( title, "Resource %s\n",
			defclass->resname );
	}
	create_window( NULL, title );

	/*--- First read current value (stored inside the widget or not) ---*/
	if ( get_res_bool( wgt_selected, wgtdef, wgtdef_depth, defclass, wgt_parent, &arg, &parg ) == -1 )
		return;

	/*--- Update data ---*/
	value = GTK_VALUE_BOOL( arg  );
	if ( value )
	{
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_btn_yes), TRUE );
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_btn_no ), FALSE );
	}
	else
	{
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_btn_no ), TRUE );
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_btn_yes), FALSE );
	}
	text_data = malloc( sizeof( text_data_t ) );
	memset( text_data, 0, sizeof( text_data_t ) );
	text_data->wgt_parent	 = wgt_parent;
	text_data->defclass	 	 = defclass;
	text_data->wgtdef		 = wgtdef;
	text_data->wgtdef_depth  = wgtdef_depth;
	set_object_data( wgt_btn_yes, "text_data", text_data, TRUE );
	set_object_data( wgt_btn_no,  "text_data", text_data, FALSE );

	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_default), FALSE );
	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_apply), FALSE );
	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_ok), FALSE );

	gtk_signal_connect( GTK_OBJECT(wgt_res_edit_bool), "delete_event",
		GTK_SIGNAL_FUNC(cb_close_window), NULL );
	gtk_widget_show_all( wgt_res_edit_bool );

	push_block_all_windows();
	while ( wgt_res_edit_bool != NULL )
		gtk_main_iteration();
	pop_block_all_windows();

}								// dlg_res_editor_bool
