#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <math.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


static GtkWidget	*wgt_res_edit_int = NULL;
static gboolean cb_num_focus_out(GtkWidget *widget, GdkEventFocus *event, gpointer user_data);	// xx.c
static void cb_num_changed(GtkEditable *editable, gpointer user_data);	// xx.c
static void cb_btn_default(GtkButton *button, gpointer user_data);	// xx.c
static void cb_btn_cancel(GtkButton *button, gpointer user_data);	// xx.c
static void cb_btn_apply(GtkButton *button, gpointer user_data);	// xx.c
static void cb_btn_ok(GtkButton *button, gpointer user_data);	// xx.c
static GtkWidget	*wgt_label;
static GtkWidget	*wgt_int;
static GtkWidget	*wgt_btn_default;
static GtkWidget	*wgt_btn_cancel;
static GtkWidget	*wgt_btn_apply;
static GtkWidget	*wgt_btn_ok;


typedef struct
{
	GtkWidget		*wgt_parent;
	defclass_t		*defclass;
	gtk_wgtdef_t	*wgtdef;
	gtk_wgtdef_t	*wgtdef_depth;
}	text_data_t;


typedef struct
{
	defclass_t		*defclass;
	GtkArg			arg;
	GtkWidget		*wgt_parent;
	int				first;
	gtk_wgtdef_t	*wgtdef;
	gtk_wgtdef_t	*wgtdef_depth;
}	foreach_selection_data;


static void
foreach_selection( gpointer data, gpointer user_data )
{
	GtkWidget				*wgt = GTK_WIDGET( data );
	foreach_selection_data	*user = (foreach_selection_data *)user_data;

	/*--- Set the resource of the widget ---*/
	set_res_int( wgt, &user->arg,
		user->wgtdef, user->wgtdef_depth, user->defclass, user->wgt_parent,
		NULL, NULL );

}								// foreach_selection


/*--- This CB is used to avoid the close of window when user clicks X - top/right corner ---*/
static gint
cb_close_window( GtkWidget * widget, gpointer data )
{
	return TRUE;
}								// cb_close_window


/* Callback "clicked" for GtkButton widget wgt_btn_default */
static void
cb_btn_default(GtkButton *button, gpointer user_data)
{
	
}								// cb_btn_default


/* Callback "clicked" for GtkButton widget wgt_btn_cancel */
static void
cb_btn_cancel(GtkButton *button, gpointer user_data)
{

	/*--- Close the dialog ---*/
	gtk_widget_destroy( wgt_res_edit_int );
	wgt_res_edit_int = NULL;
	
}								// cb_btn_cancel


/* Callback "clicked" for GtkButton widget wgt_btn_apply */
static void
cb_btn_apply(GtkButton *button, gpointer user_data)
{
	text_data_t				*text_data;
	foreach_selection_data	data;
	gfloat					value;

	text_data = (text_data_t *)get_object_data( wgt_int, "text_data" );
	assert( text_data != NULL );

	data.arg.name = text_data->defclass->resname;
	value = gtk_spin_button_get_value_as_float( GTK_SPIN_BUTTON( wgt_int ) );
	switch ( text_data->defclass->restype )
	{
#if 0
		case GTK_TYPE_INT :
			gtk_spin_button_set_value( GTK_SPIN_BUTTON( wgt_int ), GTK_VALUE_INT( arg ) );
			break;
		case GTK_TYPE_UINT :
			SET( GTK_VALUE_UINT );
			break;
		case GTK_TYPE_LONG :
			SET( GTK_VALUE_LONG );
			break;
#endif
		case GTK_TYPE_ULONG :
			GTK_VALUE_ULONG( data.arg ) = value;
			break;
#if 0
		case GTK_TYPE_FLOAT :
			SET( GTK_VALUE_FLOAT );
			break;
#endif
	}							// switch

	data.defclass 	  = text_data->defclass;
	data.wgt_parent   = text_data->wgt_parent;
	data.first		  = TRUE;
	data.wgtdef		  = text_data->wgtdef;
	data.wgtdef_depth = text_data->wgtdef_depth;
	g_slist_foreach( list_selection, foreach_selection, &data );
	
	/*--- Reselect current selected widget ---*/
	refresh_properties_selected_widgets();

	/*--- Enable 'Apply' only a next modification ---*/	
	gtk_widget_set_sensitive( GTK_WIDGET( wgt_btn_apply ), FALSE );

}								// cb_btn_apply


/* Callback "clicked" for GtkButton widget wgt_btn_ok */
static void
cb_btn_ok(GtkButton *button, gpointer user_data)
{
	
}								// cb_btn_ok


/* Callback "focus_out_event" for GtkSpinButton widget wgt_int */
static gboolean
cb_num_focus_out(GtkWidget *widget, GdkEventFocus *event, gpointer user_data)
{
	return FALSE;
}								// cb_num_focus_out


/* Callback "changed" for GtkSpinButton widget wgt_int */
static void
cb_num_changed(GtkEditable *editable, gpointer user_data)
{

	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_apply), TRUE );
	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_ok), TRUE );
	
}								// cb_num_changed


static GtkWidget *
create_window( GtkWidget *parent, char *title )
{
	GtkWidget	*wgt_1_2, *wgt_2_4, *wgt_2_6;

	wgt_res_edit_int = gtk_widget_new( gtk_window_get_type(),
		"width", 320,
		"height", 150,
		"events", 0x0000030C,
		"resize_mode", GTK_RESIZE_QUEUE,
		"title", title,
		"allow_grow", TRUE,
		"default_width", 320,
		"default_height", 150,
		NULL );

	wgt_1_2 = gtk_widget_new( gtk_vbox_get_type(),
		"parent", wgt_res_edit_int,
		NULL );

	wgt_label = gtk_widget_new( gtk_label_get_type(),
		"parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_label,
		"expand", FALSE,
		NULL );

	wgt_2_4 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_1_2,
		"border_width", 48,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_4,
		"position", 1,
		NULL );

	wgt_int = gtk_widget_new( gtk_spin_button_get_type(),
		"parent", wgt_2_4,
		"can_focus", TRUE,
		"events", 0x00000800,
		"adjustment", gtk_adjustment_new( 0.000000, -MAXFLOAT, MAXFLOAT, 0.000000, 0.000000, 0.000000 ),
		NULL );
	gtk_spin_button_set_update_policy( GTK_SPIN_BUTTON( wgt_int ), GTK_UPDATE_ALWAYS );
	gtk_signal_connect( GTK_OBJECT( wgt_int ), "focus_out_event",
		GTK_SIGNAL_FUNC( cb_num_focus_out ), NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_int ), "changed",
		GTK_SIGNAL_FUNC( cb_num_changed ), NULL );

	wgt_2_6 = gtk_widget_new( gtk_hbox_get_type(),
		"parent", wgt_1_2,
		"border_width", 4,
		"spacing", 8,
		"homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_6,
		"expand", FALSE,
		"position", 2,
		NULL );

	wgt_btn_default = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_6,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "Default",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_6 ), wgt_btn_default,
		"expand", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_default ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_default ), NULL );

	wgt_btn_cancel = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_6,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "Cancel",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_6 ), wgt_btn_cancel,
		"expand", FALSE,
		"position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_cancel ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_cancel ), NULL );

	wgt_btn_apply = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_6,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "Apply",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_6 ), wgt_btn_apply,
		"expand", FALSE,
		"position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_apply ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_apply ), NULL );

	wgt_btn_ok = gtk_widget_new( gtk_button_get_type(),
		"parent", wgt_2_6,
		"can_focus", TRUE,
		"receives_default", TRUE,
		"label", "Ok",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_6 ), wgt_btn_ok,
		"expand", FALSE,
		"position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_ok ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_ok ), NULL );

	return wgt_res_edit_int;

}								// create_window


PUBLIC void
dlg_res_editor_int( GtkWidget *wgt_btn,  
	defclass_t *defclass, 
	GtkWidget *wgt_parent,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth )
{
	text_data_t		*text_data;
	char			title[ 200 ];
	GtkWidget		*wgt_selected;
	GtkArg			arg;

	/*--- Create the dialog ---*/
	wgt_selected = GTK_WIDGET( g_slist_last( list_selection )->data );
	assert( wgt_selected != NULL );
	if ( get_nametype_wgt( wgt_selected ) == NAMETYPE_GLOBAL )
	{
		char *widget_name = get_name_wgt( wgt_selected );
		sprintf( title, "%s::%s\n",
			widget_name, defclass->resname );
	}
	else
	{
		sprintf( title, "Resource %s\n",
			defclass->resname );
	}
	create_window( NULL, title );

	/*--- First read current value (stored inside the widget or not) ---*/
	if ( get_res_int( wgt_selected, wgtdef, wgtdef_depth, defclass, wgt_parent, &arg ) == -1 )
		return;

	/*--- Update data ---*/
	switch ( defclass->restype )
	{
		case GTK_TYPE_INT :
			gtk_spin_button_set_value( GTK_SPIN_BUTTON( wgt_int ), GTK_VALUE_INT( arg ) );
			break;
#if 0
		case GTK_TYPE_UINT :
			SET( GTK_VALUE_UINT );
			break;
		case GTK_TYPE_LONG :
			SET( GTK_VALUE_LONG );
			break;
#endif
		case GTK_TYPE_ULONG :
			gtk_spin_button_set_value( GTK_SPIN_BUTTON( wgt_int ), GTK_VALUE_ULONG( arg ) );
			break;
#if 0
		case GTK_TYPE_FLOAT :
			SET( GTK_VALUE_FLOAT );
			break;
#endif
	}							// switch
	gtk_spin_button_update( GTK_SPIN_BUTTON( wgt_int ) );
	text_data = malloc( sizeof( text_data_t ) );
	memset( text_data, 0, sizeof( text_data_t ) );
	text_data->wgt_parent	 = wgt_parent;
	text_data->defclass	 	 = defclass;
	text_data->wgtdef		 = wgtdef;
	text_data->wgtdef_depth  = wgtdef_depth;
	set_object_data( wgt_int, "text_data", text_data, TRUE );

	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_default), FALSE );
	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_apply), FALSE );
	gtk_widget_set_sensitive( GTK_WIDGET(wgt_btn_ok), FALSE );

	gtk_signal_connect( GTK_OBJECT(wgt_res_edit_int), "delete_event",
		GTK_SIGNAL_FUNC(cb_close_window), NULL );
	gtk_widget_show_all( wgt_res_edit_int );

	push_block_all_windows();
	while ( wgt_res_edit_int != NULL )
		gtk_main_iteration();
	pop_block_all_windows();

}								// dlg_res_editor_int
