#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


static	GtkWidget *wgt_dialog_cb;
static	GtkWidget *wgt_dlgcb_list;
static	GtkWidget *wgt_dlgcb_btn_add;
static	GtkWidget *wgt_dlgcb_btn_delete;
static	GtkWidget *wgt_dlgcb_btn_update;
static	GtkWidget *wgt_dlgcb_btn_edit;
static	GtkWidget *wgt_dlgcb_frame_accelerator;
static	GtkWidget *wgt_label_callback;
static	GtkWidget *wgt_dlgcb_newcb_cb;
static	GtkWidget *wgt_dlgcb_newcb_file;
static	GtkWidget *wgt_dlgcb_newcb_after_yes;
static	GtkWidget *wgt_dlgcb_newcb_after_no;
static	GtkWidget *wgt_dlgcb_newcb_accelerator_yes;
static	GtkWidget *wgt_dlgcb_accel_key;
static	GtkWidget *wgt_dlgcb_accel_modifier_shift;
static	GtkWidget *wgt_dlgcb_accel_modifier_ctrl;
static	GtkWidget *wgt_dlgcb_accel_modifier_alt;
static	GtkWidget *wgt_dlgcb_accel_visible_yes;
static	GtkWidget *wgt_dlgcb_btn_cancel;
static	GtkWidget *wgt_dlgcb_btn_ok;

static	data_cb_t	datacb;
static	int			dlg_done;
static	int			select_hist_handler_id_select;
static	int			select_hist_handler_id_unselect;

static	int			is_cancel;


static void
block_list_signals( void )
{
	gtk_signal_handler_block( GTK_OBJECT( wgt_dlgcb_list ), select_hist_handler_id_select );
	gtk_signal_handler_block( GTK_OBJECT( wgt_dlgcb_list ), select_hist_handler_id_unselect );
}								// block_list_signals


static void
unblock_list_signals( void )
{
	gtk_signal_handler_unblock( GTK_OBJECT( wgt_dlgcb_list ), select_hist_handler_id_select );
	gtk_signal_handler_unblock( GTK_OBJECT( wgt_dlgcb_list ), select_hist_handler_id_unselect );
}								// unblock_list_signals


/*--- This CB is used to avoid the close of window when user clicks X - top/right corner ---*/
static gint
cb_close_window( GtkWidget * widget, gpointer data )
{
	return TRUE;
}								// cb_close_window


PUBLIC void
cb_destroy_signal_notify( gpointer data )
{
	data_cb_t	*datacb = (data_cb_t *)data;
	
	g_free( datacb->cb );
	g_free( datacb );

}								// cb_destroy_signal_notify


static void
cb_dlgcb_btn_add( GtkWidget *widget, void *data )
{
	defclasssignal_t	*defclasssignal = (defclasssignal_t *)data;
	char				*cbname, *cbfile;
	char				item[MAXSZ_CBNAME + MAXSZ_CB_FILENAME + 10];
	char 				*pitem[1];
	def_cb_t			*defcb;
	GtkWidget			*wgt_selected;
	module_info_t		*module;

	cbname = gtk_editable_get_chars( GTK_EDITABLE(wgt_dlgcb_newcb_cb), 0, -1 );
	cbfile = gtk_editable_get_chars( GTK_EDITABLE(wgt_dlgcb_newcb_file), 0, -1 );
	sprintf( item, "%s@%s", 
		cbname,
		(!strcmp(cbfile, "")) ? cbname : cbfile );

	pitem[0] = item;
	block_list_signals();
	gtk_clist_append( GTK_CLIST(wgt_dlgcb_list), pitem );
	unblock_list_signals();

	if ( datacb.nb_cb == 0 )
		datacb.cb = malloc(sizeof(def_cb_t));
	else
		datacb.cb = realloc(datacb.cb, (datacb.nb_cb+1) * sizeof(def_cb_t));
	defcb = &datacb.cb[datacb.nb_cb++];
	memset(defcb, 0, sizeof(def_cb_t));
	defcb->defclasssignal = defclasssignal;
	defcb->cbname = strdup(cbname);
	defcb->cbfile = (!strcmp(cbfile, "")) ? strdup(cbname) : strdup(cbfile);
	defcb->f_after = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_dlgcb_newcb_after_yes) );

	if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_newcb_accelerator_yes ) ) )
	{
		char		*key;
		
		defcb->is_accelerator = TRUE;
		key =  gtk_editable_get_chars( GTK_EDITABLE( GTK_COMBO( wgt_dlgcb_accel_key )->entry ), 0, -1 );
		defcb->accelerator_key_val = key_to_val( key );
		strcpy( defcb->accelerator_key_string, key );
		g_free( key );
		if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_modifier_shift ) ) )
			defcb->accelerator_mods |= GDK_SHIFT_MASK;
		if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_modifier_ctrl ) ) )
			defcb->accelerator_mods |= GDK_CONTROL_MASK;
		if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_modifier_alt ) ) )
			defcb->accelerator_mods |= GDK_MOD1_MASK;
		if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_visible_yes ) ) )
			defcb->accel_flags |= GTK_ACCEL_VISIBLE;

	}
	else
	{
		defcb->is_accelerator = FALSE;
	}

	g_free( cbname );
	g_free( cbfile );

	gtk_entry_set_text( GTK_ENTRY(wgt_dlgcb_newcb_cb), "" );
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgcb_newcb_file), "" );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgcb_newcb_after_yes), FALSE );

	/*--- This module has been modified ---*/
	wgt_selected = GTK_WIDGET( g_slist_last(list_selection)->data );
	assert( wgt_selected != NULL );
	module = get_object_data( wgt_selected, WGTDATA_MODULE );
	assert( module != NULL );
	project_touched( module );

}								// cb_dlgcb_btn_add
	
	
static void
cb_dlgcb_btn_delete( GtkWidget *widget, void *data )
{
	int					n, index;
	def_cb_t			*defcb;
	int					row;
	GtkWidget			*wgt_selected;

	/*--- Which one is selected ? ---*/
	row = (int)get_object_data( widget, "cb_info" );
	assert( row != 0 );
	row--;
	wgt_selected = GTK_WIDGET( g_slist_last(list_selection)->data );
	assert( wgt_selected != NULL );

	/*--- Delete the selected callback ---*/
	if ( datacb.nb_cb == 1 )
	{
		free( datacb.cb );
		datacb.cb = NULL;
	}
	else
	{
		defcb = malloc( (datacb.nb_cb - 1) * sizeof( def_cb_t ) );
		for ( index = 0, n = 0; n < datacb.nb_cb; n++ )
		{
			if ( n != row )
			{
				memmove( &defcb[ index ], &datacb.cb[ n ], sizeof( def_cb_t ) );
				index++;
			}
		}
		free( datacb.cb );
		datacb.cb = defcb;
	}
	datacb.nb_cb--;

	/*--- Remove the selected callback ---*/
	block_list_signals();
	gtk_clist_remove( GTK_CLIST( wgt_dlgcb_list ), row );
	gtk_clist_select_row(GTK_CLIST( wgt_dlgcb_list ), 0, 0);
	gtk_clist_unselect_row(GTK_CLIST( wgt_dlgcb_list ), 0, 0);
	unblock_list_signals();

	gtk_widget_set_sensitive( wgt_dlgcb_btn_delete, FALSE );
	gtk_widget_set_sensitive( wgt_dlgcb_btn_update, FALSE );
	gtk_widget_set_sensitive( wgt_dlgcb_btn_edit, FALSE );

}								// cb_dlgcb_btn_delete


static void
cb_dlgcb_btn_update( GtkWidget *widget, void *data )
{
	int				row;
	int				is_a_selection;
	def_cb_t		*defcb;
	char			*cbname, *cbfile;
	char			item[MAXSZ_CBNAME + MAXSZ_CB_FILENAME + 10];

	is_a_selection = (int)get_object_data( wgt_dlgcb_btn_add, "cb_info" );
	assert( is_a_selection );

	/*--- Which item is selected ? ---*/
	row = (int)get_object_data( widget, "cb_info" );
	assert( row != 0 );
	row--;

	/*--- Modify the callback ---*/
	defcb = &datacb.cb[ row ];
	cbname = gtk_editable_get_chars( GTK_EDITABLE(wgt_dlgcb_newcb_cb), 0, -1 );
	cbfile = gtk_editable_get_chars( GTK_EDITABLE(wgt_dlgcb_newcb_file), 0, -1 );
	sprintf( item, "%s@%s", 
		cbname,
		(!strcmp(cbfile, "")) ? cbname : cbfile );
	defcb->cbname = strdup(cbname);
	defcb->cbfile = (!strcmp(cbfile, "")) ? strdup(cbname) : strdup(cbfile);
	defcb->f_after = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_dlgcb_newcb_after_yes) );

	if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_newcb_accelerator_yes ) ) )
	{
		char		*key;
		
		defcb->is_accelerator = TRUE;
		key =  gtk_editable_get_chars( GTK_EDITABLE( GTK_COMBO( wgt_dlgcb_accel_key )->entry ), 0, -1 );
		defcb->accelerator_key_val = key_to_val( key );
		strcpy( defcb->accelerator_key_string, key );
		g_free( key );
		if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_modifier_shift ) ) )
			defcb->accelerator_mods |= GDK_SHIFT_MASK;
		if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_modifier_ctrl ) ) )
			defcb->accelerator_mods |= GDK_CONTROL_MASK;
		if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_modifier_alt ) ) )
			defcb->accelerator_mods |= GDK_MOD1_MASK;
		if ( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_visible_yes ) ) )
			defcb->accel_flags |= GTK_ACCEL_VISIBLE;

	}
	else
	{
		defcb->is_accelerator = FALSE;
	}

	g_free( cbname );
	g_free( cbfile );

	gtk_clist_set_text( GTK_CLIST(wgt_dlgcb_list), row, 0, item );

	gtk_widget_set_sensitive( wgt_dlgcb_btn_update, FALSE );

}								// cb_dlgcb_btn_update


static void 
cb_newcb_cb_changed( GtkEditable *editable,
	gpointer user_data )
{
	GtkWidget	*wgt_entry = (GtkWidget *)user_data;
	char		*str;
	int			is_a_selection;

	is_a_selection = (int)get_object_data( wgt_dlgcb_btn_add, "cb_info" );

	str = gtk_editable_get_chars( GTK_EDITABLE(wgt_entry), 0, -1 );
	if ( !is_a_selection && strcmp(str, "") )
		gtk_widget_set_sensitive( wgt_dlgcb_btn_add, TRUE );
	else
		gtk_widget_set_sensitive( wgt_dlgcb_btn_add, FALSE );
	gtk_widget_set_sensitive( wgt_dlgcb_btn_delete, FALSE );
	gtk_widget_set_sensitive( wgt_dlgcb_btn_update, FALSE );
	gtk_widget_set_sensitive( wgt_dlgcb_btn_edit, FALSE );
	g_free(str);

	block_list_signals();
	gtk_clist_select_row(GTK_CLIST( wgt_dlgcb_list ), 0, 0);
	gtk_clist_unselect_row(GTK_CLIST( wgt_dlgcb_list ), 0, 0);
	unblock_list_signals();

	gtk_widget_set_sensitive( wgt_dlgcb_btn_ok,
		(!strcmp( str, "" )) ? TRUE : FALSE );
	
}								// cb_newcb_cb_changed
	

static void 
cb_newcb_file_changed( GtkEditable *editable,
	gpointer user_data )
{
//	GtkWidget	*wgt_entry = (GtkWidget *)user_data;
	int			is_a_selection;

	is_a_selection = (int)get_object_data( wgt_dlgcb_btn_add, "cb_info" );

	if ( is_a_selection )
		gtk_widget_set_sensitive( wgt_dlgcb_btn_update, TRUE );

}								// cb_newcb_file_changed

	
static void 
cb_newcb_after_yes_toggled( GtkToggleButton *togglebutton,
	gpointer user_data )
{
	int			is_a_selection;

	is_a_selection = (int)get_object_data( wgt_dlgcb_btn_add, "cb_info" );

	if ( is_a_selection )
		gtk_widget_set_sensitive( wgt_dlgcb_btn_update, TRUE );

}								// cb_newcb_after_yes_toggled

	
static void 
cb_accel_visible_toggled( GtkToggleButton *togglebutton,
	gpointer user_data )
{
	int			is_a_selection;

	is_a_selection = (int)get_object_data( wgt_dlgcb_btn_add, "cb_info" );

	if ( is_a_selection )
		gtk_widget_set_sensitive( wgt_dlgcb_btn_update, TRUE );

}								// cb_accel_visible_toggled

	
static void 
cb_accel_modifier_shift_toggled( GtkToggleButton *togglebutton,
	gpointer user_data )
{
	int			is_a_selection;

	is_a_selection = (int)get_object_data( wgt_dlgcb_btn_add, "cb_info" );

	if ( is_a_selection )
		gtk_widget_set_sensitive( wgt_dlgcb_btn_update, TRUE );

}								// cb_accel_modifier_shift_toggled

	
static void 
cb_accel_modifier_ctrl_toggled( GtkToggleButton *togglebutton,
	gpointer user_data )
{
	int			is_a_selection;

	is_a_selection = (int)get_object_data( wgt_dlgcb_btn_add, "cb_info" );

	if ( is_a_selection )
		gtk_widget_set_sensitive( wgt_dlgcb_btn_update, TRUE );

}								// cb_accel_modifier_ctrl_toggled

	
static void 
cb_accel_modifier_alt_toggled( GtkToggleButton *togglebutton,
	gpointer user_data )
{
	int			is_a_selection;

	is_a_selection = (int)get_object_data( wgt_dlgcb_btn_add, "cb_info" );

	if ( is_a_selection )
		gtk_widget_set_sensitive( wgt_dlgcb_btn_update, TRUE );

}								// cb_accel_modifier_alt_toggled

	
static void
cb_dlgcb_btn_edit( GtkWidget *widget, void *data )
{
	int			row;
	GtkWidget	*wgt_selected;

	row = (int)get_object_data( widget, "cb_info" );
	assert( row != 0 );
	row--;

	wgt_selected = GTK_WIDGET( g_slist_last(list_selection)->data );
	assert( wgt_selected != NULL );
	
	edit_cb( wgt_selected, &datacb.cb[ row ] );

}								// cb_dlgcb_btn_edit


static void
cb_dlgcb_btn_ok( GtkWidget *widget, void *data )
{
	dlg_done = TRUE;
	is_cancel = FALSE;
}								// cb_dlgcb_btn_ok


static void
cb_dlgcb_btn_cancel( GtkWidget *widget, void *data )
{
	dlg_done = TRUE;
	is_cancel = TRUE;
}								// cb_dlgcb_btn_cancel


static void
cb_dlgcb_list_selected( GtkWidget * clist,
	gint row, gint column, GdkEventButton *event, gpointer data)
{
	int			xrow = row + 1;
	def_cb_t	*defcb;

	gtk_widget_set_sensitive( wgt_dlgcb_btn_delete,	TRUE );
	gtk_widget_set_sensitive( wgt_dlgcb_btn_update,	FALSE );
	gtk_widget_set_sensitive( wgt_dlgcb_btn_edit,	TRUE );

	set_object_data( wgt_dlgcb_btn_add,    "cb_info", (gpointer)TRUE, FALSE );
	set_object_data( wgt_dlgcb_btn_delete, "cb_info", (gpointer)xrow, FALSE );
	set_object_data( wgt_dlgcb_btn_update, "cb_info", (gpointer)xrow, FALSE );
	set_object_data( wgt_dlgcb_btn_edit,   "cb_info", (gpointer)xrow, FALSE );

	gtk_signal_handler_block_by_func( GTK_OBJECT( wgt_dlgcb_newcb_cb ), 
		GTK_SIGNAL_FUNC( cb_newcb_cb_changed ), wgt_dlgcb_newcb_cb );
	gtk_signal_handler_block_by_func( GTK_OBJECT( wgt_dlgcb_newcb_file ), 
		GTK_SIGNAL_FUNC( cb_newcb_file_changed ), wgt_dlgcb_newcb_file );
	defcb = &datacb.cb[ row ];
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgcb_newcb_cb), defcb->cbname );
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgcb_newcb_file), defcb->cbfile );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgcb_newcb_after_yes ), 
		(defcb->f_after) ? TRUE : FALSE );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgcb_newcb_after_no ), 
		(defcb->f_after) ? FALSE : TRUE );
	gtk_signal_handler_unblock_by_func( GTK_OBJECT( wgt_dlgcb_newcb_cb ), 
		GTK_SIGNAL_FUNC( cb_newcb_cb_changed ), wgt_dlgcb_newcb_cb );
	gtk_signal_handler_unblock_by_func( GTK_OBJECT( wgt_dlgcb_newcb_file ), 
		GTK_SIGNAL_FUNC( cb_newcb_file_changed ), wgt_dlgcb_newcb_file );

	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_newcb_accelerator_yes ), 
		(defcb->is_accelerator) ? TRUE : FALSE );
	if ( defcb->is_accelerator )
		gtk_widget_set_sensitive( wgt_dlgcb_frame_accelerator, TRUE );
	else
		gtk_widget_set_sensitive( wgt_dlgcb_frame_accelerator, FALSE );
	gtk_entry_set_text( GTK_ENTRY( GTK_COMBO( wgt_dlgcb_accel_key )->entry ),
		defcb->accelerator_key_string );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_modifier_shift ), 
		(defcb->accelerator_mods & GDK_SHIFT_MASK) ? TRUE : FALSE );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_modifier_ctrl ), 
		(defcb->accelerator_mods & GDK_CONTROL_MASK) ? TRUE : FALSE );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_modifier_alt ), 
		(defcb->accelerator_mods & GDK_MOD1_MASK) ? TRUE : FALSE );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_dlgcb_accel_visible_yes ), 
		(defcb->accel_flags & GTK_ACCEL_VISIBLE) ? TRUE : FALSE );

	gtk_widget_set_sensitive( wgt_label_callback,	FALSE );
	gtk_widget_set_sensitive( wgt_dlgcb_newcb_cb,	FALSE );

	gtk_widget_set_sensitive( wgt_dlgcb_btn_ok, TRUE );

}								// cb_dlgcb_list_selected


static void
cb_dlgcb_list_unselected( GtkWidget * clist,
	gint row, gint column, GdkEventButton *event, gpointer data)
{

	gtk_widget_set_sensitive( wgt_dlgcb_btn_delete,	FALSE );
	gtk_widget_set_sensitive( wgt_dlgcb_btn_update,	FALSE );
	gtk_widget_set_sensitive( wgt_dlgcb_btn_edit,	FALSE );

	set_object_data( wgt_dlgcb_btn_add,    "cb_info", (gpointer)FALSE, FALSE );

	gtk_signal_handler_block_by_func( GTK_OBJECT( wgt_dlgcb_newcb_cb ), 
		GTK_SIGNAL_FUNC( cb_newcb_cb_changed ), wgt_dlgcb_newcb_cb );
	gtk_signal_handler_block_by_func( GTK_OBJECT( wgt_dlgcb_newcb_file ), 
		GTK_SIGNAL_FUNC( cb_newcb_file_changed ), wgt_dlgcb_newcb_file );
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgcb_newcb_cb), "" );
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgcb_newcb_file), "" );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_dlgcb_newcb_after_yes), FALSE );
	gtk_signal_handler_unblock_by_func( GTK_OBJECT( wgt_dlgcb_newcb_cb ), 
		GTK_SIGNAL_FUNC( cb_newcb_cb_changed ), wgt_dlgcb_newcb_cb );
	gtk_signal_handler_unblock_by_func( GTK_OBJECT( wgt_dlgcb_newcb_file ), 
		GTK_SIGNAL_FUNC( cb_newcb_file_changed ), wgt_dlgcb_newcb_file );

	gtk_widget_set_sensitive( wgt_label_callback,	TRUE );
	gtk_widget_set_sensitive( wgt_dlgcb_newcb_cb,	TRUE );

}								// cb_dlgcb_list_unselected


static void 
cb_newcb_accelerator_yes_toggled( GtkToggleButton *togglebutton,
	gpointer user_data )
{
	int			is_a_selection;

	is_a_selection = (int)get_object_data( wgt_dlgcb_btn_add, "cb_info" );

	if ( is_a_selection )
		gtk_widget_set_sensitive( wgt_dlgcb_btn_update, TRUE );

	if ( gtk_toggle_button_get_active( togglebutton ) )
		gtk_widget_set_sensitive( wgt_dlgcb_frame_accelerator, TRUE );
	else
		gtk_widget_set_sensitive( wgt_dlgcb_frame_accelerator, FALSE );

}								// cb_newcb_accelerator_yes_toggled


static void
create_dialog_cb( defclasssignal_t *defclasssignal )
{
	GtkWidget	*wgt_1_2, *wgt_2_3, *wgt_3_4, *wgt_4_5, *wgt_3_7, 
				*wgt_2_12, *wgt_3_13, *wgt_4_14, *wgt_4_15, *wgt_4_16, 
				*wgt_4_19, *wgt_5_21, *wgt_4_22, *wgt_4_24, *wgt_3_27, 
				*wgt_4_28, *wgt_4_30, *wgt_4_35, *wgt_4_36, *wgt_4_37, 
				*wgt_2_38, *wgt_2_39;
	GtkWidget	*wgt_selected;
	char		title[ 200 ];
	GtkTooltips *tooltips;
	data_cb_t	*old_datacb;

	/*--- Is there a cb data attached to this widget ? ---*/
	assert( nb_selection() == 1 );
	wgt_selected = GTK_WIDGET( g_slist_last(list_selection)->data );
	assert( wgt_selected != NULL );
	old_datacb = get_object_data( wgt_selected, defclasssignal->resname );
	if ( old_datacb == NULL )
	{
		datacb.nb_cb = 0;
		datacb.cb = NULL;
	}
	else
	{
		datacb.nb_cb = old_datacb->nb_cb;
		datacb.cb = malloc( sizeof(def_cb_t) * datacb.nb_cb );
		memmove( datacb.cb, old_datacb->cb, sizeof(def_cb_t) * datacb.nb_cb );
	}
	
	tooltips = gtk_tooltips_new ();

	if ( get_nametype_wgt( wgt_selected ) == NAMETYPE_GLOBAL )
	{
		char *widget_name = get_name_wgt( wgt_selected );
		sprintf( title, "%s::%s\n",
			widget_name, defclasssignal->resname );
	}
	else
	{
		sprintf( title, "%s::%s\n",
			gtk_widget_get_name( wgt_selected ), defclasssignal->resname );
	}

	wgt_dialog_cb = gtk_widget_new( gtk_window_get_type(),
		"GtkWidget::width", 490,
		"GtkWidget::height", 440,
		"GtkWidget::events", 0x0000030C,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkWindow::title", title,
		"GtkWindow::allow_grow", TRUE,
		"GtkWindow::default_width", 400,
		"GtkWindow::default_height", 300,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dialog_cb ), "delete_event",
		GTK_SIGNAL_FUNC( cb_close_window ), NULL );

	wgt_1_2 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_dialog_cb,
		NULL );

	wgt_2_3 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );

	wgt_3_4 = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", wgt_2_3,
		"GtkFrame::label", "Current Callbacks",
		NULL );

	wgt_4_5 = gtk_widget_new( gtk_scrolled_window_get_type(),
		"GtkWidget::parent", wgt_3_4,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkScrolledWindow::hadjustment", gtk_adjustment_new( 0.000000, 0.000000, 872.000000, 10.000000, 216.000000, 433.000000 ),
		"GtkScrolledWindow::vadjustment", gtk_adjustment_new( 0.000000, 0.000000, 1.000000, 15.000000, 90.000000, 1.000000 ),
		"GtkScrolledWindow::hscrollbar_policy", GTK_POLICY_NEVER,
		"GtkScrolledWindow::vscrollbar_policy", GTK_POLICY_AUTOMATIC,
		NULL );

	wgt_dlgcb_list = gtk_widget_new( gtk_clist_get_type(),
		"GtkWidget::parent", wgt_4_5,
		"GtkWidget::can_focus", TRUE,
		NULL );
	if (old_datacb != NULL )
	{
		char	*pitem[1];
		int		n;
		char	item[MAXSZ_CBNAME + MAXSZ_CB_FILENAME + 10];
		for ( n = 0; n < datacb.nb_cb; n++ )
		{
			sprintf( item, "%s@%s.c", datacb.cb[n].cbname, datacb.cb[n].cbfile );
			pitem[0] = item;
			gtk_clist_append(GTK_CLIST(wgt_dlgcb_list), pitem);
		}
		gtk_clist_select_row(GTK_CLIST(wgt_dlgcb_list), 0, 0);
		gtk_clist_unselect_row(GTK_CLIST(wgt_dlgcb_list), 0, 0);
	}
	select_hist_handler_id_select = 
		gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_list ), "select_row",
			GTK_SIGNAL_FUNC( cb_dlgcb_list_selected ), NULL );
	select_hist_handler_id_unselect =
		gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_list ), "unselect_row",
			GTK_SIGNAL_FUNC( cb_dlgcb_list_unselected ), NULL );

	wgt_3_7 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", wgt_2_3,
		"GtkBox::spacing", 4,
		"GtkBox::homogeneous", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_3 ), wgt_3_7,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 2,
		"GtkBox::position", 1,
		NULL );

	wgt_dlgcb_btn_add = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_3_7,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Add",
		"GtkWidget::sensitive", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_btn_add ), "clicked",
		GTK_SIGNAL_FUNC( cb_dlgcb_btn_add ), defclasssignal );

	wgt_dlgcb_btn_delete = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_3_7,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Delete",
		"GtkWidget::sensitive", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_7 ), wgt_dlgcb_btn_delete,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_btn_delete ), "clicked",
		GTK_SIGNAL_FUNC( cb_dlgcb_btn_delete ), NULL );

	wgt_dlgcb_btn_update = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_3_7,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Update",
		"GtkWidget::sensitive", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_7 ), wgt_dlgcb_btn_update,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_btn_update ), "clicked",
		GTK_SIGNAL_FUNC( cb_dlgcb_btn_update ), NULL );

	wgt_dlgcb_btn_edit = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_3_7,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Edit",
		"GtkWidget::sensitive", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_7 ), wgt_dlgcb_btn_edit,
		"GtkBox::position", 3,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_btn_edit ), "clicked",
		GTK_SIGNAL_FUNC( cb_dlgcb_btn_edit ), NULL );

	wgt_2_12 = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkFrame::label", "Callback Description",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_12,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 1,
		NULL );

	wgt_3_13 = gtk_widget_new( gtk_table_get_type(),
		"GtkWidget::parent", wgt_2_12,
		"GtkTable::n_rows", 4,
		"GtkTable::n_columns", 2,
		"GtkTable::row_spacing", 2,
		"GtkTable::column_spacing", 4,
		NULL );

	wgt_4_14 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_3_13,
		"GtkMisc::xalign", 0.950000,
		"GtkLabel::label", "Accelerator:",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_13 ), wgt_4_14,
		"GtkTable::top_attach", 3,
		"GtkTable::bottom_attach", 4,
		"GtkTable::x_options", 0x00000004,
		NULL );

	wgt_4_15 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_3_13,
		"GtkMisc::xalign", 0.950000,
		"GtkLabel::label", "After:",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_13 ), wgt_4_15,
		"GtkTable::top_attach", 2,
		"GtkTable::bottom_attach", 3,
		"GtkTable::x_options", 0x00000004,
		NULL );

	wgt_4_16 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_3_13,
		"GtkMisc::xalign", 0.950000,
		"GtkLabel::label", "File:",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_13 ), wgt_4_16,
		"GtkTable::top_attach", 1,
		"GtkTable::bottom_attach", 2,
		"GtkTable::x_options", 0x00000004,
		NULL );

	wgt_label_callback = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_3_13,
		"GtkMisc::xalign", 0.950000,
		"GtkLabel::label", "Callback:",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_13 ), wgt_label_callback,
		"GtkTable::x_options", 0x00000004,
		NULL );

	wgt_dlgcb_newcb_cb = gtk_widget_new( gtk_entry_get_type(),
		"GtkWidget::parent", wgt_3_13,
		"GtkWidget::can_focus", TRUE,
		"GtkEntry::max_length", MAXSZ_CBNAME,
		NULL );
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgcb_newcb_cb), "" );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_13 ), wgt_dlgcb_newcb_cb,
		"GtkTable::left_attach", 1,
		"GtkTable::right_attach", 2,
		"GtkTable::y_options", 0x00000000,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_newcb_cb ), "changed",
		GTK_SIGNAL_FUNC( cb_newcb_cb_changed ), wgt_dlgcb_newcb_cb );

	wgt_4_19 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_3_13,
		"GtkBox::spacing", 4,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_13 ), wgt_4_19,
		"GtkTable::left_attach", 1,
		"GtkTable::right_attach", 2,
		"GtkTable::top_attach", 1,
		"GtkTable::bottom_attach", 2,
		"GtkTable::x_options", 0x00000004,
		"GtkTable::y_options", 0x00000000,
		NULL );

	wgt_dlgcb_newcb_file = gtk_widget_new( gtk_entry_get_type(),
		"GtkWidget::parent", wgt_4_19,
		"GtkWidget::can_focus", TRUE,
		"GtkEntry::max_length", MAXSZ_CB_FILENAME,
		NULL );
	gtk_entry_set_text( GTK_ENTRY(wgt_dlgcb_newcb_file), "" );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_newcb_file ), "changed",
		GTK_SIGNAL_FUNC( cb_newcb_file_changed ), wgt_dlgcb_newcb_file );

	wgt_5_21 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_4_19,
		"GtkLabel::label", ".c",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_19 ), wgt_5_21,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 2,
		"GtkBox::position", 1,
		NULL );

	wgt_4_22 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_3_13,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_13 ), wgt_4_22,
		"GtkTable::left_attach", 1,
		"GtkTable::right_attach", 2,
		"GtkTable::top_attach", 2,
		"GtkTable::bottom_attach", 3,
		"GtkTable::x_options", 0x00000004,
		NULL );

	wgt_dlgcb_newcb_after_yes = gtk_widget_new( gtk_check_button_get_type(),
		"GtkWidget::parent", wgt_4_22,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Yes",
		"GtkToggleButton::active", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_22 ), wgt_dlgcb_newcb_after_yes,
		"GtkBox::expand", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_newcb_after_yes ), "toggled",
		GTK_SIGNAL_FUNC( cb_newcb_after_yes_toggled ), NULL );

	wgt_4_24 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_3_13,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_13 ), wgt_4_24,
		"GtkTable::left_attach", 1,
		"GtkTable::right_attach", 2,
		"GtkTable::top_attach", 3,
		"GtkTable::bottom_attach", 4,
		"GtkTable::x_options", 0x00000004,
		NULL );

	wgt_dlgcb_newcb_accelerator_yes = gtk_widget_new( gtk_check_button_get_type(),
		"GtkWidget::parent", wgt_4_24,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Yes",
		"GtkToggleButton::active", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_24 ), wgt_dlgcb_newcb_accelerator_yes,
		"GtkBox::expand", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_newcb_accelerator_yes ), "toggled",
		GTK_SIGNAL_FUNC( cb_newcb_accelerator_yes_toggled ), NULL );

	wgt_dlgcb_frame_accelerator = gtk_widget_new( gtk_frame_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkFrame::label", "Accelerator Description",
		"GtkWidget::sensitive", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_dlgcb_frame_accelerator,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 2,
		NULL );

	wgt_3_27 = gtk_widget_new( gtk_table_get_type(),
		"GtkWidget::parent", wgt_dlgcb_frame_accelerator,
		"GtkTable::n_rows", 3,
		"GtkTable::n_columns", 2,
		"GtkTable::row_spacing", 2,
		"GtkTable::column_spacing", 4,
		NULL );

	wgt_4_28 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_3_27,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_27 ), wgt_4_28,
		"GtkTable::left_attach", 1,
		"GtkTable::right_attach", 2,
		"GtkTable::top_attach", 2,
		"GtkTable::bottom_attach", 3,
		NULL );

	wgt_dlgcb_accel_visible_yes = gtk_widget_new( gtk_check_button_get_type(),
		"GtkWidget::parent", wgt_4_28,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Yes",
		"GtkToggleButton::active", TRUE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_28 ), wgt_dlgcb_accel_visible_yes,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 4,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_accel_visible_yes ), "toggled",
		GTK_SIGNAL_FUNC( cb_accel_visible_toggled ), NULL );

	wgt_4_30 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_3_27,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_27 ), wgt_4_30,
		"GtkTable::left_attach", 1,
		"GtkTable::right_attach", 2,
		"GtkTable::top_attach", 1,
		"GtkTable::bottom_attach", 2,
		NULL );

	wgt_dlgcb_accel_modifier_shift = gtk_widget_new( gtk_check_button_get_type(),
		"GtkWidget::parent", wgt_4_30,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Shift",
		"GtkToggleButton::active", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_30 ), wgt_dlgcb_accel_modifier_shift,
		"GtkBox::expand", FALSE,
		"GtkBox::fill", FALSE,
		"GtkBox::padding", 4,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_accel_modifier_shift ), "toggled",
		GTK_SIGNAL_FUNC( cb_accel_modifier_shift_toggled ), NULL );

	wgt_dlgcb_accel_modifier_ctrl = gtk_widget_new( gtk_check_button_get_type(),
		"GtkWidget::parent", wgt_4_30,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Ctrl",
		"GtkToggleButton::active", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_30 ), wgt_dlgcb_accel_modifier_ctrl,
		"GtkBox::expand", FALSE,
		"GtkBox::fill", FALSE,
		"GtkBox::padding", 4,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_accel_modifier_ctrl ), "toggled",
		GTK_SIGNAL_FUNC( cb_accel_modifier_ctrl_toggled ), NULL );

	wgt_dlgcb_accel_modifier_alt = gtk_widget_new( gtk_check_button_get_type(),
		"GtkWidget::parent", wgt_4_30,
		"GtkWidget::can_focus", TRUE,
		"GtkButton::label", "Alt",
		"GtkToggleButton::active", FALSE,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_4_30 ), wgt_dlgcb_accel_modifier_alt,
		"GtkBox::expand", FALSE,
		"GtkBox::fill", FALSE,
		"GtkBox::padding", 4,
		"GtkBox::position", 2,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_accel_modifier_alt ), "toggled",
		GTK_SIGNAL_FUNC( cb_accel_modifier_alt_toggled ), NULL );

	wgt_dlgcb_accel_key = gtk_widget_new( gtk_combo_get_type(),
		"GtkWidget::parent", wgt_3_27,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_27 ), wgt_dlgcb_accel_key,
		"GtkTable::left_attach", 1,
		"GtkTable::right_attach", 2,
		NULL );
	gtk_entry_set_editable( GTK_ENTRY( GTK_COMBO( wgt_dlgcb_accel_key )->entry ), FALSE );

	gtk_combo_set_popdown_strings( GTK_COMBO( wgt_dlgcb_accel_key ), 
		keys_glist() );

	wgt_4_35 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_3_27,
		"GtkLabel::label", "Visible:",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_27 ), wgt_4_35,
		"GtkTable::top_attach", 2,
		"GtkTable::bottom_attach", 3,
		"GtkTable::x_options", 0x00000004,
		NULL );

	wgt_4_36 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_3_27,
		"GtkMisc::xalign", 0.950000,
		"GtkLabel::label", "Modifier:",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_27 ), wgt_4_36,
		"GtkTable::top_attach", 1,
		"GtkTable::bottom_attach", 2,
		"GtkTable::x_options", 0x00000004,
		NULL );

	wgt_4_37 = gtk_widget_new( gtk_label_get_type(),
		"GtkWidget::parent", wgt_3_27,
		"GtkMisc::xalign", 0.950000,
		"GtkLabel::label", "Key:",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_3_27 ), wgt_4_37,
		"GtkTable::x_options", 0x00000004,
		NULL );

	wgt_2_38 = gtk_widget_new( gtk_hseparator_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_38,
		"GtkBox::expand", FALSE,
		"GtkBox::padding", 4,
		"GtkBox::position", 3,
		NULL );

	wgt_2_39 = gtk_widget_new( gtk_hbox_get_type(),
		"GtkWidget::parent", wgt_1_2,
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), wgt_2_39,
		"GtkBox::expand", FALSE,
		"GtkBox::position", 4,
		NULL );

	wgt_dlgcb_btn_cancel = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_39,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Cancel",
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_btn_cancel ), "clicked",
		GTK_SIGNAL_FUNC( cb_dlgcb_btn_cancel ), NULL );

	wgt_dlgcb_btn_ok = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_2_39,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Ok",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_2_39 ), wgt_dlgcb_btn_ok,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_dlgcb_btn_ok ), "clicked",
		GTK_SIGNAL_FUNC( cb_dlgcb_btn_ok ), NULL );

	gtk_widget_show_all( wgt_dialog_cb );

}								// create_dialog_cb


PUBLIC void
do_dialog_cb( defclasssignal_t *defclasssignal )
{
	GtkWidget			*wgt_selected;
	data_cb_t			*new_datacb;

	create_dialog_cb( defclasssignal );

	/*--- Wait until user selects either 'yes' or 'no' ---*/
	dlg_done = FALSE;
	push_block_all_windows();
	while ( !dlg_done )
		gtk_main_iteration();
	pop_block_all_windows();
	gtk_widget_destroy( wgt_dialog_cb );

	if ( !is_cancel )
	{

		/*--- Attach the cb data to the widget ---*/
		wgt_selected = GTK_WIDGET( g_slist_last(list_selection)->data );
		new_datacb = malloc( sizeof( data_cb_t ) );
		memmove( new_datacb, &datacb, sizeof( data_cb_t ) );
		gtk_object_set_data_full( GTK_OBJECT(wgt_selected), defclasssignal->resname, 
			new_datacb, (GtkDestroyNotify)cb_destroy_signal_notify );

		/*--- Rebuild the callbacks tree ---*/
		update_tree();
	   	   
		/*--- Reselect current selected widget ---*/
		refresh_properties_selected_widgets();
	
	}

}								// do_dialog_cb


PUBLIC void
cb_dialog_cb( GtkWidget *widget, void *data )
{
	defclasssignal_t	*defclasssignal = (defclasssignal_t *)data;

	do_dialog_cb( defclasssignal );
	
}								// cb_dialog_cb

