#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <time.h>
#include <unistd.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"

typedef struct
{
	defclass_t		*xdef;
	GtkArg			xarg;
	gtk_wgtdef_t	*wgtdef_depth;
	int				burned;
}	defres_t;

static	defres_t	defres[ 100 ];
static	int			nb_defres;

static	def_cb_t	defsignal[ 100 ];
static	int			nb_defsignal;


#if 0
static int
test( int lineno, int *p, int vmin, int vmax )
{
	int	ok = TRUE;

	if ( *p < vmin )
	{
		fprintf( stderr, "Value out of range at line %d\n", lineno );
		*p = vmin;
		ok = FALSE;
	}

	if ( *p > vmax )
	{
		fprintf( stderr, "Value out of range at line %d\n", lineno );
		*p = vmax;
		ok = FALSE;
	}

	return ok;

}								// test
#endif

static int
read_glg_file( FILE *fp )
{
	char			*line;
	int				len;
	int				step;
	int				px, py, dx, dy;
	char			module_type[ 100 ], module_name[ 200 ];
	module_info_t	*module=NULL;
	int				w = gdk_screen_width();
	int				h = gdk_screen_height();
	int				lineno;
	char			gnome_yesno[ 40 ];
	int				is_gnome;

	/*--- Each line ---*/
	line = malloc( 32768 );
	assert( line != NULL );
	lineno = 0;
	step = 1;
	while ( fgets( line, 32767, fp ) )
	{

		lineno++;
			
		/*--- Skip line beginning with '#' ---*/
		if ( ((len = strlen(line)) >= 1) && (line[len-1] == '\n') )
			line[len-1] = 0;
		if ( !strcmp( line, "" ) || (line[0] == '#') )
			continue;
		switch ( step )
		{

			case 1 :
				sscanf( line, "Gnome = %s",
					gnome_yesno );
				is_gnome = (!strcmp( gnome_yesno, "yes" )) ? TRUE : FALSE;
#ifndef USE_GNOME
				if ( is_gnome )
				{
					modal_error( "\nThis is a GNOME project.\n" );
					free( line );
					return -1;
				}
#endif
				step++;
				break;

			case 2 :
				sscanf( line, "\tPalette window = %d,%d,%d,%d",
					&px, &py, &dx, &dy );
#if 0
				if ( test( lineno, &px, 0, w - 1 ) &&
					 test( lineno, &py, 0, h - 1 ) &&
					 test( lineno, &dx, 0, w - 1 ) &&
					 test( lineno, &dy, 0, h - 1 ) )
				{
					if ( is_restore_windows_position )
						gdk_window_move_resize( wgt_wnd_palette->window,
							px, py, dx, dy );
					else
						gdk_window_resize( wgt_wnd_palette->window,
							dx, dy );
				}
#endif
				step++;
				break;

			case 3 :
				sscanf( line, "\tTree window = %d,%d,%d,%d",
					&px, &py, &dx, &dy );
#if 0
				if ( test( lineno, &px, 0, w - 1 ) &&
					 test( lineno, &py, 0, h - 1 ) &&
					 test( lineno, &dx, 0, w - 1 ) &&
					 test( lineno, &dy, 0, h - 1 ) )
				{
					if ( is_restore_windows_position )
						gdk_window_move_resize( wgt_wnd_tree->window,
							px, py, dx, dy );
					else
						gdk_window_resize( wgt_wnd_tree->window,
							dx, dy );
				}
#endif
				step++;
				break;

			case 4 :
				sscanf( line, "\tProperties window = %d,%d,%d,%d",
					&px, &py, &dx, &dy );
#if 0
				if ( test( lineno, &px, 0, w - 1 ) &&
					 test( lineno, &py, 0, h - 1 ) &&
					 test( lineno, &dx, 0, w - 1 ) &&
					 test( lineno, &dy, 0, h - 1 ) )
				{
					if ( is_restore_windows_position )
						gdk_window_move_resize( wgt_wnd_resources->window,
							px, py, dx, dy );
					else
						gdk_window_resize( wgt_wnd_resources->window,
							dx, dy );
				}
#endif
				step++;
				break;

			case 5 :
				sscanf( line, "\t%s %s", 
					module_type, 
					module_name );
				if ( !strcmp( module_type, "GtkWindow" ) || !strcmp( module_type, "GtkDialog" ) 
#ifdef USE_GNOME
					 || !strcmp( module_type, "GnomeAbout" ) )
#else
					)
#endif
				{
					char	opened[80], fixedpos[80];
					char	iconified_state[80];
					char	name_function[ sizeof(module->u1.window.name_function)+1];

					fgets( line, 32767, fp );
					if ( ((len = strlen(line)) >= 1) && (line[len-1] == '\n') )
						line[ len-1 ] = 0;
					strcpy( iconified_state, "" );
					sscanf( line, "\t\t%s %s %s %s %d,%d", 
						opened, fixedpos, 
						name_function,
						iconified_state,
						&w, &h );
					if ( !strcmp( module_type, "GtkWindow" ) )
						module = module_create_window( module_name, w, h, TRUE );
					else if ( !strcmp( module_type, "GtkDialog" ) )
						module = module_create_dialog( module_name, w, h, TRUE,
							MODULE_TYPE_DIALOG, "GtkDialog" );
#ifdef USE_GNOME
					else if ( !strcmp( module_type, "GnomeAbout" ) )
						module = module_create_dialog( module_name, w, h, TRUE,
							MODULE_TYPE_GNOMEDIALOG_ABOUT, "GnomeAbout" );
#endif
					strcpy( module->u1.window.name_function, name_function );
					module->u1.window.f_opened_from_main = 
						!strcasecmp( opened, "yes") ? TRUE : FALSE;
					module->u1.window.f_fixed_position = 
						!strcasecmp( fixedpos, "yes" ) ? TRUE : FALSE;
					if ( !strcmp( iconified_state, "iconified" ) )
						module->iconified = TRUE;
					else
						module->iconified = FALSE;
				}
				else if ( !strcmp( module_type, "GtkMenu" ) )
				{
					char	iconified_state[80];
					char	name_function[ sizeof(module->u1.menu.name_function)+1];

					fgets( line, 32768, fp );
					if ( ((len = strlen(line)) >= 1) && (line[len-1] == '\n') )
						line[ len-1 ] = 0;
					strcpy( iconified_state, "" );
					sscanf( line, "\t\t%s %s", 
						name_function,
						iconified_state );
					module = module_create_menu( module_name, TRUE );
					gdk_window_lower( module->wgt_window->window );
					strcpy( module->u1.menu.name_function, name_function );
					if ( !strcmp( iconified_state, "iconified" ) )
						module->iconified = TRUE;
				}
				else assert( 0 );
				break;

			default :
				assert(0);
				break;

		}						// switch ( step )

	}

	/*--- Ok, done ---*/
	free( line );
	return 0;

}								// read_glg_file


typedef struct
{
	gtk_wgtdef_t		*wgtdef;
	int					hierarchy;	   			// If this is a composite widget
	GtkWidget			*hierarchy_father_wgt;
	char				*wgt_name;
	GtkWidget			*wgt;
	int					nametype;
	int					nb_cb;
	int					is_placeholder;
}	level_info_t;


PUBLIC gtk_wgtdef_t *
search_widget_class( const char * const name )
{
	gtk_wgtdef_t	**p, *q;

	for ( p = (gtk_wgtdef_t **)gtk_wgtdef; (q = *p); p++ )
	{
		if ( !strcmp( name, q->widget_name ) )
			return q;
	}

	return NULL;

}								// search_widget_class


static GtkWidget *
get_hierarchy_father_wgt( GtkWidget *wgt )
{
	GtkArg		arg;
	GtkWidget	*widget, *wgt_parent;

	for ( widget = wgt; ; )
	{
		if ( IS_WGT_NOCOMPOSITE( widget ) )
			return widget;
		arg.name = "GtkWidget::parent";
		arg.type = GTK_TYPE_CONTAINER;	
		gtk_widget_getv( GTK_WIDGET( widget ), 1, &arg );
		wgt_parent = GTK_WIDGET( GTK_VALUE_OBJECT(arg) );
		assert( wgt_parent != NULL );
		widget = wgt_parent;
	}							// for (;;)

}								// get_hierarchy_father_wgt


static int
syntax_error( FILE *fp, const char *fmt, ... )
{
	va_list ap;
	char    buff[ 384 ];

	va_start( ap, fmt );
	vsprintf( buff, fmt, ap );
	va_end( ap );

	fprintf( stderr, "Syntax error: %s\n", buff );

	fclose( fp );
	
	return -1;

}								// syntax_error


#if 0
static defclass_t *
_search_res( gtk_wgtdef_t *wgtdef, const char * const name, gtk_wgtdef_t **wgtdef_depth )
{
	defclass_t	*def;
	int			depth, n;
	int			nb_res;
	char		tmp[ 200 ];

	*wgtdef_depth = NULL;
	for ( depth = 0; 
		  (depth < MAXNB_HIERARCHIES) && (wgtdef->def[depth].classnames != NULL); 
		  depth++ )
	{

		/*--- Is a widget resource ? ---*/
		nb_res = wgtdef->def[depth].nb_classes; 
		for ( n = 0, def = wgtdef->def[depth].classes; n < nb_res; def++, n++ )
		{
			if ( name[0] != '~' )
				sprintf( tmp, "%s::%s", wgtdef->def[ depth ].wgtdef_depth->widget_name, name );
			else
				sprintf( tmp, "~%s::%s", wgtdef->def[ depth ].wgtdef_depth->widget_name, &name[1] );
			if ( !strcmp( def->resname, tmp ) )
			{
				*wgtdef_depth = wgtdef->def[depth].wgtdef_depth;
				return def;
			}
		}						// for 

	}

	return NULL;

}								// _search_res


static defclass_t *
_search_res_child( gtk_wgtdef_t *wgtdef, const char * const name, 
	gtk_wgtdef_t **wgtdef_depth )
{
	defclass_t		*def;
	int				depth, n;
	int				nb_res;
	char			tmp[ 200 ];

	*wgtdef_depth = NULL;
	for ( depth = 0; 
		  (depth < MAXNB_HIERARCHIES) && (wgtdef->def[depth].wgtdef_depth != NULL); 
		  depth++ )
	{

		/*--- Is a child container resource ? ---*/
		nb_res = wgtdef->def[depth].nb_classes_child; 
		for ( n = 0, def = wgtdef->def[depth].classes_child; n < nb_res; def++, n++ )
		{
			if ( name[0] != '~' )
				sprintf( tmp, "%s::%s", wgtdef->def[ depth ].wgtdef_depth->widget_name, name );
			else
				sprintf( tmp, "~%s::%s", wgtdef->def[ depth ].wgtdef_depth->widget_name, &name[1] );
			if ( !strcmp( def->resname, tmp ) )
			{
				*wgtdef_depth = wgtdef->def[depth].wgtdef_depth;
				return def;
			}
		}							// for 

	}

	return NULL;

}								// _search_res_child


#else

static defclass_t *
_search_res( gtk_wgtdef_t *wgtdef, const char * const name, gtk_wgtdef_t **wgtdef_depth )
{
	defclass_t	*def;
	int			depth, n;
	int			nb_res;

	*wgtdef_depth = NULL;
	for ( depth = 0; 
		  (depth < MAXNB_HIERARCHIES) && (wgtdef->def[depth].classnames != NULL); 
		  depth++ )
	{

		/*--- Is a widget resource ? ---*/
		nb_res = wgtdef->def[depth].nb_classes; 
		for ( n = 0, def = wgtdef->def[depth].classes; n < nb_res; def++, n++ )
		{
			if ( !strcmp( def->resname, name ) )
			{
				*wgtdef_depth = wgtdef->def[depth].wgtdef_depth;
				return def;
			}
		}						// for 

	}

	return NULL;

}								// _search_res


static defclass_t *
_search_res_child( gtk_wgtdef_t *wgtdef, const char * const name, 
	gtk_wgtdef_t **wgtdef_depth )
{
	defclass_t		*def;
	int				depth, n;
	int				nb_res;

	for ( depth = 0; 
		  (depth < MAXNB_HIERARCHIES) && (wgtdef->def[depth].wgtdef_depth != NULL); 
		  depth++ )
	{

		/*--- Is a child container resource ? ---*/
		nb_res = wgtdef->def[depth].nb_classes_child; 
		for ( n = 0, def = wgtdef->def[depth].classes_child; n < nb_res; def++, n++ )
		{
			if ( !strcmp( def->resname, name ) )
			{
				*wgtdef_depth = wgtdef->def[depth].wgtdef_depth;
				return def;
			}
		}							// for 

	}

	return NULL;

}								// _search_res_child

#endif

static defclasssignal_t *
_search_signal( gtk_wgtdef_t *wgtdef, const char * const name,
	gtk_wgtdef_t **wgtdef_depth )
{
	int			depth, n;

	for ( depth = 0; 
		  (depth < MAXNB_HIERARCHIES) && (wgtdef->def[depth].classnames != NULL); 
		  depth++ )
	{
		defclasssignal_t	*classes_signal, *q;
		int					nb_signals;
		
		classes_signal = wgtdef->def[depth].classes_signal;
		nb_signals	   = wgtdef->def[depth].nb_classes_signal;
		for ( q = classes_signal, n = 0; n < nb_signals; n++, q++ )
		{
			if ( !strcmp( q->resname, name ) )
			{
				*wgtdef_depth = wgtdef->def[depth].wgtdef_depth;
				return q;
			}
		}						// for (q)

	}							// for (depth)

	return NULL;

}								// _search_signal


static void
_move_res( void )
{
	defres_t		*pdefres;
	defclass_t		*def;
	int				n;

	for ( pdefres = defres, n = 0; n < nb_defres; n++, pdefres++ )
	{
		def = pdefres->xdef;
		if ( def->saved_where == SAVED_INSIDE )
		{
			if ( !def->f_child )
			{
				memmove( &args[ nb_args ], 
					&pdefres->xarg,
					sizeof( GtkArg ) );
				nb_args++;
				pdefres->burned = TRUE;
			}
		}						// if
	}							// for
	
}								// _move_res


static void
_set_res( GtkWidget *wgt, GtkWidget *wgt_parent )
{
	defres_t		*pdefres;
	defclass_t		*def;
	int				n;

	for ( pdefres = defres, n = 0; n < nb_defres; n++, pdefres++ )
	{
		def = pdefres->xdef;

		if ( def->saved_where == SAVED_INSIDE )
		{
			if ( !def->f_child )
			{
				if ( !defres->burned )
					gtk_widget_setv( GTK_WIDGET(wgt), 1, &pdefres->xarg );
			}
			else
			{
				gtk_container_child_setv( GTK_CONTAINER(wgt_parent), wgt, 1, &pdefres->xarg );
			}
		}
		else if ( def->saved_where == SAVED_OUTSIDE ||
				 def->saved_where == SAVED_OUTSIDE_FUNCTION )
		{
			GtkArg *arg = gtk_arg_new(def->restype);
			gtk_arg_copy( &pdefres->xarg, arg );
			set_outsideres_wgt( wgt, def->resname, arg );
		}
		else if (def->saved_where == SAVED_FUNCTION)
		{
			GtkArg *arg = gtk_arg_new(def->restype);
			gtk_arg_copy( &pdefres->xarg, arg );
			set_outsideres_wgt( wgt, def->resname, arg );
			(pdefres->wgtdef_depth->pfct_putdlg)(def, wgt, &pdefres->xarg);
		}
		else assert(0);

		/*--- Resource entry disabled ? ---*/
		set_is_disabled_resource_wgt( wgt, def, FALSE );

	}							// for

	/*--- Reset ---*/
	nb_defres = 0;

}
								// _set_res

static void
_set_signal( GtkWidget *wgt, GtkWidget *wgt_parent )
{
	def_cb_t			*pdefsignal;
	int					n;
	defclasssignal_t	*defclasssignal;
	def_cb_t			*defcb;
	data_cb_t			*datacb;

	for ( pdefsignal = defsignal, n = 0; n < nb_defsignal; n++, pdefsignal++ )
	{
		defclasssignal = pdefsignal->defclasssignal;
		
		datacb = get_object_data( wgt, defclasssignal->resname );
		if ( datacb == NULL )
		{
			datacb = malloc( sizeof( data_cb_t ) );
			memset( datacb, 0, sizeof( data_cb_t ) );
			datacb->nb_cb = 1;
			defcb = malloc( sizeof( def_cb_t ) );
			datacb->cb = defcb;
			gtk_object_set_data_full( GTK_OBJECT(wgt), defclasssignal->resname, 
				datacb, (GtkDestroyNotify)cb_destroy_signal_notify );
		}
		else
		{
			datacb->cb = realloc( datacb->cb, (datacb->nb_cb+1) * sizeof( def_cb_t ));
			defcb = &datacb->cb[ datacb->nb_cb++ ];
		}

		memmove( defcb, pdefsignal, sizeof( def_cb_t ) );
		defcb->defclasssignal = defclasssignal;

	}							// for

	/*--- Reset ---*/
	nb_defsignal = 0;

}								// _set_signal


static void
_read_int( FILE *fp, gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth, defclass_t *def )
{
	char		*p;
	defres_t	*pdefres;
	GtkArg		*arg;

	/*--- Allocate a new entry ---*/
	assert( nb_defres < sizeof(defres) / sizeof(defres_t) );
	pdefres = &defres[ nb_defres++ ];
	memset( pdefres, 0, sizeof( defres_t ) );
	pdefres->xdef = def;
	pdefres->wgtdef_depth = wgtdef_depth;
	pdefres->burned = FALSE;

	/*--- Create the arg entry ---*/
	p = strtok( NULL, "\n" );
	arg = &pdefres->xarg;
	switch ( def->restype )
	{
		case GTK_TYPE_INT :
			arg->type = GTK_TYPE_INT;
			arg->name = def->resname;
			GTK_VALUE_INT(arg[0]) = strtol( p, NULL, 0 );
			break;
		case GTK_TYPE_UINT :
			arg->type = GTK_TYPE_UINT;
			arg->name = def->resname;
			GTK_VALUE_UINT(arg[0]) = strtol( p, NULL, 0 );
			break;
		case GTK_TYPE_LONG :
			arg->type = GTK_TYPE_LONG;
			arg->name = def->resname;
			GTK_VALUE_LONG(arg[0]) = strtol( p, NULL, 0 );
			break;
		case GTK_TYPE_ULONG :
			arg->type = GTK_TYPE_ULONG;
			arg->name = def->resname;
			GTK_VALUE_ULONG(arg[0]) = strtoul( p, NULL, 0 );
			break;
		case GTK_TYPE_FLOAT :
			arg->type = GTK_TYPE_FLOAT;
			arg->name = def->resname;
			GTK_VALUE_FLOAT(arg[0]) = atof( p );
			break;
		default :
			RES_NOT_YET_HANDLED( wgtdef, def );
			assert(0);
	}

}								// _read_int


static void
_read_bool( FILE *fp, gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth, defclass_t *def )
{
	char		*p;
	defres_t	*pdefres;
	GtkArg		*arg;

	/*--- Allocate a new entry ---*/
	assert( nb_defres < sizeof(defres) / sizeof(defres_t) );
	pdefres = &defres[ nb_defres++ ];
	memset( pdefres, 0, sizeof( defres_t ) );
	pdefres->xdef = def;
	pdefres->wgtdef_depth = wgtdef_depth;
	pdefres->burned = FALSE;
	arg = &pdefres->xarg;

	/*--- Create the arg entry ---*/
	p = strtok( NULL, "\n" );
	arg->type = GTK_TYPE_BOOL;
	arg->name = def->resname;
	GTK_VALUE_BOOL( arg[0] ) = strtol( p, NULL, 0 );

}								// _read_bool


static void
_read_style( FILE *fp, gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth, defclass_t *def,
	char *mname, int line_no )
{
	char			*p;
	defres_t		*pdefres;
	GtkArg			*arg;
	GtkStyle		*style;
	int				n;

	/*--- Seatch the style ---*/
	p = strtok( NULL, "\n" );
	for ( style = NULL, n = 0; n < nb_styles; n++ )
	{
		if ( !strcmp( styles_infos[ n ]->name, p ) )
		{
			style = styles[ n ];
			break;
		}
	}
	
	if ( style == NULL)
	{
		modal_error( "Reference to style %s which is unknown\nfile %s line %d", 
			p, mname, line_no );
		return;
	}

	/*--- Allocate a new entry ---*/
	assert( nb_defres < sizeof(defres) / sizeof(defres_t) );
	pdefres = &defres[ nb_defres++ ];
	memset( pdefres, 0, sizeof( defres_t ) );
	pdefres->xdef = def;
	pdefres->wgtdef_depth = wgtdef_depth;
	pdefres->burned = FALSE;
	arg = &pdefres->xarg;

	/*--- Create the arg entry ---*/
	arg->type = GTK_TYPE_STYLE;
	arg->name = def->resname;
	GTK_VALUE_OBJECT( arg[0] ) = (GtkObject *)style;

}								// _read_style


static void
_read_adjustment( FILE *fp, gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth, defclass_t *def )
{
	char			*p;
	defres_t		*pdefres;
	GtkArg			*arg;
	gfloat			value, lower, upper, step_increment, page_increment, page_size;
	GtkAdjustment	*adj;

	/*--- Allocate a new entry ---*/
	assert( nb_defres < sizeof(defres) / sizeof(defres_t) );
	pdefres = &defres[ nb_defres++ ];
	memset( pdefres, 0, sizeof( defres_t ) );
	pdefres->xdef = def;
	pdefres->wgtdef_depth = wgtdef_depth;
	pdefres->burned = FALSE;
	arg = &pdefres->xarg;

	/*--- Create the arg entry ---*/
	p = strtok( NULL, "\n" );
	arg->type = GTK_TYPE_POINTER;
	arg->name = def->resname;
	sscanf( p, "%f %f %f %f %f %f", 
		&value, &lower, &upper,
		&step_increment, &page_increment, &page_size);
	adj = GTK_ADJUSTMENT( gtk_adjustment_new( value, lower, upper, step_increment, 
		page_increment, page_size ) );
	GTK_VALUE_POINTER( arg[0] ) = adj;

}								// _read_adjustment


static void
_read_string( FILE *fp, gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth, defclass_t *def )
{
	char			*p, *q;
	defres_t		*pdefres;
	GtkArg			*arg;
	int				nb1, nb2;
	char			*r, *s;
	unsigned char	c1, c2, c3, n;

	/*--- Allocate a new entry ---*/
	assert( nb_defres < sizeof(defres) / sizeof(defres_t) );
	pdefres = &defres[ nb_defres++ ];
	memset( pdefres, 0, sizeof( defres_t ) );
	pdefres->xdef = def;
	pdefres->wgtdef_depth = wgtdef_depth;
	pdefres->burned = FALSE;

	arg = &pdefres->xarg;
	arg->type = GTK_TYPE_STRING;
	arg->name = def->resname;

	/*--- Create the arg entry ---*/
	p = strtok( NULL, "\"" );
	if ( p == NULL )
	{
		GTK_VALUE_STRING( arg[0] ) = NULL;
		return;
	}
	for ( nb1 = nb2 = 0, q = p; *q; q++, nb1++ )
		if ( *q == '\\' )
			nb2++;	
	if ( nb2 == 0 )
	{
		GTK_VALUE_STRING( arg[0] ) = strdup(p);
		return;
	}

	q = malloc( nb1+nb2+1 );
	for ( r = p, s = q; *r; )
	{
		if ( *r != '\\' )
		{
			*s++ = *r++;
		}
		else
		{
			c1 = *++r - '0';
			c2 = *++r - '0';
			c3 = *++r - '0';
			n = (c1 << 6) + (c2 << 3) + c3;
			*s++ = n;
			r++;
		}
	}
	*s = 0;
	GTK_VALUE_STRING( arg[0] ) = q;

}								// _read_string


static void
_read_strings( FILE *fp, gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth, defclass_t *def,
	char *line, int maxlen, int *line_no )
{
	char					*p;
	defres_t				*pdefres;
	GtkArg					*arg;
	gtk_usertype_strings_t	*strings;
	int						index;
	int						len;

	/*--- Allocate a new entry ---*/
	assert( nb_defres < sizeof(defres) / sizeof(defres_t) );
	pdefres = &defres[ nb_defres++ ];
	memset( pdefres, 0, sizeof( defres_t ) );
	pdefres->xdef = def;
	pdefres->wgtdef_depth = wgtdef_depth;
	pdefres->burned = FALSE;

	arg = &pdefres->xarg;
	arg->type = GTK_TYPE_POINTER;
	arg->name = def->resname;

	/*--- How many strings are defined ? ---*/
	p = strtok( NULL, "\"" );
	assert ( p != NULL );
	strings = malloc( sizeof( gtk_usertype_strings_t ) );
	GTK_VALUE_POINTER( arg[0] ) = strings;
	strings->nb_strings = atoi( p );
	if ( strings->nb_strings == 0 )
	{
		strings->strings = NULL;
		return;
	}
	strings->strings = malloc( sizeof( char * ) * strings->nb_strings );

	/*--- Now read the strings ---*/
	for ( index = 0; index < strings->nb_strings; index++ )
	{

		for (;;)
		{
			assert ( fgets( line, 32768, fp ) != NULL );

			/*--- Skip line beginning with '#' ---*/
			len = strlen( line );
			if ( (len >= 1) && (line[len-1] == '\n') )
				line[--len] = 0;
			(*line_no)++;
			if ( !strcmp( line, "" ) || (line[0] == '#') )
				continue;
			break;
		}

		p = strtok( line, "\"" );
		assert( p != NULL );
		p = strtok( NULL, "\"" );
		assert( p != NULL );
		
		strings->strings[ index ] = strdup( p );

	}

}								// _read_strings


static void
_read_enum( FILE *fp, gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth, defclass_t *def )
{
	char				*p;
	defres_t			*pdefres;
	GtkArg				*arg;
	GtkEnumValue const	*penum;
	int					found, index;

	/*--- Allocate a new entry ---*/
	assert( nb_defres < sizeof(defres) / sizeof(defres_t) );
	pdefres = &defres[ nb_defres++ ];
	memset( pdefres, 0, sizeof( defres_t ) );
	pdefres->xdef = def;
	pdefres->wgtdef_depth = wgtdef_depth;
	pdefres->burned = FALSE;
	arg = &pdefres->xarg;

	/*--- Create the arg entry ---*/
	p = strtok( NULL, "\n" );
	arg->name = def->resname;
	arg->type = enum_infos[ def->object_restype_ptr ].type;
	
	/*--- Locate the enum value into the table ---*/
	for ( found = FALSE, index = 0, penum = def->enum_list; 
		  penum->value_name;
		  penum++, index++ )
	{
		if ( !strcmp( p, penum->value_name ) )
		{
			found = TRUE;
			break;
		}
	}
	assert( found == TRUE );
	GTK_VALUE_ENUM( arg[ 0 ] ) = index;

}								// _read_enum


static void
_read_flags( FILE *fp, gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth, defclass_t *def )
{
	char		*p;
	defres_t	*pdefres;
	GtkArg		*arg;

	/*--- Allocate a new entry ---*/
	assert( nb_defres < sizeof(defres) / sizeof(defres_t) );
	pdefres = &defres[ nb_defres++ ];
	memset( pdefres, 0, sizeof( defres_t ) );
	pdefres->xdef = def;
	pdefres->wgtdef_depth = wgtdef_depth;
	pdefres->burned = FALSE;

	/*--- Create the arg entry ---*/
	p = strtok( NULL, "\n" );
	arg = &pdefres->xarg;
	arg->type = enum_infos[ def->object_restype_ptr ].type;
	arg->name = def->resname;
	GTK_VALUE_FLAGS( arg[ 0 ] ) = strtol( p, NULL, 16 );

}								// _read_flags


static void
_read_widget( FILE *fp, module_info_t *module, gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth, defclass_t *def )
{
	char			*p;
	defres_t		*pdefres;
	GtkArg			*arg;
	GtkWidget		*wgt;

	/*--- Allocate a new entry ---*/
	assert( nb_defres < sizeof(defres) / sizeof(defres_t) );
	pdefres = &defres[ nb_defres++ ];
	memset( pdefres, 0, sizeof( defres_t ) );
	pdefres->xdef = def;
	pdefres->wgtdef_depth = wgtdef_depth;
	pdefres->burned = FALSE;
	arg = &pdefres->xarg;

	/*--- Create the arg entry ---*/
	p = strtok( NULL, "\n" );
	arg->type = GTK_TYPE_CONTAINER;
	arg->name = def->resname;
	wgt = search_widget_by_name( module->wgt_window, p );
	assert( wgt != NULL );
	GTK_VALUE_OBJECT( arg[0] ) = GTK_OBJECT( wgt );

}								// _read_widgets


static void
_read_signal( FILE *fp, gtk_wgtdef_t *wgtdef, defclasssignal_t *defclasssignal )
{
	char		*cbname, *cbfile, *after;
	def_cb_t	*pdefsignal;
	char		*accel_yes;

	/*--- Allocate a new entry ---*/
	assert( nb_defsignal < sizeof(defsignal) / sizeof( def_cb_t ) );
	pdefsignal = &defsignal[ nb_defsignal++ ];
	memset( pdefsignal, 0, sizeof( def_cb_t ) );
	pdefsignal->defclasssignal = defclasssignal;

	/*--- Create the arg entry ---*/
	cbname = strtok( NULL, "@" );
	cbfile = strtok( NULL, " " );
	after  = strtok( NULL, " \n" );
	pdefsignal->cbname = strdup(cbname);
	pdefsignal->cbfile = strdup(cbfile);
	pdefsignal->f_after = (!strcmp(after, "after=yes")) ? TRUE : FALSE;

	accel_yes = strtok( NULL, " \n" );
	pdefsignal->is_accelerator = FALSE;
	if ( accel_yes && !strcmp( accel_yes, "accelerator=yes" ) )
	{
		char		*keyval, *keystr;
		char		*is_shift, *is_ctrl, *is_alt;
		char		*is_visible;
	
		pdefsignal->is_accelerator = TRUE;
		keyval = strtok( NULL, " \n" );
		pdefsignal->accelerator_key_val = strtol( keyval, NULL, 16 );
		keystr = strtok( NULL, " \n ");
		strcpy( pdefsignal->accelerator_key_string, keystr );

		is_shift = strtok( NULL, " \n ");
		is_ctrl  = strtok( NULL, " \n ");
		is_alt   = strtok( NULL, " \n ");
		if ( !strcmp( is_shift, "shift=yes" ) )
			pdefsignal->accelerator_mods |= GDK_SHIFT_MASK;
		if ( !strcmp( is_ctrl, "ctrl=yes" ) )
			pdefsignal->accelerator_mods |= GDK_CONTROL_MASK;
		if ( !strcmp( is_alt, "alt=yes" ) )
			pdefsignal->accelerator_mods |= GDK_MOD1_MASK;

		is_visible = strtok( NULL, " \n ");
		if ( !strcmp( is_visible, "visible=yes" ) )
			pdefsignal->accel_flags |= GTK_ACCEL_VISIBLE;

	}
	
}								// _read_signal


static void
_attach_data_wgt( level_info_t *plevel, module_info_t *module, char *dirname )
{
	GtkWidget			*wgt = plevel->wgt;
	gtk_wgtdef_t		*wgtdef;
	char				dname[ PATH_MAX + 80 ];

	/*--- Current directory ---*/
	sprintf( dname, "%s/lg", dirname );
	chdir( dname );

	/*--- Attach the current module to the widget ---*/
	set_object_data( wgt, WGTDATA_MODULE, module, FALSE );

	/*--- Attach the current palette to the widget ---*/
	wgtdef = plevel->wgtdef;
	set_object_data( wgt, WGTDATA_WGTDEF, wgtdef, FALSE );

	if ( plevel->hierarchy == -1 )
		wgt_put_flag( wgt, WGTFLAG_NOCOMPOSITE );
	if ( plevel->is_placeholder )
	{
		wgt_put_flag( wgt, WGTFLAG_PLACEHOLDER );
		install_draw_placeholder( wgt );
	}
	check_for_composite_childs( module->wgt_window );

	/*--- Attach the name to the widget ---*/
	if ( plevel->wgt_name )
		set_name_wgt( wgt, plevel->wgt_name );

	/*--- Attach the type of the name to the widget ---*/
	set_nametype_wgt( wgt, plevel->nametype );

}								// _attach_data_wgt


static int
load_module( GtkWidget *wgt_dlgfile, char *dirname, module_info_t *module )
{
	char				mname[ PATH_MAX+NAME_MAX + 64 ];
	char				*line;
	int					line_no;
	int					len;
	FILE				*fp;
	int					level;
	gtk_wgtdef_t		*wgtdef;
	gtk_wgtdef_t		*wgtdef_depth;
	char				*p;
	level_info_t		*levels, *plevel=NULL;
	defclass_t			*def;
	defclasssignal_t 	*defsignal;
	int					prev_close_bracket;
	int					hierarchy;
	int					cpt_wgt;

	/*--- Open the module file ---*/
	sprintf( mname, "%s/glg/%s.glg", 
		dirname, get_name_wgt( module->wgt_window ) );
	fp = fopen( mname, "r" );
	if ( fp == NULL )
	{
		modal_error( "Unable to read module file\n%s\nerrno=%d", mname, errno );
		return -1;
	}							// if

	/*--- Each line ---*/
	line = malloc( 32768 );
	assert( line != NULL );
	line_no = 0;
	level = -1;
	levels = NULL;
	prev_close_bracket = TRUE;
	nb_defres = 0;
	nb_defsignal = 0;
	cpt_wgt = 0;
	INIT_ARGS;
	while ( fgets( line, 32768, fp ) )
	{
			
		/*--- Skip line beginning with '#' ---*/
		len = strlen( line );
		if ( (len >= 1) && (line[len-1] == '\n') )
			line[--len] = 0;
		line_no++;
		if ( !strcmp( line, "" ) || (line[0] == '#') )
			continue;

		/*--- Until the end of " ? ---*/
		if ( strchr( line, '"' ) && (line[len-1] != '"') )
		{
			char	*line2 = malloc( 8192 );
			for (;;)
			{
				if ( !fgets( line2, 8192, fp ) )
					break;
				strcat( line, line2 );
				if ( strchr( line2, '"' ) )
					break;
			}					// for (;;)
			free( line2 );
		}						// if

		p = strtok( line, " \t" );

		/*--- Is-it a composite widget ? If yes, which hierarchy ? ---*/
		if ( (strlen(p) >= 4) && (p[0] == '*') )
		{
			hierarchy = atoi( &p[1] );
			p = strchr( &p[1], '*' );
			p++;
		}
		else
		{
			hierarchy = -1;
		}

		if ( !strcmp( p, "}" ) )
		{

			if ( level > 0 )
			{
				if ( levels[level].wgt == NULL )
				{
					INIT_ARGS;
					if ( plevel->hierarchy == -1 )
						_move_res();
					assert( plevel == &levels[ level ] );
					if ( plevel->hierarchy == -1 )
					{
						cpt_wgt++;
						SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", levels[level-1].wgt );
						plevel->wgt = insert_new_widget( 
							levels[level-1].wgt, plevel->wgtdef, 
							FALSE, 			// f_select
							TRUE,			// is_disabled
							FALSE,			// Default values
							NULL );
					}
					else
					{
						cpt_wgt++;
						plevel->hierarchy_father_wgt =
							get_hierarchy_father_wgt( levels[level-1].wgt );
						plevel->wgt = 
							_compute_hierarchy_composite_childs( plevel->hierarchy_father_wgt, 
								plevel->hierarchy );
					}
					assert( plevel->wgt != NULL );
					_set_res( plevel->wgt, levels[level-1].wgt );
					_set_signal( plevel->wgt, levels[level-1].wgt );
					_attach_data_wgt( plevel, module, dirname );
					if ( plevel->hierarchy != -1 )
						wgt_clear_flag( plevel->wgt, WGTFLAG_NOCOMPOSITE );
					gtk_widget_show( plevel->wgt );
					update_tooltip_widget( plevel->wgt );
				}
			}
			else
			{
				_set_res( module->wgt_window, NULL );
				_set_signal( module->wgt_window, NULL );
			}
			level--;
			INIT_ARGS;
			prev_close_bracket = TRUE;
		}

			/*--- Is-it a new widget ? ---*/

		else if ( (wgtdef = search_widget_class( p )) != NULL )
		{
			if ( !prev_close_bracket )
			{
				if ( level == 0 )
				{
					levels[level].wgt = module->wgt_window;
					_set_res( levels[level].wgt, NULL );
					_set_signal( levels[level].wgt, NULL );
					_attach_data_wgt( &levels[level], module, dirname );
				}
				else
				{
					assert( plevel == &levels[ level ] );
					INIT_ARGS;
					if ( plevel->hierarchy == -1 )
						_move_res();
					if ( level > 0 )
					{
						SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", levels[ level-1 ].wgt );
					}
					if ( plevel->hierarchy == -1 )
					{
						cpt_wgt++;
						plevel->wgt = 
							insert_new_widget( levels[level-1].wgt, plevel->wgtdef,
								FALSE, 			// f_select
								TRUE,			// is_disabled
								FALSE,			// Default values
								NULL );
					}
					else
					{
						cpt_wgt++;
						plevel->hierarchy_father_wgt =
							get_hierarchy_father_wgt( levels[level-1].wgt );
						plevel->wgt = 
							_compute_hierarchy_composite_childs( plevel->hierarchy_father_wgt,
								plevel->hierarchy );
					}
					assert( plevel->wgt != NULL );
					if ( level > 0 )
					{
						_set_res( plevel->wgt, levels[level-1].wgt );
						_set_signal( plevel->wgt, levels[level-1].wgt );
					}
					else
					{
						_set_res( plevel->wgt, NULL );
						_set_signal( plevel->wgt, NULL );
					}
					_attach_data_wgt( plevel, module, dirname );
					if ( plevel->hierarchy != -1 )
						wgt_clear_flag( plevel->wgt, WGTFLAG_NOCOMPOSITE );
					gtk_widget_show( plevel->wgt );
				}
			}
			level++;
			if ( levels == NULL )
				levels = malloc( sizeof( level_info_t ) );
			else
				levels = realloc( levels, sizeof( level_info_t ) * (level+1) );
			plevel = &levels[ level ];
			memset( plevel, 0, sizeof( level_info_t ) );
			plevel->wgtdef = wgtdef;
			plevel->is_placeholder = FALSE;
			plevel->hierarchy = hierarchy;
			p = strtok( NULL, " \t" );
			if ( !strcmp( p, "(anonymous)" ))	plevel->nametype = NAMETYPE_ANONYMOUS;
			else if ( !strcmp( p, "(global)" ))	plevel->nametype = NAMETYPE_GLOBAL;
			else if ( !strcmp( p, "(placeholder)" ))	
			{
				plevel->nametype = NAMETYPE_ANONYMOUS;
				plevel->is_placeholder = TRUE;
			}
			else
				assert( 0 );
			p = strtok( NULL, " \t" );
			if ( !strcmp( p, "?" ) )
				plevel->wgt_name = strdup( "" );
			else
				plevel->wgt_name = strdup( p );
			plevel->wgt = NULL;					// Will be created later
			plevel->nb_cb = 0;
			p = strtok( NULL, " \t\n" );
			if ( strcmp( p, "{" ) )
			{
				return 
					syntax_error( fp, "\"{\" not found after creation of a widget\n'%s'\nfile %s line %d", 
						p, mname, line_no );
			}
			prev_close_bracket = FALSE;
		}
		else
		{

			/*--- Is-is a resource ? ---*/
			wgtdef = levels[ level ].wgtdef;
			defsignal = NULL;
			def = _search_res( wgtdef, p, &wgtdef_depth );
			if ( (def == NULL) && (level >= 1) )
				def = _search_res_child( levels[ level-1 ].wgtdef, p, &wgtdef_depth );
			if ( def == NULL )
			{
				defsignal = _search_signal( wgtdef, p, &wgtdef_depth );
				if (defsignal)
				{
					_read_signal( fp, wgtdef, defsignal );
					prev_close_bracket = FALSE;
				}
			}
			if ( !def && !defsignal )
			{
				modal_error( "The resource\n'%s'\nis not defined into the GLG palette for %s.\nfile %s\nline %d",
					p, wgtdef->widget_name, mname, line_no );
			}

			else if ( def )
			{
				switch ( def->restype )
				{

					case GTK_TYPE_INT		: 
					case GTK_TYPE_UINT		: 
					case GTK_TYPE_LONG		: 
					case GTK_TYPE_ULONG		: 
					case GTK_TYPE_FLOAT		: 
						_read_int( fp, wgtdef, wgtdef_depth, def ); 
						break;

					case GTK_TYPE_BOOL		: 
						_read_bool( fp, wgtdef, wgtdef_depth, def ); 
						break;

					case GTK_TYPE_STRING	: 
						_read_string( fp, wgtdef, wgtdef_depth, def ); 
						break;

					case GTK_TYPE_ENUM		: 
						_read_enum( fp, wgtdef, wgtdef_depth, def ); 
						break;

					case GTK_TYPE_FLAGS		: 
						_read_flags( fp, wgtdef, wgtdef_depth, def ); 
						break;

					case GTK_TYPE_OBJECT :
						if ( !strcmp( def->object_restype_str, "GTK_TYPE_STYLE" ) )
							_read_style( fp, wgtdef, wgtdef_depth, def, mname, line_no );
						else if ( !strcmp( def->object_restype_str, "GTK_TYPE_CONTAINER" ) )
							_read_widget( fp, module, wgtdef, wgtdef_depth, def );
						else 
							assert( 0 );
						break;

					case GTK_TYPE_POINTER :
						if ( !strcmp( def->object_restype_str, "GTK_TYPE_ADJUSTMENT" ) )
							_read_adjustment( fp, wgtdef, wgtdef_depth, def ); 
						else if ( !strcmp( def->object_restype_str, "GTK_USERTYPE_STRINGS" ) )
							_read_strings( fp, wgtdef, wgtdef_depth, def, line, 32768, &line_no ); 
						else
							assert( 0 );
						break;

					default :
						RES_NOT_YET_HANDLED( wgtdef, def );
						assert(0);

				}				// switch
				prev_close_bracket = FALSE;
			}

		}						// else

	}							// while

	check_for_composite_childs( module->wgt_window );

	fclose( fp );
	if ( levels )
		free( levels );
	free( line );

	return 0;

}								// load_module


static int
read_style_color( FILE *fp, char *line, char *what, GdkColor *color )
{
	char		name[ 80 ];
	unsigned	red, green, blue;

	if ( fgets( line, 32768, fp ) == NULL )
		return -1;
		
	sscanf( line, "%s = (%u,%u,%u)",
		name, &red, &green, &blue );
	assert( !strcmp( what, name ) );
	
	color->red   = red;
	color->green = green;
	color->blue  = blue;
		
	return 0;

}								// read_style_color


static int
_read_styles( FILE *fp, char *line, 
	GtkStyle *style, style_info_t *style_info )
{
	char	*p;

	p = strtok( line, " \t\n" );
	assert( !strcmp( p, "style" ) );

	p = strtok( NULL, " \t\n" );
	strcpy( style_info->name, p );

	p = strtok( NULL, " \t\n" );
	assert( !strcmp( p, "{" ) );

	read_style_color( fp, line, "fg0", &style->fg[ 0 ] );
	read_style_color( fp, line, "fg1", &style->fg[ 1 ] );
	read_style_color( fp, line, "fg2", &style->fg[ 2 ] );
	read_style_color( fp, line, "fg3", &style->fg[ 3 ] );
	read_style_color( fp, line, "fg4", &style->fg[ 4 ] );

	read_style_color( fp, line, "bg0", &style->bg[ 0 ] );
	read_style_color( fp, line, "bg1", &style->bg[ 1 ] );
	read_style_color( fp, line, "bg2", &style->bg[ 2 ] );
	read_style_color( fp, line, "bg3", &style->bg[ 3 ] );
	read_style_color( fp, line, "bg4", &style->bg[ 4 ] );

	read_style_color( fp, line, "text0", &style->text[ 0 ] );
	read_style_color( fp, line, "text1", &style->text[ 1 ] );
	read_style_color( fp, line, "text2", &style->text[ 2 ] );
	read_style_color( fp, line, "text3", &style->text[ 3 ] );
	read_style_color( fp, line, "text4", &style->text[ 4 ] );

	read_style_color( fp, line, "base0", &style->base[ 0 ] );
	read_style_color( fp, line, "base1", &style->base[ 1 ] );
	read_style_color( fp, line, "base2", &style->base[ 2 ] );
	read_style_color( fp, line, "base3", &style->base[ 3 ] );
	read_style_color( fp, line, "base4", &style->base[ 4 ] );

	fgets( line, 32768, fp );
	p = strtok( line, " \t\n" );
	assert( !strcmp( p, "}" ) );

	return 0;

}								// _read_styles


static int
read_styles( FILE *fp )
{
	char	*line;
	int		len;
	int		n;

	assert( nb_styles == 0 );

	/*--- Each line ---*/									   
	line = malloc( 32768 );
	assert( line != NULL );
	while ( fgets( line, 32768, fp ) )
	{
			
		/*--- Skip empty line or line beginning with '#' ---*/
		if ( ((len = strlen(line)) >= 1) && (line[len-1] == '\n') )
			line[len-1] = 0;
		if ( !strcmp( line, "" ) || (line[0] == '#') )
			continue;

		if ( !strncmp( line, "Number of styles = ", 19 ) )
		{
			assert( nb_styles == 0 );
			nb_styles = atoi( &line[ 19 ] );
			break;
		}
		
	}							// while

	styles = malloc( nb_styles * sizeof( GtkStyle * ) );
	styles_infos = malloc( nb_styles * sizeof( style_info_t * ) );

	n = 0;
	while ( fgets( line, 32768, fp ) )
	{

		/*--- Skip empty line or line beginning with '#' ---*/
		if ( ((len = strlen(line)) >= 1) && (line[len-1] == '\n') )
			line[len-1] = 0;
		if ( !strcmp( line, "" ) || (line[0] == '#') )
			continue;

		assert( n < nb_styles );
		styles[ n ] = gtk_style_new();
		styles_infos[ n ] = malloc( sizeof( style_info_t ) );
		memset( styles_infos[n], 0, sizeof( style_info_t ) );
		_read_styles( fp, line, styles[ n ], styles_infos[ n ] );
		n++;

	}							// while

	/*--- Ok ---*/
	free( line );
	return 0;

}								// read_styles


PUBLIC int
do_load_project( GtkWidget *wgt_dlgfile, char *dirname )
{
	char			glgdir[ PATH_MAX+NAME_MAX + 100 ];
	char			glg_fname[ PATH_MAX+NAME_MAX + 100 ];
	char			styles_fname[ PATH_MAX+NAME_MAX + 100 ];
	FILE			*fp;
	struct stat		sbuf;
	module_info_t	*module;

	if ( stat( dirname, &sbuf ) == -1 )
	{
		modal_error( "\n%s\ndoes not exist.\n", dirname );
		return -1;
	}

	if ( S_ISREG( sbuf.st_mode ) )
	{
		modal_error( "\n%s\nis not a directory.\n", dirname );
		return -1;
	}
	sprintf( glgdir, "%s/glg", dirname );

	/*--- First read the config project specific file ---*/
	sprintf( glg_fname, "%s/lo_gafet.cfg", dirname );
	if ( access( glg_fname, F_OK ) == 0 )
		read_config( glg_fname, FALSE );

	/*--- Open the main file ---*/
	sprintf( glg_fname, "%s/glg", glgdir );
	fp = fopen( glg_fname, "r" );
	if ( fp == NULL )
	{
		modal_error( "Unable to read lg file\n%s\nerrno=%d", glg_fname, errno );
		return -1;
	}			// if
	read_glg_file( fp );
	fclose( fp );

	/*--- Read the styles ---*/
	sprintf( styles_fname, "%s/styles", glgdir );
	fp = fopen( styles_fname, "r" );
	if ( fp == NULL )
	{
		modal_error( "Unable to read lg file\n%s\nerrno=%d", styles_fname, errno );
		return -1;
	}			// if
	read_styles( fp );
	fclose( fp );

	/*--- Load each module ---*/
	module = next_module( FIRST );
	while ( module )
	{
		switch ( module->type )
		{
			case MODULE_TYPE_WINDOW :
			case MODULE_TYPE_DIALOG :
#ifdef USE_GNOME
			case MODULE_TYPE_GNOMEDIALOG_DIALOG :
			case MODULE_TYPE_GNOMEDIALOG_ABOUT :
			case MODULE_TYPE_GNOMEDIALOG_PROPERTYBOX :
			case MODULE_TYPE_GNOMEDIALOG_MESSAGEBOX :
#endif
			case MODULE_TYPE_MENU :
				load_module( wgt_dlgfile, dirname, module );
				module->f_not_generated = FALSE;
				project_saved( module );
				break;
			default :
				assert(0);
				break;
		}
		module = next_module( NEXT );
	}

	/*--- Raise the module non iconified ---*/
	module = next_module( FIRST );
	while ( module )
	{
		switch ( module->type )
		{
			case MODULE_TYPE_WINDOW :
			case MODULE_TYPE_DIALOG :
#ifdef USE_GNOME
			case MODULE_TYPE_GNOMEDIALOG_DIALOG :
			case MODULE_TYPE_GNOMEDIALOG_ABOUT :
			case MODULE_TYPE_GNOMEDIALOG_PROPERTYBOX :
			case MODULE_TYPE_GNOMEDIALOG_MESSAGEBOX :
#endif
				if ( !module->iconified )
					gdk_window_raise( module->wgt_window->window );					
				break;
			case MODULE_TYPE_MENU :
				if ( !module->iconified )
					gdk_window_raise( module->u1.menu.menudlg.wgt_showmenu->window );
				break;
			default :
				assert(0);
				break;
		}
		module = next_module( NEXT );
	}

	/*--- Make the first window module selected ---*/
	module = next_module( FIRST );
	curr_module = module;
	if ( curr_module != NULL )
	{
		update_tree();
		select_widget( module->wgt_window, 
			TRUE,
			TRUE );					// Select 1st CB, if any
		gtk_ctree_select( GTK_CTREE(wgt_tree_modules),
			GTK_CTREE_NODE(module->wgt_tree_node) );
	}

#ifdef GLG_SUPPORT_EDIT_COMPOSITE
	/*--- Update flag 'Show and Edit Composite Childs ---*/
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wgt_opt_editcompositechilds ),
		config.show_composite_childs );
#endif

	/*--- Load project is Ok ---*/
	strcpy( project_dirname, dirname );

	/*--- Update main menu ---*/
	update_main_menu();

	return 0;

}								// do_load_project
