#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <sys/wait.h>
#include <signal.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


static int
_locate_startup( FILE *fp, int *lineno, char *model )
{
	int			sz;
	char		*buff, *p;

	/*--- Read the file into a temp buffer ---*/
	fseek( fp, 0, SEEK_END );
	sz = (int)ftell( fp );
	fseek( fp, 0, SEEK_SET );
	buff = malloc( sz + 1 );
	if ( buff == NULL )
		return FALSE;
	fread( buff, sz, 1, fp );
	buff[ sz ] = 0;

	/*--- Found ? ---*/
	if ( (p = strstr( buff, model )) == NULL )
	{
		for ( p = buff, *lineno = 0; ; )
		{
			if ( (p = strchr( p, '\n' )) == NULL )
				break;
			(*lineno)++;
			p++;
		}		
		free( buff );
		return FALSE;
	}

	/*--- Search for the line number ---*/
	for ( p[0] = 0, p = buff, *lineno = 0; ; )
	{
		if ( (p = strchr( p, '\n' )) == NULL )
			break;
		(*lineno)++;
		p++;
	}		
	free( buff );
	return TRUE;

}								// _locate_startup


PUBLIC int
edit_startup( void )
{
	char	cfile[ PATH_MAX+NAME_MAX + 100 ];
	FILE	*fp;
	int		lineno;
	char	model[ 512 ];
	int		found;

	sprintf( cfile, "%s/src/startup.c", 
		project_dirname );
	fp = fopen( cfile, "r" );
	assert( fp != NULL );

	/*--- The string to search ---*/
	sprintf( model, "void\nstartup( int argc, char *argv[] )\n{" );

	found = _locate_startup( fp, &lineno, model );
	assert( found );
	lineno += 4;
	fclose( fp );

	edit_file( cfile, lineno );

	return 0;
	
}								// edit_startup
