#define GLG_APPID				"Gtk Lo Gafet"
#define	FLG_APPVERSION_MAJOR	0
#define	FLG_APPVERSION_MINOR	2
#define	FLG_APPVERSION_SEQ		0
#define	FLG_APPVERSION_DATE		__DATE__
#define	FLG_APPVERSION_TIME		__TIME__

#ifdef USE_GNOME
#include <gnome.h>
#else
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#endif

// #ifdef DLG_EMAIL

#ifdef __MAIN__
#	define COMMON
#	define INIT(v) = v;
#else
#	define COMMON extern
#	define INIT(v) ;
#endif

#define PUBLIC

#ifdef DEBUG
#define trace	printf
#else
#define trace	printf
#endif

#define YES	-1
#define	NO	0

/*--- Environment variables ---*/
#define	ENVVAR_GLG_RESTOREWNDOWSPOSITION	"GLG_RESTOREWINDOWSPOSITION"
#define	ENVVAR_GLG_EDITOR1					"GLG_EDITOR1"
#define	ENVVAR_GLG_EDITOR2					"GLG_EDITOR2"
#define	ENVVAR_GLG_EDITOR3					"GLG_EDITOR3"

/*--- See field: setgetres_method ---*/
enum
{
	SETGETRES_METHOD_ARGS = 1,
	SETGETRES_METHOD_ARGV
};
enum
{
	INDENTSTYLE_BLOCK1 = 1,
	INDENTSTYLE_BLOCK2,
	INDENTSTYLE_BLOCK3,
};
enum
{
	LANGUAGE_C = 1,
#ifdef GLG_SUPPORT_LANGUAGECPP
	LANGUAGE_CPP = 2,
#endif
#ifdef GLG_SUPPORT_LANGUAGEWFROTH
	LANGUAGE_WFROTH = 3,
#endif
};

/*--- Which system ---*/
#define SYST_UNKNOW			0
#define SYST_FREEBSD		1
COMMON	int		syst;

/*--- Configuration (global, and per project) ---*/
#define MAXNB_CFILES_ADDED	12
typedef struct
{

	struct
	{
		int		x, y;
		int		w, h;
	}	tree_wnd;
	struct
	{
		int		x, y;
		int		w, h;
	}	resources_wnd;
	struct
	{
		int		x, y;
		int		w, h;
	}	palette_wnd;

	int			initial_w_module_window, 
				initial_h_module_window;
	int			initial_w_module_dialog, 
				initial_h_module_dialog;
	int			selection_mark_type;					// 1: rect, 2: round
	int			flag_list_as;							// 1: constant, 2: manifest
	int			max_source_line;						// Default is 80
	char		editor1[92], editor2[92], editor3[92];	// External editor to launch
	int			is_glo_after;							// Goto line option is after of before ?
	char		goto_line_option[4];					// -l for vedit

	int			platform_is_lib_m;						// -l m ?

	int			indentstyle_function;					// 1, 2
	int			indentstyle_block;						// INDENTSTYLE_BLOCK1, INDENTSTYLE_BLOCK2
	int			setgetres_method;						// SETGETRES_METHOD_
#ifdef GLG_SUPPORT_EDIT_COMPOSITE
	int			show_composite_childs;					// Show and Edit composite childs ?
#endif
	
	int			is_expand_container_blank;

	int			tree_is_display_icon;
	int			tree_is_display_gtktype;
	int			callbacks_is_display_icon;

	/*--- Project specific ---*/
	char		exe_name[ 64 ];									// Executable name
	char		header_to_include[ 80 ];						// Header to include
	char		list_cfiles_added[ MAXNB_CFILES_ADDED ][ 64 ];	// .c files added
	int			is_gnome;
	int			language_newprj;
	int			language_current;

}	config_t;
COMMON	config_t	config;


/*
	*** *************************************************************** ***
	***																	***
	*** This data structure is linked to a module item (Project Window) ***
	***																	***
	*** *************************************************************** ***
*/

enum
{
	MODULE_TYPE_WINDOW = 1,
	MODULE_TYPE_DIALOG = 100,
#ifdef USE_GNOME
	MODULE_TYPE_GNOMEDIALOG_DIALOG,
	MODULE_TYPE_GNOMEDIALOG_ABOUT,
	MODULE_TYPE_GNOMEDIALOG_PROPERTYBOX,
	MODULE_TYPE_GNOMEDIALOG_MESSAGEBOX,
#endif
	MODULE_TYPE_MENU = 200,
};

typedef struct
{
	GtkWidget	*wgt_showmenu;
	GtkWidget	*wgt_showmenu_btn_test;
	GtkWidget	*wgt_showmenu_btn_edit;
}	module_menu_dlg_t;

typedef struct
{
	GtkWidget	*wgt_menued_window;
	GtkWidget	*wgt_menued_btn_testmenu;
	GtkWidget	*wgt_menued_list_items;
	GtkWidget	*wgt_menued_btn_move_up;
	GtkWidget	*wgt_menued_btn_move_down;
	GtkWidget	*wgt_menued_btn_move_left;
	GtkWidget	*wgt_menued_btn_move_right;
	GtkWidget	*wgt_menued_label_item;
	GtkWidget	*wgt_menued_entry_item;
	GtkWidget	*wgt_menued_checkbtn_type_menuitem;
	GtkWidget	*wgt_menued_checkbtn_type_toggleitem;
	GtkWidget	*wgt_menued_checkbtn_type_radioitem;
	GtkWidget	*wgt_menued_checkbtn_type_separator;
	GtkWidget	*wgt_menued_checkbtn_type_submenu;
	GtkWidget	*wgt_menued_btn_add_item;
	GtkWidget	*wgt_menued_btn_delete_item;
	GtkWidget	*wgt_menued_close;
}	module_menu_editor_t;

typedef struct
{
	int					type;						// MODULE_TYPE_
	GtkCTreeNode		*wgt_tree_node;				// Into the project window tree
	GtkWidget			*wgt_window;  				// Window (module)
	union
	{
		struct
		{
			int				f_opened_from_main;
			int				f_fixed_position;
			char			name_function[64];
			GtkTooltips		*tooltips;	
		}					window;
		struct
		{
			int				f_opened_from_main;
			int				f_fixed_position;
			char			name_function[64];
		}					dialog;
		struct
		{
			char					name_function[64];
			GtkTooltips				*tooltips;	
			module_menu_dlg_t		menudlg;
			module_menu_editor_t	menued;
		}					menu;
	}					u1;
	int					f_not_saved;		// Module not saved ?
	int					f_not_generated;	// Module not saved ?
	int					iconified;			// gdk_window_raise/lower
}	module_info_t;


/*--- To be used with next_module() ---*/
#define FIRST 1
#define NEXT  2

/*--- Type of infos added to the widget (PtAddWidgetData) ---*/
enum
{
	NAMETYPE_ANONYMOUS = 1,
	NAMETYPE_GLOBAL
};

/*--- Data attached to widgets ---*/
#define WGTDATA_MODULE					"module"
#define WGTDATA_WGTDEF					"wgtdef"
#define WGTDATA_NAME					"name"
#define WGTDATA_NAMETYPE				"name_type"
#define WGTDATA_OUTSIDERES				"outside_res"
#define WGTDATA_HIERARCHY_CHILD			"hierarchy_child"
#define WGTDATA_HIERARCHY_CHILD_MASTER	"hierarchy_child_master"

#define WGTDATA_FLAGS					"flags"
#define WGTFLAG_PLACEHOLDER				0x01
#define WGTFLAG_NOCOMPOSITE				0x02
#define WGTFLAG_DONTDELETE				0x04
#define IS_WGT_PLACEHOLDER(wgt) 		(wgt_get_flag(wgt) & WGTFLAG_PLACEHOLDER)
#define IS_WGT_NOCOMPOSITE(wgt) 		(wgt_get_flag(wgt) & WGTFLAG_NOCOMPOSITE)
#define IS_WGT_DONTDELETE(wgt) 			(wgt_get_flag(wgt) & WGTFLAG_DONTDELETE)

/*--- Data attached to property widgets ---*/
#define PROPERTIES_WGTDATA_LABEL		"label"

/*--- Data attached to tree widgets ---*/
#define TREENODE_WGTDATA				"tree_node"
#define CALLBACKSNODE_WGTDATA			"callbacks_node"

COMMON int		nb_args;
COMMON GtkArg	args[ 100 ];

#define INIT_ARGS \
	nb_args = 0

#define SETARG_INT( n, v ) \
	args[nb_args].type=GTK_TYPE_INT; \
	args[nb_args].name=n; \
	GTK_VALUE_INT(args[nb_args++])=v

#define SETARG_UINT( n, v ) \
	args[nb_args].type=GTK_TYPE_UINT; \
	args[nb_args].name=n; \
	GTK_VALUE_UINT(args[nb_args++])=v

#define SETARG_LONG( n, v ) \
	args[nb_args].type=GTK_TYPE_LONG; \
	args[nb_args].name=n; \
	GTK_VALUE_LONG(args[nb_args++])=v

#define SETARG_ULONG( n, v ) \
	args[nb_args].type=GTK_TYPE_ULONG; \
	args[nb_args].name=n; \
	GTK_VALUE_ULONG(args[nb_args++])=v

#define SETARG_BOOL( n, v ) \
	args[nb_args].type=GTK_TYPE_BOOL; \
	args[nb_args].name=n; \
	GTK_VALUE_BOOL(args[nb_args++])=v

#define SETARG_STRING( n, v ) \
	args[nb_args].type=GTK_TYPE_STRING; \
	args[nb_args].name=n; \
	GTK_VALUE_STRING(args[nb_args++])=v

#define SETARG_OBJECT( T, N, V ) \
	args[nb_args].type=T; \
	args[nb_args].name=N; \
	GTK_VALUE_OBJECT(args[nb_args++])=GTK_OBJECT(V)

#define SETARG_ENUM( T, n, v ) \
	args[nb_args].type=T; \
	args[nb_args].name=n; \
	GTK_VALUE_ENUM(args[nb_args++])=v

#define SETARG_FLAGS( T, n, v ) \
	args[nb_args].type=T; \
	args[nb_args].name=n; \
	GTK_VALUE_FLAGS(args[nb_args++])=v

/*--- Offsets to add to a window position (Window Manager) - Yucky! ---*/
COMMON	gint	wm_x_offset;
COMMON	gint	wm_y_offset;

/*--- dlg_infos_addwgt.c ---*/
int infos_addwgt_dialog( char *title, int *val, int vmin, int vmax, char *fmt, ... );

/*--- dlg_infos_addwgt2.c ---*/
int infos_addwgt_dialog2( char *title, 
	int *val1, int vmin1, int vmax1, char *msg1,
	int *val2, int vmin2, int vmax2, char *msg2 );

/*--- module_window.c ---*/
void set_data_wgtdef( GtkWidget *widget, GtkWidget *wgt_parent,
	module_info_t *module, 
	int type_wgt, int is_composite,
	int is_disabled );
struct gtk_wgtdef_t;
GtkWidget *create_new_wgt( struct gtk_wgtdef_t *wgtdef_newwgt, module_info_t *module,
	GtkWidget *wgt_parent, GtkWidget *wgt_container,
	GtkWidget * (*pfct_create_wgt)(void) );

/*--- module_window_prop.c ---*/
void module_window_properties( module_info_t *module );

/*--- module_menu_prop.c ---*/
void module_menu_properties( module_info_t *module );

/*--- placeholder.c ---*/
void install_draw_placeholder( GtkWidget *wgt_placeholder );
GtkWidget *create_placeholder( int type, GtkWidget *wgt_parent, int index, 
	module_info_t *module );

/*--- utils ---*/
int count_nb_widgets( GtkWidget *wgt );
#ifdef DEBUG
double now( void );
#endif
void destroy_notify( gpointer data );
void compute_hierarchy_composite_childs( GtkWidget *wgt_main );
void set_object_data( GtkWidget *obj, char *key, void *ptr, int f_free );
void *get_object_data( GtkWidget *obj, char *key );
void wgt_put_flag( GtkWidget *wgt, const int flag );
void wgt_clear_flag( GtkWidget *wgt, const int flag );
void wgt_set_flag( GtkWidget *wgt, const int flag );
int wgt_get_flag( GtkWidget *wgt );
void set_name_wgt( GtkWidget *wgt, char *name );
char *get_name_wgt( GtkWidget *wgt );

/*--- Widgets Resources ---*/
COMMON	GtkWidget	*wgt_resources_btn_anonymous;
COMMON	GtkWidget	*wgt_resources_btn_global;
COMMON	GtkWidget	*wgt_resources_label_name;
COMMON	GtkWidget	*wgt_resources_entry_name;
COMMON	int			cb_name_changed_id;
COMMON	int			cb_name_focus_in_id;
#include "resources/resources.h"

/*--- Structure to define callbacks (Signal) attached to widgets ---*/
#define MAXSZ_CBNAME		48
#define MAXSZ_CB_FILENAME	128
typedef struct
{
	defclasssignal_t	*defclasssignal;
	char				*cbname;					// srtdup
	char				*cbfile;					// strdup
	int					f_after;					// After ?
	int					is_accelerator;
	guint				accelerator_key_val;
	char				accelerator_key_string[ 16 ];
	GdkModifierType		accelerator_mods;
	GtkAccelFlags		accel_flags;
}	def_cb_t;
typedef struct
{
	int			nb_cb;
	def_cb_t	*cb;
}	data_cb_t;

/*--- Project Window ---*/
COMMON	char			*config_name			INIT( NULL );
#define MAXNB_LAST_PROJECTS	12
COMMON	char			*last_projects[ MAXNB_LAST_PROJECTS ];
COMMON	char			project_dirname[ PATH_MAX+NAME_MAX ];
COMMON	int				is_project_touched		INIT( FALSE );
COMMON	int				is_preview_mode			INIT( FALSE );
COMMON	int				cpt_module_window;
COMMON	int				cpt_module_dialog;
COMMON	int				cpt_module_menu;
COMMON	module_info_t	*curr_module			INIT( NULL );

/*--- Tree Window ---*/
COMMON	GtkWidget	*wgt_wnd_tree;

/*--- Resources Window ---*/
COMMON	GtkWidget	*wgt_wnd_resources;
COMMON	GtkWidget	*wgt_res_notebook;


/*--- Palette Window ---*/
COMMON	GtkWidget	*wgt_wnd_palette;
COMMON	GtkWidget	*wgt_selected_wgt_palette	INIT( NULL );
COMMON	GtkStyle	*properties_style_normal, 
					*properties_style_bold,
					*properties_style_oblique;

/*--- Tree ---*/
COMMON	GtkWidget	*wgt_tree_modules	INIT( NULL );
COMMON	GtkWidget	*wgt_tree_widgets;
COMMON	GtkWidget	*wgt_tree_callbacks;
COMMON	GtkWidget	*wgt_tree_styles;
COMMON	GtkWidget	*wgt_statusbar		INIT( NULL );

/*--- Do we restore windows position at startup/load project ? ---*/
COMMON	int			is_restore_windows_position;

/*--- Current widget(s) selection ---*/
COMMON	GSList		*list_selection		INIT( NULL );

/*--- Styles ---*/
COMMON	int				nb_styles	INIT( 0 ) ;
COMMON	GtkStyle		**styles	INIT( NULL );
typedef struct
{
	char			name[ 48+1 ];	// C-name of the style
	GtkCTreeNode	*wgt_node;		// wgt_tree_styles
	int				nb_ref;			// Total nb of refernces - If >0, delete is disabled
}	style_info_t;
COMMON	style_info_t	**styles_infos	INIT( NULL );

/*--- project.c ---*/
int give_a_chance_to_save( void );
gint cb_close_app( GtkWidget * widget, gpointer data );
void reset_styles( void );
int clear_project(char *title);
GtkWidget *create_menu_sep( GtkWidget *menu );
GtkWidget *create_menu_item( GtkWidget *wgt_menu, char *label,
	int sensitive,
	int acc_key, int acc_control, GtkSignalFunc cb, gpointer user_data );
GtkWidget *create_toggle_item( GtkWidget *wgt_menu, char *label,
	int sensitive, int state,
	int acc_key, int acc_control, GtkSignalFunc cb, gpointer user_data );
void touch_all_modules( void );
int  cb_project_module_button_press_event( GtkCTree *ctree, GdkEventButton *event, gpointer data );
void project_touched( module_info_t *module );
void project_saved( module_info_t *module );
void project_generated( module_info_t *module );

/*--- tree.c ---*/
COMMON	GtkWidget	*wgt_popup_menu 				INIT(NULL);
COMMON	GtkWidget	*wgt_opt_editcompositechilds	INIT( NULL );
#ifdef DEBUG
COMMON	GtkWidget	*wgt_debug_infos_properties;
#endif
void cb_windows_arrange_right( GtkWidget *widget, gpointer data );
void cb_windows_arrange_left( GtkWidget *widget, gpointer data );
void cb_debug_walk( GtkWidget * w, gpointer _data );
void update_main_menu( void );
void create_tree_window( void );

/*--- resources.c ---*/
void update_tooltip_widget( GtkWidget *wgt );
gboolean cb_string_focus_in( GtkWidget *widget, GdkEventFocus *event, gpointer user_data );
void create_resources_window( void );

/*--- disp_res_one_widget ---*/
void clear_resources( int clear_widget_name_area );
void display_resource_one_widget( GtkWidget *widget, int page );

/*--- palette.c ---*/
#ifdef DEBUG
void cb_window_size_allocate( GtkWidget *widget, GtkAllocation *allocation, 
	gpointer user_data );
#endif
void create_palette_window( void );
void set_palette_sensitive( int ok );

/*--- module_window.c ---*/
int nb_modules( void );
module_info_t *next_module( int op );
gint cb_module_window_close( GtkWidget * widget, gpointer data );
module_info_t *module_create_window( char *title, int w, int h, int iconified );
void recreate_tree( module_info_t *module, GtkWidget *wgt );
module_info_t *module_create_dialog( char *title, int w, int h, int iconified,
	int type, char *which_dlg );
void new_widget_inserted( GtkWidget *wgt_new, GtkWidget *wgt_container, 
	gtk_wgtdef_t *wgtdef_newwgt );
void set_outsideres_function( GtkWidget *wgt_new, gtk_wgtdef_t *wgtdef_newwgt );
GtkWidget *insert_new_widget( GtkWidget *wgt_container, gtk_wgtdef_t *wgtdef_newwgt,
	int f_select, int is_disabled,
	int f_deft_values,
	module_info_t *_module );
gboolean cb_window_focus_in( GtkWidget *widget, GdkEventFocus *event, gpointer user_data );

/*--- module_menu.c ---*/
module_info_t * module_create_menu( char *title, int iconified );

/*--- menu_editor.c ---*/
void menu_touched( module_info_t *module );
void menu_editor( module_info_t *module );

/*--- save_project ---*/
void save_project( void );
int save_project_as( void );

/*--- do_save_project ---*/
int save_wnd_infos( FILE *fp, GtkWidget *wnd, char *tag );
int do_save_project( char *dirname );

/*--- load_project ---*/
void load_project( void );
void add_to_last_projects( char *new_prj );

/*--- do_load_project ---*/
gtk_wgtdef_t *
search_widget_class( const char * const name );
int do_load_project( GtkWidget *wgt_dlgfile, char *dirname );

/*--- prjopt.c ---*/
void create_default_config( void );
int write_config( const char * const filename, const int save_project_specific );
int read_config( const char * const filename, const int position_windows );

/*--- gen_c ---*/
void add_system_includes( FILE *fp );
int generate_c( const char * const dirname,
	void (*output)(char *fmt, ... ) );

/*--- generate ---*/
char *get_style_name( GtkStyle *style );
int gen_any_tooltips( module_info_t *module );
int gen_any_accelerator( module_info_t *module );
int is_accelerator( GtkWidget *wgt, char **signal_name, guint *keyval,
	GdkModifierType *accelerator_mods, GtkAccelFlags *accel_flags );
int generate( const char * const dirname,
	void (*output)(char *fmt, ... ) );

/*--- utils ---*/
void check_for_composite_childs( GtkWidget *widget );
void set_outsideres_wgt( GtkWidget *wgt, char *resname, GtkArg *arg );
GtkArg *get_outsideres_wgt( GtkWidget *wgt, char *resname );
void set_nametype_wgt( GtkWidget *wgt, int type );
int  get_nametype_wgt( GtkWidget *wgt );
void set_is_disabled_resource_wgt( GtkWidget *wgt, defclass_t *defclass, int is_disabled );
int  get_is_disabled_resource_wgt( GtkWidget *wgt, defclass_t *defclass );
void modal_error( char *fmt, ... );
int yesno_dialog( char *title, int default_val, char *fmt, ... );
int dialog3( char *title, int default_val,
	char *btn1, char *btn2, char *btn3,
	char *fmt, ... );
void push_block_all_windows( void );
void pop_block_all_windows( void );
gtk_wgtdef_t * search_wgtdef( char *class );
GtkWidget *_compute_hierarchy_composite_childs( GtkWidget *wgt_main, int depth );
int search_enum( int value, defclass_t *defclass );
guint key_to_val( char *key );
char * val_to_key( guint val );
GList *keys_glist( void );
GtkWidget *search_widget_by_name( GtkWidget *start, char *name );

/*--- warning ---*/
void clear_warning( void );
void warning( char *fmt, ... );

/*--- default_wgt ---*/
void check_default_values( void );
int is_default_value( GtkWidget *wgt, GtkWidget *wgt_parent, 
	gtk_wgtdef_t *wgtdef, defclass_t *p );

/*--- tree.c ---*/
void tree_select_popup_menu( GtkWidget *wgt, GdkEventButton *event,
	GtkCTreeNode *node, int from_ctree );

/*--- create_tree.c ---*/
typedef struct
{
	char		*resname;
	def_cb_t	*defcb;
}	get_first_callback_t;
int get_first_callbacks( int maxnb_cb, get_first_callback_t *cbget,
	GtkWidget *wgt, gtk_wgtdef_t *wgtdef );
void update_tree( void );

/*--- select_widget.c ---*/
void select_widget( GtkWidget *widget, int do_select, int f_select_first_cb );
PUBLIC void refresh_properties_selected_widgets( void );

/*--- res_edit_string.c ---*/
GtkWidget *res_editor_string( gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	GtkWidget *wgt_container, defclass_t *defclass,
	GtkWidget *wgt_parent );

/*--- dlg_res_edit_string.c ---*/
void dlg_res_editor_string( GtkWidget *wgt_btn, GtkWidget *wgt_entry, 
	defclass_t *defclass, 
	GtkWidget *wgt_parent,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth );

/*--- res_edit_bool.c ---*/
GtkWidget *res_editor_bool( gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	GtkWidget *wgt_container, defclass_t *defclass,
	GtkWidget *wgt_parent );

/*--- dlg_res_edit_bool.c ---*/
void dlg_res_editor_bool( GtkWidget *wgt_btn,
	defclass_t *defclass, 
	GtkWidget *wgt_parent,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth );

/*--- res_edit_int.c ---*/
GtkWidget *res_editor_int( int f_optional,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	GtkWidget *wgt_container, defclass_t *defclass,
	GtkWidget *wgt_parent );

/*--- dlg_res_edit_int.c ---*/
void dlg_res_editor_int( GtkWidget *wgt_btn,
	defclass_t *defclass, 
	GtkWidget *wgt_parent,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth );

/*--- res_edit_enum.c ---*/
GtkWidget *res_editor_enum( gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	GtkWidget *wgt_container, defclass_t *defclass,
	GtkWidget *wgt_parent );

/*--- res_edit_flags.c ---*/
GtkWidget *res_editor_flags( gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	GtkWidget *wgt_container, defclass_t *defclass,
	GtkWidget *wgt_parent );

/*--- res_edit_signal.c ---*/
GtkWidget *res_editor_signal( gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	GtkWidget *wgt_container, 
	defclasssignal_t *defclasssignal,
	GtkWidget *wgt_label );
	
/*--- dlg_res_edit_signal.c ---*/
void cb_destroy_signal_notify( gpointer data );
void cb_dialog_cb( GtkWidget *widget, void *data );
void do_dialog_cb( defclasssignal_t *defclasssignal );

/*--- res_edit_style.c ---*/
GtkWidget *res_editor_style( gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	GtkWidget *wgt_container, defclass_t *defclass,
	GtkWidget *wgt_parent );

/*--- res_edit_adjustment.c ---*/
GtkWidget *res_editor_adjustment( gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	GtkWidget *wgt_container, defclass_t *defclass,
	GtkWidget *wgt_parent );

/*--- res_edit_string.c ---*/
GtkWidget *res_editor_strings( gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	GtkWidget *wgt_container, defclass_t *defclass,
	GtkWidget *wgt_parent );

/*--- dlg_res_edit_string.c ---*/
void dlg_res_editor_strings( GtkWidget *wgt_btn, GtkWidget *wgt_entry, 
	defclass_t *defclass, 
	GtkWidget *wgt_parent,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth );

/*--- edit_cb.o ---*/
int locate_cb_in_file( GtkWidget *wgt, def_cb_t *defcb );
int edit_file( char *cfile, int lineno );
int edit_cb( GtkWidget *wgt, def_cb_t *defcb );

/*--- edit_startup ---*/
int edit_startup( void );

/*--- edit_header ---*/
int edit_header( void );

/*--- handles.c ---*/
void reset_selection( void );
void add_wgt_to_selection( GtkWidget *wgt );
int nb_selection( void );
gtk_wgtdef_t *get_wgtdef_selection( void );

/*--- comprun.c ---*/
void comprun_dlg( void );

/*--- dlg_prjopt.c ---*/
void dialog_project_options( const int is_project );

/*--- dlg_about.c ---*/
void dlg_about( void );

/*--- dlg_email.c ---*/
void dlg_email( void );

/*--- dlg_edit_styles.c ---*/
char *get_font_name( GtkStyle *style );
void edit_styles( GtkStyle *style );

/*--- dlg_edit_style.c ---*/
int edit_style( GtkStyle *style );

/*--- res.c ---*/
int get_res_string( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg );
void set_res_string( GtkWidget *wgt, char *string,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent );

int get_res_int( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg );
void set_res_int( GtkWidget *wgt, GtkArg *arg,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	int *first, GtkSpinButton *wgt_num );

int get_res_bool( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg, GtkArg **parg );
void set_res_bool( GtkWidget *wgt, int state,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent );

int get_res_enum( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg, GtkArg **parg );
void set_res_enum( GtkWidget *wgt, int value,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent );

int get_res_flags( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg, GtkArg **parg );
void set_res_flags( GtkWidget *wgt, gint value,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent );

void cb_destroy_notify_strings( gpointer data );
int get_res_strings( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg );
void set_res_strings( GtkWidget *wgt, gtk_usertype_strings_t **strings,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent );

int get_res_pointer( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg, GtkArg **parg );

