#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


PUBLIC void
reset_selection( void )
{

	g_slist_free( list_selection );
	list_selection = NULL;

}								// reset_selection


PUBLIC void
add_wgt_to_selection( GtkWidget *wgt )
{

	list_selection = g_slist_append( list_selection, wgt );

}								// add_wgt-to_selection


PUBLIC int
nb_selection( void )
{
	return g_slist_length( list_selection );
}								// nb_selection


typedef struct
{
	gtk_wgtdef_t	*wgtdef;
	int				bad;
}	foreach_get_wgtdef_selection_data;

static void
foreach_get_wgtdef_selection( gpointer data, gpointer user_data )
{
	GtkWidget							*wgt = GTK_WIDGET( data );
	foreach_get_wgtdef_selection_data	*p = (foreach_get_wgtdef_selection_data *)user_data;
	gtk_wgtdef_t						*wgtdef;

	/*--- Find the description of this widget ---*/
	if ( !p->bad )
	{
		wgtdef = gtk_object_get_data( GTK_OBJECT( wgt ), WGTDATA_WGTDEF );
		assert( wgtdef != NULL );
		if ( p->wgtdef != NULL )
		{
			if ( p->wgtdef != wgtdef )
				p->bad = TRUE;
		}
		else
		{
			p->wgtdef = wgtdef;
		}
	}

}								// foreach_get_wgtdef_selection

PUBLIC gtk_wgtdef_t	*
get_wgtdef_selection( void )
{
	foreach_get_wgtdef_selection_data	data;
	
	data.wgtdef = NULL;
	data.bad    = FALSE;
	g_slist_foreach( list_selection, foreach_get_wgtdef_selection, &data );
	return (data.bad) ? NULL : data.wgtdef;

}								// get_wgtdef_selection
