#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"



/* Callback "clicked" for GtkButton widget wgt_showmenu_btn_test */
static void
cb_showmenu_btn_test_clicked(GtkButton *button, gpointer user_data)
{
	module_info_t		*module = (module_info_t *)user_data;
	GdkEvent			*event;

	event = gtk_get_current_event();
	gtk_menu_popup( GTK_MENU( module->wgt_window ), NULL, NULL, NULL, NULL,
		1, NULL );
}								// cb_showmenu_btn_test_clicked


/* Callback "clicked" for GtkButton widget wgt_showmenu_btn_edit */
static void
cb_showmenu_btn_edit_clicked(GtkButton *button, gpointer user_data)
{
	module_info_t		*module = (module_info_t *)user_data;
//	module_menu_dlg_t	*dlg = &module->u1.menu.menudlg;

	menu_editor( module );
	
}								// cb_showmenu_btn_edit_clicked


static GtkWidget *
create_window( module_info_t *module, char *title, int iconified )
{
	GtkWidget			*wgt_1_2;
	module_menu_dlg_t	*dlg = &module->u1.menu.menudlg;

	dlg->wgt_showmenu = gtk_widget_new( gtk_window_get_type(),
		"GtkWidget::width", 100,
		"GtkWidget::height", 140,
		"GtkWidget::events", 0x0000030C,
		"GtkContainer::resize_mode", GTK_RESIZE_QUEUE,
		"GtkWindow::title", "window1",
		"GtkWindow::allow_grow", TRUE,
		"GtkWindow::default_width", 100,
		"GtkWindow::default_height", 140,
		NULL );

	wgt_1_2 = gtk_widget_new( gtk_vbox_get_type(),
		"GtkWidget::parent", dlg->wgt_showmenu,
		NULL );

	dlg->wgt_showmenu_btn_test = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Test menu",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), dlg->wgt_showmenu_btn_test,
		"GtkBox::expand", FALSE,
		NULL );
	gtk_signal_connect( GTK_OBJECT( dlg->wgt_showmenu_btn_test ), "clicked",
		GTK_SIGNAL_FUNC( cb_showmenu_btn_test_clicked ), module );

	dlg->wgt_showmenu_btn_edit = gtk_widget_new( gtk_button_get_type(),
		"GtkWidget::parent", wgt_1_2,
		"GtkWidget::can_focus", TRUE,
		"GtkWidget::receives_default", TRUE,
		"GtkButton::label", "Edit Menu",
		NULL );
	gtk_container_child_set( GTK_CONTAINER( wgt_1_2 ), dlg->wgt_showmenu_btn_edit,
		"GtkBox::position", 1,
		NULL );
	gtk_signal_connect( GTK_OBJECT( dlg->wgt_showmenu_btn_edit ), "clicked",
		GTK_SIGNAL_FUNC( cb_showmenu_btn_edit_clicked ), module );

	if ( iconified )
	{
		gtk_widget_show_all( dlg->wgt_showmenu );
		gdk_window_lower( dlg->wgt_showmenu->window );
		module->iconified = TRUE;
	}
	else
	{
		gtk_widget_show_all( dlg->wgt_showmenu );
		gdk_window_raise( dlg->wgt_showmenu->window );
		module->iconified = FALSE;
	}

	set_data_wgtdef( dlg->wgt_showmenu, NULL, module, 
		FALSE, 			// Placeholder
		FALSE, 			// Composite
		FALSE );		// Disabled
#ifdef GLG_SUPPORT_EDIT_COMPOSITE
	if ( config.show_composite_childs )
		check_for_composite_childs( dlg->wgt_showmenu );
#endif

	return dlg->wgt_showmenu;
}								// create_window


PUBLIC module_info_t *
module_create_menu( char *title, int iconified )
{
	module_info_t	*module;
	char			title_menu[ 200 ];
	gtk_wgtdef_t	*wgtdef_menu=NULL;
	GtkCTreeNode	*wgt_node;
	char			*text[1];

	/*--- Create a new module info ---*/
	module = g_malloc( sizeof( module_info_t ) );
	memset( module, 0, sizeof( module_info_t ) );
	cpt_module_menu++;
	if (title == NULL)
		sprintf( title_menu, "menu%d", cpt_module_menu );
	else
		sprintf( title_menu, title );
	module->type = MODULE_TYPE_MENU;
	sprintf( module->u1.menu.name_function, "create_%s", title_menu );
	module->iconified = FALSE;
	module->f_not_saved = FALSE;
	module->u1.menu.tooltips = gtk_tooltips_new();

	/*--- Create the window ---*/
	create_window( module, title_menu, iconified );
	gtk_widget_set_events( module->u1.menu.menudlg.wgt_showmenu,
		gtk_widget_get_events( module->u1.menu.menudlg.wgt_showmenu ) |
		GDK_POINTER_MOTION_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK  );
	gtk_signal_connect( GTK_OBJECT( module->u1.menu.menudlg.wgt_showmenu ), "focus_in_event",
		GTK_SIGNAL_FUNC(cb_window_focus_in), module );
	gtk_signal_connect( GTK_OBJECT(module->u1.menu.menudlg.wgt_showmenu), "destroy",
		GTK_SIGNAL_FUNC( cb_module_window_close ), module );
	gtk_signal_connect(GTK_OBJECT(module->u1.menu.menudlg.wgt_showmenu), "delete_event",
		GTK_SIGNAL_FUNC( cb_module_window_close ), module );

	/*--- Create the menu ---*/
	if ( module->wgt_window == NULL )
	{

		wgtdef_menu = search_wgtdef( "GtkMenu" );
		assert( wgtdef_menu != NULL );
		INIT_ARGS;
		module->wgt_window = insert_new_widget( NULL, wgtdef_menu, 
			FALSE, 			// f_select
			TRUE,			// is_disabled
			TRUE,			// Default values
			module );

#if 0
		gtk_signal_connect( GTK_OBJECT( module->wgt_window ), "add",
			GTK_SIGNAL_FUNC( cb_menu_add ), module );
		gtk_signal_connect( GTK_OBJECT( module->wgt_window ), "remove",
			GTK_SIGNAL_FUNC( cb_menu_remove ), module );
#endif

	}							// if

	/*--- Add this new module into the tree ---*/
	text[ 0 ] = title_menu;	
	wgt_node = gtk_ctree_insert_node( GTK_CTREE(wgt_tree_modules), 
		NULL, NULL,
		text, 5,
		wgtdef_menu->gdkpixmap, wgtdef_menu->gdkbitmap,
		wgtdef_menu->gdkpixmap, wgtdef_menu->gdkbitmap,
		FALSE, FALSE );
	module->wgt_tree_node = wgt_node;
	gtk_ctree_node_set_row_data( GTK_CTREE(wgt_tree_modules), GTK_CTREE_NODE(wgt_node), 
		module );

	/*--- Attach some data to the window widget ---*/
 	set_name_wgt( module->wgt_window, title_menu );
	set_nametype_wgt( module->wgt_window, NAMETYPE_GLOBAL );
	gtk_widget_show_all( module->wgt_window );

	/*--- Resources stored outside the widget ? ---*/
	new_widget_inserted( module->u1.menu.menudlg.wgt_showmenu, NULL, wgtdef_menu );

	/*--- Project modified ---*/
	is_project_touched = TRUE;

//	block_module( module, TRUE );

	/*--- Make the new window the selected widget ---*/
	curr_module = module;
	update_tree();
	select_widget( module->wgt_window, 
		TRUE,
		TRUE );					// Select 1st CB, if any

	/*--- Make the line selection (list of modules) ---*/
	gtk_ctree_select( GTK_CTREE(wgt_tree_modules),
		GTK_CTREE_NODE(module->wgt_tree_node) );

	/*--- Make the palette widget sensitive ---*/
	set_palette_sensitive( TRUE );

	/*--- This module has been modified ---*/
	project_touched( module );

	return module;

}								// module_create_menu

