#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <unistd.h>
#include <sys/time.h>
#include <errno.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"

static	GtkWidget	*wgt_propwindow = NULL;
static	GtkWidget	*wgt_propwindow_btn_ok;
static	GtkWidget	*wgt_propwindow_btn_cancel;
static	GtkWidget	*wgt_propwindow_funcname;
static	GtkWidget	*wgt_propwindow_openedfrommain;
static	GtkWidget	*wgt_propwindow_fixedposition;


/* Callback "clicked" for GtkButton widget  */
static void
cb_propwindow_btn_ok(GtkButton *button, gpointer user_data)
{
	module_info_t	*module = (module_info_t *)user_data;

	strcpy( module->u1.window.name_function,
		gtk_editable_get_chars( GTK_EDITABLE(wgt_propwindow_funcname), 0, -1 ) );
	module->u1.window.f_opened_from_main =
		gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_propwindow_openedfrommain) );
	module->u1.window.f_fixed_position =
		gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(wgt_propwindow_fixedposition) );

	/*--- This module has been modified ---*/
	project_touched( module );

	gtk_widget_destroy( wgt_propwindow );
	wgt_propwindow = NULL;	
	
}								// cb_propwindow_btn_ok

/* Callback "clicked" for GtkButton widget  */
static void
cb_propwindow_btn_cancel(GtkButton *button, gpointer user_data)
{
	gtk_widget_destroy( wgt_propwindow );
	wgt_propwindow = NULL;	
}								// cb_propwindow_btn_cancel


static GtkWidget *
create_window( GtkWidget *parent, const int realize,
	module_info_t *module )
{
	GtkWidget	*wgt_1_2, *wgt_2_3, *wgt_3_4, *wgt_4_5, *wgt_2_4;

	INIT_ARGS;
	SETARG_STRING( "title", "Window Properties" );
	SETARG_BOOL( "allow_grow", 1 );
	wgt_propwindow = gtk_widget_newv( gtk_window_get_type(), nb_args, args );

	INIT_ARGS;
	SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_propwindow );
	wgt_1_2 = gtk_widget_newv( gtk_vbox_get_type(), nb_args, args );

	INIT_ARGS;
	SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_1_2 );
	SETARG_ULONG( "border_width", 4 );
	SETARG_INT( "spacing", 8 );
	wgt_2_3 = gtk_widget_newv( gtk_vbox_get_type(), nb_args, args );

	INIT_ARGS;
	SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_2_3 );
	SETARG_INT( "spacing", 4 );
	wgt_3_4 = gtk_widget_newv( gtk_hbox_get_type(), nb_args, args );
	INIT_ARGS;
	SETARG_BOOL( "expand", 0 );
	gtk_container_child_setv( GTK_CONTAINER( wgt_2_3 ), wgt_3_4, nb_args, args );

	INIT_ARGS;
	SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_3_4 );
	SETARG_STRING( "label", "Module creation function:" );
	wgt_4_5 = gtk_widget_newv( gtk_label_get_type(), nb_args, args );

	INIT_ARGS;
	SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_3_4 );
	SETARG_BOOL( "can_focus", 1 );
	SETARG_BOOL( "editable", 1 );
	wgt_propwindow_funcname = 
		gtk_widget_newv( gtk_entry_get_type(), nb_args, args );
	INIT_ARGS;
	SETARG_LONG( "position", 1 );
	gtk_container_child_setv( GTK_CONTAINER( wgt_3_4 ), 
		wgt_propwindow_funcname, nb_args, args );

	INIT_ARGS;
	SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_2_3 );
	SETARG_BOOL( "can_focus", 1 );
	SETARG_STRING( "label", "Window opened automatically from main()" );
	wgt_propwindow_openedfrommain = 
		gtk_widget_newv( gtk_check_button_get_type(), nb_args, args );
	INIT_ARGS;
	SETARG_BOOL( "expand", 0 );
	SETARG_LONG( "position", 1 );
	gtk_container_child_setv( GTK_CONTAINER( wgt_2_3 ), 
		wgt_propwindow_openedfrommain, nb_args, args );

	INIT_ARGS;
	SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_2_3 );
	SETARG_BOOL( "can_focus", 1 );
	SETARG_STRING( "label", "Window fixed position" );
	wgt_propwindow_fixedposition = 
		gtk_widget_newv( gtk_check_button_get_type(), nb_args, args );
	INIT_ARGS;
	SETARG_BOOL( "expand", 0 );
	SETARG_LONG( "position", 2 );
	gtk_container_child_setv( GTK_CONTAINER( wgt_2_3 ), 
		wgt_propwindow_fixedposition, nb_args, args );

	INIT_ARGS;
	SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_1_2 );
	SETARG_ULONG( "border_width", 4 );
	SETARG_INT( "spacing", 8 );
	wgt_2_4 = gtk_widget_newv( gtk_hbox_get_type(), nb_args, args );
	INIT_ARGS;
	SETARG_BOOL( "expand", 0 );
	SETARG_LONG( "position", 1 );
	gtk_container_child_setv( GTK_CONTAINER( wgt_1_2 ), wgt_2_4, nb_args, args );

	INIT_ARGS;
	SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_2_4 );
	SETARG_BOOL( "can_focus", 1 );
	SETARG_BOOL( "receives_default", 1 );
	SETARG_STRING( "label", "Ok" );
	wgt_propwindow_btn_ok = gtk_widget_newv( gtk_button_get_type(), nb_args, args );
	gtk_signal_connect( GTK_OBJECT( wgt_propwindow_btn_ok ), "clicked",
		GTK_SIGNAL_FUNC( cb_propwindow_btn_ok ), module );

	INIT_ARGS;
	SETARG_OBJECT( GTK_TYPE_CONTAINER, "parent", wgt_2_4 );
	SETARG_BOOL( "can_focus", 1 );
	SETARG_BOOL( "receives_default", 1 );
	SETARG_STRING( "label", "Cancel" );
	wgt_propwindow_btn_cancel = gtk_widget_newv( gtk_button_get_type(), nb_args, args );
	INIT_ARGS;
	SETARG_LONG( "position", 1 );
	gtk_container_child_setv( GTK_CONTAINER( wgt_2_4 ), wgt_propwindow_btn_cancel, nb_args, args );
	gtk_signal_connect( GTK_OBJECT( wgt_propwindow_btn_cancel ), "clicked",
		GTK_SIGNAL_FUNC( cb_propwindow_btn_cancel ), module );

	if ( realize )
		gtk_widget_show_all( wgt_propwindow );

	return wgt_propwindow;

}					// create_window


PUBLIC void
module_window_properties( module_info_t *module )
{

	create_window( NULL, TRUE, module );

	gtk_entry_set_text( GTK_ENTRY(wgt_propwindow_funcname), 
		module->u1.window.name_function );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_propwindow_openedfrommain),
		module->u1.window.f_opened_from_main );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(wgt_propwindow_fixedposition),
		module->u1.window.f_fixed_position );

	gtk_window_set_modal( GTK_WINDOW(wgt_propwindow), TRUE );
	while ( wgt_propwindow != NULL )
		gtk_main_iteration();
	
}								// module_window_properties
