#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


/*
	***************
	***			***
	*** String	***
	***			***
	***************
*/

PUBLIC int
get_res_string( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg )
{

	if ( defclass->saved_where == SAVED_INSIDE )
	{
		arg->name = defclass->resname;
		if ( !wgt_parent )
			gtk_widget_get( GTK_WIDGET( wgt ), arg );
		else
			gtk_container_child_getv( GTK_CONTAINER( wgt_parent ), 
				GTK_WIDGET( wgt ), 1, arg );
		if ( arg->type != GTK_TYPE_STRING )
			return -1;
	}
	else if ( defclass->saved_where == SAVED_OUTSIDE ||
			 defclass->saved_where == SAVED_OUTSIDE_FUNCTION )
	{
		arg = get_outsideres_wgt( wgt, defclass->resname );
		assert( arg != NULL );
	}
	else if ( defclass->saved_where == SAVED_FUNCTION )
	{
		if ( wgt_parent != NULL )
			assert(0);
		if ( (*wgtdef_depth->pfct_getdlg)(defclass, wgt, arg) == NULL )
		{
			GtkArg *parg = get_outsideres_wgt( wgt, defclass->resname );
			gtk_arg_copy( parg, arg );
		}
		assert( arg != NULL );
	}
	else assert(0);
	
	return 0;

}								// get_res_string


PUBLIC void
set_res_string( GtkWidget *wgt, char *string,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent )
{

	if ( defclass->saved_where == SAVED_INSIDE )
	{
		if ( !wgt_parent )
			gtk_widget_set( GTK_WIDGET( wgt ),
				defclass->resname, string, NULL );
		else
			gtk_container_child_set( GTK_CONTAINER( wgt_parent ), GTK_WIDGET( wgt ), 
				defclass->resname, string, NULL );
	}
	else if ( defclass->saved_where == SAVED_OUTSIDE ||
			 defclass->saved_where == SAVED_OUTSIDE_FUNCTION )
	{
		GtkArg	*parg;
		parg = get_outsideres_wgt( wgt, defclass->resname );
		assert( parg != NULL );
		if (GTK_VALUE_STRING(parg[0]))
			free(GTK_VALUE_STRING(parg[0]));
		GTK_VALUE_STRING(parg[0]) = strdup( string );
	}
	else if ( defclass->saved_where == SAVED_FUNCTION )
	{
		GtkArg	arg;

		GTK_VALUE_STRING( arg ) = strdup( string );
		if ( (*wgtdef_depth->pfct_putdlg)( defclass, wgt, &arg ) == 1 )
		{
			GtkArg	*parg;
			parg = get_outsideres_wgt( wgt, defclass->resname );
			assert( parg != NULL );
			if (GTK_VALUE_STRING(parg[0]))
				free(GTK_VALUE_STRING(parg[0]));
			GTK_VALUE_STRING(parg[0]) = strdup( string );
			free( GTK_VALUE_STRING( arg ) );
		}
	}
	else assert(0);

}								// set_res_string


/*
	***************
	***			***
	*** Int		***
	***			***
	***************
*/

PUBLIC int
get_res_int( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg )
{

	if ( defclass->saved_where == SAVED_INSIDE )
	{
		arg->name = defclass->resname;
		if ( !wgt_parent )
			gtk_widget_get( GTK_WIDGET( wgt ), arg );
		else
			gtk_container_child_getv( GTK_CONTAINER( wgt_parent ), 
				GTK_WIDGET( wgt ), 1, arg );
	}
	else if ( defclass->saved_where == SAVED_OUTSIDE ||
			 defclass->saved_where == SAVED_OUTSIDE_FUNCTION )
	{
		RES_NOT_YET_HANDLED( wgtdef, defclass );
		assert( 0 );
	}
	else if ( defclass->saved_where == SAVED_FUNCTION )
	{
//		if ( wgt_parent != NULL )
//			assert(0);
		if ( (*wgtdef_depth->pfct_getdlg)(defclass, wgt, arg) == NULL )
		{
			GtkArg *parg = get_outsideres_wgt( wgt, defclass->resname );
			gtk_arg_copy( parg, arg );
		}
		assert( arg != NULL );
	}
	else assert(0);

	return 0;

}								// get_res_int


PUBLIC void
set_res_int( GtkWidget *wgt, GtkArg *arg,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	int *first, GtkSpinButton *wgt_num )
{
	GtkArg		arg2;
	float		v1, v2;

#define SET( V ) \
	v1 = V(arg[0]); \
	if ( defclass->saved_where == SAVED_INSIDE ) \
	{ \
		if ( !wgt_parent ) \
			gtk_widget_set( GTK_WIDGET(wgt), \
				defclass->resname, V(arg[0]), NULL ); \
		else \
			gtk_container_child_set( GTK_CONTAINER(wgt_parent), GTK_WIDGET( wgt ), \
				defclass->resname, V(arg[0]), NULL ); \
	} \
	else if ( defclass->saved_where == SAVED_OUTSIDE || defclass->saved_where == SAVED_OUTSIDE_FUNCTION ) \
	{ \
		GtkArg	*parg; \
		parg = get_outsideres_wgt( wgt, defclass->resname ); \
		assert( parg != NULL ); \
		V(parg[0]) = V(arg[0]); \
	} \
	else if ( defclass->saved_where == SAVED_FUNCTION ) \
	{ \
		GtkArg	arg2; \
		V(arg2) = V(arg[0]); \
		if ( (*wgtdef_depth->pfct_putdlg)(defclass, wgt, &arg2) == 1 ) \
		{ \
			GtkArg	*new_arg; \
			new_arg = gtk_arg_new( arg->type ); \
			gtk_arg_copy( arg, new_arg ); \
			set_outsideres_wgt( wgt, defclass->resname, new_arg ); \
		} \
	} else assert(0); \
	if ( first ) \
	{ \
		if ( *first && (defclass->saved_where == SAVED_INSIDE) ) \
		{ \
			arg2.name = defclass->resname; \
			if ( !wgt_parent ) \
				gtk_widget_get( GTK_WIDGET(wgt), &arg2 ); \
			else \
				gtk_container_child_getv( GTK_CONTAINER(wgt_parent), GTK_WIDGET( wgt ), \
					1, &arg2 ); \
			v2 = V(arg2); \
			if ( v1 != v2 ) \
				gtk_spin_button_set_value( GTK_SPIN_BUTTON(wgt_num), v2 ); \
			*first = FALSE; \
		} \
	}

	switch ( defclass->restype )
	{
		case GTK_TYPE_INT :
			SET( GTK_VALUE_INT );
			break;
		case GTK_TYPE_UINT :
			SET( GTK_VALUE_UINT );
			break;
		case GTK_TYPE_LONG :
			SET( GTK_VALUE_LONG );
			break;
		case GTK_TYPE_ULONG :
			SET( GTK_VALUE_ULONG );
			break;
		case GTK_TYPE_FLOAT :
			SET( GTK_VALUE_FLOAT );
			break;
	}							// switch
	
#undef SET

}								// set_res_int


/*
	***************
	***			***
	*** Bool	***
	***			***
	***************
*/

PUBLIC int
get_res_bool( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg, GtkArg **parg )
{

	if ( defclass->saved_where == SAVED_INSIDE )
	{
		arg->name = defclass->resname;
		if ( !wgt_parent )
			gtk_widget_get( GTK_WIDGET( wgt ), arg );
		else
			gtk_container_child_getv( GTK_CONTAINER( wgt_parent ), 
				GTK_WIDGET( wgt ), 1, arg );
		*parg = arg;
	}
	else if ( defclass->saved_where == SAVED_OUTSIDE ||
			 defclass->saved_where == SAVED_OUTSIDE_FUNCTION )
	{
		*parg = get_outsideres_wgt( wgt, defclass->resname );
		assert( *parg != NULL );
	}
	else if ( defclass->saved_where == SAVED_FUNCTION )
	{
		if ( wgt_parent != NULL )
			assert(0);
		if ( (*wgtdef_depth->pfct_getdlg)( defclass, wgt, arg ) == NULL )
			*parg = get_outsideres_wgt( wgt, defclass->resname );
		else
			*parg = arg;
		assert( *parg != NULL );
	}
	else assert(0);

	return 0;

}								// get_res_bool


PUBLIC void
set_res_bool( GtkWidget *wgt, int state,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent )
{

	if ( defclass->saved_where == SAVED_INSIDE )
	{
		if ( !wgt_parent )
			gtk_widget_set( GTK_WIDGET( wgt ),
				defclass->resname, state, NULL );
		else
			gtk_container_child_set( GTK_CONTAINER( wgt_parent ), GTK_WIDGET( wgt ), 
				defclass->resname, state, NULL );
	}
	else if ( defclass->saved_where == SAVED_OUTSIDE ||
			 defclass->saved_where == SAVED_OUTSIDE_FUNCTION )
	{
		GtkArg	*parg;
		parg = get_outsideres_wgt( wgt, defclass->resname );
		assert( parg != NULL );
		GTK_VALUE_BOOL( parg[0] ) = state;
	}
	else if ( defclass->saved_where == SAVED_FUNCTION )
	{
		GtkArg	arg;

		GTK_VALUE_BOOL( arg ) = state;
		if ( (*wgtdef_depth->pfct_putdlg)( defclass, wgt, &arg ) == 1 )
		{
			GtkArg	*parg;
			parg = get_outsideres_wgt( wgt, defclass->resname );
			assert( parg != NULL );
			GTK_VALUE_BOOL(parg[0]) = state;
		}
	}
	else assert(0);

}								// set_res_bool


/*
	***************
	***			***
	*** Enum	***
	***			***
	***************
*/

PUBLIC int
get_res_enum( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg, GtkArg **parg )
{

	if ( defclass->saved_where == SAVED_INSIDE )
	{
		arg->name = defclass->resname;
		if ( !wgt_parent )
			gtk_widget_get( GTK_WIDGET( wgt ), arg );
		else
			gtk_container_child_getv( GTK_CONTAINER( wgt_parent ), 
				GTK_WIDGET( wgt ), 1, arg );
		*parg = arg;
	}
	else if ( defclass->saved_where == SAVED_OUTSIDE ||
			 defclass->saved_where == SAVED_OUTSIDE_FUNCTION )
	{
		*parg = get_outsideres_wgt( wgt, defclass->resname );
		assert( *parg != NULL );
	}
	else if ( defclass->saved_where == SAVED_FUNCTION )
	{
		if ( wgt_parent != NULL )
			assert(0);
		if ( (*wgtdef_depth->pfct_getdlg)( defclass, wgt, arg ) == NULL )
			*parg = get_outsideres_wgt( wgt, defclass->resname );
		else
			*parg = arg;
		assert( *parg != NULL );
	}
	else assert(0);

	return 0;

}								// get_res_enum


PUBLIC void
set_res_enum( GtkWidget *wgt, int value,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent )
{

	if ( defclass->saved_where == SAVED_INSIDE )
	{
		if ( !wgt_parent )
			gtk_widget_set( GTK_WIDGET( wgt ),
				defclass->resname, value, NULL );
		else
			gtk_container_child_set( GTK_CONTAINER( wgt_parent ), GTK_WIDGET( wgt ), 
				defclass->resname, value, NULL );
	}
	else if ( defclass->saved_where == SAVED_OUTSIDE ||
			 defclass->saved_where == SAVED_OUTSIDE_FUNCTION )
	{
		GtkArg	*parg;
		parg = get_outsideres_wgt( wgt, defclass->resname );
		assert( parg != NULL );
		GTK_VALUE_ENUM( parg[0] ) = value;
	}
	else if ( defclass->saved_where == SAVED_FUNCTION )
	{
		GtkArg	arg;

		GTK_VALUE_ENUM( arg ) = value;
		if ( (*wgtdef_depth->pfct_putdlg)( defclass, wgt, &arg ) == 1 )
		{
			GtkArg	*parg;
			parg = get_outsideres_wgt( wgt, defclass->resname );
			assert( parg != NULL );
			GTK_VALUE_ENUM(parg[0]) = value;
		}
	}
	else assert(0);

}								// set_res_enum


/*
	***************
	***			***
	*** Flags	***
	***			***
	***************
*/

PUBLIC int
get_res_flags( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg, GtkArg **parg )
{

	if ( defclass->saved_where == SAVED_INSIDE )
	{
		arg->name = defclass->resname;
		if ( !wgt_parent )
			gtk_widget_get( GTK_WIDGET( wgt ), arg );
		else
			gtk_container_child_getv( GTK_CONTAINER( wgt_parent ), 
				GTK_WIDGET( wgt ), 1, arg );
		*parg = arg;
	}
	else if ( defclass->saved_where == SAVED_OUTSIDE ||
			 defclass->saved_where == SAVED_OUTSIDE_FUNCTION )
	{
		*parg = get_outsideres_wgt( wgt, defclass->resname );
		assert( *parg != NULL );
	}
	else if ( defclass->saved_where == SAVED_FUNCTION )
	{
		if ( wgt_parent != NULL )
			assert(0);
		if ( (*wgtdef_depth->pfct_getdlg)( defclass, wgt, arg ) == NULL )
			*parg = get_outsideres_wgt( wgt, defclass->resname );
		else
			*parg = arg;
		assert( *parg != NULL );
	}
	else assert(0);

	return 0;

}								// get_res_enum


PUBLIC void
set_res_flags( GtkWidget *wgt, gint value,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent )
{

	if ( defclass->saved_where == SAVED_INSIDE )
	{
		if ( !wgt_parent )
			gtk_widget_set( GTK_WIDGET( wgt ),
				defclass->resname, value, NULL );
		else
			gtk_container_child_set( GTK_CONTAINER( wgt_parent ), GTK_WIDGET( wgt ), 
				defclass->resname, value, NULL );
	}
	else if ( defclass->saved_where == SAVED_OUTSIDE ||
			 defclass->saved_where == SAVED_OUTSIDE_FUNCTION )
	{
		GtkArg	*parg;
		parg = get_outsideres_wgt( wgt, defclass->resname );
		assert( parg != NULL );
		GTK_VALUE_FLAGS( parg[0] ) = value;
	}
	else if ( defclass->saved_where == SAVED_FUNCTION )
	{
		GtkArg	arg;

		GTK_VALUE_FLAGS( arg ) = value;
		if ( (*wgtdef_depth->pfct_putdlg)( defclass, wgt, &arg ) == 1 )
		{
			GtkArg	*parg;
			parg = get_outsideres_wgt( wgt, defclass->resname );
			assert( parg != NULL );
			GTK_VALUE_FLAGS( parg[0] ) = value;
		}
	}
	else assert(0);

}								// set_res_flags


/*
	***************
	***			***
	*** Strings	***
	***			***
	***************
*/

PUBLIC int
get_res_strings( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg )
{

	assert( defclass->saved_where == SAVED_FUNCTION );

	(*wgtdef_depth->pfct_getdlg)( defclass, wgt, arg );
	
	return 0;

}								// get_res_strings


PUBLIC void
cb_destroy_notify_strings( gpointer data )
{
	gtk_usertype_strings_t	*strings = (gtk_usertype_strings_t *)data;
	int						n;

	for ( n = 0; n < strings->nb_strings; n++ )
		g_free( strings->strings[ n ] );
	g_free( strings->strings );
	g_free( strings );

}								// cb_destroy_notify_strings


PUBLIC void
set_res_strings( GtkWidget *wgt, gtk_usertype_strings_t **strings,
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent )
{
	GtkArg					arg;
	gtk_usertype_strings_t	*new_strings, *prev_strings;
	int						index;

	assert( defclass->saved_where == SAVED_FUNCTION );
	
	GTK_VALUE_POINTER( arg ) = *strings;
	if ( (*wgtdef_depth->pfct_putdlg)( defclass, wgt, &arg ) == 1 )
		assert( 0 );

	prev_strings = gtk_object_get_data( GTK_OBJECT( wgt ), defclass->resname );
	if ( prev_strings != *strings)
	{
		gtk_object_set_data_full( GTK_OBJECT( wgt ), defclass->resname, *strings, 
			(GtkDestroyNotify) cb_destroy_notify_strings );
	}
	else
	{
		new_strings = malloc( sizeof( gtk_usertype_strings_t ) );
		new_strings->nb_strings = prev_strings->nb_strings;
		new_strings->strings = malloc( sizeof( char * ) * new_strings->nb_strings );
		for ( index = 0; index < new_strings->nb_strings; index++ )
			new_strings->strings[ index ] = strdup( prev_strings->strings[ index ] );
		gtk_object_set_data_full( GTK_OBJECT( wgt ), defclass->resname, new_strings, 
			(GtkDestroyNotify) cb_destroy_notify_strings );
		*strings = new_strings;
	}

}								// set_res_string



/*
	***************
	***			***
	*** Pointer	***
	***			***
	***************
*/


PUBLIC int
get_res_pointer( GtkWidget *wgt, 
	gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	defclass_t *defclass,
	GtkWidget *wgt_parent,
	GtkArg *arg, GtkArg **parg )
{

	if ( defclass->saved_where == SAVED_INSIDE )
	{
		arg->name = defclass->resname;
		if ( !wgt_parent )
			gtk_widget_get( GTK_WIDGET( wgt ), arg );
		else
			gtk_container_child_getv( GTK_CONTAINER( wgt_parent ), 
				GTK_WIDGET( wgt ), 1, arg );
#if 0
		if ( arg.type != GTK_TYPE_STYLE )
			return -1;
#endif
		*parg = arg;
	}
	else if ( defclass->saved_where == SAVED_OUTSIDE ||
			 defclass->saved_where == SAVED_OUTSIDE_FUNCTION )
	{
		RES_NOT_YET_HANDLED( wgtdef, defclass );
		assert( 0 );
	}
	else if ( defclass->saved_where == SAVED_FUNCTION )
	{
		if ( wgt_parent != NULL )
			assert(0);
		(*wgtdef_depth->pfct_getdlg)(defclass, wgt, arg);
		*parg = arg;
	}
	else assert(0);
	
	return 0;

}								// get_res_pointer

