#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


	
PUBLIC GtkWidget *
res_editor_signal( gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	GtkWidget *wgt_container, 
	defclasssignal_t *defclasssignal,
	GtkWidget *wgt_label )
{
	GtkWidget	*wgt_selected;
	GtkWidget	*wgt_hbox;
	GtkWidget	*wgt_entry;
	GtkWidget	*wgt_btn;
	data_cb_t	*old_datacb;
	GtkTooltips *tooltips;

	/*--- Which widget is selected ? ---*/
	assert(nb_selection() == 1);
	wgt_selected = GTK_WIDGET( g_slist_last(list_selection)->data );
	assert( wgt_selected != NULL );

	/*--- Create the display area ---*/		
	wgt_hbox = gtk_hbox_new( FALSE, 0 );
	gtk_container_add (GTK_CONTAINER(wgt_container), wgt_hbox );
	INIT_ARGS;
	SETARG_BOOL( "expand", FALSE );
	SETARG_BOOL( "fill", FALSE );
	gtk_container_child_setv( GTK_CONTAINER(wgt_container), wgt_hbox, nb_args, args );

	/*--- Field to display the signal ---*/
	wgt_entry = gtk_entry_new();
	gtk_container_add (GTK_CONTAINER(wgt_hbox), wgt_entry );
	INIT_ARGS;
	SETARG_BOOL( "editable", FALSE );
	gtk_widget_setv( GTK_WIDGET(wgt_entry), 1, args );
	INIT_ARGS;
	SETARG_BOOL( "expand", TRUE );
	SETARG_BOOL( "fill", TRUE );
	gtk_container_child_setv( GTK_CONTAINER(wgt_hbox), wgt_entry, nb_args, args );

	/*--- Button to edit signals ---*/
	wgt_btn = gtk_button_new_with_label("...");
	gtk_container_add (GTK_CONTAINER(wgt_hbox), wgt_btn );
	INIT_ARGS;
	SETARG_BOOL( "expand", FALSE );
	SETARG_BOOL( "fill", FALSE );
	gtk_container_child_setv( GTK_CONTAINER(wgt_hbox), wgt_btn, nb_args, args );
	tooltips = gtk_tooltips_new ();
	gtk_tooltips_set_tip( tooltips, wgt_btn, "Click here to add/remove signals", NULL );
    gtk_signal_connect( GTK_OBJECT(wgt_btn), "clicked",
		GTK_SIGNAL_FUNC( cb_dialog_cb ), defclasssignal );

	/*--- Display current signals, if any ---*/
	old_datacb = get_object_data( wgt_selected, defclasssignal->resname );
	if ( old_datacb == NULL )
	{
		gtk_entry_set_text( GTK_ENTRY(wgt_entry), "" );
	}
	else
	{
		int			nb_cb, n;
		def_cb_t	*defcb;
		char		label[200], tmp[100], tip[500];
		GtkTooltips *tooltips;

		tooltips = gtk_tooltips_new ();

		strcpy( tip, "" );
		strcpy( label, "" );		
		nb_cb = old_datacb->nb_cb;
		for ( defcb = old_datacb->cb, n = 0; n < nb_cb; n++, defcb++ )
		{

			sprintf( tmp, "%s%s",
				(n) ? " + " : "", defcb->cbname );
			if ( strlen(tmp) + strlen(label) <= sizeof(label)-1 )
				strcat( label, tmp );

			sprintf( tmp, "%s%s@%s%s.c",
				(n) ? "\n" : "", 
				defcb->cbname,
				defcb->cbfile,
				(defcb->f_after) ? " (after)" : "" );
			if ( strlen(tmp) + strlen(tip) <= sizeof(tip)-1 )
				strcat( tip, tmp );

		}
		gtk_entry_set_text( GTK_ENTRY(wgt_entry), label );
		gtk_tooltips_set_tip( tooltips, wgt_entry, tip, NULL );

	}

	return wgt_entry;
}								// res_editor_signal
