#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <math.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


typedef struct
{
	GtkWidget		*wgt_combo;
	defclass_t		*defclass;
	GtkWidget		*wgt_parent;
	gtk_wgtdef_t	*wgtdef;
	gtk_wgtdef_t	*wgtdef_depth;
}	entry_data_t;


static void
cb_btn_dialog_clicked( GtkWidget *wgt, gpointer user_data )
{
	GtkWidget		*wgt_btn_dialog = (GtkWidget *)user_data;
	entry_data_t	*entry_data;

	entry_data = (entry_data_t *)get_object_data( wgt_btn_dialog, "entry_data" );
	assert( entry_data != NULL );
	dlg_res_editor_strings( wgt_btn_dialog, entry_data->wgt_combo,
		entry_data->defclass,
		entry_data->wgt_parent,
		entry_data->wgtdef, entry_data->wgtdef_depth );

}								// cb_btn_dialog_clicked


PUBLIC GtkWidget *
res_editor_strings( gtk_wgtdef_t *wgtdef, gtk_wgtdef_t *wgtdef_depth,
	GtkWidget *wgt_container, defclass_t *defclass,
	GtkWidget *wgt_parent )
{
	GtkWidget		*wgt_selected;
	GtkWidget		*wgt_hbox0;
	GtkWidget		*wgt_hbox;
	GtkWidget		*wgt_label;
	GtkWidget		*wgt_combo;
	GtkWidget		*wgt_btn_dialog;
	GtkTooltips 	*tooltips;
	entry_data_t	*entry_data;

	/*--- First read current value (stored inside the widget or not) ---*/
	wgt_selected = GTK_WIDGET( g_slist_last( list_selection )->data );

	/*--- Create an horizontal box ---*/
	wgt_hbox0 = gtk_hbox_new( FALSE, 0 );
	gtk_box_pack_start( GTK_BOX( wgt_container ), wgt_hbox0, FALSE, FALSE, 0 );

	/*--- Create the display area ---*/		
	wgt_hbox = gtk_hbox_new( FALSE, 0 );
	gtk_box_pack_start( GTK_BOX( wgt_hbox0 ), wgt_hbox, TRUE, TRUE, 0 );

	wgt_label = gtk_label_new( "List of items" );
	gtk_box_pack_start( GTK_BOX( wgt_hbox ), wgt_label, FALSE, FALSE, 2 );

	wgt_combo = gtk_combo_new();
	gtk_box_pack_start( GTK_BOX( wgt_hbox ), wgt_combo, TRUE, TRUE, 2 );

	/*--- Button to bring a dialog ---*/
	wgt_btn_dialog = gtk_button_new_with_label( "..." );
	gtk_container_add( GTK_CONTAINER( wgt_hbox0 ), wgt_btn_dialog );
	INIT_ARGS;
	SETARG_BOOL( "expand", FALSE );
	SETARG_BOOL( "fill", FALSE );
	gtk_container_child_setv( GTK_CONTAINER( wgt_hbox0 ), wgt_btn_dialog, nb_args, args );
	tooltips = gtk_tooltips_new ();
	gtk_tooltips_set_tip( tooltips, wgt_btn_dialog, 
		"Click here to edit the string", NULL );
	gtk_signal_connect( GTK_OBJECT( wgt_btn_dialog ), "clicked",
		GTK_SIGNAL_FUNC( cb_btn_dialog_clicked ), wgt_btn_dialog );

	/*--- Data attached to the dialog ---*/	
	entry_data = malloc( sizeof( entry_data_t ) );
	memset( entry_data, 0, sizeof( entry_data_t ) );
	entry_data->wgt_combo	 = wgt_combo;
	entry_data->defclass	 = defclass;
	entry_data->wgt_parent	 = wgt_parent;
	entry_data->wgtdef		 = wgtdef;
	entry_data->wgtdef_depth = wgtdef_depth;
	set_object_data( wgt_combo, "entry_data", entry_data, TRUE );
	set_object_data( wgt_btn_dialog, "entry_data", entry_data, FALSE );

	return wgt_hbox;

}								// res_editor_adjustment

