#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "../glg.h"


PUBLIC GtkArg * 
getdlg_button_box( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	if ( !strcmp( defclass->resname, "~GtkButtonBox::spacing" ) )
	{
		parg->type = GTK_TYPE_INT;
		GTK_VALUE_INT(parg[0]) = gtk_button_box_get_spacing( GTK_BUTTON_BOX(wgt) );
		return parg;
	}
	else if ( !strcmp( defclass->resname, "~GtkButtonBox::layout" ) )
	{
		parg->type = GTK_TYPE_ENUM;
		GTK_VALUE_ENUM(parg[0]) = gtk_button_box_get_layout( GTK_BUTTON_BOX(wgt) );
		return parg;
	}
	else assert(0);
	return NULL;
}								// getdlg_button_box


PUBLIC int 
putdlg_button_box( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	if ( !strcmp( defclass->resname, "~GtkButtonBox::spacing" ) )
	{
		gtk_button_box_set_spacing( GTK_BUTTON_BOX(wgt), GTK_VALUE_INT(parg[0]) );
		return 0;
	}
	else if ( !strcmp( defclass->resname, "~GtkButtonBox::layout" ) )
	{
		gtk_button_box_set_layout( GTK_BUTTON_BOX(wgt), GTK_VALUE_ENUM(parg[0]) );
		return 0;
	}
	else assert(0);
	return -1;
}								// putdlg_button_box


PUBLIC int
writecode_button_box( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	GtkArg		arg;

	*parg = NULL;
	memset( &arg, 0, sizeof(GtkArg) );
	arg.type = defclass->restype;
	if ( !strcmp( defclass->resname, "~GtkButtonBox::spacing" ) )
	{
		(*defclass->wgtdef_depth->pfct_getdlg)( defclass, wgt, &arg );
		str[0] = malloc( 200 );
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_button_box_set_spacing( GTK_BUTTON_BOX(%s), %d );",
			get_name_wgt( wgt ), 
			GTK_VALUE_INT( arg ) );
		return 1;
	}
	else if ( !strcmp( defclass->resname, "~GtkButtonBox::layout" ) )
	{
		(*defclass->wgtdef_depth->pfct_getdlg)( defclass, wgt, &arg );
		str[0] = malloc( 200 );
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_button_box_set_layout( GTK_BUTTON_BOX(%s), %d );",
			get_name_wgt( wgt ), 
			GTK_VALUE_ENUM( arg ) );
		return 1;
	}
	else assert(0);
	return 0;
}								// writecode_button_box


PUBLIC int
writecode_after_button_box( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	return 0;
}								// writecode_after_button_box


PUBLIC void
afteraddwgt_button_box( GtkWidget *wgt )
{
}								// afteraddwgt_button_box


PUBLIC GtkWidget *
addwgt_button_box( struct gtk_wgtdef_t *wgtdef_newwgt, module_info_t *module,
	GtkWidget *wgt_parent, GtkWidget *wgt_container )
{
	assert(0);
	return NULL;
}								// infos_addwgt_button_box
