
#include	"../src/graphics/GtkCList.xpm"

_EXTERN( clist )

static defclass_t defclass_GtkCList[] =
{
	{ "GtkCList::n_columns",		GTK_TYPE_UINT,		"Number of columns", GTK_ARG_READWRITE | GTK_ARG_CONSTRUCT_ONLY, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkCList::shadow_type",		GTK_TYPE_ENUM,		"Shadow type", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE, _gtk_shadow_type_values, OBJRES(GTK_TYPE_SHADOW_TYPE) },
	{ "GtkCList::selection_mode",	GTK_TYPE_ENUM,		"Selection type", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE, _gtk_selection_mode_values, OBJRES(GTK_TYPE_SELECTION_MODE) },
	{ "GtkCList::row_height",		GTK_TYPE_UINT,		"Row height (pixels)", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkCList::reorderable",		GTK_TYPE_BOOL,		"Reorderable", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkCList::titles_active",	GTK_TYPE_BOOL,		"titles_active", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkCList::use_drag_icons",	GTK_TYPE_BOOL,		"use_drag_icons", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "~GtkCList::show_titles",		GTK_TYPE_BOOL,		"Show titles", GTK_ARG_READWRITE, SAVED_FUNCTION, TRUE, TRUE },
	{ "~GtkCList::titles_columns",	GTK_TYPE_POINTER,	"Tittle. of columns", GTK_ARG_READWRITE, SAVED_FUNCTION, TRUE, TRUE, NULL, OBJRES(GTK_USERTYPE_STRINGS) },
	{ "~GtkCList::titles_passive",	GTK_TYPE_BOOL,		"Titles passive", GTK_ARG_READWRITE, SAVED_FUNCTION, TRUE, TRUE },
};

static defclasssignal_t defclasssignal_GtkCList[] =
{
	{
		"select_row", "Select Row",
		{
			"void", 
			{"GtkCList *clist", "gint row", "gint column", "GdkEventButton *event", "gpointer user_data"},
			NULL 
		}
	},
	{
		"unselect_row", "Unselect Row",
		{
			"void", 
			{"GtkCList *clist", "gint row", "gint column", "GdkEventButton *event", "gpointer user_data"},
			NULL 
		}
	},
	{
		"row_move", "Row Move",
		{
			"void", 
			{"GtkCList *clist", "gint arg1", "gint arg2", "gpointer user_data"},
			NULL 
		}
	},
	{
		"click_column", "Click Column",
		{
			"void", 
			{"GtkCList *clist", "gint column", "gpointer user_data"},
			NULL 
		}
	},
	{
		"resize_column", "Resize Column",
		{
			"void", 
			{"GtkCList *clist", "gint column", "gint width", "gpointer user_data"},
			NULL 
		}
	},
	{
		"toggle_focus_row", "Toggle Focus Row",
		{
			"void", 
			{"GtkCList *clist", "gpointer user_data"},
			NULL 
		}
	},
	{
		"select_all", "Select All",
		{
			"void", 
			{"GtkCList *clist", "gpointer user_data"},
			NULL 
		}
	},
	{
		"unselect_all", "Unselect All",
		{
			"void", 
			{"GtkCList *clist", "gpointer user_data"},
			NULL 
		}
	},
	{
		"undo_selection", "Undo Selection",
		{
			"void", 
			{"GtkCList *clist", "gpointer user_data"},
			NULL 
		}
	},
	{
		"start_selection", "Start Selection",
		{
			"void", 
			{"GtkCList *clist", "gpointer user_data"},
			NULL 
		}
	},
	{
		"end_selection", "End Selection",
		{
			"void", 
			{"GtkCList *clist", "gpointer user_data"},
			NULL 
		}
	},
	{
		"toggle_add_mode", "Toggle Add Mode",
		{
			"void", 
			{"GtkCList *clist", "gpointer user_data"},
			NULL 
		}
	},
	{
		"extend_selection", "Extend Selection",
		{
			"void", 
			{"GtkCList *clist", "GtkScrollType scroll_type", "gfloat position", 
			 "gboolean auto_start_selection", "gpointer user_data"},
			NULL 
		}
	},
	{
		"scroll_vertical", "Scroll Vertical",
		{
			"void", 
			{"GtkCList *clist", "GtkScrollType scroll_type", "gfloat position", 
			 "gpointer user_data"},
			NULL 
		}
	},
	{
		"scroll_horizontal", "Scroll Horizontal",
		{
			"void", 
			{"GtkCList *clist", "GtkScrollType scroll_type", "gfloat position", 
			 "gpointer user_data"},
			NULL 
		}
	},
	{
		"abort_column_resize", "Abort Column Resize",
		{
			"void", 
			{"GtkCList *clist", "gpointer user_data"},
			NULL 
		}
	}
};

static defclass_t defclasschild_GtkCList[] =
{
};

static char *defblockres_GtkCList[] =
{
};

static char *defrightclickmenu_GtkCList[] =
{
	"select_row",
	"unselect_row",
	"click_column"
};

static init_GtkArg deftvalues_GtkCList[] =
{
	{ GTK_TYPE_INT,		"GtkWidget::width",				INIT_INT_VALUE( 64 ) },
	{ GTK_TYPE_INT,		"GtkWidget::height",			INIT_INT_VALUE( 48 ) },
	{ GTK_TYPE_BOOL,	"~GtkCList::titles_passive",	INIT_BOOL_VALUE( FALSE ) }
};

static gtk_wgtdef_t wgtdef_GtkCList =
{
	"GtkCList",
	_X( gtk_clist_get_type, clist, GtkCList ),
	{ __(GtkObject), __(GtkWidget), __(GtkContainer), __(GtkCList), {NULL} },
	PALETTE_BASIC,						// Display this widget into which palette ?
	gtk_clist_xpm,						// xpm bitmap
	-1,									// Max number of childs
	TRUE,								// Can't specify position of children
	TRUE,								// Can't specify size of children
	FALSE,								// See insert_new_widget(), placeholder only
	FALSE,								// See cb_module_button_press_event()
};
