
#include	"../src/graphics/GtkCTree.xpm"

_EXTERN( ctree )

static defclass_t defclass_GtkCTree[] =
{
	{ "GtkCTree::n_columns",		GTK_TYPE_UINT,		"Nb. of columns", GTK_ARG_READWRITE | GTK_ARG_CONSTRUCT_ONLY, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkCTree::tree_columns",		GTK_TYPE_UINT,		"Tree columns", GTK_ARG_READWRITE | GTK_ARG_CONSTRUCT_ONLY, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkCTree::indent",			GTK_TYPE_UINT,		"Indentation", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkCTree::spacing",			GTK_TYPE_UINT,		"Spacing", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkCTree::show_stub",		GTK_TYPE_BOOL,		"Show stub", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkCTree::line_style",		GTK_TYPE_ENUM,		"Line Style", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE, _gtk_ctree_line_style_values, OBJRES(GTK_TYPE_CTREE_LINE_STYLE) },
	{ "GtkCTree::expander_style",	GTK_TYPE_ENUM,		"Expander Style", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE, _gtk_ctree_expander_style_values, OBJRES(GTK_TYPE_CTREE_EXPANDER_STYLE) },
};


static defclasssignal_t defclasssignal_GtkCTree[] =
{
	{
		"tree_select_row", "Tree select row",
		{
			"void", 
			{"GtkCTree *ctree", "GList *node", "gint column", "gpointer user_data"},
			NULL 
		}
	},
	{
		"tree_unselect_row", "Tree unselect row",
		{
			"void", 
			{"GtkCTree *ctree", "GList *node", "gint column", "gpointer user_data"},
			NULL 
		}
	},
	{
		"tree_expand", "Tree expand",
		{
			"void", 
			{"GtkCTree *ctree", "GList *node", "gpointer user_data"},
			NULL 
		}
	},
	{
		"tree_collapse", "Tree collapse",
		{
			"void", 
			{"GtkCTree *ctree", "GList *node", "gpointer user_data"},
			NULL 
		}
	},
	{
		"tree_move", "Tree move",
		{
			"void", 
			{"GtkCTree *ctree", "GList *node", "GList *new_parent", "GList *new_sibling", "gpointer user_data"},
			NULL 
		}
	},
	{
		"change_focus_row_expansion", "Change focus row expansion",
		{
			"void", 
			{"GtkCTree *ctree", "GtkCTreeExpansionType expansion", "gpointer user_data"},
			NULL 
		}
	},
};

static defclass_t defclasschild_GtkCTree[] =
{
};

static char *defblockres_GtkCTree[] =
{
	"GtkCList::n_columns"
};

static char *defrightclickmenu_GtkCTree[] =
{
	"tree_select_row",
	"tree_unselect_row",
	"tree_expand",
	"tree_collapse"
};

static init_GtkArg deftvalues_GtkCTree[] =
{
};

static gtk_wgtdef_t wgtdef_GtkCTree =
{
	"GtkCTree",
	_X( gtk_ctree_get_type, ctree, GtkCTree ),
	{ __(GtkObject), __(GtkWidget), __(GtkContainer), __(GtkCList), __(GtkCTree), {NULL} },
	PALETTE_BASIC,						// Display this widget into which palette ?
	gtk_ctree_xpm,						// xpm bitmap
	-1,									// Max number of childs
	TRUE,								// Can't specify position of children
	TRUE,								// Can't specify size of children
	FALSE,								// See insert_new_widget(), placeholder only
	FALSE,								// See cb_module_button_press_event()
};
