#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "../glg.h"


PUBLIC GtkArg * 
getdlg_calendar( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	GtkCalendarDisplayOptions opt = GTK_CALENDAR(wgt)->display_flags;

	if ( !strcmp( defclass->resname, "~GtkCalendar::show_heading" ) )
	{
		parg->type = GTK_TYPE_BOOL;
		GTK_VALUE_BOOL(parg[0]) = (opt & GTK_CALENDAR_SHOW_HEADING) ? TRUE : FALSE;
		return parg;
	}
	else if ( !strcmp( defclass->resname, "~GtkCalendar::show_day_names" ) )
	{
		parg->type = GTK_TYPE_BOOL;
		GTK_VALUE_BOOL(parg[0]) = (opt & GTK_CALENDAR_SHOW_DAY_NAMES) ? TRUE : FALSE;
		return parg;
	}
	else if ( !strcmp( defclass->resname, "~GtkCalendar::no_month_change" ) )
	{
		parg->type = GTK_TYPE_BOOL;
		GTK_VALUE_BOOL(parg[0]) = (opt & GTK_CALENDAR_NO_MONTH_CHANGE) ? TRUE : FALSE;
		return parg;
	}
	if ( !strcmp( defclass->resname, "~GtkCalendar::show_week_numbers" ) )
	{
		parg->type = GTK_TYPE_BOOL;
		GTK_VALUE_BOOL(parg[0]) = (opt & GTK_CALENDAR_SHOW_WEEK_NUMBERS) ? TRUE : FALSE;
		return parg;
	}
	if ( !strcmp( defclass->resname, "~GtkCalendar::week_start_monday" ) )
	{
		parg->type = GTK_TYPE_BOOL;
		GTK_VALUE_BOOL(parg[0]) = (opt & GTK_CALENDAR_WEEK_START_MONDAY) ? TRUE : FALSE;
		return parg;
	}
	else assert(0);

	return NULL;
}								// getdlg_calendar


PUBLIC int 
putdlg_calendar( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	GtkCalendarDisplayOptions opt = GTK_CALENDAR(wgt)->display_flags;

	if ( !strcmp( defclass->resname, "~GtkCalendar::show_heading" ) )
	{
		gtk_calendar_display_options( GTK_CALENDAR(wgt),
			GTK_VALUE_BOOL(parg[0]) ? (opt | GTK_CALENDAR_SHOW_HEADING) 
				: (opt & ~GTK_CALENDAR_SHOW_HEADING) );
		return 0;
	}
	else if ( !strcmp( defclass->resname, "~GtkCalendar::show_day_names" ) )
	{
		gtk_calendar_display_options( GTK_CALENDAR(wgt),
			GTK_VALUE_BOOL(parg[0]) ? (opt | GTK_CALENDAR_SHOW_DAY_NAMES) 
				: (opt & ~GTK_CALENDAR_SHOW_DAY_NAMES) );
		return 0;
	}
	else if ( !strcmp( defclass->resname, "~GtkCalendar::no_month_change" ) )
	{
		gtk_calendar_display_options( GTK_CALENDAR(wgt),
			GTK_VALUE_BOOL(parg[0]) ? (opt | GTK_CALENDAR_NO_MONTH_CHANGE) 
				: (opt & ~GTK_CALENDAR_NO_MONTH_CHANGE) );
		return 0;
	}
	else if ( !strcmp( defclass->resname, "~GtkCalendar::show_week_numbers" ) )
	{
		gtk_calendar_display_options( GTK_CALENDAR(wgt),
			GTK_VALUE_BOOL(parg[0]) ? (opt | GTK_CALENDAR_SHOW_WEEK_NUMBERS) 
				: (opt & ~GTK_CALENDAR_SHOW_WEEK_NUMBERS) );
		return 0;
	}
	else if ( !strcmp( defclass->resname, "~GtkCalendar::week_start_monday" ) )
	{
		gtk_calendar_display_options( GTK_CALENDAR(wgt),
			GTK_VALUE_BOOL(parg[0]) ? (opt | GTK_CALENDAR_WEEK_START_MONDAY) 
				: (opt & ~GTK_CALENDAR_WEEK_START_MONDAY) );
		return 0;
	}
	else assert(0);

	return -1;
}								// putdlg_calendar


PUBLIC int
writecode_calendar( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	GtkArg		arg;

	*parg = NULL;
	memset( &arg, 0, sizeof(GtkArg) );
	arg.type = defclass->restype;
	if ( !strcmp( defclass->resname, "~GtkCalendar::show_heading" ) ||
		 !strcmp( defclass->resname, "~GtkCalendar::show_day_names" ) ||
		 !strcmp( defclass->resname, "~GtkCalendar::no_month_change" ) ||
		 !strcmp( defclass->resname, "~GtkCalendar::show_week_numbers" ) ||
		 !strcmp( defclass->resname, "~GtkCalendar::week_start_monday" ) )
	{
		GtkCalendarDisplayOptions opt = GTK_CALENDAR(wgt)->display_flags;
		str[0] = malloc(200);
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_calendar_display_options( GTK_CALENDAR(%s), %d",
			get_name_wgt(wgt), opt );
		return 1;
	}
	else assert(0);

	return 0;
}								// writecode_calendar


PUBLIC int
writecode_after_calendar( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	return 0;
}								// writecode_after_calendar


static void
cb_calendar_press_event( GtkWidget *widget, GdkEventCrossing *event, void *data )
{
	gtk_signal_emit_stop_by_name( GTK_OBJECT (widget), "button_press_event" );
}								// cb_calendar_press_event


PUBLIC void
afteraddwgt_calendar( GtkWidget *wgt )
{

	gtk_signal_connect( GTK_OBJECT(wgt), "button_press_event",
		GTK_SIGNAL_FUNC(cb_calendar_press_event), NULL );

}								// afteraddwgt_calendar


PUBLIC GtkWidget *
addwgt_calendar( struct gtk_wgtdef_t *wgtdef_newwgt, module_info_t *module,
	GtkWidget *wgt_parent, GtkWidget *wgt_container )
{
	GtkWidget	*wgt_new;

	wgt_new = create_new_wgt( wgtdef_newwgt, module, wgt_parent, wgt_container, NULL );

	return wgt_new;

}								// addwgt_calendar

