#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "../glg.h"


PUBLIC GtkArg * 
getdlg_combo( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	if ( !strcmp( defclass->resname, "~GtkCombo::strings" ) )
	{
		gtk_usertype_strings_t	*strings;
		strings = gtk_object_get_data( GTK_OBJECT( wgt ), defclass->resname );
		GTK_VALUE_POINTER( parg[ 0 ] ) = strings;
		return parg;
	}
	else if ( !strcmp( defclass->resname, "~GtkCombo::val_match" ) )
	{
		return NULL;
	}	
	else if ( !strcmp( defclass->resname, "~GtkCombo::ok_if_empty" ) )
	{
		return NULL;
	}	
	else if ( !strcmp( defclass->resname, "~GtkCombo::use_arrows" ) )
	{
		return NULL;
	}	
	else if ( !strcmp( defclass->resname, "~GtkCombo::use_arrows_always" ) )
	{
		return NULL;
	}	
	else if ( !strcmp( defclass->resname, "~GtkCombo::case_sensitive" ) )
	{
		return NULL;
	}	
	else if ( !strcmp( defclass->resname, "~GtkCombo::disable_activate" ) )
	{
		return NULL;
	} else assert(0);
	return NULL;
}								// getdlg_combo


PUBLIC int 
putdlg_combo( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	if ( !strcmp( defclass->resname, "~GtkCombo::strings" ) )
	{
		gtk_usertype_strings_t	*strings, *new_strings;
		int						nb, n;
		GList					*items = NULL;

		strings = GTK_VALUE_POINTER( parg[ 0 ] );
		nb = strings->nb_strings;
		new_strings = malloc( sizeof( gtk_usertype_strings_t ) );
		new_strings->nb_strings = nb;
		new_strings->strings = malloc( nb * sizeof( char * ) );
		for ( n = 0; n < nb; n++ )
		{
			new_strings->strings[ n ] = strdup( strings->strings[ n ] );
			items = g_list_append( items, new_strings->strings[ n ] );
		}
		gtk_combo_set_popdown_strings( GTK_COMBO( wgt ), items );

		gtk_object_set_data_full( GTK_OBJECT( wgt ), defclass->resname, new_strings, 
			(GtkDestroyNotify) cb_destroy_notify_strings );

		return 0;
	}
	else if ( !strcmp( defclass->resname, "~GtkCombo::val_match" ) )
	{
		return 1;
	}	
	else if ( !strcmp( defclass->resname, "~GtkCombo::ok_if_empty" ) )
	{
		return 1;
	}	
	else if ( !strcmp( defclass->resname, "~GtkCombo::use_arrows" ) )
	{
		return 1;
	}	
	else if ( !strcmp( defclass->resname, "~GtkCombo::use_arrows_always" ) )
	{
		return 1;
	}	
	else if ( !strcmp( defclass->resname, "~GtkCombo::case_sensitive" ) )
	{
		return 1;
	}	
	else if ( !strcmp( defclass->resname, "~GtkCombo::disable_activate" ) )
	{
		return 1;
	} else assert(0);
	return -1;
}								// putdlg_combo


#define GET_FUNCTION_VALUE( type ) \
	if ( getdlg_##type( defclass, wgt, &arg ) == NULL ) \
		xarg = get_outsideres_wgt( wgt, defclass->resname ); \
	else \
		xarg = &arg; \
	assert( xarg != NULL )


PUBLIC int
writecode_combo( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	GtkArg	arg;
	
	if ( !strcmp( defclass->resname, "~GtkCombo::strings" ) )
	{
		gtk_usertype_strings_t	*strings;
		int						n;
		char					*tmp;
		GList					*list;

		memset( &arg, 0, sizeof(GtkArg) );
		arg.type = defclass->restype;
		(*defclass->wgtdef_depth->pfct_getdlg)( defclass, wgt, &arg );

		*parg = NULL;
		strings = GTK_VALUE_POINTER( arg );
		assert( strings->nb_strings < 100 );		// See generate.c for max strings
		if ( strings->nb_strings == 0 )
			return 0;
		tmp = malloc( 100  );
		sprintf( tmp, "{ GList *list_combo = NULL;" );
		str[ 0 ] = strdup( tmp );
		free( tmp );
		for ( list = NULL, n = 0; n < strings->nb_strings; n++ )
		{
			tmp = malloc( 100 + strlen( strings->strings[ n ] ) );
			sprintf( tmp, "list_combo = g_list_append( %s, \"%s\" );",
				"list_combo",
				strings->strings[ n ] );
			str[ n+1 ] = strdup( tmp );
			free( tmp );
		}
		tmp = malloc( 200  );
		sprintf( tmp, "gtk_combo_set_popdown_strings( GTK_COMBO( %s ), list_combo ); }",
			get_name_wgt( wgt ) );
		str[ n+1 ] = strdup( tmp );
		free( tmp );
		return strings->nb_strings + 2;
	}
	else if ( !strcmp( defclass->resname, "~GtkCombo::val_match" ) )
	{
		GtkArg	arg, *xarg, *yarg;
		*parg = NULL;
		GET_FUNCTION_VALUE( combo );
		yarg = get_outsideres_wgt( wgt, "~GtkCombo::ok_if_empty" );
		str[0] = malloc( 200 );
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_combo_set_value_in_list( GTK_COMBO( %s ), %s, %s );",
			get_name_wgt( wgt ),
			GTK_VALUE_BOOL( xarg[0] ) ? "TRUE" : "FALSE",
			GTK_VALUE_BOOL( yarg[0] ) ? "TRUE" : "FALSE" );
		return 1;
	}
	else if ( !strcmp( defclass->resname, "~GtkCombo::ok_if_empty" ) )
	{
		GtkArg	arg, *xarg, *yarg;
		*parg = NULL;
		GET_FUNCTION_VALUE( combo );
		yarg = get_outsideres_wgt( wgt, "~GtkCombo::val_match" );
		str[0] = malloc( 200 );
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_combo_set_value_in_list( GTK_COMBO( %s ), %s, %s );",
			get_name_wgt( wgt ),
			GTK_VALUE_BOOL( yarg[0] ) ? "TRUE" : "FALSE",
			GTK_VALUE_BOOL( xarg[0] ) ? "TRUE" : "FALSE" );
		return 1;
	}
	else if ( !strcmp( defclass->resname, "~GtkCombo::use_arrows" ) )
	{
		GtkArg	arg, *xarg;
		*parg = NULL;
		GET_FUNCTION_VALUE( combo );
		str[0] = malloc( 200 );
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_combo_set_use_arrows( GTK_COMBO( %s ), %s );",
			get_name_wgt( wgt ),
			GTK_VALUE_BOOL( xarg[0] ) ? "TRUE" : "FALSE" );
		return 1;
	}
	else if ( !strcmp( defclass->resname, "~GtkCombo::use_arrows_always" ) )
	{
		GtkArg	arg, *xarg;
		*parg = NULL;
		GET_FUNCTION_VALUE( combo );
		str[0] = malloc( 200 );
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_combo_set_use_arrows_always( GTK_COMBO( %s ), %s );",
			get_name_wgt( wgt ),
			GTK_VALUE_BOOL( xarg[0] ) ? "TRUE" : "FALSE" );
		return 1;
	}
	else if ( !strcmp( defclass->resname, "~GtkCombo::case_sensitive" ) )
	{
		GtkArg	arg, *xarg;
		*parg = NULL;
		GET_FUNCTION_VALUE( combo );
		str[0] = malloc( 200 );
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_combo_set_case_sensitive( GTK_COMBO( %s ), %s );",
			get_name_wgt( wgt ),
			GTK_VALUE_BOOL( xarg[0] ) ? "TRUE" : "FALSE" );
		return 1;
	}
	else if ( !strcmp( defclass->resname, "~GtkCombo::disable_activate" ) )
	{
		GtkArg	arg, *xarg;
		*parg = NULL;
		GET_FUNCTION_VALUE( combo );
		str[0] = malloc( 200 );
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_combo_disable_activate( GTK_COMBO( %s ), %s );",
			get_name_wgt( wgt ),
			GTK_VALUE_BOOL( xarg[0] ) ? "TRUE" : "FALSE" );
		return 1;
	}
	else assert( 0 );
	return 0;
}								// writecode_combo


PUBLIC int
writecode_after_combo( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	return 0;
}								// writecode_after_combo


static void
cb_enter_notify_event( GtkWidget *widget, GdkEventCrossing *event, void *data )
{
	gtk_signal_emit_stop_by_name( GTK_OBJECT (widget), "enter_notify_event" );
}								// cb_enter_notify_event

static void
cb_button_press_event( GtkWidget *widget, GdkEventCrossing *event, void *data )
{
	gtk_signal_emit_stop_by_name( GTK_OBJECT (widget), "button_press_event" );
}								// cb_button_press_event


PUBLIC void
afteraddwgt_combo( GtkWidget *wgt )
{
	GtkWidget	*btn	= GTK_COMBO(wgt)->button;
	GtkWidget	*entry	= GTK_COMBO(wgt)->entry;

	gtk_signal_connect( GTK_OBJECT(btn), "enter_notify_event",
		GTK_SIGNAL_FUNC(cb_enter_notify_event), NULL );
	gtk_signal_connect( GTK_OBJECT(btn), "button_press_event",
		GTK_SIGNAL_FUNC(cb_button_press_event), NULL );
		
	gtk_signal_connect( GTK_OBJECT(entry), "enter_notify_event",
		GTK_SIGNAL_FUNC(cb_enter_notify_event), NULL );
	gtk_signal_connect( GTK_OBJECT(entry), "button_press_event",
		GTK_SIGNAL_FUNC(cb_button_press_event), NULL );
		
}								// afteraddwgt_combo


PUBLIC GtkWidget *
addwgt_combo( struct gtk_wgtdef_t *wgtdef_newwgt, module_info_t *module,
	GtkWidget *wgt_parent, GtkWidget *wgt_container )
{
	gtk_usertype_strings_t	*strings;
	GtkWidget				*wgt_new;

	wgt_new = create_new_wgt( wgtdef_newwgt, module, wgt_parent, wgt_container, NULL );

	strings = malloc( sizeof( gtk_usertype_strings_t ) );
	strings->nb_strings = 0;
	strings->strings = NULL;
	gtk_object_set_data_full( GTK_OBJECT( wgt_new ), "~GtkCombo::strings", strings, 
		(GtkDestroyNotify) cb_destroy_notify_strings );

	return wgt_new;

}								// addwgt_combo

