#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "../glg.h"


PUBLIC GtkArg * 
getdlg_drawing_area( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	if ( !strcmp( defclass->resname, "~GtkDrawingArea::width" ) )
	{
		return NULL;
	}
	else if ( !strcmp( defclass->resname, "~GtkDrawingArea::height" ) )
	{
		return NULL;
	}
	else assert(0);
	return NULL;
}								// getdlg_drawing_area


PUBLIC int 
putdlg_drawing_area( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	if ( !strcmp( defclass->resname, "~GtkDrawingArea::width" ) )
	{
		return 1;
	}
	else if ( !strcmp( defclass->resname, "~GtkDrawingArea::height" ) )
	{
		return 1;
	}
	else assert(0);
	return -1;
}								// putdlg_drawing_area


PUBLIC int
writecode_drawing_area( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	*parg = NULL;
	if ( !strcmp( defclass->resname, "~GtkDrawingArea::width" ) )
	{
		GtkArg	arg, *xarg, *parg;

		if ( (*defclass->wgtdef_depth->pfct_getdlg)( defclass, wgt, &arg ) == NULL )
			xarg = get_outsideres_wgt( wgt, defclass->resname );
		else
			xarg = &arg;
		str[ 0 ] = malloc( 200 );
		assert(str[0] != NULL);

		parg = get_outsideres_wgt( wgt, "~GtkDrawingArea::height" );
		assert( parg != NULL );

		sprintf( str[ 0 ], "gtk_drawing_area_size( GTK_DRAWING_AREA( %s ), %d, %d );",
			get_name_wgt( wgt ),
			GTK_VALUE_INT( xarg[0] ),
			GTK_VALUE_INT( parg[0] ) );
		return 1;
	}
	else if ( !strcmp( defclass->resname, "~GtkDrawingArea::height" ) )
	{
		return 0;
	}
	else assert(0);
	return 0;
}								// writecode_drawing_area


PUBLIC int
writecode_after_drawing_area( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	return 0;
}								// writecode_after_drawing_area


PUBLIC void
afteraddwgt_drawing_area( GtkWidget *wgt )
{
}								// afteraddwgt_drawing_area


PUBLIC GtkWidget *
addwgt_drawing_area( struct gtk_wgtdef_t *wgtdef_newwgt, module_info_t *module,
	GtkWidget *wgt_parent, GtkWidget *wgt_container )
{
	GtkWidget	*wgt_new;

	wgt_new = create_new_wgt( wgtdef_newwgt, module, wgt_parent, wgt_container, NULL );

	return wgt_new;

}								// infos_addwgt_drawing_area
