
_EXTERN( editable )

static defclass_t defclass_GtkEditable[] =
{
	{ "GtkEditable::text_position",		GTK_TYPE_INT,		"Text position", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "~GtkEditable::editable",			GTK_TYPE_BOOL,		"Editable", GTK_ARG_READWRITE, SAVED_FUNCTION, TRUE, TRUE }
};

static defclasssignal_t defclasssignal_GtkEditable[] =
{
	{
		"changed", "Changed",
		{
			"void", 
			{"GtkEditable *editable", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"insert_text", "Insert Text",
		{
			"void", 
			{"GtkEditable *editable", "gchar *new_text", "gint new_text_length", 
			 "gint *position", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"delete_text", "Delete Text",
		{
			"void", 
			{"GtkEditable *editable", "gint start_pos", "gint end_pos", 
			 "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"activate", "Activate",
		{
			"void", 
			{"GtkEditable *editable", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"set_editable", "Set Editable",
		{
			"void", 
			{"GtkEditable *editable", "gboolean is_editable", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"move_cursor", "Move Cursor",
		{
			"void", 
			{"GtkEditable *editable", "gint x", "gint y", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"move_word", "Move Word",
		{
			"void", 
			{"GtkEditable *editable", "gint num_words", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"move_page", "Move Page",
		{
			"void", 
			{"GtkEditable *editable", "gint x", "gint y", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"move_to_row", "Move To Row",
		{
			"void", 
			{"GtkEditable *editable", "gint row", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"move_to_column", "Move To Column",
		{
			"void", 
			{"GtkEditable *editable", "gint column", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"kill_char", "Kill Char",
		{
			"void", 
			{"GtkEditable *editable", "gint direction", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"kill_word", "Kill Word",
		{
			"void", 
			{"GtkEditable *editable", "gint direction", "gpointer user_data"},
			NULL 
		}
	},
	{
		"kill_line", "Kill Line",
		{
			"void", 
			{"GtkEditable *editable", "gint direction", "gpointer user_data"},
			NULL 
		}
	},
	{
		"cut_clipboard", "Cut Clipboard",
		{
			"void", 
			{"GtkEditable *editable", "gpointer user_data"},
			NULL 
		} 
	},
	{
		"copy_clipboard", "Copy Clipboard",
		{
			"void", 
			{"GtkEditable *editable", "gpointer user_data"},
			NULL 
		}
	},
	{
		"paste_clipboard", "Paste Clipboard",
		{
			"void", 
			{"GtkEditable *editable", "gpointer user_data"},
			NULL 
		}
	}
};

static defclass_t defclasschild_GtkEditable[] =
{
};

static char *defblockres_GtkEditable[] =
{
};

static char *defrightclickmenu_GtkEditable[] =
{
	"changed"
};

static init_GtkArg deftvalues_GtkEditable[] =
{
	{ GTK_TYPE_BOOL,	"~GtkEditable::editable",	INIT_BOOL_VALUE( FALSE ) }
};

static gtk_wgtdef_t wgtdef_GtkEditable =
{
	"GtkEditable",
	_X( gtk_editable_get_type, editable, GtkEditable ),
	{ __(GtkObject), __(GtkWidget), __(GtkEditable), {NULL} },
	-1,									// Display this widget into the palette
	NULL,								// xpm bitmap
	-1,									// Max number of childs
	-1,									// Can't specify position of children
	-1,									// Can't specify size of children
	FALSE,								// See insert_new_widget(), placeholder only
	FALSE,								// See cb_module_button_press_event()
};
