#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "../glg.h"


PUBLIC GtkArg * 
getdlg_entry( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{

	if ( !strcmp( defclass->resname, "~GtkEntry::text" ) )
	{
		char *p = gtk_editable_get_chars( GTK_EDITABLE(wgt), 0, -1 );
		parg->type = GTK_TYPE_STRING;
		GTK_VALUE_STRING(parg[0]) = (p) ? strdup(p) : p;
		if (p)
			free(p);
		return parg;
	}
	else assert(0);

	return NULL;
}								// getdlg_entry


PUBLIC int 
putdlg_entry( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{

	if ( !strcmp( defclass->resname, "~GtkEntry::text" ) )
	{
		gtk_entry_set_text( GTK_ENTRY(wgt), GTK_VALUE_STRING(parg[0]) );
		return 0;
	}
	else assert(0);

	return -1;
}								// putdlg_entry


PUBLIC int
writecode_entry( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	GtkArg		arg;

	*parg = NULL;
	memset( &arg, 0, sizeof(GtkArg) );
	arg.type = defclass->restype;
	if ( !strcmp( defclass->resname, "~GtkEntry::text" ) )
	{
		int		len;
		(*defclass->wgtdef_depth->pfct_getdlg)( defclass, wgt, &arg );
		len = strlen(GTK_VALUE_STRING(arg));
		str[0] = malloc(len+200);
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_entry_set_text( GTK_ENTRY(%s), \"%s\" );",
			get_name_wgt(wgt), GTK_VALUE_STRING(arg) );
		return 1;
	}
	else assert(0);
	return 0;
}								// writecode_entry


PUBLIC int
writecode_after_entry( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	return 0;
}								// writecode_after_entry


static void
cb_enter_notify_event( GtkWidget *widget, GdkEventCrossing *event, void *data )
{
	gtk_signal_emit_stop_by_name( GTK_OBJECT (widget), "enter_notify_event" );
}								// cb_enter_notify_event

static void
cb_button_press_event( GtkWidget *widget, GdkEventCrossing *event, void *data )
{
	gtk_signal_emit_stop_by_name( GTK_OBJECT (widget), "button_press_event" );
}								// cb_button_press_event


PUBLIC void
afteraddwgt_entry( GtkWidget *wgt )
{

	gtk_signal_connect( GTK_OBJECT(wgt), "enter_notify_event",
		GTK_SIGNAL_FUNC(cb_enter_notify_event), NULL );
	gtk_signal_connect( GTK_OBJECT(wgt), "button_press_event",
		GTK_SIGNAL_FUNC(cb_button_press_event), NULL );

}								// afteraddwgt_entry


PUBLIC GtkWidget *
addwgt_entry( struct gtk_wgtdef_t *wgtdef_newwgt, module_info_t *module,
	GtkWidget *wgt_parent, GtkWidget *wgt_container )
{
	GtkWidget	*wgt_new;

	wgt_new = create_new_wgt( wgtdef_newwgt, module, wgt_parent, wgt_container, NULL );

	return wgt_new;

}								// infos_entry_button

