#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "../glg.h"


PUBLIC GtkArg * 
getdlg_hscale( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	if ( !strcmp( defclass->resname, "GtkHScale::adjustment" ) )
	{
		GtkAdjustment *adj = gtk_range_get_adjustment( GTK_RANGE(wgt) );
		parg->type = GTK_TYPE_POINTER;
		GTK_VALUE_POINTER(parg[0]) = adj;
		return parg;
	}
	else assert(0);
	return NULL;
}								// getdlg_hscale


PUBLIC int 
putdlg_hscale( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	if ( !strcmp( defclass->resname, "GtkHScale::adjustment" ) )
	{
		gtk_range_set_adjustment( GTK_RANGE(wgt),
			GTK_ADJUSTMENT( GTK_VALUE_POINTER(parg[0]) ) );
		return 0;
	}
	else assert(0);
	return -1;
}								// putdlg_hscale


PUBLIC int
writecode_hscale( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	if ( !strcmp( defclass->resname, "GtkHScale::adjustment" ) )
	{
		(*defclass->wgtdef_depth->pfct_getdlg)( defclass, wgt, *parg );
		return 0;
	}
	else assert(0);
	return 0;
}								// writecode_hscale


PUBLIC int
writecode_after_hscale( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	return 0;
}								// writecode_after_hscale


PUBLIC void
afteraddwgt_hscale( GtkWidget *wgt )
{
}								// afteraddwgt_hscale


PUBLIC GtkWidget *
addwgt_hscale( struct gtk_wgtdef_t *wgtdef_newwgt, module_info_t *module,
	GtkWidget *wgt_parent, GtkWidget *wgt_container )
{
	GtkWidget	*wgt_new;

	wgt_new = create_new_wgt( wgtdef_newwgt, module, wgt_parent, wgt_container, NULL );

	return wgt_new;

}								// addwgt_button

