#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "../glg.h"


PUBLIC GtkArg * 
getdlg_layout( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	if ( !strcmp( defclass->resname, "~GtkLayout::hadjustment" ) )
	{
		parg->type = GTK_TYPE_ADJUSTMENT;
		GTK_VALUE_POINTER( parg[0] ) = gtk_layout_get_hadjustment( GTK_LAYOUT( wgt ) );
		return parg;
	}
	else if ( !strcmp( defclass->resname, "~GtkLayout::vadjustment" ) )
	{
		parg->type = GTK_TYPE_ADJUSTMENT;
		GTK_VALUE_POINTER( parg[0] ) = gtk_layout_get_vadjustment( GTK_LAYOUT( wgt ) );
		return parg;
	}
	else assert(0);
	return NULL;
}								// getdlg_layout


PUBLIC int 
putdlg_layout( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	if ( !strcmp( defclass->resname, "~GtkLayout::hadjustment" ) )
	{
		gtk_layout_set_hadjustment( GTK_LAYOUT( wgt ), 
			GTK_ADJUSTMENT( GTK_VALUE_POINTER( parg[0] ) ) );
		return 0;
	}
	else if ( !strcmp( defclass->resname, "~GtkLayout::vadjustment" ) )
	{
		gtk_layout_set_vadjustment( GTK_LAYOUT( wgt ), 
			GTK_ADJUSTMENT( GTK_VALUE_POINTER( parg[0] ) ) );
		return 0;
	}
	else assert(0);
	return -1;
}								// putdlg_layout


PUBLIC int
writecode_layout( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	assert(0);
	return 0;
}								// writecode_layout


PUBLIC int
writecode_after_layout( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	return 0;
}								// writecode_after_layout


PUBLIC void
afteraddwgt_layout( GtkWidget *wgt )
{
}								// afteraddwgt_layout


PUBLIC GtkWidget *
addwgt_layout( struct gtk_wgtdef_t *wgtdef_newwgt, module_info_t *module,
	GtkWidget *wgt_parent, GtkWidget *wgt_container )
{
	GtkWidget		*wgt_new;
	GtkArg 			arg_container;
	GtkAdjustment	*wgt_adj1, *wgt_adj2;
	
	ADDWGT_PLACEHOLDER_BEFORE
	wgt_adj1 = GTK_ADJUSTMENT( gtk_adjustment_new( 0, 0, 1000, 0, 0, 0 ) );
	wgt_adj2 = GTK_ADJUSTMENT( gtk_adjustment_new( 0, 0, 1000, 0, 0, 0 ) );
	wgt_new = gtk_layout_new( wgt_adj1, wgt_adj2 );
	ADDWGT_PLACEHOLDER_AFTER
	gtk_widget_setv( wgt_new, nb_args, args );

	return wgt_new;

}								// addwgt_layout

