#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "../glg.h"


PUBLIC GtkArg * 
getdlg_menu( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	set_is_disabled_resource_wgt( wgt, defclass, FALSE );
	if ( !strcmp( defclass->resname, "~GtkMenu::position" ) )
	{
		GtkMenuShell	*menu_shell = GTK_MENU_SHELL( gtk_widget_get_ancestor( wgt, GTK_TYPE_MENU ) );
		parg->type = defclass->restype;
		GTK_VALUE_INT( parg[0] ) = g_list_index( menu_shell->children, wgt );
		return parg;
	} 
	else if ( !strcmp( defclass->resname, "~GtkMenu::father" ) )
	{
		parg->type = defclass->restype;
		GTK_VALUE_OBJECT( parg[0] ) = GTK_OBJECT( gtk_menu_get_attach_widget( GTK_MENU( wgt ) ) );
		return parg;
	}
	else if ( !strcmp( defclass->resname, "~GtkMenu::title" ) )
	{
		return NULL;
	}
	else if ( !strcmp( defclass->resname, "~GtkMenu::tearoff" ) )
	{
		return NULL;
	} else assert( 0 );
	return NULL;
}								// getdlg_menu


PUBLIC int 
putdlg_menu( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{
	if ( !strcmp( defclass->resname, "~GtkMenu::position" ) )
	{
		GtkMenu	*menu = GTK_MENU( gtk_widget_get_ancestor( wgt, GTK_TYPE_MENU ) );
		gtk_menu_reorder_child( menu, wgt, GTK_VALUE_INT( parg[0] ) );
		return 0;
	}
	else if ( !strcmp( defclass->resname, "~GtkMenu::father" ) )
	{
		gtk_menu_item_set_submenu( GTK_MENU_ITEM( GTK_VALUE_OBJECT( parg[0] ) ), wgt );
		return 0;
	}
	else if ( !strcmp( defclass->resname, "~GtkMenu::title" ) )
	{
		gtk_menu_set_title( GTK_MENU( wgt ), GTK_VALUE_STRING( parg[0] ) );
		return 1;
	}
	else if ( !strcmp( defclass->resname, "~GtkMenu::tearoff" ) )
	{
		gtk_menu_set_tearoff_state( GTK_MENU( wgt ), GTK_VALUE_BOOL( parg[0] ) );
		return 1;
	} else assert(0);
	return -1;
}								// putdlg_menu


PUBLIC int
writecode_menu( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	
	if ( !strcmp( defclass->resname, "~GtkMenu::position" ) )
	{
		*parg = NULL;
		return 0;
	}
	else if ( !strcmp( defclass->resname, "~GtkMenu::father" ) )
	{
		GtkWidget	*wgt_father;
		wgt_father = GTK_WIDGET( gtk_menu_get_attach_widget( GTK_MENU( wgt ) ) );
		assert( wgt_father != NULL );
		if ( !GTK_IS_WINDOW( wgt_father ) )
		{
			str[0] = malloc(400);
			assert(str[0] != NULL);
			sprintf( str[0], "gtk_menu_item_set_submenu( GTK_MENU_ITEM( %s ), %s );",
				get_name_wgt( wgt_father ), get_name_wgt( wgt ) );
			return 1;
		}						// if
		return 0;
	}
	else if ( !strcmp( defclass->resname, "~GtkMenu::title" ) )
	{
		GtkArg	arg, *xarg;
		if ( (*defclass->wgtdef_depth->pfct_getdlg)( defclass, wgt, &arg ) == NULL )
			xarg = get_outsideres_wgt( wgt, defclass->resname );
		else
			xarg = &arg;
		gtk_arg_copy( xarg, *parg );
		str[0] = malloc(400);
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_menu_set_title( GTK_MENU( %s ), \"%s\" );",
			get_name_wgt( wgt ), GTK_VALUE_STRING( *parg[0] ) );
		return 1;
	}
	else if ( !strcmp( defclass->resname, "~GtkMenu::tearoff" ) )
	{
		GtkArg	arg, *xarg;
		if ( (*defclass->wgtdef_depth->pfct_getdlg)( defclass, wgt, &arg ) == NULL )
			xarg = get_outsideres_wgt( wgt, defclass->resname );
		else
			xarg = &arg;
		gtk_arg_copy( xarg, *parg );
		str[0] = malloc(400);
		assert(str[0] != NULL);
		sprintf( str[0], "gtk_menu_set_tearoff_state( GTK_MENU( %s ), %s );",
			get_name_wgt( wgt ),
			(GTK_VALUE_BOOL( *parg[0] )) ? "TRUE" : "FALSE" );
		return 1;
	} else assert(0);
	return 0;
}								// writecode_menu


PUBLIC int
writecode_after_menu( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	return 0;
}								// writecode_after_menu


PUBLIC void
afteraddwgt_menu( GtkWidget *wgt )
{
}								// afteraddwgt_menu


PUBLIC GtkWidget *
addwgt_menu( struct gtk_wgtdef_t *wgtdef_newwgt, module_info_t *module,
	GtkWidget *wgt_parent, GtkWidget *wgt_container )
{
	GtkWidget	*wgt_new;

	wgt_new = create_new_wgt( wgtdef_newwgt, module, wgt_parent, wgt_container, NULL );

	return wgt_new;
}								// infos_addwgt_menu
