#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "../glg.h"


PUBLIC GtkArg * 
getdlg_menu_item( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{

	if ( !strcmp( defclass->resname, "~GtkMenuItem::right_justify" ) )
	{
		GtkMenuItem	*menu_item = GTK_MENU_ITEM( wgt );
		parg->type = GTK_TYPE_BOOL;
		GTK_VALUE_BOOL( parg[0] ) = (menu_item->right_justify) ? TRUE : FALSE;
		return parg;
	}
	else assert(0);

	return NULL;
}								// getdlg_menu_item


PUBLIC int 
putdlg_menu_item( defclass_t *defclass, GtkWidget *wgt, GtkArg *parg )
{

	if ( !strcmp( defclass->resname, "~GtkMenuItem::right_justify" ) )
	{
		GtkMenuItem	*menu_item = GTK_MENU_ITEM( wgt );
		menu_item->right_justify = (GTK_VALUE_BOOL(parg[0])) ? TRUE : FALSE;
		gtk_widget_queue_draw( GTK_WIDGET( menu_item ) );
		return 0;
	}
	else assert(0);

	return -1;
}								// putdlg_menu_item


PUBLIC int
writecode_menu_item( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	GtkArg		arg;

	*parg = NULL;
	memset( &arg, 0, sizeof(GtkArg) );
	arg.type = defclass->restype;
	if ( !strcmp( defclass->resname, "~GtkMenuItem::right_justify" ) )
	{
		(*defclass->wgtdef_depth->pfct_getdlg)( defclass, wgt, &arg );
		if ( GTK_VALUE_BOOL( arg ) )
		{
			str[0] = malloc( 200 );
			assert(str[0] != NULL);
			sprintf( str[0], "gtk_menu_item_right_justify( GTK_MENU_ITEM(%s) );",
				get_name_wgt(wgt) );
			return 1;
		}
		return 0;
	}
	else assert(0);

	return 0;
}								// writecode_menu_item


PUBLIC int
writecode_after_menu_item( defclass_t *defclass, GtkWidget *wgt, GtkArg **parg, char **str )
{
	return 0;
}								// writecode_after_menu_item


PUBLIC void
afteraddwgt_menu_item( GtkWidget *wgt )
{
}								// afteraddwgt_menu_item


PUBLIC GtkWidget *
addwgt_menu_item( struct gtk_wgtdef_t *wgtdef_newwgt, module_info_t *module,
	GtkWidget *wgt_parent, GtkWidget *wgt_container )
{
	GtkWidget	*wgt_new;

	wgt_new = create_new_wgt( wgtdef_newwgt, module, wgt_parent, wgt_container, NULL );

	return wgt_new;

}								// infos_addwgt_menu_item
