
_EXTERN( widget )
static defclass_t defclass_GtkWidget[] =
{
	{ "GtkWidget::parent",				GTK_TYPE_OBJECT,	NULL, GTK_ARG_READWRITE, SAVED_INSIDE, FALSE, TRUE, NULL, OBJRES(GTK_TYPE_CONTAINER) },
	{ "~GtkWidget::x",					GTK_TYPE_INT,		"X", GTK_ARG_READWRITE, SAVED_FUNCTION, TRUE, TRUE },
	{ "~GtkWidget::y",					GTK_TYPE_INT,		"Y", GTK_ARG_READWRITE, SAVED_FUNCTION, TRUE, TRUE },
	{ "~GtkWidget::width",				GTK_TYPE_INT,		"Width", GTK_ARG_READWRITE, SAVED_FUNCTION, TRUE, TRUE },
	{ "~GtkWidget::height",				GTK_TYPE_INT,		"Height", GTK_ARG_READWRITE, SAVED_FUNCTION, TRUE, TRUE },
	{ "~GtkWidget::visible",			GTK_TYPE_BOOL,		"Widget visible", GTK_ARG_READWRITE, SAVED_FUNCTION, TRUE, TRUE },
	{ "GtkWidget::sensitive",			GTK_TYPE_BOOL,		"Widget sensitive", GTK_ARG_READWRITE, SAVED_OUTSIDE, TRUE, TRUE },
	{ "~GtkWidget::tip_text",			GTK_TYPE_STRING,	"Tooltips", GTK_ARG_READWRITE, SAVED_FUNCTION, TRUE, TRUE },
	{ "GtkWidget::app_paintable",		GTK_TYPE_BOOL,		"App paintable", GTK_ARG_READWRITE, SAVED_OUTSIDE,	TRUE, TRUE },
	{ "GtkWidget::can_focus",			GTK_TYPE_BOOL,		"Widget can focus", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkWidget::has_focus",			GTK_TYPE_BOOL,		"Widget has focus", GTK_ARG_READWRITE, SAVED_OUTSIDE, TRUE, TRUE },
	{ "GtkWidget::can_default",			GTK_TYPE_BOOL,		"Widget can default", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkWidget::has_default",			GTK_TYPE_BOOL,		"Widget has default", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkWidget::receives_default",	GTK_TYPE_BOOL,		"Widget receives default", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE },
	{ "GtkWidget::style",				GTK_TYPE_OBJECT,	"Style", GTK_ARG_READWRITE, SAVED_INSIDE, TRUE, TRUE, NULL, OBJRES(GTK_TYPE_STYLE) },
	{ "GtkWidget::events",				GTK_TYPE_FLAGS,		"Events", GTK_ARG_READWRITE, SAVED_OUTSIDE_FUNCTION, TRUE, TRUE, _gdk_event_mask_values, OBJRES(GTK_TYPE_GDK_EVENT_MASK) },
	{ "GtkWidget::extension_events",	GTK_TYPE_FLAGS,		"Extension events", GTK_ARG_READWRITE, SAVED_OUTSIDE, TRUE, TRUE, _gdk_extension_mode_values, OBJRES(GTK_TYPE_GDK_EVENT_MASK) },
};
  
static defclasssignal_t defclasssignal_GtkWidget[] =
{
	{
		"expose_event", "Expose Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventExpose *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"configure_event", "Configure Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventConfigure *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"show",	"Show",
		{
			"void", 
			{"GtkWidget *widget", "gpointer user_data"},
			NULL 
		}
	},
	{
		"hide",	"Hide",
		{
			"void", 
			{"GtkWidget *widget", "gpointer user_data"},
			NULL 
		} 
	},
	{
		"map",	"Map",
		{
			"void", 
			{"GtkWidget *widget", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"unmap",	"Unmap",
		{
			"void", 
			{"GtkWidget *widget", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"realize",	"Realize",
		{
			"void", 
			{"GtkWidget *widget", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"unrealize",	"Unrealize",
		{
			"void", 
			{"GtkWidget *widget", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"draw",	"Draw",
		{
			"void", 
			{"GtkWidget *widget", "GdkRectangle *area", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"draw_focus",	"Draw Focus",
		{
			"void", 
			{"GtkWidget *widget", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"draw_default",	"Draw Default",
		{
			"void", 
			{"GtkWidget *widget", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"size_request",	"Size Request",
		{
			"void", 
			{"GtkWidget *widget", "GtkRequisition *requisition", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"size_allocate",	"Size Allocate",
		{
			"void", 
			{"GtkWidget *widget", "GtkAllocation *allocation", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"state_changed",	"State Changed",
		{
			"void", 
			{"GtkWidget *widget", "GtkStateType state", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"parent_set",	"Parent Set",
		{
			"void", 
			{"GtkWidget *widget", "GtkObject *old_parent", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"style_set",	"Style Set",
		{
			"void", 
			{"GtkWidget *widget", "GtkStyle *previous_style", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"add_accelerator", "Add Accelerator",
		{
			"void", 
			{"GtkWidget *widget", "guint accel_signal_id", "GtkAccelGroup *accel_group", 
			 "guint accel_key", "GdkModifierType accel_mods", "GtkAccelFlags accel_flags", 
			 "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"remove_accelerator", "Remove Accelerator",
		{
			"void", 
			{"GtkWidget *widget", "GtkAccelGroup *accel_group", 
			 "guint accel_key", "GdkModifierType accel_mods", 
			 "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"grab_focus", "Grab Focus",
		{
			"void", 
			{"GtkWidget *widget", "gpointer user_data"},
			NULL 
		}, 
	},
	{
		"event", "Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEvent *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"button_press_event", "Button Press Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventButton *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"button_release_event", "Button Release Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventButton *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"motion_notify_event", "Motion Notify Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventMotion *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"delete_event", "Delete Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEvent *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"destroy_event", "Destroy Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEvent *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"no_expose_event", "No Expose Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventNoExpose *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"key_press_event", "Key Press Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventKey *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"key_release_event", "Key Release Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventKey *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"enter_notify_event", "Enter Notify Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventCrossing *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"leave_notify_event", "Leave Notify Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventCrossing *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"focus_in_event", "Focus In Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventFocus *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"focus_out_event", "Focus Out Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventFocus *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"map_event", "Map Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEvent *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"unmap_event", "Unmap Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEvent *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"property_notify_event", "Property Notify Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventProperty *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"selection_clear_event", "Selection Clear Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventSelection *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"selection_request_event", "Selection Request Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventSelection *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"selection_notify_event", "Selection Notify Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventSelection *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"selection_get", "Selection Get",
		{
			"void", 
			{"GtkWidget *widget", "GtkSelectionData *data", 
			 "guint info", "guint time", "gpointer user_data"},
			NULL 
		} 
	},
	{
		"selection_received", "Selection Received",
		{
			"void", 
			{"GtkWidget *widget", "GtkSelectionData *data", 
			 "guint time", "gpointer user_data"},
			NULL 
		} 
	},
	{
		"proximity_in_event", "Proximity In Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventProximity *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"proximity_out_event", "Proximity Out Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventProximity *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"drag_begin", "Drag Begin Event",
		{
			"void", 
			{"GtkWidget *widget", "GdkDragContext *drag_context", "gpointer user_data"},
			NULL 
		} 
	},
	{
		"drag_end", "Drag End Event",
		{
			"void", 
			{"GtkWidget *widget", "GdkDragContext *drag_context", "gpointer user_data"},
			NULL 
		} 
	},
	{
		"drag_data_delete", "Drag Data Delete Event",
		{
			"void", 
			{"GtkWidget *widget", "GdkDragContext *drag_context", "gpointer user_data"},
			NULL 
		} 
	},
	{
		"drag_leave", "Drag Leave Event",
		{
			"void", 
			{"GtkWidget *widget", "GdkDragContext *drag_context", "guint time", "gpointer user_data"},
			NULL 
		} 
	},
	{
		"drag_motion", "Drag Motion Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkDragContext *drag_context", 
			 "gint x", "gint y", "guint time", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"drag_drop", "Drag Drop Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkDragContext *drag_context", 
			 "gint x", "gint y", "guint time", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"drag_data_get", "Drag Data Get Event",
		{
			"void", 
			{"GtkWidget *widget", "GdkDragContext *drag_context", 
			 "GtkSelectionData *data", "guint info", "guint time", "gpointer user_data"},
			NULL 
		} 
	},
	{
		"drag_data_received", "Drag Data Received Event",
		{
			"void", 
			{"GtkWidget *widget", "GdkDragContext *drag_context", 
			 "gint x", "gint y",
			 "GtkSelectionData *data", "guint info", "guint time", "gpointer user_data"},
			NULL 
		} 
	},
	{
		"client_event", "Client Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEventClient *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"visibility_notify_event", "Visibility Notify Event",
		{
			"gboolean", 
			{"GtkWidget *widget", "GdkEvent *event", "gpointer user_data"},
			"return FALSE" 
		} 
	},
	{
		"debug_msg", "Debug Msg Event",
		{
			"void", 
			{"GtkWidget *widget", "gchar *message", "gpointer user_data"},
			NULL 
		} 
	}
};

static defclass_t defclasschild_GtkWidget[] =
{
};

static char *defblockres_GtkWidget[] =
{
};

static char *defrightclickmenu_GtkWidget[] =
{
};

static init_GtkArg deftvalues_GtkWidget[] =
{
	{ GTK_TYPE_BOOL, 	"~GtkWidget::visible",		INIT_BOOL_VALUE( TRUE ) },
	{ GTK_TYPE_STRING,	"~GtkWidget::tip_text",		INIT_STRING_VALUE( "" ) },
};

static gtk_wgtdef_t wgtdef_GtkWidget =
{
	"GtkWidget",
	_X( gtk_widget_get_type, widget, GtkWidget ),
	{ __(GtkObject), __(GtkWidget), {NULL} },
	-1,									// Don't display this widget into the palette
	NULL,								// xpm bitmap
	-1,									// Max number of childs
	-1,									// Can't specify position of children
	-1,									// Can't specify size of children
	FALSE,								// See insert_new_widget(), placeholder only
	FALSE,								// See cb_module_button_press_event()
};
