#define INIT_STRING_VALUE( V )	{ V, 0, 0, 0 }
#define INIT_INT_VALUE( V )		{ NULL, V, 0, 0 }
#define INIT_FLOAT_VALUE( V )	{ NULL, 0, V, 0 }
#define INIT_BOOL_VALUE( V )	{ NULL, 0, 0, V }
#define INIT_ENUM_VALUE( V )	{ NULL, V, 0, 0 }
#define INIT_FLAGS_VALUE( V )	{ NULL, V, 0, 0 }

typedef struct
{
	GtkType		type;
	gchar		*name;
	struct
	{
		char	*string_value;
		int		int_value;
		float	float_value;
		int		bool_value;
	}	u;
}	init_GtkArg;
    
	
// See: saved_where
#define SAVED_INSIDE			1
#define SAVED_OUTSIDE			2
#define SAVED_FUNCTION			3
#define SAVED_OUTSIDE_FUNCTION	4

#ifdef __MAIN__
#include "gtktypebuiltins_evals.c"
#endif

enum
{
	GTK_USERTYPE_STRINGS = 1001,
	GTK_USERTYPE_ACCELERATOR
};

typedef struct
{
	int16_t		nb_strings;
	char		**strings;
}	gtk_usertype_strings_t;

typedef struct
{
	GtkType		type;
}	enum_info_t;

#ifdef __MAIN__
	enum {
		#define ___( X ) \
			_token_##X,
		_token_null = -1,
		#include "enum_infos.h"
		#undef ___
	};
#else
	#define ___( X ) \
		extern int _token_##X;
	#include "enum_infos.h"
	#undef ___
#endif


#ifdef __MAIN__
	#define ___( X ) \
		{ -1 },
	enum_info_t enum_infos[] =
	{
		#include "enum_infos.h"
	};
	#undef ___
#else
	extern enum_info_t enum_infos[];
#endif


#define OBJRES( X ) \
	#X, \
	_token_##X

typedef struct defclass_t
{
	char				*resname;
	int					restype;
	char				*title;
	int					resflags;				// GTK_ARG_READWRITE, GTK_ARG_CONSTRUCT_ONLY
	int					saved_where;			// SAVED_INSIDE or SAVED_OUTSIDE (into the widget or not)
	short				f_user;					// User can modify this resource ?
	short				f_generate;				// Is this resource used when generated ?
	GtkEnumValue const	*enum_list;
	char				*object_restype_str;	// OBJRES(
	int					object_restype_ptr;		// @GTK_TYPE_RELIEF_STYLE etc...
	
	// Computed  only at run-time
	int					f_child;				// Child container ?	
	GtkArg				arg_default;			// Default value
	struct gtk_wgtdef_t	*wgtdef_depth;

}	defclass_t;

struct gtk_wgtdef_t;
typedef GtkArg * (fct_getdlg)(defclass_t *defclass_t, GtkWidget *, GtkArg *);
typedef int (fct_putdlg)(defclass_t *defclass_t, GtkWidget *wgt, GtkArg *parg);
typedef int (fct_writecode)(defclass_t *defclass_t, GtkWidget *, GtkArg **parg, char **str);
typedef int (fct_writecode_after)(defclass_t *defclass_t, GtkWidget *, GtkWidget *, GtkArg **parg, char **str);
typedef GtkWidget * (fct_addwgt)(struct gtk_wgtdef_t *, module_info_t *, GtkWidget *, GtkWidget *);
typedef void (fct_afteraddwgt)(GtkWidget * );

typedef struct
{
	char				*resname;
	char				*title;
	struct
	{
		char			*ret;
		char			*params[8];
		char			*retval;			// NULL if just return (i.e. ret=="void")
	}					proto;
}	defclasssignal_t;

#define RES_NOT_YET_HANDLED( w, p ) \
	trace( "File:%s Line:%d:\n   Res. [%s], type=%d not yet handled, widget [%s]\n", \
		__FILE__, __LINE__, \
		p->resname, p->restype, w->widget_name )

#define MAXNB_HIERARCHIES	10

enum
{
	PALETTE_BASIC = 1,
	PALETTE_MORE,
	PALETTE_MENU,
#ifdef USE_GNOME
	PALETTE_GNOME,
#endif
	PALETTE_TEMPLATES
};

typedef struct gtk_wgtdef_t
{
	char				*widget_name;

	char				*widget_type;		// Example: GTK_TYPE_BUTTON GTK_TYPE_BIN ...
	GtkType (*pfct_get_widget_type)(void);	// Ptr to function (gtk_button_get_type, etc.)

	fct_addwgt			*pfct_addwgt;
	fct_getdlg			*pfct_getdlg;
	fct_putdlg			*pfct_putdlg;
	fct_writecode		*pfct_writecode;
	fct_writecode_after	*pfct_writecode_after;
	fct_afteraddwgt		*pfct_afteraddwgt;

	init_GtkArg			*deft_values;
	int					nb_deft_values;
	
	char				**blockedres;
	int					nb_blockedres;

	char				**rightclickmenu;
	int					nb_rightclickmenu;

	struct
	{
		struct gtk_wgtdef_t	*wgtdef_depth;
		char				*classnames;
		defclass_t			*classes;
		short				nb_classes;
		defclass_t			*classes_child;		// See: gtk_container_add_child_arg_type
		short				nb_classes_child;
		defclasssignal_t	*classes_signal;
		int					nb_classes_signal;
	}					def[ MAXNB_HIERARCHIES ];

	int					which_palette;			// Display this widget into which palette ?
	char				**pixmap;				// Pixmap (can be NULL)

	int					max_nb_children;		// Only accept one, two or more children ?
	int					f_children_autopos;		// Can't specify position of children
	int					f_children_autodim;		// Can't specify size of children
	int					insnewwgt_insinwgt;		// See insert_new_widget(), placeholder only
	int					stop_emit_btnpressevt;	// See cb_module_button_press_event()

	// *** Computed at run-time ***
	GdkPixmap			*gdkpixmap;
	GdkBitmap			*gdkbitmap;
	
	// No Window ? In this case, put this widget into a GtkEventBox
	int					gtk_no_window;
	
	// Is-it a window derivated from a GtkWindow ?
	int					is_window;		

}	gtk_wgtdef_t;

#define _EXTERN(a) \
	extern fct_getdlg 			getdlg_##a; \
	extern fct_putdlg 			putdlg_##a; \
	extern fct_writecode		writecode_##a; \
	extern fct_writecode_after	writecode_after_##a; \
	extern fct_addwgt			addwgt_##a; \
	extern fct_afteraddwgt		afteraddwgt_##a;

// See gtk_wgtdef_t
#define _X(t, a, b) \
	#t, \
	&t, \
	&addwgt_##a, \
	&getdlg_##a, \
	&putdlg_##a, \
	&writecode_##a, \
	&writecode_after_##a, \
	&afteraddwgt_##a, \
	deftvalues_##b, \
	sizeof( deftvalues_##b ) / sizeof(init_GtkArg), \
	defblockres_##b, \
	sizeof(defblockres_##b) / sizeof(char *), \
	defrightclickmenu_##b, \
	sizeof(defrightclickmenu_##b) / sizeof(char *)

#define __(p) \
{ \
	&wgtdef_##p, \
	#p, \
	defclass_##p, \
	sizeof( defclass_##p ) / sizeof( defclass_t ), \
	defclasschild_##p, \
	sizeof( defclasschild_##p ) / sizeof( defclass_t ), \
	defclasssignal_##p, \
	sizeof(defclasssignal_##p) / sizeof(defclasssignal_t), \
}

#define ADDWGT_PLACEHOLDER_BEFORE \
	if ( IS_WGT_PLACEHOLDER(wgt_container) ) \
	{ \
		arg_container.name = "position"; \
		gtk_container_child_getv( GTK_CONTAINER(wgt_parent), wgt_container, 1, &arg_container ); \
	}

#define ADDWGT_PLACEHOLDER_AFTER \
	if ( IS_WGT_PLACEHOLDER(wgt_container) ) \
	{ \
		gtk_container_child_setv( GTK_CONTAINER(wgt_parent), wgt_new, 1, &arg_container ); \
	}

#ifdef __MAIN__

#include "GtkObject.h"
#include "GtkWidget.h"
#include "GtkMisc.h"
#include "GtkContainer.h"
#include "GtkBin.h"
#include "GtkWindow.h"
#include "GtkLabel.h"
#include "GtkButton.h"
#include "GtkToggleButton.h"
#include "GtkCheckButton.h"
#include "GtkRadioButton.h"
#include "GtkOptionMenu.h"
#include "GtkBox.h"
#include "GtkHBox.h"
#include "GtkVBox.h"
#include "GtkTable.h"
#include "GtkStatusbar.h"
#include "GtkCombo.h"
#include "GtkMenuShell.h"
#include "GtkMenu.h"
#include "GtkMenuBar.h"
#include "GtkItem.h"
#include "GtkMenuItem.h"
#include "GtkCheckMenuItem.h"
#include "GtkRadioMenuItem.h"
#include "GtkFixed.h"
#include "GtkNotebook.h"
#include "GtkList.h"
#include "GtkCList.h"
#include "GtkDrawingArea.h"
#include "GtkPaned.h"
#include "GtkHPaned.h"
#include "GtkVPaned.h"
#include "GtkButtonBox.h"
#include "GtkHButtonBox.h"
#include "GtkVButtonBox.h"
#include "GtkFrame.h"
#include "GtkAspectFrame.h"
#include "GtkHandleBox.h"
#include "GtkScrolledWindow.h"
#include "GtkViewport.h"
#include "GtkEditable.h"
#include "GtkEntry.h"
#include "GtkText.h"
#include "GtkSeparator.h"
#include "GtkHSeparator.h"
#include "GtkVSeparator.h"
#include "GtkProgress.h"
#include "GtkProgressBar.h"
#include "GtkSpinButton.h"
#include "GtkToolbar.h"
#include "GtkTree.h"
#include "GtkCTree.h"
#include "GtkPixmap.h"
#include "GtkRange.h"
#include "GtkScale.h"
#include "GtkHScale.h"
#include "GtkVScale.h"
#include "GtkRuler.h"
#include "GtkHRuler.h"
#include "GtkVRuler.h"
#include "GtkScrollbar.h"
#include "GtkHScrollbar.h"
#include "GtkVScrollbar.h"
#include "GtkAlignment.h"
#include "GtkArrow.h"
#include "GtkCalendar.h"
#include "GtkEventBox.h"
#include "GtkAccelLabel.h"
#include "GtkLayout.h"
#include "GtkPacker.h"
#include "GtkDialog.h"
#include "GtkData.h"
#include "GtkAdjustment.h"

#ifdef USE_GNOME
#include "gnome/GtkDial.h"
#include "gnome/GnomeDialog.h"
#include "gnome/GnomeCalculator.h"
#include "gnome/GnomeEntry.h"
#include "gnome/GnomeFileEntry.h"
#include "gnome/GnomePixmapEntry.h"
#include "gnome/GnomeIconEntry.h"
#include "gnome/GnomeNumberEntry.h"
#include "gnome/GnomeAppBar.h"
#include "gnome/GnomeAnimator.h"
#include "gnome/GnomeCanvas.h"
#include "gnome/GnomeColorPicker.h"
#include "gnome/GnomeFontPicker.h"
#include "gnome/GnomePaperSelector.h"
#include "gnome/GnomeDateEdit.h"
#include "gnome/GnomeDock.h"
#include "gnome/GnomeDockBand.h"
#include "gnome/GnomeDockItem.h"
#include "gnome/GnomeDruid.h"
#include "gnome/GnomeDruidPage.h"
#include "gnome/GnomeDruidPageStandard.h"
#include "gnome/GnomeDruidPageStart.h"
#include "gnome/GnomeDruidPageFinish.h"
#include "gnome/GnomeHRef.h"
#include "gnome/GnomeLess.h"
#include "gnome/GnomeAbout.h"
#include "gnome/GnomePropertyBox.h"
#include "gnome/GnomeMessageBox.h"
#include "gnome/GnomeScores.h"
#include "gnome/GnomePixmap.h"
#include "gnome/GnomeStock.h"
#endif

COMMON	gtk_wgtdef_t	*gtk_wgtdef[] =
{
	&wgtdef_GtkObject,
	&wgtdef_GtkWidget,
	&wgtdef_GtkMisc,
	&wgtdef_GtkContainer,
	&wgtdef_GtkBin,
	&wgtdef_GtkWindow,
	&wgtdef_GtkLabel,
	&wgtdef_GtkButton,
	&wgtdef_GtkToggleButton,
	&wgtdef_GtkCheckButton,
	&wgtdef_GtkRadioButton,
	&wgtdef_GtkOptionMenu,
	&wgtdef_GtkEditable,
	&wgtdef_GtkEntry,
	&wgtdef_GtkText,
	&wgtdef_GtkBox,
	&wgtdef_GtkHBox,
	&wgtdef_GtkVBox,
	&wgtdef_GtkTable,
	&wgtdef_GtkFixed,
	&wgtdef_GtkStatusBar,
	&wgtdef_GtkCombo,
	&wgtdef_GtkMenuShell,
	&wgtdef_GtkMenu,
	&wgtdef_GtkMenuBar,
	&wgtdef_GtkItem,
	&wgtdef_GtkMenuItem,
	&wgtdef_GtkCheckMenuItem,
	&wgtdef_GtkRadioMenuItem,
	&wgtdef_GtkNotebook,
	&wgtdef_GtkList,
	&wgtdef_GtkCList,
	&wgtdef_GtkDrawingArea,
	&wgtdef_GtkPaned,
	&wgtdef_GtkHPaned,
	&wgtdef_GtkVPaned,
	&wgtdef_GtkButtonBox,
	&wgtdef_GtkHButtonBox,
	&wgtdef_GtkVButtonBox,
	&wgtdef_GtkFrame,
	&wgtdef_GtkAspectFrame,
	&wgtdef_GtkHandleBox,
	&wgtdef_GtkScrolledWindow,
	&wgtdef_GtkViewport,
	&wgtdef_GtkSeparator,
	&wgtdef_GtkHSeparator,
	&wgtdef_GtkVSeparator,
	&wgtdef_GtkProgress,
	&wgtdef_GtkProgressBar,
	&wgtdef_GtkSpinButton,
	&wgtdef_GtkToolbar,
	&wgtdef_GtkTree,
	&wgtdef_GtkCTree,
	&wgtdef_GtkPixmap,
	&wgtdef_GtkRange,
	&wgtdef_GtkScale,
	&wgtdef_GtkHScale,
	&wgtdef_GtkVScale,
	&wgtdef_GtkRuler,
	&wgtdef_GtkHRuler,
	&wgtdef_GtkVRuler,
	&wgtdef_GtkScrollbar,
	&wgtdef_GtkHScrollbar,
	&wgtdef_GtkVScrollbar,
	&wgtdef_GtkAlignment,
	&wgtdef_GtkArrow,
	&wgtdef_GtkCalendar,
	&wgtdef_GtkEventBox,
	&wgtdef_GtkAccelLabel,
	&wgtdef_GtkLayout,
	&wgtdef_GtkPacker,
	&wgtdef_GtkDialog,
	&wgtdef_GtkData,
	&wgtdef_GtkAdjustment,

#ifdef USE_GNOME
	&wgtdef_GtkDial,
	&wgtdef_GnomeCalculator,
	&wgtdef_GnomeEntry,
	&wgtdef_GnomeNumberEntry,
	&wgtdef_GnomeFileEntry,
	&wgtdef_GnomePixmapEntry,
	&wgtdef_GnomeIconEntry,
	&wgtdef_GnomeAppBar,
	&wgtdef_GnomeAnimator,
	&wgtdef_GnomeCanvas,
	&wgtdef_GnomeColorPicker,
	&wgtdef_GnomeFontPicker,
	&wgtdef_GnomePaperSelector,
	&wgtdef_GnomeDateEdit,
	&wgtdef_GnomeDock,
	&wgtdef_GnomeDockBand,
	&wgtdef_GnomeDockItem,
	&wgtdef_GnomeDruid,
	&wgtdef_GnomeDruidPage,
	&wgtdef_GnomeDruidPageStandard,
	&wgtdef_GnomeDruidPageStart,
	&wgtdef_GnomeDruidPageFinish,
	&wgtdef_GnomeHRef,
	&wgtdef_GnomeLess,
	&wgtdef_GnomeDialog,
	&wgtdef_GnomeAbout,
	&wgtdef_GnomePropertyBox,
	&wgtdef_GnomeMessageBox,
	&wgtdef_GnomeScores,
	&wgtdef_GnomePixmap,
	&wgtdef_GnomeStock,
#endif

	NULL
};

#else

extern	gtk_wgtdef_t	gtk_wgtdef[];

#endif
