#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


static	GtkWidget	*wgt_filesel;
static	int			f_ok;


PUBLIC void
save_project( void )
{

	/*--- 'Save As' if not project directoy not yet given ---*/
	if ( !strcmp( project_dirname, "" ) )
	{
		save_project_as();
		return;
	}
	do_save_project( project_dirname );
		
}								// save_project


static void
cb_filesel_ok( GtkWidget *widget, void *data )
{
	gchar	*filename;
	gint	len;

	filename = gtk_file_selection_get_filename( GTK_FILE_SELECTION(wgt_filesel) );
	len = strlen( filename );
	if (len == 0)
		return;
	if ( (len >= 1) && (filename[len - 1] == '/') )
		filename[len - 1] = 0;

	do_save_project( filename );

	gtk_widget_destroy( widget );
	wgt_filesel = NULL;
	f_ok = TRUE;
	
}								// cb_filesel_ok


static void
cb_filesel_cancel( GtkWidget *widget, void *data )
{
	gtk_widget_destroy( widget );
	wgt_filesel = NULL;
	f_ok = FALSE;
}								// cb_filesel_cancel


PUBLIC int
save_project_as( void )
{
	GtkWidget	*parent;

	/*--- Create the dialog 'Save As...' ---*/
	wgt_filesel = gtk_file_selection_new( "Save As..." );
	gtk_window_set_position( GTK_WINDOW(wgt_filesel), GTK_WIN_POS_MOUSE );
	gtk_window_set_modal( GTK_WINDOW( wgt_filesel ), TRUE );

	/*--- Hide file list ---*/
	parent = gtk_widget_get_ancestor( GTK_WIDGET(GTK_FILE_SELECTION(wgt_filesel)->file_list), 
		GTK_TYPE_SCROLLED_WINDOW );
	gtk_widget_hide( parent ),

	/*--- 'Ok' button signal ---*/
	gtk_signal_connect_object( GTK_OBJECT( GTK_FILE_SELECTION(wgt_filesel)->ok_button ),
		"clicked", GTK_SIGNAL_FUNC(cb_filesel_ok), (gpointer)wgt_filesel );

	/*--- 'Cancel' button signal ---*/
	gtk_signal_connect_object( GTK_OBJECT( GTK_FILE_SELECTION(wgt_filesel)->cancel_button ),
		"clicked", GTK_SIGNAL_FUNC(cb_filesel_cancel), (gpointer)wgt_filesel );

	/*--- Current project directory ---*/
	if ( strcmp( project_dirname, "" ) )
		gtk_file_selection_set_filename( GTK_FILE_SELECTION(wgt_filesel), project_dirname );

	/*--- Show the file selection dialog ---*/
	gtk_widget_show( wgt_filesel );
	gdk_window_show( wgt_filesel->window );

	/*--- Wait until user selects either 'yes' or 'no' ---*/
	push_block_all_windows();
	while ( wgt_filesel )
		gtk_main_iteration();
	pop_block_all_windows();
	
	return f_ok;
		   	   
}								// save_project_as

