#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <inttypes.h>
#include <assert.h>

#include "glg.h"


PUBLIC void
select_widget( GtkWidget *widget, 
	int do_select, 
	int f_select_first_cb )
{
		GtkCTreeNode	*tree_node;
		GtkCTreeNode	*curr;
		GtkCTreeRow		*tree_row;
		gtk_wgtdef_t	*prev_wgtdef, *wgtdef;
		int				curr_page=-1, page;
static	int				rentrant = FALSE;

#if 0
	{
	static int cpt = 0;
	trace( "%4d : select_widget: %p [%s] (%d, %d)\n", 
		++cpt, widget, gtk_widget_get_name( widget ), do_select, f_select_first_cb );
	}
#endif

	if ( rentrant )
		assert(0);

	rentrant = TRUE;

	/*--- Which class of widget has been previously selected ---*/
	prev_wgtdef = get_wgtdef_selection();
	if ( prev_wgtdef != NULL )
		curr_page = gtk_notebook_get_current_page( GTK_NOTEBOOK( wgt_res_notebook ) );

	/*--- Update the list of the selected widget(s) ---*/
	reset_selection();
	add_wgt_to_selection( widget );
	
	/*--- If same class of widget, restore previous page ---*/
	wgtdef = gtk_object_get_data( GTK_OBJECT( widget ), WGTDATA_WGTDEF );
	assert( wgtdef != NULL );
	if ( wgtdef == prev_wgtdef )
		page = curr_page;
	else
		page = 0;

	if ( !IS_WGT_PLACEHOLDER(widget) )
		display_resource_one_widget( widget, page );
	else
		clear_resources( FALSE );

	/*--- Select the tree item for this widget ---*/
	if ( do_select )
	{

		gtk_signal_handler_block_by_data( GTK_OBJECT( wgt_tree_widgets ), 
			wgt_tree_widgets );
		tree_node = get_object_data( widget, TREENODE_WGTDATA );
		assert( tree_node != NULL );
		gtk_ctree_select( GTK_CTREE( wgt_tree_widgets ), GTK_CTREE_NODE(tree_node) );
//		if ( config.is_expand_container_blank )
//			gtk_ctree_expand_recursive( GTK_CTREE( wgt_tree_widgets ),
//				gtk_ctree_node_nth( GTK_CTREE( wgt_tree_widgets ), 1 ) );
//		else
			gtk_ctree_collapse_recursive( GTK_CTREE( wgt_tree_widgets ),
				gtk_ctree_node_nth( GTK_CTREE( wgt_tree_widgets ), 1 ) );
		curr = tree_node;
		while ( curr )
		{
			tree_row = GTK_CTREE_ROW( curr );
			curr = tree_row->parent;
			if ( curr )
			{
				gtk_ctree_expand( GTK_CTREE( wgt_tree_widgets ), GTK_CTREE_NODE( curr ) );
			}
		}
		if ( config.is_expand_container_blank )
			gtk_ctree_expand_recursive( GTK_CTREE( wgt_tree_widgets ), 
				GTK_CTREE_NODE( tree_node ) );
		gtk_signal_handler_unblock_by_data( GTK_OBJECT( wgt_tree_widgets ), 
			wgt_tree_widgets );

	}							// if

	/*--- Select 1st callback, if any ---*/
	if ( f_select_first_cb )
	{
		defclasssignal_t	*q;
		int					depth, k, index;
		int					done;
		GtkCTreeNode		*tree_node;

		for ( done = FALSE, depth = 0; 
			  (depth < MAXNB_HIERARCHIES) && (wgtdef->def[depth].classnames != NULL); 
			  depth++ )
		{
			for ( q = wgtdef->def[depth].classes_signal, k = 0; 
				  k < wgtdef->def[depth].nb_classes_signal; 
				  k++, q++, index++ )
			{
				data_cb_t		*old_datacb;
				def_cb_t		*defcb;
				int				n;
				char			label[200];

				old_datacb = get_object_data( widget, q->resname );
				if (old_datacb == NULL)
					continue;

				for ( defcb = old_datacb->cb, n = 0; 
					  n < old_datacb->nb_cb; 
					  n++, defcb++ )
				{
					if ( !strcmp(defcb->cbname, defcb->cbfile) )
						sprintf( label, "%s::%s - %s",
							wgtdef->widget_name, q->resname, 
							defcb->cbname );
					else
						sprintf( label, "%s::%s - %s@%s",
							wgtdef->widget_name, q->resname, 
							defcb->cbname, defcb->cbfile );

					tree_node = get_object_data( widget, CALLBACKSNODE_WGTDATA );
					assert( tree_node != NULL );
					gtk_signal_handler_block_by_data( GTK_OBJECT( wgt_tree_callbacks ), 
						wgt_tree_callbacks );
					gtk_ctree_select( GTK_CTREE( wgt_tree_callbacks ), 
						GTK_CTREE_NODE(tree_node) );
					gtk_signal_handler_unblock_by_data( GTK_OBJECT( wgt_tree_callbacks ), 
						wgt_tree_callbacks );

					done = TRUE;
					break;
				}				// for (n)
				if ( done )
					break;

			}					// for (k)
			if ( done )
				break;
		}						// for (depth)

		if ( !done )
		{
			GtkCList	*clist;
			clist = GTK_CLIST( wgt_tree_callbacks );
//			gtk_clist_unselect_all( clist );
 		}

	}							// if ( f_select_first_cb )

	rentrant = FALSE;
	
}								// select_widget


PUBLIC void
refresh_properties_selected_widgets( void )
{

	if ( nb_selection() == 1 )
	{
		GtkWidget *wgt_selected = GTK_WIDGET( g_slist_last(list_selection)->data );
		assert( wgt_selected != NULL );
		select_widget( wgt_selected, 
			TRUE, 
			TRUE );
	}
	else if ( nb_selection() > 1 )
	{
		trace( "%s %d\nNot yet handled.\n", __FILE__, __LINE__ );
	}

}								// refresh_properties_selected_widgets
